/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(130957),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35876), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36514), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36677), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36698),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91306), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(98968),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(99126),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(99284),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99701),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(99859),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100464),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100622),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(100838),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(100946), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(101219), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101551),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(101799),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(102168),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(102813),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(104113),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(104758), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(105778),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(108131),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(109808),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(110789), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(112880), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(113045),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114576),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(114812),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(115084),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116418),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(117752),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118404), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(119056), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(119832),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120424), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(121016),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(121750), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122484),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122517),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122553),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122682), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(122715),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(123258),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(123801),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(124722),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125643), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(126114), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126187),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126544), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(127105),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(127213),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127503),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(127935), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128310),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128448),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128823),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(129119), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129257),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129303), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129390), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129811),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(130091),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130380),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130661),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5670 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5670,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5671 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5671,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5705 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5705,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5706 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5706,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 2000 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 2000,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 2001 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 2001,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2239 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2239,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2240 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2240,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5681 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5681,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5682 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5682,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2106 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2106,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5680 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5680,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5449 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5449,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5486 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5486,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5448 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5448,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5485 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5485,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5447 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5447,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5484 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5484,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5679 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5679,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2105 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2105,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5446 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5446,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5483 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5483,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3248 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3248,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3249 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3249,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3252 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3252,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5950 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5950,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5951 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5951,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5954 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5954,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5672 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5672,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5673 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5673,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5707 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5707,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5708 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5708,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3053 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3053,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3081 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3081,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3091 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3091,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5443 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5443,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5444 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5444,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5481 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5481,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2004 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2004,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2005 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2005,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2243 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2243,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2244 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2244,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5445 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5445,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5482 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5482,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5926 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5926,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5940 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5940,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5945 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5945,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5463 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5463,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 762 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 762,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5532 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5532,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 889 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 889,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 758 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 758,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 782 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 782,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 781 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 781,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 770 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 770,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 780 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 780,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 779 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 779,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5511 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5511,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5505 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5505,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5510 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5510,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 791 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 791,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 785 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 785,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 790 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 790,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 763 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 763,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5531 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5531,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 888 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 888,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 757 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 757,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 778 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 778,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 777 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 777,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 769 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 769,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 776 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 776,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 775 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 775,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5535 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5535,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5509 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5509,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5504 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5504,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5508 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5508,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 892 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 892,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 789 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 789,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 784 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 784,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 788 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 788,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 761 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 761,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3496 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3496,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5530 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5530,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 887 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 887,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 756 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 756,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 774 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 774,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 773 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 773,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 768 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 768,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 772 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 772,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 771 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 771,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5534 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5534,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5507 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5507,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5503 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5503,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5506 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5506,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 891 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 891,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 787 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 787,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 783 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 783,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 786 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 786,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 760 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 760,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3492 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3492,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5533 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5533,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 890 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 890,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 759 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 759,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3488 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3488,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 966 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 966,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 917 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 917,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 962 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 962,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 986 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 986,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 985 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 985,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 974 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 974,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 984 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 984,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 983 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 983,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 995 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 995,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 989 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 989,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 994 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 994,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 967 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 967,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 916 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 916,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 961 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 961,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 982 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 982,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 981 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 981,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 973 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 973,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 980 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 980,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 979 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 979,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 920 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 920,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 993 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 993,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 988 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 988,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 992 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 992,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 965 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 965,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3508 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3508,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 915 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 915,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 960 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 960,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 978 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 978,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 977 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 977,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 972 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 972,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 976 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 976,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 975 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 975,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 919 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 919,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 991 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 991,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 987 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 987,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 990 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 990,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 964 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 964,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3504 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3504,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 918 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 918,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 963 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 963,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3500 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3500,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 837 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 837,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 836 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 836,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4421 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4421,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 840 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 840,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3466 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3466,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 835 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 835,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4426 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4426,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 839 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 839,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3462 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3462,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 838 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 838,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3458 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3458,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1855 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1855,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2112 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2112,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1997 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1997,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1998 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1998,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1999 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1999,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2236 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2236,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2237 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2237,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2238 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2238,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5439 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5439,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5472 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5472,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5438 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5438,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5471 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5471,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5437 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5437,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5470 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5470,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5440 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5440,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5461 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5461,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5473 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5473,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1894 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1894,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2526 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2526,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1826 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1826,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1133 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1133,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2529 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2529,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3370 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3370,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1827 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1827,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2525 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2525,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1134 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1134,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3366 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3366,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1828 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1828,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2524 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2524,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2528 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2528,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3362 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3362,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1829 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1829,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2527 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2527,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3358 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3358,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5655 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5655,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5697 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5697,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1914 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1914,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2196 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2196,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5453 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5453,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5490 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5490,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5660 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5660,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5702 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5702,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5452 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5452,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5489 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5489,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1919 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1919,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2201 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2201,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1915 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1915,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2197 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2197,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5656 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5656,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5698 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5698,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1918 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1918,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2200 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2200,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1917 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1917,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2199 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2199,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1916 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1916,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2198 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2198,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5659 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5659,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5701 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5701,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5658 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5658,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5700 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5700,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5657 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5657,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5699 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5699,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5477 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5477,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5476 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5476,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5475 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5475,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5478 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5478,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1848 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1848,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2094 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2094,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2532 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2532,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1834 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1834,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1137 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1137,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2535 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2535,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3384 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3384,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1835 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1835,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2531 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2531,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1138 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1138,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3380 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3380,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1836 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1836,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2530 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2530,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2534 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2534,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3376 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3376,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1837 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1837,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2533 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2533,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3372 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3372,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5480 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5480,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2538 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2538,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1830 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1830,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1135 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1135,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2541 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2541,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3398 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3398,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1831 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1831,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2537 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2537,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1136 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1136,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3394 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3394,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1832 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1832,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2536 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2536,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2540 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2540,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3390 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3390,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1833 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1833,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2539 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2539,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3386 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3386,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3024 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3024,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3025 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3025,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3028 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3028,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3026 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3026,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3029 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3029,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3027 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3027,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 692 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 692,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 693 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 693,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2718 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2718,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2720 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2720,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2721 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2721,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2732 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2732,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2733 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2733,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2734 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2734,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2735 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2735,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2736 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2736,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2737 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2737,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2738 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2738,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2739 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2739,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2740 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2740,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2741 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2741,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2804 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2804,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2805 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2805,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2806 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2806,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2807 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2807,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2808 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2808,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2809 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2809,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2810 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2810,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2811 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2811,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2812 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2812,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2813 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2813,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2722 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2722,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2723 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2723,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2742 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2742,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2743 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2743,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2744 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2744,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2745 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2745,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2746 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2746,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2747 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2747,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2748 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2748,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2749 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2749,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2750 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2750,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2751 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2751,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2814 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2814,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2815 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2815,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2816 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2816,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2817 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2817,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2818 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2818,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2819 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2819,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2820 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2820,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2821 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2821,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2822 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2822,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2823 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2823,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2726 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2726,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2727 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2727,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2768 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2768,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2769 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2769,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2770 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2770,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2771 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2771,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2772 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2772,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2773 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2773,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2774 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2774,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2775 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2775,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2776 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2776,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2777 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2777,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2840 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2840,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2841 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2841,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2842 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2842,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2843 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2843,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2844 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2844,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2845 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2845,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2846 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2846,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2847 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2847,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2848 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2848,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2849 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2849,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5283 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5283,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5284 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5284,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5289 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5289,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5290 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5290,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5291 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5291,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5292 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5292,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5293 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5293,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5294 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5294,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5295 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5295,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5296 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5296,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5297 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5297,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5298 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5298,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5325 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5325,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5326 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5326,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5327 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5327,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5328 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5328,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5329 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5329,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5330 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5330,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5331 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5331,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5332 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5332,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5333 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5333,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5334 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5334,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2724 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2724,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2725 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2725,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2752 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2752,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2753 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2753,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2754 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2754,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2755 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2755,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2756 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2756,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2757 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2757,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2758 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2758,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2759 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2759,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2760 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2760,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2761 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2761,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2824 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2824,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2825 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2825,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2826 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2826,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2827 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2827,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2828 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2828,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2829 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2829,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2830 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2830,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2831 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2831,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2832 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2832,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2833 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2833,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2728 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2728,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2729 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2729,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2778 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2778,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2779 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2779,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2780 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2780,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2781 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2781,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2782 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2782,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2783 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2783,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2784 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2784,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2785 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2785,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2786 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2786,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2787 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2787,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2850 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2850,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2851 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2851,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2852 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2852,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2853 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2853,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2854 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2854,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2855 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2855,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2856 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2856,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2857 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2857,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2858 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2858,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2859 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2859,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5285 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5285,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5286 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5286,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5299 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5299,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5300 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5300,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5301 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5301,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5302 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5302,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5303 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5303,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5304 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5304,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5305 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5305,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5306 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5306,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5307 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5307,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5308 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5308,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5335 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5335,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5336 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5336,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5337 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5337,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5338 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5338,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5339 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5339,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5340 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5340,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5341 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5341,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5342 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5342,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5343 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5343,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5344 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5344,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2762 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2762,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2763 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2763,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2764 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2764,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2765 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2765,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2766 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2766,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2767 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2767,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2834 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2834,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2835 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2835,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2836 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2836,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2837 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2837,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2838 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2838,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2839 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2839,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2730 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2730,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2731 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2731,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2788 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2788,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2789 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2789,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2790 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2790,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2791 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2791,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2792 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2792,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2793 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2793,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2794 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2794,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2795 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2795,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2796 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2796,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2797 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2797,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2860 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2860,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2861 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2861,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2862 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2862,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2863 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2863,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2864 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2864,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2865 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2865,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2866 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2866,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2867 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2867,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2868 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2868,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2869 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2869,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5287 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5287,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5288 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5288,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5309 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5309,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5310 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5310,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5311 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5311,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5312 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5312,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5313 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5313,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5314 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5314,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5315 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5315,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5316 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5316,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5317 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5317,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5318 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5318,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5345 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5345,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5346 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5346,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5347 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5347,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5348 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5348,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5349 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5349,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5350 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5350,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5351 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5351,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5352 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5352,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5353 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5353,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5354 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5354,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2798 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2798,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2799 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2799,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2800 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2800,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2801 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2801,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2802 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2802,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2803 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2803,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2870 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2870,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2871 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2871,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2872 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2872,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2873 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2873,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2874 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2874,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2875 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2875,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5319 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5319,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5320 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5320,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5321 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5321,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5322 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5322,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5323 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5323,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5324 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5324,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5355 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5355,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5356 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5356,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5357 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5357,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5358 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5358,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5359 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5359,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5360 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5360,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 793*/ GIMT_Encode4(35875),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 792*/ GIMT_Encode4(35816),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 794: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 795: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 796: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35815), // Rule ID 3982 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35793 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35813 */   GIR_RootConstrainSelectedInstOperands,
     /*  35814 */   // GIR_Coverage, 3982,
     /*  35814 */   GIR_EraseRootFromParent_Done,
     /*  35815 */ // Label 797: @35815
     /*  35815 */ GIM_Reject,
     /*  35816 */ // Label 792: @35816
     /*  35816 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35874), // Rule ID 3970 //
     /*  35821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35835 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35852 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35872 */   GIR_RootConstrainSelectedInstOperands,
     /*  35873 */   // GIR_Coverage, 3970,
     /*  35873 */   GIR_EraseRootFromParent_Done,
     /*  35874 */ // Label 798: @35874
     /*  35874 */ GIM_Reject,
     /*  35875 */ // Label 793: @35875
     /*  35875 */ GIM_Reject,
     /*  35876 */ // Label 11: @35876
     /*  35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 806*/ GIMT_Encode4(36250),
     /*  35887 */ /*GILLT_s16*//*Label 799*/ GIMT_Encode4(35939),
     /*  35891 */ /*GILLT_s32*//*Label 800*/ GIMT_Encode4(35966),
     /*  35895 */ /*GILLT_s64*//*Label 801*/ GIMT_Encode4(35993), GIMT_Encode4(0),
     /*  35903 */ /*GILLT_v2s32*//*Label 802*/ GIMT_Encode4(36020), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35915 */ /*GILLT_v4s16*//*Label 803*/ GIMT_Encode4(36047),
     /*  35919 */ /*GILLT_v4s32*//*Label 804*/ GIMT_Encode4(36074), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35935 */ /*GILLT_v8s16*//*Label 805*/ GIMT_Encode4(36162),
     /*  35939 */ // Label 799: @35939
     /*  35939 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(35965), // Rule ID 674 //
     /*  35944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35958 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35963 */   GIR_RootConstrainSelectedInstOperands,
     /*  35964 */   // GIR_Coverage, 674,
     /*  35964 */   GIR_Done,
     /*  35965 */ // Label 807: @35965
     /*  35965 */ GIM_Reject,
     /*  35966 */ // Label 800: @35966
     /*  35966 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(35992), // Rule ID 675 //
     /*  35971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35985 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35990 */   GIR_RootConstrainSelectedInstOperands,
     /*  35991 */   // GIR_Coverage, 675,
     /*  35991 */   GIR_Done,
     /*  35992 */ // Label 808: @35992
     /*  35992 */ GIM_Reject,
     /*  35993 */ // Label 801: @35993
     /*  35993 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36019), // Rule ID 676 //
     /*  35998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36012 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36017 */   GIR_RootConstrainSelectedInstOperands,
     /*  36018 */   // GIR_Coverage, 676,
     /*  36018 */   GIR_Done,
     /*  36019 */ // Label 809: @36019
     /*  36019 */ GIM_Reject,
     /*  36020 */ // Label 802: @36020
     /*  36020 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(36046), // Rule ID 1699 //
     /*  36025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36039 */   // (fround:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  36044 */   GIR_RootConstrainSelectedInstOperands,
     /*  36045 */   // GIR_Coverage, 1699,
     /*  36045 */   GIR_Done,
     /*  36046 */ // Label 810: @36046
     /*  36046 */ GIM_Reject,
     /*  36047 */ // Label 803: @36047
     /*  36047 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(36073), // Rule ID 1701 //
     /*  36052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36066 */   // (fround:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  36071 */   GIR_RootConstrainSelectedInstOperands,
     /*  36072 */   // GIR_Coverage, 1701,
     /*  36072 */   GIR_Done,
     /*  36073 */ // Label 811: @36073
     /*  36073 */ GIM_Reject,
     /*  36074 */ // Label 804: @36074
     /*  36074 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(36161),
     /*  36079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36082 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(36105), // Rule ID 1700 //
     /*  36087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36098 */     // (fround:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  36103 */     GIR_RootConstrainSelectedInstOperands,
     /*  36104 */     // GIR_Coverage, 1700,
     /*  36104 */     GIR_Done,
     /*  36105 */   // Label 813: @36105
     /*  36105 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(36160), // Rule ID 3980 //
     /*  36110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36121 */     // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36138 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36158 */     GIR_RootConstrainSelectedInstOperands,
     /*  36159 */     // GIR_Coverage, 3980,
     /*  36159 */     GIR_EraseRootFromParent_Done,
     /*  36160 */   // Label 814: @36160
     /*  36160 */   GIM_Reject,
     /*  36161 */ // Label 812: @36161
     /*  36161 */ GIM_Reject,
     /*  36162 */ // Label 805: @36162
     /*  36162 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36249),
     /*  36167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36170 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36193), // Rule ID 1702 //
     /*  36175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36186 */     // (fround:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  36191 */     GIR_RootConstrainSelectedInstOperands,
     /*  36192 */     // GIR_Coverage, 1702,
     /*  36192 */     GIR_Done,
     /*  36193 */   // Label 816: @36193
     /*  36193 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36248), // Rule ID 3968 //
     /*  36198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36209 */     // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36226 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36246 */     GIR_RootConstrainSelectedInstOperands,
     /*  36247 */     // GIR_Coverage, 3968,
     /*  36247 */     GIR_EraseRootFromParent_Done,
     /*  36248 */   // Label 817: @36248
     /*  36248 */   GIM_Reject,
     /*  36249 */ // Label 815: @36249
     /*  36249 */ GIM_Reject,
     /*  36250 */ // Label 806: @36250
     /*  36250 */ GIM_Reject,
     /*  36251 */ // Label 12: @36251
     /*  36251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 823*/ GIMT_Encode4(36513),
     /*  36262 */ /*GILLT_s16*//*Label 818*/ GIMT_Encode4(36314),
     /*  36266 */ /*GILLT_s32*//*Label 819*/ GIMT_Encode4(36341),
     /*  36270 */ /*GILLT_s64*//*Label 820*/ GIMT_Encode4(36368), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36294 */ /*GILLT_v4s32*//*Label 821*/ GIMT_Encode4(36395), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36310 */ /*GILLT_v8s16*//*Label 822*/ GIMT_Encode4(36454),
     /*  36314 */ // Label 818: @36314
     /*  36314 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36340), // Rule ID 678 //
     /*  36319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36333 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36338 */   GIR_RootConstrainSelectedInstOperands,
     /*  36339 */   // GIR_Coverage, 678,
     /*  36339 */   GIR_Done,
     /*  36340 */ // Label 824: @36340
     /*  36340 */ GIM_Reject,
     /*  36341 */ // Label 819: @36341
     /*  36341 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36367), // Rule ID 680 //
     /*  36346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36360 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36365 */   GIR_RootConstrainSelectedInstOperands,
     /*  36366 */   // GIR_Coverage, 680,
     /*  36366 */   GIR_Done,
     /*  36367 */ // Label 825: @36367
     /*  36367 */ GIM_Reject,
     /*  36368 */ // Label 820: @36368
     /*  36368 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36394), // Rule ID 682 //
     /*  36373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36387 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36392 */   GIR_RootConstrainSelectedInstOperands,
     /*  36393 */   // GIR_Coverage, 682,
     /*  36393 */   GIR_Done,
     /*  36394 */ // Label 826: @36394
     /*  36394 */ GIM_Reject,
     /*  36395 */ // Label 821: @36395
     /*  36395 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36453), // Rule ID 3976 //
     /*  36400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36414 */   // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36431 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36436 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36442 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36451 */   GIR_RootConstrainSelectedInstOperands,
     /*  36452 */   // GIR_Coverage, 3976,
     /*  36452 */   GIR_EraseRootFromParent_Done,
     /*  36453 */ // Label 827: @36453
     /*  36453 */ GIM_Reject,
     /*  36454 */ // Label 822: @36454
     /*  36454 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36512), // Rule ID 3964 //
     /*  36459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36473 */   // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36490 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36510 */   GIR_RootConstrainSelectedInstOperands,
     /*  36511 */   // GIR_Coverage, 3964,
     /*  36511 */   GIR_EraseRootFromParent_Done,
     /*  36512 */ // Label 828: @36512
     /*  36512 */ GIM_Reject,
     /*  36513 */ // Label 823: @36513
     /*  36513 */ GIM_Reject,
     /*  36514 */ // Label 13: @36514
     /*  36514 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(36676),
     /*  36519 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36525 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(36600), // Rule ID 2053 //
     /*  36530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36544 */     // MIs[0] Rn
     /*  36544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36552 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36564 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36576 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36598 */     GIR_RootConstrainSelectedInstOperands,
     /*  36599 */     // GIR_Coverage, 2053,
     /*  36599 */     GIR_EraseRootFromParent_Done,
     /*  36600 */   // Label 830: @36600
     /*  36600 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(36675), // Rule ID 2054 //
     /*  36605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36619 */     // MIs[0] Rn
     /*  36619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36627 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36639 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36651 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36673 */     GIR_RootConstrainSelectedInstOperands,
     /*  36674 */     // GIR_Coverage, 2054,
     /*  36674 */     GIR_EraseRootFromParent_Done,
     /*  36675 */   // Label 831: @36675
     /*  36675 */   GIM_Reject,
     /*  36676 */ // Label 829: @36676
     /*  36676 */ GIM_Reject,
     /*  36677 */ // Label 14: @36677
     /*  36677 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(36697), // Rule ID 5421 //
     /*  36682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36685 */   // MIs[0] Operand 0
     /*  36685 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36688 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36692 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36695 */   GIR_RootConstrainSelectedInstOperands,
     /*  36696 */   // GIR_Coverage, 5421,
     /*  36696 */   GIR_EraseRootFromParent_Done,
     /*  36697 */ // Label 832: @36697
     /*  36697 */ GIM_Reject,
     /*  36698 */ // Label 15: @36698
     /*  36698 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(41949),
     /*  36703 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36706 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36754), // Rule ID 1856 //
     /*  36711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36733 */     // (intrinsic_wo_chain:{ *:[i32] } 3946:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36752 */     GIR_RootConstrainSelectedInstOperands,
     /*  36753 */     // GIR_Coverage, 1856,
     /*  36753 */     GIR_EraseRootFromParent_Done,
     /*  36754 */   // Label 834: @36754
     /*  36754 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(36802), // Rule ID 2110 //
     /*  36759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36781 */     // (intrinsic_wo_chain:{ *:[i32] } 3946:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36800 */     GIR_RootConstrainSelectedInstOperands,
     /*  36801 */     // GIR_Coverage, 2110,
     /*  36801 */     GIR_EraseRootFromParent_Done,
     /*  36802 */   // Label 835: @36802
     /*  36802 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(36838), // Rule ID 677 //
     /*  36807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36829 */     // (intrinsic_wo_chain:{ *:[f16] } 3833:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36836 */     GIR_RootConstrainSelectedInstOperands,
     /*  36837 */     // GIR_Coverage, 677,
     /*  36837 */     GIR_EraseRootFromParent_Done,
     /*  36838 */   // Label 836: @36838
     /*  36838 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(36874), // Rule ID 679 //
     /*  36843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36865 */     // (intrinsic_wo_chain:{ *:[f32] } 3833:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36872 */     GIR_RootConstrainSelectedInstOperands,
     /*  36873 */     // GIR_Coverage, 679,
     /*  36873 */     GIR_EraseRootFromParent_Done,
     /*  36874 */   // Label 837: @36874
     /*  36874 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(36910), // Rule ID 681 //
     /*  36879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36901 */     // (intrinsic_wo_chain:{ *:[f64] } 3833:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36908 */     GIR_RootConstrainSelectedInstOperands,
     /*  36909 */     // GIR_Coverage, 681,
     /*  36909 */     GIR_EraseRootFromParent_Done,
     /*  36910 */   // Label 838: @36910
     /*  36910 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(36955), // Rule ID 696 //
     /*  36915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36937 */     // (intrinsic_wo_chain:{ *:[f32] } 3947:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36953 */     GIR_RootConstrainSelectedInstOperands,
     /*  36954 */     // GIR_Coverage, 696,
     /*  36954 */     GIR_EraseRootFromParent_Done,
     /*  36955 */   // Label 839: @36955
     /*  36955 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37000), // Rule ID 697 //
     /*  36960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36982 */     // (intrinsic_wo_chain:{ *:[f32] } 3947:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36998 */     GIR_RootConstrainSelectedInstOperands,
     /*  36999 */     // GIR_Coverage, 697,
     /*  36999 */     GIR_EraseRootFromParent_Done,
     /*  37000 */   // Label 840: @37000
     /*  37000 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37045), // Rule ID 698 //
     /*  37005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37027 */     // (intrinsic_wo_chain:{ *:[f32] } 3948:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  37030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37043 */     GIR_RootConstrainSelectedInstOperands,
     /*  37044 */     // GIR_Coverage, 698,
     /*  37044 */     GIR_EraseRootFromParent_Done,
     /*  37045 */   // Label 841: @37045
     /*  37045 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37090), // Rule ID 699 //
     /*  37050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37072 */     // (intrinsic_wo_chain:{ *:[f32] } 3948:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  37075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37088 */     GIR_RootConstrainSelectedInstOperands,
     /*  37089 */     // GIR_Coverage, 699,
     /*  37089 */     GIR_EraseRootFromParent_Done,
     /*  37090 */   // Label 842: @37090
     /*  37090 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37135), // Rule ID 1242 //
     /*  37095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37133 */     GIR_RootConstrainSelectedInstOperands,
     /*  37134 */     // GIR_Coverage, 1242,
     /*  37134 */     GIR_EraseRootFromParent_Done,
     /*  37135 */   // Label 843: @37135
     /*  37135 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37180), // Rule ID 1243 //
     /*  37140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37162 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37178 */     GIR_RootConstrainSelectedInstOperands,
     /*  37179 */     // GIR_Coverage, 1243,
     /*  37179 */     GIR_EraseRootFromParent_Done,
     /*  37180 */   // Label 844: @37180
     /*  37180 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37225), // Rule ID 1244 //
     /*  37185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37207 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3801:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37223 */     GIR_RootConstrainSelectedInstOperands,
     /*  37224 */     // GIR_Coverage, 1244,
     /*  37224 */     GIR_EraseRootFromParent_Done,
     /*  37225 */   // Label 845: @37225
     /*  37225 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37270), // Rule ID 1245 //
     /*  37230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37252 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3801:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37268 */     GIR_RootConstrainSelectedInstOperands,
     /*  37269 */     // GIR_Coverage, 1245,
     /*  37269 */     GIR_EraseRootFromParent_Done,
     /*  37270 */   // Label 846: @37270
     /*  37270 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37315), // Rule ID 1246 //
     /*  37275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3801:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37313 */     GIR_RootConstrainSelectedInstOperands,
     /*  37314 */     // GIR_Coverage, 1246,
     /*  37314 */     GIR_EraseRootFromParent_Done,
     /*  37315 */   // Label 847: @37315
     /*  37315 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37360), // Rule ID 1247 //
     /*  37320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37342 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3801:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37358 */     GIR_RootConstrainSelectedInstOperands,
     /*  37359 */     // GIR_Coverage, 1247,
     /*  37359 */     GIR_EraseRootFromParent_Done,
     /*  37360 */   // Label 848: @37360
     /*  37360 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37405), // Rule ID 1248 //
     /*  37365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37387 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37403 */     GIR_RootConstrainSelectedInstOperands,
     /*  37404 */     // GIR_Coverage, 1248,
     /*  37404 */     GIR_EraseRootFromParent_Done,
     /*  37405 */   // Label 849: @37405
     /*  37405 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37450), // Rule ID 1249 //
     /*  37410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37432 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37448 */     GIR_RootConstrainSelectedInstOperands,
     /*  37449 */     // GIR_Coverage, 1249,
     /*  37449 */     GIR_EraseRootFromParent_Done,
     /*  37450 */   // Label 850: @37450
     /*  37450 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37495), // Rule ID 1250 //
     /*  37455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37477 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37493 */     GIR_RootConstrainSelectedInstOperands,
     /*  37494 */     // GIR_Coverage, 1250,
     /*  37494 */     GIR_EraseRootFromParent_Done,
     /*  37495 */   // Label 851: @37495
     /*  37495 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37540), // Rule ID 1251 //
     /*  37500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37522 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3802:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37538 */     GIR_RootConstrainSelectedInstOperands,
     /*  37539 */     // GIR_Coverage, 1251,
     /*  37539 */     GIR_EraseRootFromParent_Done,
     /*  37540 */   // Label 852: @37540
     /*  37540 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37585), // Rule ID 1252 //
     /*  37545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37567 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3802:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37583 */     GIR_RootConstrainSelectedInstOperands,
     /*  37584 */     // GIR_Coverage, 1252,
     /*  37584 */     GIR_EraseRootFromParent_Done,
     /*  37585 */   // Label 853: @37585
     /*  37585 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37630), // Rule ID 1253 //
     /*  37590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37612 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3802:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37628 */     GIR_RootConstrainSelectedInstOperands,
     /*  37629 */     // GIR_Coverage, 1253,
     /*  37629 */     GIR_EraseRootFromParent_Done,
     /*  37630 */   // Label 854: @37630
     /*  37630 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37675), // Rule ID 1282 //
     /*  37635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37657 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37673 */     GIR_RootConstrainSelectedInstOperands,
     /*  37674 */     // GIR_Coverage, 1282,
     /*  37674 */     GIR_EraseRootFromParent_Done,
     /*  37675 */   // Label 855: @37675
     /*  37675 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37720), // Rule ID 1283 //
     /*  37680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37702 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37718 */     GIR_RootConstrainSelectedInstOperands,
     /*  37719 */     // GIR_Coverage, 1283,
     /*  37719 */     GIR_EraseRootFromParent_Done,
     /*  37720 */   // Label 856: @37720
     /*  37720 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(37765), // Rule ID 1284 //
     /*  37725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37747 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37763 */     GIR_RootConstrainSelectedInstOperands,
     /*  37764 */     // GIR_Coverage, 1284,
     /*  37764 */     GIR_EraseRootFromParent_Done,
     /*  37765 */   // Label 857: @37765
     /*  37765 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(37810), // Rule ID 1285 //
     /*  37770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37792 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37808 */     GIR_RootConstrainSelectedInstOperands,
     /*  37809 */     // GIR_Coverage, 1285,
     /*  37809 */     GIR_EraseRootFromParent_Done,
     /*  37810 */   // Label 858: @37810
     /*  37810 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(37855), // Rule ID 1286 //
     /*  37815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3829:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37853 */     GIR_RootConstrainSelectedInstOperands,
     /*  37854 */     // GIR_Coverage, 1286,
     /*  37854 */     GIR_EraseRootFromParent_Done,
     /*  37855 */   // Label 859: @37855
     /*  37855 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(37900), // Rule ID 1287 //
     /*  37860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3829:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37898 */     GIR_RootConstrainSelectedInstOperands,
     /*  37899 */     // GIR_Coverage, 1287,
     /*  37899 */     GIR_EraseRootFromParent_Done,
     /*  37900 */   // Label 860: @37900
     /*  37900 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(37945), // Rule ID 1292 //
     /*  37905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37927 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3839:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37943 */     GIR_RootConstrainSelectedInstOperands,
     /*  37944 */     // GIR_Coverage, 1292,
     /*  37944 */     GIR_EraseRootFromParent_Done,
     /*  37945 */   // Label 861: @37945
     /*  37945 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(37990), // Rule ID 1293 //
     /*  37950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3839:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37988 */     GIR_RootConstrainSelectedInstOperands,
     /*  37989 */     // GIR_Coverage, 1293,
     /*  37989 */     GIR_EraseRootFromParent_Done,
     /*  37990 */   // Label 862: @37990
     /*  37990 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38035), // Rule ID 1294 //
     /*  37995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38017 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3839:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  38017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  38020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38033 */     GIR_RootConstrainSelectedInstOperands,
     /*  38034 */     // GIR_Coverage, 1294,
     /*  38034 */     GIR_EraseRootFromParent_Done,
     /*  38035 */   // Label 863: @38035
     /*  38035 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38080), // Rule ID 1295 //
     /*  38040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38062 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3839:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  38062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  38065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38078 */     GIR_RootConstrainSelectedInstOperands,
     /*  38079 */     // GIR_Coverage, 1295,
     /*  38079 */     GIR_EraseRootFromParent_Done,
     /*  38080 */   // Label 864: @38080
     /*  38080 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38125), // Rule ID 1296 //
     /*  38085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38107 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3839:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  38107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  38110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38123 */     GIR_RootConstrainSelectedInstOperands,
     /*  38124 */     // GIR_Coverage, 1296,
     /*  38124 */     GIR_EraseRootFromParent_Done,
     /*  38125 */   // Label 865: @38125
     /*  38125 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38170), // Rule ID 1297 //
     /*  38130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38152 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3839:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38168 */     GIR_RootConstrainSelectedInstOperands,
     /*  38169 */     // GIR_Coverage, 1297,
     /*  38169 */     GIR_EraseRootFromParent_Done,
     /*  38170 */   // Label 866: @38170
     /*  38170 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38215), // Rule ID 1518 //
     /*  38175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3807:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38213 */     GIR_RootConstrainSelectedInstOperands,
     /*  38214 */     // GIR_Coverage, 1518,
     /*  38214 */     GIR_EraseRootFromParent_Done,
     /*  38215 */   // Label 867: @38215
     /*  38215 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38260), // Rule ID 1519 //
     /*  38220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38242 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38258 */     GIR_RootConstrainSelectedInstOperands,
     /*  38259 */     // GIR_Coverage, 1519,
     /*  38259 */     GIR_EraseRootFromParent_Done,
     /*  38260 */   // Label 868: @38260
     /*  38260 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38305), // Rule ID 1520 //
     /*  38265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38287 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38303 */     GIR_RootConstrainSelectedInstOperands,
     /*  38304 */     // GIR_Coverage, 1520,
     /*  38304 */     GIR_EraseRootFromParent_Done,
     /*  38305 */   // Label 869: @38305
     /*  38305 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38350), // Rule ID 1521 //
     /*  38310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38332 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3807:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38348 */     GIR_RootConstrainSelectedInstOperands,
     /*  38349 */     // GIR_Coverage, 1521,
     /*  38349 */     GIR_EraseRootFromParent_Done,
     /*  38350 */   // Label 870: @38350
     /*  38350 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38395), // Rule ID 1522 //
     /*  38355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38377 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3807:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38393 */     GIR_RootConstrainSelectedInstOperands,
     /*  38394 */     // GIR_Coverage, 1522,
     /*  38394 */     GIR_EraseRootFromParent_Done,
     /*  38395 */   // Label 871: @38395
     /*  38395 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38440), // Rule ID 1523 //
     /*  38400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38438 */     GIR_RootConstrainSelectedInstOperands,
     /*  38439 */     // GIR_Coverage, 1523,
     /*  38439 */     GIR_EraseRootFromParent_Done,
     /*  38440 */   // Label 872: @38440
     /*  38440 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38485), // Rule ID 1534 //
     /*  38445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38467 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3813:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38483 */     GIR_RootConstrainSelectedInstOperands,
     /*  38484 */     // GIR_Coverage, 1534,
     /*  38484 */     GIR_EraseRootFromParent_Done,
     /*  38485 */   // Label 873: @38485
     /*  38485 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38530), // Rule ID 1535 //
     /*  38490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38512 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38528 */     GIR_RootConstrainSelectedInstOperands,
     /*  38529 */     // GIR_Coverage, 1535,
     /*  38529 */     GIR_EraseRootFromParent_Done,
     /*  38530 */   // Label 874: @38530
     /*  38530 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38575), // Rule ID 1536 //
     /*  38535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38557 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38573 */     GIR_RootConstrainSelectedInstOperands,
     /*  38574 */     // GIR_Coverage, 1536,
     /*  38574 */     GIR_EraseRootFromParent_Done,
     /*  38575 */   // Label 875: @38575
     /*  38575 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38620), // Rule ID 1537 //
     /*  38580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38602 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3813:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38618 */     GIR_RootConstrainSelectedInstOperands,
     /*  38619 */     // GIR_Coverage, 1537,
     /*  38619 */     GIR_EraseRootFromParent_Done,
     /*  38620 */   // Label 876: @38620
     /*  38620 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38665), // Rule ID 1538 //
     /*  38625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3813:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38663 */     GIR_RootConstrainSelectedInstOperands,
     /*  38664 */     // GIR_Coverage, 1538,
     /*  38664 */     GIR_EraseRootFromParent_Done,
     /*  38665 */   // Label 877: @38665
     /*  38665 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38710), // Rule ID 1539 //
     /*  38670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38708 */     GIR_RootConstrainSelectedInstOperands,
     /*  38709 */     // GIR_Coverage, 1539,
     /*  38709 */     GIR_EraseRootFromParent_Done,
     /*  38710 */   // Label 878: @38710
     /*  38710 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(38755), // Rule ID 1540 //
     /*  38715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38737 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3754:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38753 */     GIR_RootConstrainSelectedInstOperands,
     /*  38754 */     // GIR_Coverage, 1540,
     /*  38754 */     GIR_EraseRootFromParent_Done,
     /*  38755 */   // Label 879: @38755
     /*  38755 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(38800), // Rule ID 1541 //
     /*  38760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38782 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38798 */     GIR_RootConstrainSelectedInstOperands,
     /*  38799 */     // GIR_Coverage, 1541,
     /*  38799 */     GIR_EraseRootFromParent_Done,
     /*  38800 */   // Label 880: @38800
     /*  38800 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(38845), // Rule ID 1542 //
     /*  38805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38827 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38843 */     GIR_RootConstrainSelectedInstOperands,
     /*  38844 */     // GIR_Coverage, 1542,
     /*  38844 */     GIR_EraseRootFromParent_Done,
     /*  38845 */   // Label 881: @38845
     /*  38845 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(38890), // Rule ID 1543 //
     /*  38850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3754:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38888 */     GIR_RootConstrainSelectedInstOperands,
     /*  38889 */     // GIR_Coverage, 1543,
     /*  38889 */     GIR_EraseRootFromParent_Done,
     /*  38890 */   // Label 882: @38890
     /*  38890 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(38935), // Rule ID 1544 //
     /*  38895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38917 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38933 */     GIR_RootConstrainSelectedInstOperands,
     /*  38934 */     // GIR_Coverage, 1544,
     /*  38934 */     GIR_EraseRootFromParent_Done,
     /*  38935 */   // Label 883: @38935
     /*  38935 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(38980), // Rule ID 1545 //
     /*  38940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38962 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38978 */     GIR_RootConstrainSelectedInstOperands,
     /*  38979 */     // GIR_Coverage, 1545,
     /*  38979 */     GIR_EraseRootFromParent_Done,
     /*  38980 */   // Label 884: @38980
     /*  38980 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39025), // Rule ID 1589 //
     /*  38985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39007 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  39010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39023 */     GIR_RootConstrainSelectedInstOperands,
     /*  39024 */     // GIR_Coverage, 1589,
     /*  39024 */     GIR_EraseRootFromParent_Done,
     /*  39025 */   // Label 885: @39025
     /*  39025 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39070), // Rule ID 1590 //
     /*  39030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39052 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  39055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39068 */     GIR_RootConstrainSelectedInstOperands,
     /*  39069 */     // GIR_Coverage, 1590,
     /*  39069 */     GIR_EraseRootFromParent_Done,
     /*  39070 */   // Label 886: @39070
     /*  39070 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39115), // Rule ID 1591 //
     /*  39075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39097 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  39100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39113 */     GIR_RootConstrainSelectedInstOperands,
     /*  39114 */     // GIR_Coverage, 1591,
     /*  39114 */     GIR_EraseRootFromParent_Done,
     /*  39115 */   // Label 887: @39115
     /*  39115 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39160), // Rule ID 1592 //
     /*  39120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39142 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3812:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39158 */     GIR_RootConstrainSelectedInstOperands,
     /*  39159 */     // GIR_Coverage, 1592,
     /*  39159 */     GIR_EraseRootFromParent_Done,
     /*  39160 */   // Label 888: @39160
     /*  39160 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39205), // Rule ID 1593 //
     /*  39165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39187 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3812:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39203 */     GIR_RootConstrainSelectedInstOperands,
     /*  39204 */     // GIR_Coverage, 1593,
     /*  39204 */     GIR_EraseRootFromParent_Done,
     /*  39205 */   // Label 889: @39205
     /*  39205 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39250), // Rule ID 1594 //
     /*  39210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39232 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3812:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39248 */     GIR_RootConstrainSelectedInstOperands,
     /*  39249 */     // GIR_Coverage, 1594,
     /*  39249 */     GIR_EraseRootFromParent_Done,
     /*  39250 */   // Label 890: @39250
     /*  39250 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39295), // Rule ID 1595 //
     /*  39255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39277 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3811:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39293 */     GIR_RootConstrainSelectedInstOperands,
     /*  39294 */     // GIR_Coverage, 1595,
     /*  39294 */     GIR_EraseRootFromParent_Done,
     /*  39295 */   // Label 891: @39295
     /*  39295 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39340), // Rule ID 1596 //
     /*  39300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39322 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39338 */     GIR_RootConstrainSelectedInstOperands,
     /*  39339 */     // GIR_Coverage, 1596,
     /*  39339 */     GIR_EraseRootFromParent_Done,
     /*  39340 */   // Label 892: @39340
     /*  39340 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39385), // Rule ID 1597 //
     /*  39345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39367 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39383 */     GIR_RootConstrainSelectedInstOperands,
     /*  39384 */     // GIR_Coverage, 1597,
     /*  39384 */     GIR_EraseRootFromParent_Done,
     /*  39385 */   // Label 893: @39385
     /*  39385 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39421), // Rule ID 1620 //
     /*  39390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39412 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3755:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39419 */     GIR_RootConstrainSelectedInstOperands,
     /*  39420 */     // GIR_Coverage, 1620,
     /*  39420 */     GIR_EraseRootFromParent_Done,
     /*  39421 */   // Label 894: @39421
     /*  39421 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39457), // Rule ID 1621 //
     /*  39426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3755:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39455 */     GIR_RootConstrainSelectedInstOperands,
     /*  39456 */     // GIR_Coverage, 1621,
     /*  39456 */     GIR_EraseRootFromParent_Done,
     /*  39457 */   // Label 895: @39457
     /*  39457 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39493), // Rule ID 1622 //
     /*  39462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39484 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3756:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39491 */     GIR_RootConstrainSelectedInstOperands,
     /*  39492 */     // GIR_Coverage, 1622,
     /*  39492 */     GIR_EraseRootFromParent_Done,
     /*  39493 */   // Label 896: @39493
     /*  39493 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39529), // Rule ID 1623 //
     /*  39498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39520 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3756:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39527 */     GIR_RootConstrainSelectedInstOperands,
     /*  39528 */     // GIR_Coverage, 1623,
     /*  39528 */     GIR_EraseRootFromParent_Done,
     /*  39529 */   // Label 897: @39529
     /*  39529 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39565), // Rule ID 1624 //
     /*  39534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39556 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3755:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39563 */     GIR_RootConstrainSelectedInstOperands,
     /*  39564 */     // GIR_Coverage, 1624,
     /*  39564 */     GIR_EraseRootFromParent_Done,
     /*  39565 */   // Label 898: @39565
     /*  39565 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39601), // Rule ID 1625 //
     /*  39570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3755:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39599 */     GIR_RootConstrainSelectedInstOperands,
     /*  39600 */     // GIR_Coverage, 1625,
     /*  39600 */     GIR_EraseRootFromParent_Done,
     /*  39601 */   // Label 899: @39601
     /*  39601 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39637), // Rule ID 1626 //
     /*  39606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39628 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3756:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39635 */     GIR_RootConstrainSelectedInstOperands,
     /*  39636 */     // GIR_Coverage, 1626,
     /*  39636 */     GIR_EraseRootFromParent_Done,
     /*  39637 */   // Label 900: @39637
     /*  39637 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39673), // Rule ID 1627 //
     /*  39642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3756:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39671 */     GIR_RootConstrainSelectedInstOperands,
     /*  39672 */     // GIR_Coverage, 1627,
     /*  39672 */     GIR_EraseRootFromParent_Done,
     /*  39673 */   // Label 901: @39673
     /*  39673 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39709), // Rule ID 1628 //
     /*  39678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39700 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39707 */     GIR_RootConstrainSelectedInstOperands,
     /*  39708 */     // GIR_Coverage, 1628,
     /*  39708 */     GIR_EraseRootFromParent_Done,
     /*  39709 */   // Label 902: @39709
     /*  39709 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39745), // Rule ID 1629 //
     /*  39714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39743 */     GIR_RootConstrainSelectedInstOperands,
     /*  39744 */     // GIR_Coverage, 1629,
     /*  39744 */     GIR_EraseRootFromParent_Done,
     /*  39745 */   // Label 903: @39745
     /*  39745 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39781), // Rule ID 1630 //
     /*  39750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39772 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39779 */     GIR_RootConstrainSelectedInstOperands,
     /*  39780 */     // GIR_Coverage, 1630,
     /*  39780 */     GIR_EraseRootFromParent_Done,
     /*  39781 */   // Label 904: @39781
     /*  39781 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39817), // Rule ID 1631 //
     /*  39786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39815 */     GIR_RootConstrainSelectedInstOperands,
     /*  39816 */     // GIR_Coverage, 1631,
     /*  39816 */     GIR_EraseRootFromParent_Done,
     /*  39817 */   // Label 905: @39817
     /*  39817 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(39853), // Rule ID 1632 //
     /*  39822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39844 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39851 */     GIR_RootConstrainSelectedInstOperands,
     /*  39852 */     // GIR_Coverage, 1632,
     /*  39852 */     GIR_EraseRootFromParent_Done,
     /*  39853 */   // Label 906: @39853
     /*  39853 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(39889), // Rule ID 1633 //
     /*  39858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39880 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39887 */     GIR_RootConstrainSelectedInstOperands,
     /*  39888 */     // GIR_Coverage, 1633,
     /*  39888 */     GIR_EraseRootFromParent_Done,
     /*  39889 */   // Label 907: @39889
     /*  39889 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(39925), // Rule ID 1634 //
     /*  39894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39916 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39923 */     GIR_RootConstrainSelectedInstOperands,
     /*  39924 */     // GIR_Coverage, 1634,
     /*  39924 */     GIR_EraseRootFromParent_Done,
     /*  39925 */   // Label 908: @39925
     /*  39925 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(39961), // Rule ID 1635 //
     /*  39930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39959 */     GIR_RootConstrainSelectedInstOperands,
     /*  39960 */     // GIR_Coverage, 1635,
     /*  39960 */     GIR_EraseRootFromParent_Done,
     /*  39961 */   // Label 909: @39961
     /*  39961 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(39997), // Rule ID 1636 //
     /*  39966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39988 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39995 */     GIR_RootConstrainSelectedInstOperands,
     /*  39996 */     // GIR_Coverage, 1636,
     /*  39996 */     GIR_EraseRootFromParent_Done,
     /*  39997 */   // Label 910: @39997
     /*  39997 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40033), // Rule ID 1637 //
     /*  40002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40024 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3769:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  40027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40031 */     GIR_RootConstrainSelectedInstOperands,
     /*  40032 */     // GIR_Coverage, 1637,
     /*  40032 */     GIR_EraseRootFromParent_Done,
     /*  40033 */   // Label 911: @40033
     /*  40033 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40069), // Rule ID 1638 //
     /*  40038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40060 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  40063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40067 */     GIR_RootConstrainSelectedInstOperands,
     /*  40068 */     // GIR_Coverage, 1638,
     /*  40068 */     GIR_EraseRootFromParent_Done,
     /*  40069 */   // Label 912: @40069
     /*  40069 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40105), // Rule ID 1639 //
     /*  40074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  40099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40103 */     GIR_RootConstrainSelectedInstOperands,
     /*  40104 */     // GIR_Coverage, 1639,
     /*  40104 */     GIR_EraseRootFromParent_Done,
     /*  40105 */   // Label 913: @40105
     /*  40105 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40141), // Rule ID 1640 //
     /*  40110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40132 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40139 */     GIR_RootConstrainSelectedInstOperands,
     /*  40140 */     // GIR_Coverage, 1640,
     /*  40140 */     GIR_EraseRootFromParent_Done,
     /*  40141 */   // Label 914: @40141
     /*  40141 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40177), // Rule ID 1641 //
     /*  40146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3769:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40175 */     GIR_RootConstrainSelectedInstOperands,
     /*  40176 */     // GIR_Coverage, 1641,
     /*  40176 */     GIR_EraseRootFromParent_Done,
     /*  40177 */   // Label 915: @40177
     /*  40177 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40213), // Rule ID 1642 //
     /*  40182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40204 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40211 */     GIR_RootConstrainSelectedInstOperands,
     /*  40212 */     // GIR_Coverage, 1642,
     /*  40212 */     GIR_EraseRootFromParent_Done,
     /*  40213 */   // Label 916: @40213
     /*  40213 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40249), // Rule ID 1643 //
     /*  40218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40240 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40247 */     GIR_RootConstrainSelectedInstOperands,
     /*  40248 */     // GIR_Coverage, 1643,
     /*  40248 */     GIR_EraseRootFromParent_Done,
     /*  40249 */   // Label 917: @40249
     /*  40249 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40285), // Rule ID 1644 //
     /*  40254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40276 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3765:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40283 */     GIR_RootConstrainSelectedInstOperands,
     /*  40284 */     // GIR_Coverage, 1644,
     /*  40284 */     GIR_EraseRootFromParent_Done,
     /*  40285 */   // Label 918: @40285
     /*  40285 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40321), // Rule ID 1645 //
     /*  40290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3765:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40319 */     GIR_RootConstrainSelectedInstOperands,
     /*  40320 */     // GIR_Coverage, 1645,
     /*  40320 */     GIR_EraseRootFromParent_Done,
     /*  40321 */   // Label 919: @40321
     /*  40321 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40357), // Rule ID 1646 //
     /*  40326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3766:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40355 */     GIR_RootConstrainSelectedInstOperands,
     /*  40356 */     // GIR_Coverage, 1646,
     /*  40356 */     GIR_EraseRootFromParent_Done,
     /*  40357 */   // Label 920: @40357
     /*  40357 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40393), // Rule ID 1647 //
     /*  40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3766:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40391 */     GIR_RootConstrainSelectedInstOperands,
     /*  40392 */     // GIR_Coverage, 1647,
     /*  40392 */     GIR_EraseRootFromParent_Done,
     /*  40393 */   // Label 921: @40393
     /*  40393 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40429), // Rule ID 1648 //
     /*  40398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40420 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3765:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40427 */     GIR_RootConstrainSelectedInstOperands,
     /*  40428 */     // GIR_Coverage, 1648,
     /*  40428 */     GIR_EraseRootFromParent_Done,
     /*  40429 */   // Label 922: @40429
     /*  40429 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40465), // Rule ID 1649 //
     /*  40434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3765:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40463 */     GIR_RootConstrainSelectedInstOperands,
     /*  40464 */     // GIR_Coverage, 1649,
     /*  40464 */     GIR_EraseRootFromParent_Done,
     /*  40465 */   // Label 923: @40465
     /*  40465 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40501), // Rule ID 1650 //
     /*  40470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40492 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3766:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40499 */     GIR_RootConstrainSelectedInstOperands,
     /*  40500 */     // GIR_Coverage, 1650,
     /*  40500 */     GIR_EraseRootFromParent_Done,
     /*  40501 */   // Label 924: @40501
     /*  40501 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40537), // Rule ID 1651 //
     /*  40506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40528 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3766:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40535 */     GIR_RootConstrainSelectedInstOperands,
     /*  40536 */     // GIR_Coverage, 1651,
     /*  40536 */     GIR_EraseRootFromParent_Done,
     /*  40537 */   // Label 925: @40537
     /*  40537 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40582), // Rule ID 1668 //
     /*  40542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40564 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3761:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40580 */     GIR_RootConstrainSelectedInstOperands,
     /*  40581 */     // GIR_Coverage, 1668,
     /*  40581 */     GIR_EraseRootFromParent_Done,
     /*  40582 */   // Label 926: @40582
     /*  40582 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40627), // Rule ID 1669 //
     /*  40587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40609 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3764:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40625 */     GIR_RootConstrainSelectedInstOperands,
     /*  40626 */     // GIR_Coverage, 1669,
     /*  40626 */     GIR_EraseRootFromParent_Done,
     /*  40627 */   // Label 927: @40627
     /*  40627 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40663), // Rule ID 1691 //
     /*  40632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40654 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3833:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40661 */     GIR_RootConstrainSelectedInstOperands,
     /*  40662 */     // GIR_Coverage, 1691,
     /*  40662 */     GIR_EraseRootFromParent_Done,
     /*  40663 */   // Label 928: @40663
     /*  40663 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40699), // Rule ID 1692 //
     /*  40668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40690 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3833:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40697 */     GIR_RootConstrainSelectedInstOperands,
     /*  40698 */     // GIR_Coverage, 1692,
     /*  40698 */     GIR_EraseRootFromParent_Done,
     /*  40699 */   // Label 929: @40699
     /*  40699 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40735), // Rule ID 1693 //
     /*  40704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40726 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3833:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40733 */     GIR_RootConstrainSelectedInstOperands,
     /*  40734 */     // GIR_Coverage, 1693,
     /*  40734 */     GIR_EraseRootFromParent_Done,
     /*  40735 */   // Label 930: @40735
     /*  40735 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40771), // Rule ID 1694 //
     /*  40740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40762 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3833:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40769 */     GIR_RootConstrainSelectedInstOperands,
     /*  40770 */     // GIR_Coverage, 1694,
     /*  40770 */     GIR_EraseRootFromParent_Done,
     /*  40771 */   // Label 931: @40771
     /*  40771 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40807), // Rule ID 1695 //
     /*  40776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40798 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40805 */     GIR_RootConstrainSelectedInstOperands,
     /*  40806 */     // GIR_Coverage, 1695,
     /*  40806 */     GIR_EraseRootFromParent_Done,
     /*  40807 */   // Label 932: @40807
     /*  40807 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(40843), // Rule ID 1696 //
     /*  40812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40834 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40841 */     GIR_RootConstrainSelectedInstOperands,
     /*  40842 */     // GIR_Coverage, 1696,
     /*  40842 */     GIR_EraseRootFromParent_Done,
     /*  40843 */   // Label 933: @40843
     /*  40843 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(40879), // Rule ID 1697 //
     /*  40848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40870 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3834:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40877 */     GIR_RootConstrainSelectedInstOperands,
     /*  40878 */     // GIR_Coverage, 1697,
     /*  40878 */     GIR_EraseRootFromParent_Done,
     /*  40879 */   // Label 934: @40879
     /*  40879 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(40915), // Rule ID 1698 //
     /*  40884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40906 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3834:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40913 */     GIR_RootConstrainSelectedInstOperands,
     /*  40914 */     // GIR_Coverage, 1698,
     /*  40914 */     GIR_EraseRootFromParent_Done,
     /*  40915 */   // Label 935: @40915
     /*  40915 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(40951), // Rule ID 1703 //
     /*  40920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40942 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3835:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40949 */     GIR_RootConstrainSelectedInstOperands,
     /*  40950 */     // GIR_Coverage, 1703,
     /*  40950 */     GIR_EraseRootFromParent_Done,
     /*  40951 */   // Label 936: @40951
     /*  40951 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(40987), // Rule ID 1704 //
     /*  40956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40978 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3835:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  40981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40985 */     GIR_RootConstrainSelectedInstOperands,
     /*  40986 */     // GIR_Coverage, 1704,
     /*  40986 */     GIR_EraseRootFromParent_Done,
     /*  40987 */   // Label 937: @40987
     /*  40987 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41023), // Rule ID 1705 //
     /*  40992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41014 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3835:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  41017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41021 */     GIR_RootConstrainSelectedInstOperands,
     /*  41022 */     // GIR_Coverage, 1705,
     /*  41022 */     GIR_EraseRootFromParent_Done,
     /*  41023 */   // Label 938: @41023
     /*  41023 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41059), // Rule ID 1706 //
     /*  41028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41050 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3835:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  41053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41057 */     GIR_RootConstrainSelectedInstOperands,
     /*  41058 */     // GIR_Coverage, 1706,
     /*  41058 */     GIR_EraseRootFromParent_Done,
     /*  41059 */   // Label 939: @41059
     /*  41059 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41095), // Rule ID 1717 //
     /*  41064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41086 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3724:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41093 */     GIR_RootConstrainSelectedInstOperands,
     /*  41094 */     // GIR_Coverage, 1717,
     /*  41094 */     GIR_EraseRootFromParent_Done,
     /*  41095 */   // Label 940: @41095
     /*  41095 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41131), // Rule ID 1718 //
     /*  41100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41122 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3725:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41129 */     GIR_RootConstrainSelectedInstOperands,
     /*  41130 */     // GIR_Coverage, 1718,
     /*  41130 */     GIR_EraseRootFromParent_Done,
     /*  41131 */   // Label 941: @41131
     /*  41131 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41179), // Rule ID 1851 //
     /*  41136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41158 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41177 */     GIR_RootConstrainSelectedInstOperands,
     /*  41178 */     // GIR_Coverage, 1851,
     /*  41178 */     GIR_EraseRootFromParent_Done,
     /*  41179 */   // Label 942: @41179
     /*  41179 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41227), // Rule ID 2099 //
     /*  41184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41206 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41225 */     GIR_RootConstrainSelectedInstOperands,
     /*  41226 */     // GIR_Coverage, 2099,
     /*  41226 */     GIR_EraseRootFromParent_Done,
     /*  41227 */   // Label 943: @41227
     /*  41227 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41293), // Rule ID 3648 //
     /*  41232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41254 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3607:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41271 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41291 */     GIR_RootConstrainSelectedInstOperands,
     /*  41292 */     // GIR_Coverage, 3648,
     /*  41292 */     GIR_EraseRootFromParent_Done,
     /*  41293 */   // Label 944: @41293
     /*  41293 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41359), // Rule ID 3650 //
     /*  41298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41320 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3607:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41337 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41357 */     GIR_RootConstrainSelectedInstOperands,
     /*  41358 */     // GIR_Coverage, 3650,
     /*  41358 */     GIR_EraseRootFromParent_Done,
     /*  41359 */   // Label 945: @41359
     /*  41359 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41425), // Rule ID 3652 //
     /*  41364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41386 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3607:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41403 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41423 */     GIR_RootConstrainSelectedInstOperands,
     /*  41424 */     // GIR_Coverage, 3652,
     /*  41424 */     GIR_EraseRootFromParent_Done,
     /*  41425 */   // Label 946: @41425
     /*  41425 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41476), // Rule ID 4864 //
     /*  41430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41452 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3615:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41474 */     GIR_RootConstrainSelectedInstOperands,
     /*  41475 */     // GIR_Coverage, 4864,
     /*  41475 */     GIR_EraseRootFromParent_Done,
     /*  41476 */   // Label 947: @41476
     /*  41476 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41527), // Rule ID 4866 //
     /*  41481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41503 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3612:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41525 */     GIR_RootConstrainSelectedInstOperands,
     /*  41526 */     // GIR_Coverage, 4866,
     /*  41526 */     GIR_EraseRootFromParent_Done,
     /*  41527 */   // Label 948: @41527
     /*  41527 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41578), // Rule ID 4868 //
     /*  41532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41554 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3613:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41576 */     GIR_RootConstrainSelectedInstOperands,
     /*  41577 */     // GIR_Coverage, 4868,
     /*  41577 */     GIR_EraseRootFromParent_Done,
     /*  41578 */   // Label 949: @41578
     /*  41578 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41629), // Rule ID 4870 //
     /*  41583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41605 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3614:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41627 */     GIR_RootConstrainSelectedInstOperands,
     /*  41628 */     // GIR_Coverage, 4870,
     /*  41628 */     GIR_EraseRootFromParent_Done,
     /*  41629 */   // Label 950: @41629
     /*  41629 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41675), // Rule ID 600 //
     /*  41634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41649 */     // MIs[0] Rn
     /*  41649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41657 */     // (intrinsic_wo_chain:{ *:[i32] } 3497:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41673 */     GIR_RootConstrainSelectedInstOperands,
     /*  41674 */     // GIR_Coverage, 600,
     /*  41674 */     GIR_EraseRootFromParent_Done,
     /*  41675 */   // Label 951: @41675
     /*  41675 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41721), // Rule ID 601 //
     /*  41680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41695 */     // MIs[0] Rn
     /*  41695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41703 */     // (intrinsic_wo_chain:{ *:[i32] } 3500:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41719 */     GIR_RootConstrainSelectedInstOperands,
     /*  41720 */     // GIR_Coverage, 601,
     /*  41720 */     GIR_EraseRootFromParent_Done,
     /*  41721 */   // Label 952: @41721
     /*  41721 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41767), // Rule ID 602 //
     /*  41726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41741 */     // MIs[0] Rn
     /*  41741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41749 */     // (intrinsic_wo_chain:{ *:[i32] } 3498:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41765 */     GIR_RootConstrainSelectedInstOperands,
     /*  41766 */     // GIR_Coverage, 602,
     /*  41766 */     GIR_EraseRootFromParent_Done,
     /*  41767 */   // Label 953: @41767
     /*  41767 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41813), // Rule ID 603 //
     /*  41772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41787 */     // MIs[0] Rn
     /*  41787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41795 */     // (intrinsic_wo_chain:{ *:[i32] } 3499:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41811 */     GIR_RootConstrainSelectedInstOperands,
     /*  41812 */     // GIR_Coverage, 603,
     /*  41812 */     GIR_EraseRootFromParent_Done,
     /*  41813 */   // Label 954: @41813
     /*  41813 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(41948), // Rule ID 2693 //
     /*  41818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  41826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41836 */     // (intrinsic_wo_chain:{ *:[i32] } 3732:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  41836 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  41839 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41843 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41848 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  41852 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41857 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  41860 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  41864 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41869 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  41872 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  41875 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  41878 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  41883 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  41891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  41895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41900 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  41905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41917 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  41924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  41947 */     // GIR_Coverage, 2693,
     /*  41947 */     GIR_EraseRootFromParent_Done,
     /*  41948 */   // Label 955: @41948
     /*  41948 */   GIM_Reject,
     /*  41949 */ // Label 833: @41949
     /*  41949 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(62503),
     /*  41954 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  41957 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42014), // Rule ID 2117 //
     /*  41962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  41970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41991 */     // (intrinsic_wo_chain:{ *:[i32] } 3945:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  41991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  41994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42012 */     GIR_RootConstrainSelectedInstOperands,
     /*  42013 */     // GIR_Coverage, 2117,
     /*  42013 */     GIR_EraseRootFromParent_Done,
     /*  42014 */   // Label 957: @42014
     /*  42014 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(42113), // Rule ID 1888 //
     /*  42019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42073 */     // MIs[2] Operand 1
     /*  42073 */     // No operand predicates
     /*  42073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42081 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42085 */     // MIs[3] Operand 1
     /*  42085 */     // No operand predicates
     /*  42085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42087 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42111 */     GIR_RootConstrainSelectedInstOperands,
     /*  42112 */     // GIR_Coverage, 1888,
     /*  42112 */     GIR_EraseRootFromParent_Done,
     /*  42113 */   // Label 958: @42113
     /*  42113 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42212), // Rule ID 2154 //
     /*  42118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42172 */     // MIs[2] Operand 1
     /*  42172 */     // No operand predicates
     /*  42172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42184 */     // MIs[3] Operand 1
     /*  42184 */     // No operand predicates
     /*  42184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42186 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42210 */     GIR_RootConstrainSelectedInstOperands,
     /*  42211 */     // GIR_Coverage, 2154,
     /*  42211 */     GIR_EraseRootFromParent_Done,
     /*  42212 */   // Label 959: @42212
     /*  42212 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(42296), // Rule ID 5430 //
     /*  42217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42246 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42249 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42263 */     // MIs[1] Rn
     /*  42263 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42274 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42294 */     GIR_RootConstrainSelectedInstOperands,
     /*  42295 */     // GIR_Coverage, 5430,
     /*  42295 */     GIR_EraseRootFromParent_Done,
     /*  42296 */   // Label 960: @42296
     /*  42296 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(42380), // Rule ID 5687 //
     /*  42301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42330 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42333 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42347 */     // MIs[1] Rn
     /*  42347 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42358 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42378 */     GIR_RootConstrainSelectedInstOperands,
     /*  42379 */     // GIR_Coverage, 5687,
     /*  42379 */     GIR_EraseRootFromParent_Done,
     /*  42380 */   // Label 961: @42380
     /*  42380 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42464), // Rule ID 109 //
     /*  42385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42418 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42421 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42435 */     // MIs[1] Rn
     /*  42435 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42442 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42462 */     GIR_RootConstrainSelectedInstOperands,
     /*  42463 */     // GIR_Coverage, 109,
     /*  42463 */     GIR_EraseRootFromParent_Done,
     /*  42464 */   // Label 962: @42464
     /*  42464 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42548), // Rule ID 110 //
     /*  42469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42519 */     // MIs[1] Rn
     /*  42519 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42526 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42546 */     GIR_RootConstrainSelectedInstOperands,
     /*  42547 */     // GIR_Coverage, 110,
     /*  42547 */     GIR_EraseRootFromParent_Done,
     /*  42548 */   // Label 963: @42548
     /*  42548 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42632), // Rule ID 2132 //
     /*  42553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42586 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42589 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42603 */     // MIs[1] Rn
     /*  42603 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42610 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42630 */     GIR_RootConstrainSelectedInstOperands,
     /*  42631 */     // GIR_Coverage, 2132,
     /*  42631 */     GIR_EraseRootFromParent_Done,
     /*  42632 */   // Label 964: @42632
     /*  42632 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42716), // Rule ID 2133 //
     /*  42637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42670 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42673 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42687 */     // MIs[1] Rn
     /*  42687 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42694 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42714 */     GIR_RootConstrainSelectedInstOperands,
     /*  42715 */     // GIR_Coverage, 2133,
     /*  42715 */     GIR_EraseRootFromParent_Done,
     /*  42716 */   // Label 965: @42716
     /*  42716 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42789), // Rule ID 4058 //
     /*  42721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42750 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42767 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42787 */     GIR_RootConstrainSelectedInstOperands,
     /*  42788 */     // GIR_Coverage, 4058,
     /*  42788 */     GIR_EraseRootFromParent_Done,
     /*  42789 */   // Label 966: @42789
     /*  42789 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(42862), // Rule ID 4060 //
     /*  42794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42823 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  42838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42840 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42860 */     GIR_RootConstrainSelectedInstOperands,
     /*  42861 */     // GIR_Coverage, 4060,
     /*  42861 */     GIR_EraseRootFromParent_Done,
     /*  42862 */   // Label 967: @42862
     /*  42862 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(42935), // Rule ID 4062 //
     /*  42867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  42875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42896 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  42911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42913 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42933 */     GIR_RootConstrainSelectedInstOperands,
     /*  42934 */     // GIR_Coverage, 4062,
     /*  42934 */     GIR_EraseRootFromParent_Done,
     /*  42935 */   // Label 968: @42935
     /*  42935 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43008), // Rule ID 4064 //
     /*  42940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  42948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42969 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42986 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43006 */     GIR_RootConstrainSelectedInstOperands,
     /*  43007 */     // GIR_Coverage, 4064,
     /*  43007 */     GIR_EraseRootFromParent_Done,
     /*  43008 */   // Label 969: @43008
     /*  43008 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43081), // Rule ID 4066 //
     /*  43013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43042 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43059 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43079 */     GIR_RootConstrainSelectedInstOperands,
     /*  43080 */     // GIR_Coverage, 4066,
     /*  43080 */     GIR_EraseRootFromParent_Done,
     /*  43081 */   // Label 970: @43081
     /*  43081 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43154), // Rule ID 4068 //
     /*  43086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43115 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43132 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43152 */     GIR_RootConstrainSelectedInstOperands,
     /*  43153 */     // GIR_Coverage, 4068,
     /*  43153 */     GIR_EraseRootFromParent_Done,
     /*  43154 */   // Label 971: @43154
     /*  43154 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43227), // Rule ID 4070 //
     /*  43159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43188 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43205 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43225 */     GIR_RootConstrainSelectedInstOperands,
     /*  43226 */     // GIR_Coverage, 4070,
     /*  43226 */     GIR_EraseRootFromParent_Done,
     /*  43227 */   // Label 972: @43227
     /*  43227 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43300), // Rule ID 4072 //
     /*  43232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43261 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43278 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43298 */     GIR_RootConstrainSelectedInstOperands,
     /*  43299 */     // GIR_Coverage, 4072,
     /*  43299 */     GIR_EraseRootFromParent_Done,
     /*  43300 */   // Label 973: @43300
     /*  43300 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43373), // Rule ID 4074 //
     /*  43305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43334 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43351 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43371 */     GIR_RootConstrainSelectedInstOperands,
     /*  43372 */     // GIR_Coverage, 4074,
     /*  43372 */     GIR_EraseRootFromParent_Done,
     /*  43373 */   // Label 974: @43373
     /*  43373 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43446), // Rule ID 4076 //
     /*  43378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43407 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43424 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43444 */     GIR_RootConstrainSelectedInstOperands,
     /*  43445 */     // GIR_Coverage, 4076,
     /*  43445 */     GIR_EraseRootFromParent_Done,
     /*  43446 */   // Label 975: @43446
     /*  43446 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43519), // Rule ID 4078 //
     /*  43451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43480 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43497 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43517 */     GIR_RootConstrainSelectedInstOperands,
     /*  43518 */     // GIR_Coverage, 4078,
     /*  43518 */     GIR_EraseRootFromParent_Done,
     /*  43519 */   // Label 976: @43519
     /*  43519 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43592), // Rule ID 4080 //
     /*  43524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43553 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43570 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43590 */     GIR_RootConstrainSelectedInstOperands,
     /*  43591 */     // GIR_Coverage, 4080,
     /*  43591 */     GIR_EraseRootFromParent_Done,
     /*  43592 */   // Label 977: @43592
     /*  43592 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43665), // Rule ID 4082 //
     /*  43597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43626 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43643 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43663 */     GIR_RootConstrainSelectedInstOperands,
     /*  43664 */     // GIR_Coverage, 4082,
     /*  43664 */     GIR_EraseRootFromParent_Done,
     /*  43665 */   // Label 978: @43665
     /*  43665 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43738), // Rule ID 4084 //
     /*  43670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43699 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43716 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43736 */     GIR_RootConstrainSelectedInstOperands,
     /*  43737 */     // GIR_Coverage, 4084,
     /*  43737 */     GIR_EraseRootFromParent_Done,
     /*  43738 */   // Label 979: @43738
     /*  43738 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43811), // Rule ID 4086 //
     /*  43743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43789 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43809 */     GIR_RootConstrainSelectedInstOperands,
     /*  43810 */     // GIR_Coverage, 4086,
     /*  43810 */     GIR_EraseRootFromParent_Done,
     /*  43811 */   // Label 980: @43811
     /*  43811 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(43884), // Rule ID 4088 //
     /*  43816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  43860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43862 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43882 */     GIR_RootConstrainSelectedInstOperands,
     /*  43883 */     // GIR_Coverage, 4088,
     /*  43883 */     GIR_EraseRootFromParent_Done,
     /*  43884 */   // Label 981: @43884
     /*  43884 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(43957), // Rule ID 4532 //
     /*  43889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  43918 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3621:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  43933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43955 */     GIR_RootConstrainSelectedInstOperands,
     /*  43956 */     // GIR_Coverage, 4532,
     /*  43956 */     GIR_EraseRootFromParent_Done,
     /*  43957 */   // Label 982: @43957
     /*  43957 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44030), // Rule ID 4538 //
     /*  43962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  43991 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3621:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44028 */     GIR_RootConstrainSelectedInstOperands,
     /*  44029 */     // GIR_Coverage, 4538,
     /*  44029 */     GIR_EraseRootFromParent_Done,
     /*  44030 */   // Label 983: @44030
     /*  44030 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44098), // Rule ID 1881 //
     /*  44035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44072 */     // MIs[1] Operand 1
     /*  44072 */     // No operand predicates
     /*  44072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44074 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44082 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44096 */     GIR_RootConstrainSelectedInstOperands,
     /*  44097 */     // GIR_Coverage, 1881,
     /*  44097 */     GIR_EraseRootFromParent_Done,
     /*  44098 */   // Label 984: @44098
     /*  44098 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44163), // Rule ID 1885 //
     /*  44103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44140 */     // MIs[1] Operand 1
     /*  44140 */     // No operand predicates
     /*  44140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44142 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44150 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44161 */     GIR_RootConstrainSelectedInstOperands,
     /*  44162 */     // GIR_Coverage, 1885,
     /*  44162 */     GIR_EraseRootFromParent_Done,
     /*  44163 */   // Label 985: @44163
     /*  44163 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44231), // Rule ID 2149 //
     /*  44168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44205 */     // MIs[1] Operand 1
     /*  44205 */     // No operand predicates
     /*  44205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44207 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44215 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44229 */     GIR_RootConstrainSelectedInstOperands,
     /*  44230 */     // GIR_Coverage, 2149,
     /*  44230 */     GIR_EraseRootFromParent_Done,
     /*  44231 */   // Label 986: @44231
     /*  44231 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44296), // Rule ID 2151 //
     /*  44236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44273 */     // MIs[1] Operand 1
     /*  44273 */     // No operand predicates
     /*  44273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44275 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44283 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44294 */     GIR_RootConstrainSelectedInstOperands,
     /*  44295 */     // GIR_Coverage, 2151,
     /*  44295 */     GIR_EraseRootFromParent_Done,
     /*  44296 */   // Label 987: @44296
     /*  44296 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44379), // Rule ID 3928 //
     /*  44301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44335 */     // MIs[1] Operand 1
     /*  44335 */     // No operand predicates
     /*  44335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44337 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3682:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44377 */     GIR_RootConstrainSelectedInstOperands,
     /*  44378 */     // GIR_Coverage, 3928,
     /*  44378 */     GIR_EraseRootFromParent_Done,
     /*  44379 */   // Label 988: @44379
     /*  44379 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44462), // Rule ID 3930 //
     /*  44384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44418 */     // MIs[1] Operand 1
     /*  44418 */     // No operand predicates
     /*  44418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44420 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3682:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44460 */     GIR_RootConstrainSelectedInstOperands,
     /*  44461 */     // GIR_Coverage, 3930,
     /*  44461 */     GIR_EraseRootFromParent_Done,
     /*  44462 */   // Label 989: @44462
     /*  44462 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44545), // Rule ID 3932 //
     /*  44467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44501 */     // MIs[1] Operand 1
     /*  44501 */     // No operand predicates
     /*  44501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44503 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3682:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44543 */     GIR_RootConstrainSelectedInstOperands,
     /*  44544 */     // GIR_Coverage, 3932,
     /*  44544 */     GIR_EraseRootFromParent_Done,
     /*  44545 */   // Label 990: @44545
     /*  44545 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44606), // Rule ID 1652 //
     /*  44550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44583 */     // MIs[1] Operand 1
     /*  44583 */     // No operand predicates
     /*  44583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44585 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3759:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44604 */     GIR_RootConstrainSelectedInstOperands,
     /*  44605 */     // GIR_Coverage, 1652,
     /*  44605 */     GIR_EraseRootFromParent_Done,
     /*  44606 */   // Label 991: @44606
     /*  44606 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44667), // Rule ID 1653 //
     /*  44611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44644 */     // MIs[1] Operand 1
     /*  44644 */     // No operand predicates
     /*  44644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44646 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44665 */     GIR_RootConstrainSelectedInstOperands,
     /*  44666 */     // GIR_Coverage, 1653,
     /*  44666 */     GIR_EraseRootFromParent_Done,
     /*  44667 */   // Label 992: @44667
     /*  44667 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44728), // Rule ID 1654 //
     /*  44672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44705 */     // MIs[1] Operand 1
     /*  44705 */     // No operand predicates
     /*  44705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44707 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3762:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44726 */     GIR_RootConstrainSelectedInstOperands,
     /*  44727 */     // GIR_Coverage, 1654,
     /*  44727 */     GIR_EraseRootFromParent_Done,
     /*  44728 */   // Label 993: @44728
     /*  44728 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44789), // Rule ID 1655 //
     /*  44733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44766 */     // MIs[1] Operand 1
     /*  44766 */     // No operand predicates
     /*  44766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44768 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3763:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44787 */     GIR_RootConstrainSelectedInstOperands,
     /*  44788 */     // GIR_Coverage, 1655,
     /*  44788 */     GIR_EraseRootFromParent_Done,
     /*  44789 */   // Label 994: @44789
     /*  44789 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(44850), // Rule ID 1656 //
     /*  44794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44827 */     // MIs[1] Operand 1
     /*  44827 */     // No operand predicates
     /*  44827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44829 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3759:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  44832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44848 */     GIR_RootConstrainSelectedInstOperands,
     /*  44849 */     // GIR_Coverage, 1656,
     /*  44849 */     GIR_EraseRootFromParent_Done,
     /*  44850 */   // Label 995: @44850
     /*  44850 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(44911), // Rule ID 1657 //
     /*  44855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44888 */     // MIs[1] Operand 1
     /*  44888 */     // No operand predicates
     /*  44888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44890 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  44893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44909 */     GIR_RootConstrainSelectedInstOperands,
     /*  44910 */     // GIR_Coverage, 1657,
     /*  44910 */     GIR_EraseRootFromParent_Done,
     /*  44911 */   // Label 996: @44911
     /*  44911 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(44972), // Rule ID 1658 //
     /*  44916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44949 */     // MIs[1] Operand 1
     /*  44949 */     // No operand predicates
     /*  44949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44951 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3762:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  44954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44970 */     GIR_RootConstrainSelectedInstOperands,
     /*  44971 */     // GIR_Coverage, 1658,
     /*  44971 */     GIR_EraseRootFromParent_Done,
     /*  44972 */   // Label 997: @44972
     /*  44972 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45033), // Rule ID 1659 //
     /*  44977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45010 */     // MIs[1] Operand 1
     /*  45010 */     // No operand predicates
     /*  45010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45012 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3763:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45031 */     GIR_RootConstrainSelectedInstOperands,
     /*  45032 */     // GIR_Coverage, 1659,
     /*  45032 */     GIR_EraseRootFromParent_Done,
     /*  45033 */   // Label 998: @45033
     /*  45033 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45094), // Rule ID 1660 //
     /*  45038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45071 */     // MIs[1] Operand 1
     /*  45071 */     // No operand predicates
     /*  45071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3759:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45092 */     GIR_RootConstrainSelectedInstOperands,
     /*  45093 */     // GIR_Coverage, 1660,
     /*  45093 */     GIR_EraseRootFromParent_Done,
     /*  45094 */   // Label 999: @45094
     /*  45094 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45155), // Rule ID 1661 //
     /*  45099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45132 */     // MIs[1] Operand 1
     /*  45132 */     // No operand predicates
     /*  45132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45134 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45153 */     GIR_RootConstrainSelectedInstOperands,
     /*  45154 */     // GIR_Coverage, 1661,
     /*  45154 */     GIR_EraseRootFromParent_Done,
     /*  45155 */   // Label 1000: @45155
     /*  45155 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45216), // Rule ID 1662 //
     /*  45160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45193 */     // MIs[1] Operand 1
     /*  45193 */     // No operand predicates
     /*  45193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45195 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3762:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45214 */     GIR_RootConstrainSelectedInstOperands,
     /*  45215 */     // GIR_Coverage, 1662,
     /*  45215 */     GIR_EraseRootFromParent_Done,
     /*  45216 */   // Label 1001: @45216
     /*  45216 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45277), // Rule ID 1663 //
     /*  45221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45254 */     // MIs[1] Operand 1
     /*  45254 */     // No operand predicates
     /*  45254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45256 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3763:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45275 */     GIR_RootConstrainSelectedInstOperands,
     /*  45276 */     // GIR_Coverage, 1663,
     /*  45276 */     GIR_EraseRootFromParent_Done,
     /*  45277 */   // Label 1002: @45277
     /*  45277 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45338), // Rule ID 1664 //
     /*  45282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45315 */     // MIs[1] Operand 1
     /*  45315 */     // No operand predicates
     /*  45315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45317 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3759:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45336 */     GIR_RootConstrainSelectedInstOperands,
     /*  45337 */     // GIR_Coverage, 1664,
     /*  45337 */     GIR_EraseRootFromParent_Done,
     /*  45338 */   // Label 1003: @45338
     /*  45338 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45399), // Rule ID 1665 //
     /*  45343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45376 */     // MIs[1] Operand 1
     /*  45376 */     // No operand predicates
     /*  45376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45378 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45397 */     GIR_RootConstrainSelectedInstOperands,
     /*  45398 */     // GIR_Coverage, 1665,
     /*  45398 */     GIR_EraseRootFromParent_Done,
     /*  45399 */   // Label 1004: @45399
     /*  45399 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45460), // Rule ID 1666 //
     /*  45404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45437 */     // MIs[1] Operand 1
     /*  45437 */     // No operand predicates
     /*  45437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45439 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3762:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45458 */     GIR_RootConstrainSelectedInstOperands,
     /*  45459 */     // GIR_Coverage, 1666,
     /*  45459 */     GIR_EraseRootFromParent_Done,
     /*  45460 */   // Label 1005: @45460
     /*  45460 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45521), // Rule ID 1667 //
     /*  45465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45498 */     // MIs[1] Operand 1
     /*  45498 */     // No operand predicates
     /*  45498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45500 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3763:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45519 */     GIR_RootConstrainSelectedInstOperands,
     /*  45520 */     // GIR_Coverage, 1667,
     /*  45520 */     GIR_EraseRootFromParent_Done,
     /*  45521 */   // Label 1006: @45521
     /*  45521 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45582), // Rule ID 1725 //
     /*  45526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45559 */     // MIs[1] Operand 1
     /*  45559 */     // No operand predicates
     /*  45559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45561 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45566 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45580 */     GIR_RootConstrainSelectedInstOperands,
     /*  45581 */     // GIR_Coverage, 1725,
     /*  45581 */     GIR_EraseRootFromParent_Done,
     /*  45582 */   // Label 1007: @45582
     /*  45582 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45643), // Rule ID 1726 //
     /*  45587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45620 */     // MIs[1] Operand 1
     /*  45620 */     // No operand predicates
     /*  45620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45622 */     // (intrinsic_wo_chain:{ *:[i32] } 3589:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45627 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45641 */     GIR_RootConstrainSelectedInstOperands,
     /*  45642 */     // GIR_Coverage, 1726,
     /*  45642 */     GIR_EraseRootFromParent_Done,
     /*  45643 */   // Label 1008: @45643
     /*  45643 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45704), // Rule ID 1727 //
     /*  45648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45681 */     // MIs[1] Operand 1
     /*  45681 */     // No operand predicates
     /*  45681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45683 */     // (intrinsic_wo_chain:{ *:[i32] } 3594:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45688 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45702 */     GIR_RootConstrainSelectedInstOperands,
     /*  45703 */     // GIR_Coverage, 1727,
     /*  45703 */     GIR_EraseRootFromParent_Done,
     /*  45704 */   // Label 1009: @45704
     /*  45704 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45765), // Rule ID 1728 //
     /*  45709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45742 */     // MIs[1] Operand 1
     /*  45742 */     // No operand predicates
     /*  45742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45744 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45749 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45763 */     GIR_RootConstrainSelectedInstOperands,
     /*  45764 */     // GIR_Coverage, 1728,
     /*  45764 */     GIR_EraseRootFromParent_Done,
     /*  45765 */   // Label 1010: @45765
     /*  45765 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45819), // Rule ID 105 //
     /*  45770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45799 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45817 */     GIR_RootConstrainSelectedInstOperands,
     /*  45818 */     // GIR_Coverage, 105,
     /*  45818 */     GIR_EraseRootFromParent_Done,
     /*  45819 */   // Label 1011: @45819
     /*  45819 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(45873), // Rule ID 106 //
     /*  45824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  45832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45853 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  45856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45871 */     GIR_RootConstrainSelectedInstOperands,
     /*  45872 */     // GIR_Coverage, 106,
     /*  45872 */     GIR_EraseRootFromParent_Done,
     /*  45873 */   // Label 1012: @45873
     /*  45873 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(45927), // Rule ID 107 //
     /*  45878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  45886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45907 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  45910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45925 */     GIR_RootConstrainSelectedInstOperands,
     /*  45926 */     // GIR_Coverage, 107,
     /*  45926 */     GIR_EraseRootFromParent_Done,
     /*  45927 */   // Label 1013: @45927
     /*  45927 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(45981), // Rule ID 108 //
     /*  45932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  45940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45961 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  45964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45979 */     GIR_RootConstrainSelectedInstOperands,
     /*  45980 */     // GIR_Coverage, 108,
     /*  45980 */     GIR_EraseRootFromParent_Done,
     /*  45981 */   // Label 1014: @45981
     /*  45981 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46035), // Rule ID 111 //
     /*  45986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  45994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46015 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46033 */     GIR_RootConstrainSelectedInstOperands,
     /*  46034 */     // GIR_Coverage, 111,
     /*  46034 */     GIR_EraseRootFromParent_Done,
     /*  46035 */   // Label 1015: @46035
     /*  46035 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46089), // Rule ID 112 //
     /*  46040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46069 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46087 */     GIR_RootConstrainSelectedInstOperands,
     /*  46088 */     // GIR_Coverage, 112,
     /*  46088 */     GIR_EraseRootFromParent_Done,
     /*  46089 */   // Label 1016: @46089
     /*  46089 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46143), // Rule ID 113 //
     /*  46094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46123 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46141 */     GIR_RootConstrainSelectedInstOperands,
     /*  46142 */     // GIR_Coverage, 113,
     /*  46142 */     GIR_EraseRootFromParent_Done,
     /*  46143 */   // Label 1017: @46143
     /*  46143 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46197), // Rule ID 114 //
     /*  46148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46177 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46195 */     GIR_RootConstrainSelectedInstOperands,
     /*  46196 */     // GIR_Coverage, 114,
     /*  46196 */     GIR_EraseRootFromParent_Done,
     /*  46197 */   // Label 1018: @46197
     /*  46197 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46251), // Rule ID 115 //
     /*  46202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46231 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46249 */     GIR_RootConstrainSelectedInstOperands,
     /*  46250 */     // GIR_Coverage, 115,
     /*  46250 */     GIR_EraseRootFromParent_Done,
     /*  46251 */   // Label 1019: @46251
     /*  46251 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46305), // Rule ID 116 //
     /*  46256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46285 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46303 */     GIR_RootConstrainSelectedInstOperands,
     /*  46304 */     // GIR_Coverage, 116,
     /*  46304 */     GIR_EraseRootFromParent_Done,
     /*  46305 */   // Label 1020: @46305
     /*  46305 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46359), // Rule ID 117 //
     /*  46310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46339 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46357 */     GIR_RootConstrainSelectedInstOperands,
     /*  46358 */     // GIR_Coverage, 117,
     /*  46358 */     GIR_EraseRootFromParent_Done,
     /*  46359 */   // Label 1021: @46359
     /*  46359 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46413), // Rule ID 118 //
     /*  46364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46393 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46411 */     GIR_RootConstrainSelectedInstOperands,
     /*  46412 */     // GIR_Coverage, 118,
     /*  46412 */     GIR_EraseRootFromParent_Done,
     /*  46413 */   // Label 1022: @46413
     /*  46413 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46467), // Rule ID 119 //
     /*  46418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46447 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46465 */     GIR_RootConstrainSelectedInstOperands,
     /*  46466 */     // GIR_Coverage, 119,
     /*  46466 */     GIR_EraseRootFromParent_Done,
     /*  46467 */   // Label 1023: @46467
     /*  46467 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46521), // Rule ID 120 //
     /*  46472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46501 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46519 */     GIR_RootConstrainSelectedInstOperands,
     /*  46520 */     // GIR_Coverage, 120,
     /*  46520 */     GIR_EraseRootFromParent_Done,
     /*  46521 */   // Label 1024: @46521
     /*  46521 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46575), // Rule ID 133 //
     /*  46526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46555 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46573 */     GIR_RootConstrainSelectedInstOperands,
     /*  46574 */     // GIR_Coverage, 133,
     /*  46574 */     GIR_EraseRootFromParent_Done,
     /*  46575 */   // Label 1025: @46575
     /*  46575 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46629), // Rule ID 134 //
     /*  46580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46609 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46627 */     GIR_RootConstrainSelectedInstOperands,
     /*  46628 */     // GIR_Coverage, 134,
     /*  46628 */     GIR_EraseRootFromParent_Done,
     /*  46629 */   // Label 1026: @46629
     /*  46629 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46683), // Rule ID 135 //
     /*  46634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46663 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46681 */     GIR_RootConstrainSelectedInstOperands,
     /*  46682 */     // GIR_Coverage, 135,
     /*  46682 */     GIR_EraseRootFromParent_Done,
     /*  46683 */   // Label 1027: @46683
     /*  46683 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46737), // Rule ID 136 //
     /*  46688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46717 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46735 */     GIR_RootConstrainSelectedInstOperands,
     /*  46736 */     // GIR_Coverage, 136,
     /*  46736 */     GIR_EraseRootFromParent_Done,
     /*  46737 */   // Label 1028: @46737
     /*  46737 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46791), // Rule ID 137 //
     /*  46742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46771 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46789 */     GIR_RootConstrainSelectedInstOperands,
     /*  46790 */     // GIR_Coverage, 137,
     /*  46790 */     GIR_EraseRootFromParent_Done,
     /*  46791 */   // Label 1029: @46791
     /*  46791 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(46845), // Rule ID 138 //
     /*  46796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46825 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  46828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46843 */     GIR_RootConstrainSelectedInstOperands,
     /*  46844 */     // GIR_Coverage, 138,
     /*  46844 */     GIR_EraseRootFromParent_Done,
     /*  46845 */   // Label 1030: @46845
     /*  46845 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(46899), // Rule ID 139 //
     /*  46850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  46858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46879 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  46882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46897 */     GIR_RootConstrainSelectedInstOperands,
     /*  46898 */     // GIR_Coverage, 139,
     /*  46898 */     GIR_EraseRootFromParent_Done,
     /*  46899 */   // Label 1031: @46899
     /*  46899 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(46953), // Rule ID 140 //
     /*  46904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  46912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46933 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  46936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46951 */     GIR_RootConstrainSelectedInstOperands,
     /*  46952 */     // GIR_Coverage, 140,
     /*  46952 */     GIR_EraseRootFromParent_Done,
     /*  46953 */   // Label 1032: @46953
     /*  46953 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47007), // Rule ID 141 //
     /*  46958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  46966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46987 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  46990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47005 */     GIR_RootConstrainSelectedInstOperands,
     /*  47006 */     // GIR_Coverage, 141,
     /*  47006 */     GIR_EraseRootFromParent_Done,
     /*  47007 */   // Label 1033: @47007
     /*  47007 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47061), // Rule ID 142 //
     /*  47012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47041 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47059 */     GIR_RootConstrainSelectedInstOperands,
     /*  47060 */     // GIR_Coverage, 142,
     /*  47060 */     GIR_EraseRootFromParent_Done,
     /*  47061 */   // Label 1034: @47061
     /*  47061 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47115), // Rule ID 143 //
     /*  47066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47095 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47113 */     GIR_RootConstrainSelectedInstOperands,
     /*  47114 */     // GIR_Coverage, 143,
     /*  47114 */     GIR_EraseRootFromParent_Done,
     /*  47115 */   // Label 1035: @47115
     /*  47115 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47169), // Rule ID 144 //
     /*  47120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47149 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47167 */     GIR_RootConstrainSelectedInstOperands,
     /*  47168 */     // GIR_Coverage, 144,
     /*  47168 */     GIR_EraseRootFromParent_Done,
     /*  47169 */   // Label 1036: @47169
     /*  47169 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47223), // Rule ID 145 //
     /*  47174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47203 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47221 */     GIR_RootConstrainSelectedInstOperands,
     /*  47222 */     // GIR_Coverage, 145,
     /*  47222 */     GIR_EraseRootFromParent_Done,
     /*  47223 */   // Label 1037: @47223
     /*  47223 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47268), // Rule ID 204 //
     /*  47228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47257 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47266 */     GIR_RootConstrainSelectedInstOperands,
     /*  47267 */     // GIR_Coverage, 204,
     /*  47267 */     GIR_EraseRootFromParent_Done,
     /*  47268 */   // Label 1038: @47268
     /*  47268 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47313), // Rule ID 205 //
     /*  47273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47302 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47311 */     GIR_RootConstrainSelectedInstOperands,
     /*  47312 */     // GIR_Coverage, 205,
     /*  47312 */     GIR_EraseRootFromParent_Done,
     /*  47313 */   // Label 1039: @47313
     /*  47313 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47358), // Rule ID 206 //
     /*  47318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47347 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47356 */     GIR_RootConstrainSelectedInstOperands,
     /*  47357 */     // GIR_Coverage, 206,
     /*  47357 */     GIR_EraseRootFromParent_Done,
     /*  47358 */   // Label 1040: @47358
     /*  47358 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47403), // Rule ID 207 //
     /*  47363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47392 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47401 */     GIR_RootConstrainSelectedInstOperands,
     /*  47402 */     // GIR_Coverage, 207,
     /*  47402 */     GIR_EraseRootFromParent_Done,
     /*  47403 */   // Label 1041: @47403
     /*  47403 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47448), // Rule ID 208 //
     /*  47408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47437 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47446 */     GIR_RootConstrainSelectedInstOperands,
     /*  47447 */     // GIR_Coverage, 208,
     /*  47447 */     GIR_EraseRootFromParent_Done,
     /*  47448 */   // Label 1042: @47448
     /*  47448 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47493), // Rule ID 209 //
     /*  47453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47482 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47491 */     GIR_RootConstrainSelectedInstOperands,
     /*  47492 */     // GIR_Coverage, 209,
     /*  47492 */     GIR_EraseRootFromParent_Done,
     /*  47493 */   // Label 1043: @47493
     /*  47493 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47547), // Rule ID 432 //
     /*  47498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47527 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47545 */     GIR_RootConstrainSelectedInstOperands,
     /*  47546 */     // GIR_Coverage, 432,
     /*  47546 */     GIR_EraseRootFromParent_Done,
     /*  47547 */   // Label 1044: @47547
     /*  47547 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47601), // Rule ID 433 //
     /*  47552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47581 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47599 */     GIR_RootConstrainSelectedInstOperands,
     /*  47600 */     // GIR_Coverage, 433,
     /*  47600 */     GIR_EraseRootFromParent_Done,
     /*  47601 */   // Label 1045: @47601
     /*  47601 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47655), // Rule ID 434 //
     /*  47606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47635 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47653 */     GIR_RootConstrainSelectedInstOperands,
     /*  47654 */     // GIR_Coverage, 434,
     /*  47654 */     GIR_EraseRootFromParent_Done,
     /*  47655 */   // Label 1046: @47655
     /*  47655 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47709), // Rule ID 435 //
     /*  47660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47689 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47707 */     GIR_RootConstrainSelectedInstOperands,
     /*  47708 */     // GIR_Coverage, 435,
     /*  47708 */     GIR_EraseRootFromParent_Done,
     /*  47709 */   // Label 1047: @47709
     /*  47709 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47763), // Rule ID 436 //
     /*  47714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47743 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47761 */     GIR_RootConstrainSelectedInstOperands,
     /*  47762 */     // GIR_Coverage, 436,
     /*  47762 */     GIR_EraseRootFromParent_Done,
     /*  47763 */   // Label 1048: @47763
     /*  47763 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47817), // Rule ID 437 //
     /*  47768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47797 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47815 */     GIR_RootConstrainSelectedInstOperands,
     /*  47816 */     // GIR_Coverage, 437,
     /*  47816 */     GIR_EraseRootFromParent_Done,
     /*  47817 */   // Label 1049: @47817
     /*  47817 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(47871), // Rule ID 438 //
     /*  47822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  47830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47851 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  47854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47869 */     GIR_RootConstrainSelectedInstOperands,
     /*  47870 */     // GIR_Coverage, 438,
     /*  47870 */     GIR_EraseRootFromParent_Done,
     /*  47871 */   // Label 1050: @47871
     /*  47871 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(47925), // Rule ID 439 //
     /*  47876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  47884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47905 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  47908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47923 */     GIR_RootConstrainSelectedInstOperands,
     /*  47924 */     // GIR_Coverage, 439,
     /*  47924 */     GIR_EraseRootFromParent_Done,
     /*  47925 */   // Label 1051: @47925
     /*  47925 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(47979), // Rule ID 440 //
     /*  47930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  47938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47959 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  47962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47977 */     GIR_RootConstrainSelectedInstOperands,
     /*  47978 */     // GIR_Coverage, 440,
     /*  47978 */     GIR_EraseRootFromParent_Done,
     /*  47979 */   // Label 1052: @47979
     /*  47979 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48033), // Rule ID 441 //
     /*  47984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  47992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48013 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48031 */     GIR_RootConstrainSelectedInstOperands,
     /*  48032 */     // GIR_Coverage, 441,
     /*  48032 */     GIR_EraseRootFromParent_Done,
     /*  48033 */   // Label 1053: @48033
     /*  48033 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48087), // Rule ID 442 //
     /*  48038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48067 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48085 */     GIR_RootConstrainSelectedInstOperands,
     /*  48086 */     // GIR_Coverage, 442,
     /*  48086 */     GIR_EraseRootFromParent_Done,
     /*  48087 */   // Label 1054: @48087
     /*  48087 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48141), // Rule ID 443 //
     /*  48092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48121 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48139 */     GIR_RootConstrainSelectedInstOperands,
     /*  48140 */     // GIR_Coverage, 443,
     /*  48140 */     GIR_EraseRootFromParent_Done,
     /*  48141 */   // Label 1055: @48141
     /*  48141 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48195), // Rule ID 456 //
     /*  48146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48175 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48193 */     GIR_RootConstrainSelectedInstOperands,
     /*  48194 */     // GIR_Coverage, 456,
     /*  48194 */     GIR_EraseRootFromParent_Done,
     /*  48195 */   // Label 1056: @48195
     /*  48195 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48249), // Rule ID 457 //
     /*  48200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48229 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48247 */     GIR_RootConstrainSelectedInstOperands,
     /*  48248 */     // GIR_Coverage, 457,
     /*  48248 */     GIR_EraseRootFromParent_Done,
     /*  48249 */   // Label 1057: @48249
     /*  48249 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48303), // Rule ID 458 //
     /*  48254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48283 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48301 */     GIR_RootConstrainSelectedInstOperands,
     /*  48302 */     // GIR_Coverage, 458,
     /*  48302 */     GIR_EraseRootFromParent_Done,
     /*  48303 */   // Label 1058: @48303
     /*  48303 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48357), // Rule ID 459 //
     /*  48308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48337 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48355 */     GIR_RootConstrainSelectedInstOperands,
     /*  48356 */     // GIR_Coverage, 459,
     /*  48356 */     GIR_EraseRootFromParent_Done,
     /*  48357 */   // Label 1059: @48357
     /*  48357 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48411), // Rule ID 460 //
     /*  48362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48391 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48409 */     GIR_RootConstrainSelectedInstOperands,
     /*  48410 */     // GIR_Coverage, 460,
     /*  48410 */     GIR_EraseRootFromParent_Done,
     /*  48411 */   // Label 1060: @48411
     /*  48411 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48465), // Rule ID 461 //
     /*  48416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48445 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48463 */     GIR_RootConstrainSelectedInstOperands,
     /*  48464 */     // GIR_Coverage, 461,
     /*  48464 */     GIR_EraseRootFromParent_Done,
     /*  48465 */   // Label 1061: @48465
     /*  48465 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48519), // Rule ID 462 //
     /*  48470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48499 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48517 */     GIR_RootConstrainSelectedInstOperands,
     /*  48518 */     // GIR_Coverage, 462,
     /*  48518 */     GIR_EraseRootFromParent_Done,
     /*  48519 */   // Label 1062: @48519
     /*  48519 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48573), // Rule ID 463 //
     /*  48524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48553 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48571 */     GIR_RootConstrainSelectedInstOperands,
     /*  48572 */     // GIR_Coverage, 463,
     /*  48572 */     GIR_EraseRootFromParent_Done,
     /*  48573 */   // Label 1063: @48573
     /*  48573 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48627), // Rule ID 464 //
     /*  48578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48607 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48625 */     GIR_RootConstrainSelectedInstOperands,
     /*  48626 */     // GIR_Coverage, 464,
     /*  48626 */     GIR_EraseRootFromParent_Done,
     /*  48627 */   // Label 1064: @48627
     /*  48627 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48681), // Rule ID 465 //
     /*  48632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48661 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48679 */     GIR_RootConstrainSelectedInstOperands,
     /*  48680 */     // GIR_Coverage, 465,
     /*  48680 */     GIR_EraseRootFromParent_Done,
     /*  48681 */   // Label 1065: @48681
     /*  48681 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48735), // Rule ID 466 //
     /*  48686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48715 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48733 */     GIR_RootConstrainSelectedInstOperands,
     /*  48734 */     // GIR_Coverage, 466,
     /*  48734 */     GIR_EraseRootFromParent_Done,
     /*  48735 */   // Label 1066: @48735
     /*  48735 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48789), // Rule ID 467 //
     /*  48740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48769 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48787 */     GIR_RootConstrainSelectedInstOperands,
     /*  48788 */     // GIR_Coverage, 467,
     /*  48788 */     GIR_EraseRootFromParent_Done,
     /*  48789 */   // Label 1067: @48789
     /*  48789 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(48843), // Rule ID 468 //
     /*  48794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48823 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  48826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48841 */     GIR_RootConstrainSelectedInstOperands,
     /*  48842 */     // GIR_Coverage, 468,
     /*  48842 */     GIR_EraseRootFromParent_Done,
     /*  48843 */   // Label 1068: @48843
     /*  48843 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(48897), // Rule ID 524 //
     /*  48848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  48856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48877 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  48880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48895 */     GIR_RootConstrainSelectedInstOperands,
     /*  48896 */     // GIR_Coverage, 524,
     /*  48896 */     GIR_EraseRootFromParent_Done,
     /*  48897 */   // Label 1069: @48897
     /*  48897 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(48951), // Rule ID 525 //
     /*  48902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  48910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48931 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  48934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48949 */     GIR_RootConstrainSelectedInstOperands,
     /*  48950 */     // GIR_Coverage, 525,
     /*  48950 */     GIR_EraseRootFromParent_Done,
     /*  48951 */   // Label 1070: @48951
     /*  48951 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49005), // Rule ID 526 //
     /*  48956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  48964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48985 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  48988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49003 */     GIR_RootConstrainSelectedInstOperands,
     /*  49004 */     // GIR_Coverage, 526,
     /*  49004 */     GIR_EraseRootFromParent_Done,
     /*  49005 */   // Label 1071: @49005
     /*  49005 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49059), // Rule ID 527 //
     /*  49010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49039 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49057 */     GIR_RootConstrainSelectedInstOperands,
     /*  49058 */     // GIR_Coverage, 527,
     /*  49058 */     GIR_EraseRootFromParent_Done,
     /*  49059 */   // Label 1072: @49059
     /*  49059 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49104), // Rule ID 541 //
     /*  49064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49093 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49102 */     GIR_RootConstrainSelectedInstOperands,
     /*  49103 */     // GIR_Coverage, 541,
     /*  49103 */     GIR_EraseRootFromParent_Done,
     /*  49104 */   // Label 1073: @49104
     /*  49104 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49149), // Rule ID 542 //
     /*  49109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49138 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49147 */     GIR_RootConstrainSelectedInstOperands,
     /*  49148 */     // GIR_Coverage, 542,
     /*  49148 */     GIR_EraseRootFromParent_Done,
     /*  49149 */   // Label 1074: @49149
     /*  49149 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49194), // Rule ID 543 //
     /*  49154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49183 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49192 */     GIR_RootConstrainSelectedInstOperands,
     /*  49193 */     // GIR_Coverage, 543,
     /*  49193 */     GIR_EraseRootFromParent_Done,
     /*  49194 */   // Label 1075: @49194
     /*  49194 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49239), // Rule ID 544 //
     /*  49199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49228 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49237 */     GIR_RootConstrainSelectedInstOperands,
     /*  49238 */     // GIR_Coverage, 544,
     /*  49238 */     GIR_EraseRootFromParent_Done,
     /*  49239 */   // Label 1076: @49239
     /*  49239 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49284), // Rule ID 545 //
     /*  49244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49273 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49282 */     GIR_RootConstrainSelectedInstOperands,
     /*  49283 */     // GIR_Coverage, 545,
     /*  49283 */     GIR_EraseRootFromParent_Done,
     /*  49284 */   // Label 1077: @49284
     /*  49284 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49329), // Rule ID 546 //
     /*  49289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49318 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49327 */     GIR_RootConstrainSelectedInstOperands,
     /*  49328 */     // GIR_Coverage, 546,
     /*  49328 */     GIR_EraseRootFromParent_Done,
     /*  49329 */   // Label 1078: @49329
     /*  49329 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49383), // Rule ID 792 //
     /*  49334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49363 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49381 */     GIR_RootConstrainSelectedInstOperands,
     /*  49382 */     // GIR_Coverage, 792,
     /*  49382 */     GIR_EraseRootFromParent_Done,
     /*  49383 */   // Label 1079: @49383
     /*  49383 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49437), // Rule ID 793 //
     /*  49388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49417 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49435 */     GIR_RootConstrainSelectedInstOperands,
     /*  49436 */     // GIR_Coverage, 793,
     /*  49436 */     GIR_EraseRootFromParent_Done,
     /*  49437 */   // Label 1080: @49437
     /*  49437 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49491), // Rule ID 794 //
     /*  49442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49471 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49489 */     GIR_RootConstrainSelectedInstOperands,
     /*  49490 */     // GIR_Coverage, 794,
     /*  49490 */     GIR_EraseRootFromParent_Done,
     /*  49491 */   // Label 1081: @49491
     /*  49491 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49545), // Rule ID 795 //
     /*  49496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49525 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49543 */     GIR_RootConstrainSelectedInstOperands,
     /*  49544 */     // GIR_Coverage, 795,
     /*  49544 */     GIR_EraseRootFromParent_Done,
     /*  49545 */   // Label 1082: @49545
     /*  49545 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49599), // Rule ID 796 //
     /*  49550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49579 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3771:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49597 */     GIR_RootConstrainSelectedInstOperands,
     /*  49598 */     // GIR_Coverage, 796,
     /*  49598 */     GIR_EraseRootFromParent_Done,
     /*  49599 */   // Label 1083: @49599
     /*  49599 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49653), // Rule ID 797 //
     /*  49604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49633 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3771:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49651 */     GIR_RootConstrainSelectedInstOperands,
     /*  49652 */     // GIR_Coverage, 797,
     /*  49652 */     GIR_EraseRootFromParent_Done,
     /*  49653 */   // Label 1084: @49653
     /*  49653 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49707), // Rule ID 798 //
     /*  49658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49687 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49705 */     GIR_RootConstrainSelectedInstOperands,
     /*  49706 */     // GIR_Coverage, 798,
     /*  49706 */     GIR_EraseRootFromParent_Done,
     /*  49707 */   // Label 1085: @49707
     /*  49707 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49761), // Rule ID 799 //
     /*  49712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49741 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49759 */     GIR_RootConstrainSelectedInstOperands,
     /*  49760 */     // GIR_Coverage, 799,
     /*  49760 */     GIR_EraseRootFromParent_Done,
     /*  49761 */   // Label 1086: @49761
     /*  49761 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49815), // Rule ID 800 //
     /*  49766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49795 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3772:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49813 */     GIR_RootConstrainSelectedInstOperands,
     /*  49814 */     // GIR_Coverage, 800,
     /*  49814 */     GIR_EraseRootFromParent_Done,
     /*  49815 */   // Label 1087: @49815
     /*  49815 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(49869), // Rule ID 801 //
     /*  49820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49849 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3772:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  49852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49867 */     GIR_RootConstrainSelectedInstOperands,
     /*  49868 */     // GIR_Coverage, 801,
     /*  49868 */     GIR_EraseRootFromParent_Done,
     /*  49869 */   // Label 1088: @49869
     /*  49869 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(49923), // Rule ID 802 //
     /*  49874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49903 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3772:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  49906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49921 */     GIR_RootConstrainSelectedInstOperands,
     /*  49922 */     // GIR_Coverage, 802,
     /*  49922 */     GIR_EraseRootFromParent_Done,
     /*  49923 */   // Label 1089: @49923
     /*  49923 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(49977), // Rule ID 803 //
     /*  49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49957 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3772:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  49960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49975 */     GIR_RootConstrainSelectedInstOperands,
     /*  49976 */     // GIR_Coverage, 803,
     /*  49976 */     GIR_EraseRootFromParent_Done,
     /*  49977 */   // Label 1090: @49977
     /*  49977 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50031), // Rule ID 804 //
     /*  49982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50011 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3831:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50029 */     GIR_RootConstrainSelectedInstOperands,
     /*  50030 */     // GIR_Coverage, 804,
     /*  50030 */     GIR_EraseRootFromParent_Done,
     /*  50031 */   // Label 1091: @50031
     /*  50031 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50085), // Rule ID 805 //
     /*  50036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50065 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50083 */     GIR_RootConstrainSelectedInstOperands,
     /*  50084 */     // GIR_Coverage, 805,
     /*  50084 */     GIR_EraseRootFromParent_Done,
     /*  50085 */   // Label 1092: @50085
     /*  50085 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50139), // Rule ID 806 //
     /*  50090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50119 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3831:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50137 */     GIR_RootConstrainSelectedInstOperands,
     /*  50138 */     // GIR_Coverage, 806,
     /*  50138 */     GIR_EraseRootFromParent_Done,
     /*  50139 */   // Label 1093: @50139
     /*  50139 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50193), // Rule ID 807 //
     /*  50144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50173 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50191 */     GIR_RootConstrainSelectedInstOperands,
     /*  50192 */     // GIR_Coverage, 807,
     /*  50192 */     GIR_EraseRootFromParent_Done,
     /*  50193 */   // Label 1094: @50193
     /*  50193 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50247), // Rule ID 808 //
     /*  50198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50227 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3831:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50245 */     GIR_RootConstrainSelectedInstOperands,
     /*  50246 */     // GIR_Coverage, 808,
     /*  50246 */     GIR_EraseRootFromParent_Done,
     /*  50247 */   // Label 1095: @50247
     /*  50247 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50301), // Rule ID 809 //
     /*  50252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50281 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3831:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50299 */     GIR_RootConstrainSelectedInstOperands,
     /*  50300 */     // GIR_Coverage, 809,
     /*  50300 */     GIR_EraseRootFromParent_Done,
     /*  50301 */   // Label 1096: @50301
     /*  50301 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50355), // Rule ID 810 //
     /*  50306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50335 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3832:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50353 */     GIR_RootConstrainSelectedInstOperands,
     /*  50354 */     // GIR_Coverage, 810,
     /*  50354 */     GIR_EraseRootFromParent_Done,
     /*  50355 */   // Label 1097: @50355
     /*  50355 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50409), // Rule ID 811 //
     /*  50360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50389 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3832:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50407 */     GIR_RootConstrainSelectedInstOperands,
     /*  50408 */     // GIR_Coverage, 811,
     /*  50408 */     GIR_EraseRootFromParent_Done,
     /*  50409 */   // Label 1098: @50409
     /*  50409 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50463), // Rule ID 812 //
     /*  50414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50443 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3832:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50461 */     GIR_RootConstrainSelectedInstOperands,
     /*  50462 */     // GIR_Coverage, 812,
     /*  50462 */     GIR_EraseRootFromParent_Done,
     /*  50463 */   // Label 1099: @50463
     /*  50463 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50517), // Rule ID 813 //
     /*  50468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50497 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3832:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50515 */     GIR_RootConstrainSelectedInstOperands,
     /*  50516 */     // GIR_Coverage, 813,
     /*  50516 */     GIR_EraseRootFromParent_Done,
     /*  50517 */   // Label 1100: @50517
     /*  50517 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50571), // Rule ID 814 //
     /*  50522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50551 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3832:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50569 */     GIR_RootConstrainSelectedInstOperands,
     /*  50570 */     // GIR_Coverage, 814,
     /*  50570 */     GIR_EraseRootFromParent_Done,
     /*  50571 */   // Label 1101: @50571
     /*  50571 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50625), // Rule ID 815 //
     /*  50576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50605 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3832:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50623 */     GIR_RootConstrainSelectedInstOperands,
     /*  50624 */     // GIR_Coverage, 815,
     /*  50624 */     GIR_EraseRootFromParent_Done,
     /*  50625 */   // Label 1102: @50625
     /*  50625 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50679), // Rule ID 832 //
     /*  50630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50659 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3828:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50677 */     GIR_RootConstrainSelectedInstOperands,
     /*  50678 */     // GIR_Coverage, 832,
     /*  50678 */     GIR_EraseRootFromParent_Done,
     /*  50679 */   // Label 1103: @50679
     /*  50679 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50733), // Rule ID 833 //
     /*  50684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50713 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3828:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50731 */     GIR_RootConstrainSelectedInstOperands,
     /*  50732 */     // GIR_Coverage, 833,
     /*  50732 */     GIR_EraseRootFromParent_Done,
     /*  50733 */   // Label 1104: @50733
     /*  50733 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50787), // Rule ID 834 //
     /*  50738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50767 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3828:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50785 */     GIR_RootConstrainSelectedInstOperands,
     /*  50786 */     // GIR_Coverage, 834,
     /*  50786 */     GIR_EraseRootFromParent_Done,
     /*  50787 */   // Label 1105: @50787
     /*  50787 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(50841), // Rule ID 841 //
     /*  50792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50821 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3797:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  50824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50839 */     GIR_RootConstrainSelectedInstOperands,
     /*  50840 */     // GIR_Coverage, 841,
     /*  50840 */     GIR_EraseRootFromParent_Done,
     /*  50841 */   // Label 1106: @50841
     /*  50841 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(50895), // Rule ID 842 //
     /*  50846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50875 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3797:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  50878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50893 */     GIR_RootConstrainSelectedInstOperands,
     /*  50894 */     // GIR_Coverage, 842,
     /*  50894 */     GIR_EraseRootFromParent_Done,
     /*  50895 */   // Label 1107: @50895
     /*  50895 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(50949), // Rule ID 855 //
     /*  50900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50929 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  50932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50947 */     GIR_RootConstrainSelectedInstOperands,
     /*  50948 */     // GIR_Coverage, 855,
     /*  50948 */     GIR_EraseRootFromParent_Done,
     /*  50949 */   // Label 1108: @50949
     /*  50949 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51003), // Rule ID 856 //
     /*  50954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50983 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51001 */     GIR_RootConstrainSelectedInstOperands,
     /*  51002 */     // GIR_Coverage, 856,
     /*  51002 */     GIR_EraseRootFromParent_Done,
     /*  51003 */   // Label 1109: @51003
     /*  51003 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51057), // Rule ID 857 //
     /*  51008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51037 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3808:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51055 */     GIR_RootConstrainSelectedInstOperands,
     /*  51056 */     // GIR_Coverage, 857,
     /*  51056 */     GIR_EraseRootFromParent_Done,
     /*  51057 */   // Label 1110: @51057
     /*  51057 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51111), // Rule ID 858 //
     /*  51062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3808:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51109 */     GIR_RootConstrainSelectedInstOperands,
     /*  51110 */     // GIR_Coverage, 858,
     /*  51110 */     GIR_EraseRootFromParent_Done,
     /*  51111 */   // Label 1111: @51111
     /*  51111 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51165), // Rule ID 863 //
     /*  51116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51145 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51163 */     GIR_RootConstrainSelectedInstOperands,
     /*  51164 */     // GIR_Coverage, 863,
     /*  51164 */     GIR_EraseRootFromParent_Done,
     /*  51165 */   // Label 1112: @51165
     /*  51165 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51219), // Rule ID 864 //
     /*  51170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51199 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51217 */     GIR_RootConstrainSelectedInstOperands,
     /*  51218 */     // GIR_Coverage, 864,
     /*  51218 */     GIR_EraseRootFromParent_Done,
     /*  51219 */   // Label 1113: @51219
     /*  51219 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51273), // Rule ID 865 //
     /*  51224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51253 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51271 */     GIR_RootConstrainSelectedInstOperands,
     /*  51272 */     // GIR_Coverage, 865,
     /*  51272 */     GIR_EraseRootFromParent_Done,
     /*  51273 */   // Label 1114: @51273
     /*  51273 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51327), // Rule ID 866 //
     /*  51278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51307 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51325 */     GIR_RootConstrainSelectedInstOperands,
     /*  51326 */     // GIR_Coverage, 866,
     /*  51326 */     GIR_EraseRootFromParent_Done,
     /*  51327 */   // Label 1115: @51327
     /*  51327 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51381), // Rule ID 877 //
     /*  51332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51361 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3794:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51379 */     GIR_RootConstrainSelectedInstOperands,
     /*  51380 */     // GIR_Coverage, 877,
     /*  51380 */     GIR_EraseRootFromParent_Done,
     /*  51381 */   // Label 1116: @51381
     /*  51381 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51426), // Rule ID 878 //
     /*  51386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51415 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3794:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51424 */     GIR_RootConstrainSelectedInstOperands,
     /*  51425 */     // GIR_Coverage, 878,
     /*  51425 */     GIR_EraseRootFromParent_Done,
     /*  51426 */   // Label 1117: @51426
     /*  51426 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51480), // Rule ID 883 //
     /*  51431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51478 */     GIR_RootConstrainSelectedInstOperands,
     /*  51479 */     // GIR_Coverage, 883,
     /*  51479 */     GIR_EraseRootFromParent_Done,
     /*  51480 */   // Label 1118: @51480
     /*  51480 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51534), // Rule ID 884 //
     /*  51485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51514 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51532 */     GIR_RootConstrainSelectedInstOperands,
     /*  51533 */     // GIR_Coverage, 884,
     /*  51533 */     GIR_EraseRootFromParent_Done,
     /*  51534 */   // Label 1119: @51534
     /*  51534 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51588), // Rule ID 996 //
     /*  51539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51568 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3773:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51586 */     GIR_RootConstrainSelectedInstOperands,
     /*  51587 */     // GIR_Coverage, 996,
     /*  51587 */     GIR_EraseRootFromParent_Done,
     /*  51588 */   // Label 1120: @51588
     /*  51588 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51642), // Rule ID 997 //
     /*  51593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51622 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3773:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51640 */     GIR_RootConstrainSelectedInstOperands,
     /*  51641 */     // GIR_Coverage, 997,
     /*  51641 */     GIR_EraseRootFromParent_Done,
     /*  51642 */   // Label 1121: @51642
     /*  51642 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51696), // Rule ID 998 //
     /*  51647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51676 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3773:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51694 */     GIR_RootConstrainSelectedInstOperands,
     /*  51695 */     // GIR_Coverage, 998,
     /*  51695 */     GIR_EraseRootFromParent_Done,
     /*  51696 */   // Label 1122: @51696
     /*  51696 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51750), // Rule ID 999 //
     /*  51701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3773:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51748 */     GIR_RootConstrainSelectedInstOperands,
     /*  51749 */     // GIR_Coverage, 999,
     /*  51749 */     GIR_EraseRootFromParent_Done,
     /*  51750 */   // Label 1123: @51750
     /*  51750 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51804), // Rule ID 1000 //
     /*  51755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51784 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3773:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51802 */     GIR_RootConstrainSelectedInstOperands,
     /*  51803 */     // GIR_Coverage, 1000,
     /*  51803 */     GIR_EraseRootFromParent_Done,
     /*  51804 */   // Label 1124: @51804
     /*  51804 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(51858), // Rule ID 1001 //
     /*  51809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51838 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3773:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  51841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51856 */     GIR_RootConstrainSelectedInstOperands,
     /*  51857 */     // GIR_Coverage, 1001,
     /*  51857 */     GIR_EraseRootFromParent_Done,
     /*  51858 */   // Label 1125: @51858
     /*  51858 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(51912), // Rule ID 1002 //
     /*  51863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51892 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  51895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51910 */     GIR_RootConstrainSelectedInstOperands,
     /*  51911 */     // GIR_Coverage, 1002,
     /*  51911 */     GIR_EraseRootFromParent_Done,
     /*  51912 */   // Label 1126: @51912
     /*  51912 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(51966), // Rule ID 1003 //
     /*  51917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51946 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  51949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51964 */     GIR_RootConstrainSelectedInstOperands,
     /*  51965 */     // GIR_Coverage, 1003,
     /*  51965 */     GIR_EraseRootFromParent_Done,
     /*  51966 */   // Label 1127: @51966
     /*  51966 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52020), // Rule ID 1004 //
     /*  51971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52000 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3774:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52018 */     GIR_RootConstrainSelectedInstOperands,
     /*  52019 */     // GIR_Coverage, 1004,
     /*  52019 */     GIR_EraseRootFromParent_Done,
     /*  52020 */   // Label 1128: @52020
     /*  52020 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52074), // Rule ID 1005 //
     /*  52025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52054 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3774:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52072 */     GIR_RootConstrainSelectedInstOperands,
     /*  52073 */     // GIR_Coverage, 1005,
     /*  52073 */     GIR_EraseRootFromParent_Done,
     /*  52074 */   // Label 1129: @52074
     /*  52074 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52128), // Rule ID 1006 //
     /*  52079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52108 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3774:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52126 */     GIR_RootConstrainSelectedInstOperands,
     /*  52127 */     // GIR_Coverage, 1006,
     /*  52127 */     GIR_EraseRootFromParent_Done,
     /*  52128 */   // Label 1130: @52128
     /*  52128 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52182), // Rule ID 1007 //
     /*  52133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52162 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3774:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52180 */     GIR_RootConstrainSelectedInstOperands,
     /*  52181 */     // GIR_Coverage, 1007,
     /*  52181 */     GIR_EraseRootFromParent_Done,
     /*  52182 */   // Label 1131: @52182
     /*  52182 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52236), // Rule ID 1024 //
     /*  52187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52216 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3841:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52234 */     GIR_RootConstrainSelectedInstOperands,
     /*  52235 */     // GIR_Coverage, 1024,
     /*  52235 */     GIR_EraseRootFromParent_Done,
     /*  52236 */   // Label 1132: @52236
     /*  52236 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52290), // Rule ID 1025 //
     /*  52241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52270 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3841:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52288 */     GIR_RootConstrainSelectedInstOperands,
     /*  52289 */     // GIR_Coverage, 1025,
     /*  52289 */     GIR_EraseRootFromParent_Done,
     /*  52290 */   // Label 1133: @52290
     /*  52290 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52344), // Rule ID 1026 //
     /*  52295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52324 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3841:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52342 */     GIR_RootConstrainSelectedInstOperands,
     /*  52343 */     // GIR_Coverage, 1026,
     /*  52343 */     GIR_EraseRootFromParent_Done,
     /*  52344 */   // Label 1134: @52344
     /*  52344 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52398), // Rule ID 1119 //
     /*  52349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52378 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3749:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52396 */     GIR_RootConstrainSelectedInstOperands,
     /*  52397 */     // GIR_Coverage, 1119,
     /*  52397 */     GIR_EraseRootFromParent_Done,
     /*  52398 */   // Label 1135: @52398
     /*  52398 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52452), // Rule ID 1120 //
     /*  52403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52450 */     GIR_RootConstrainSelectedInstOperands,
     /*  52451 */     // GIR_Coverage, 1120,
     /*  52451 */     GIR_EraseRootFromParent_Done,
     /*  52452 */   // Label 1136: @52452
     /*  52452 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52506), // Rule ID 1121 //
     /*  52457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52486 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3749:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52504 */     GIR_RootConstrainSelectedInstOperands,
     /*  52505 */     // GIR_Coverage, 1121,
     /*  52505 */     GIR_EraseRootFromParent_Done,
     /*  52506 */   // Label 1137: @52506
     /*  52506 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52560), // Rule ID 1122 //
     /*  52511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52540 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3749:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52558 */     GIR_RootConstrainSelectedInstOperands,
     /*  52559 */     // GIR_Coverage, 1122,
     /*  52559 */     GIR_EraseRootFromParent_Done,
     /*  52560 */   // Label 1138: @52560
     /*  52560 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52614), // Rule ID 1123 //
     /*  52565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52594 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3750:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52612 */     GIR_RootConstrainSelectedInstOperands,
     /*  52613 */     // GIR_Coverage, 1123,
     /*  52613 */     GIR_EraseRootFromParent_Done,
     /*  52614 */   // Label 1139: @52614
     /*  52614 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52668), // Rule ID 1124 //
     /*  52619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52666 */     GIR_RootConstrainSelectedInstOperands,
     /*  52667 */     // GIR_Coverage, 1124,
     /*  52667 */     GIR_EraseRootFromParent_Done,
     /*  52668 */   // Label 1140: @52668
     /*  52668 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52722), // Rule ID 1125 //
     /*  52673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52702 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3750:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52720 */     GIR_RootConstrainSelectedInstOperands,
     /*  52721 */     // GIR_Coverage, 1125,
     /*  52721 */     GIR_EraseRootFromParent_Done,
     /*  52722 */   // Label 1141: @52722
     /*  52722 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52776), // Rule ID 1126 //
     /*  52727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52756 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3750:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52774 */     GIR_RootConstrainSelectedInstOperands,
     /*  52775 */     // GIR_Coverage, 1126,
     /*  52775 */     GIR_EraseRootFromParent_Done,
     /*  52776 */   // Label 1142: @52776
     /*  52776 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(52830), // Rule ID 1169 //
     /*  52781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52810 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3746:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52828 */     GIR_RootConstrainSelectedInstOperands,
     /*  52829 */     // GIR_Coverage, 1169,
     /*  52829 */     GIR_EraseRootFromParent_Done,
     /*  52830 */   // Label 1143: @52830
     /*  52830 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(52884), // Rule ID 1170 //
     /*  52835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52864 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3746:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  52867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52882 */     GIR_RootConstrainSelectedInstOperands,
     /*  52883 */     // GIR_Coverage, 1170,
     /*  52883 */     GIR_EraseRootFromParent_Done,
     /*  52884 */   // Label 1144: @52884
     /*  52884 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(52938), // Rule ID 1171 //
     /*  52889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52918 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3746:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  52921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52936 */     GIR_RootConstrainSelectedInstOperands,
     /*  52937 */     // GIR_Coverage, 1171,
     /*  52937 */     GIR_EraseRootFromParent_Done,
     /*  52938 */   // Label 1145: @52938
     /*  52938 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(52992), // Rule ID 1172 //
     /*  52943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52972 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3746:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  52975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52990 */     GIR_RootConstrainSelectedInstOperands,
     /*  52991 */     // GIR_Coverage, 1172,
     /*  52991 */     GIR_EraseRootFromParent_Done,
     /*  52992 */   // Label 1146: @52992
     /*  52992 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53046), // Rule ID 1237 //
     /*  52997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53026 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3800:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53044 */     GIR_RootConstrainSelectedInstOperands,
     /*  53045 */     // GIR_Coverage, 1237,
     /*  53045 */     GIR_EraseRootFromParent_Done,
     /*  53046 */   // Label 1147: @53046
     /*  53046 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53100), // Rule ID 1238 //
     /*  53051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53080 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53098 */     GIR_RootConstrainSelectedInstOperands,
     /*  53099 */     // GIR_Coverage, 1238,
     /*  53099 */     GIR_EraseRootFromParent_Done,
     /*  53100 */   // Label 1148: @53100
     /*  53100 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53154), // Rule ID 1239 //
     /*  53105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53134 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53152 */     GIR_RootConstrainSelectedInstOperands,
     /*  53153 */     // GIR_Coverage, 1239,
     /*  53153 */     GIR_EraseRootFromParent_Done,
     /*  53154 */   // Label 1149: @53154
     /*  53154 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53208), // Rule ID 1240 //
     /*  53159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53188 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53206 */     GIR_RootConstrainSelectedInstOperands,
     /*  53207 */     // GIR_Coverage, 1240,
     /*  53207 */     GIR_EraseRootFromParent_Done,
     /*  53208 */   // Label 1150: @53208
     /*  53208 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53262), // Rule ID 1241 //
     /*  53213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53242 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53260 */     GIR_RootConstrainSelectedInstOperands,
     /*  53261 */     // GIR_Coverage, 1241,
     /*  53261 */     GIR_EraseRootFromParent_Done,
     /*  53262 */   // Label 1151: @53262
     /*  53262 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53316), // Rule ID 1254 //
     /*  53267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53296 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53301 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53314 */     GIR_RootConstrainSelectedInstOperands,
     /*  53315 */     // GIR_Coverage, 1254,
     /*  53315 */     GIR_EraseRootFromParent_Done,
     /*  53316 */   // Label 1152: @53316
     /*  53316 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53370), // Rule ID 1255 //
     /*  53321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53350 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53368 */     GIR_RootConstrainSelectedInstOperands,
     /*  53369 */     // GIR_Coverage, 1255,
     /*  53369 */     GIR_EraseRootFromParent_Done,
     /*  53370 */   // Label 1153: @53370
     /*  53370 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53424), // Rule ID 1256 //
     /*  53375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53404 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53422 */     GIR_RootConstrainSelectedInstOperands,
     /*  53423 */     // GIR_Coverage, 1256,
     /*  53423 */     GIR_EraseRootFromParent_Done,
     /*  53424 */   // Label 1154: @53424
     /*  53424 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53478), // Rule ID 1257 //
     /*  53429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53458 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3798:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53476 */     GIR_RootConstrainSelectedInstOperands,
     /*  53477 */     // GIR_Coverage, 1257,
     /*  53477 */     GIR_EraseRootFromParent_Done,
     /*  53478 */   // Label 1155: @53478
     /*  53478 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53532), // Rule ID 1258 //
     /*  53483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53512 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53530 */     GIR_RootConstrainSelectedInstOperands,
     /*  53531 */     // GIR_Coverage, 1258,
     /*  53531 */     GIR_EraseRootFromParent_Done,
     /*  53532 */   // Label 1156: @53532
     /*  53532 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53586), // Rule ID 1259 //
     /*  53537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53566 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53584 */     GIR_RootConstrainSelectedInstOperands,
     /*  53585 */     // GIR_Coverage, 1259,
     /*  53585 */     GIR_EraseRootFromParent_Done,
     /*  53586 */   // Label 1157: @53586
     /*  53586 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53640), // Rule ID 1260 //
     /*  53591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53620 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3799:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53638 */     GIR_RootConstrainSelectedInstOperands,
     /*  53639 */     // GIR_Coverage, 1260,
     /*  53639 */     GIR_EraseRootFromParent_Done,
     /*  53640 */   // Label 1158: @53640
     /*  53640 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53694), // Rule ID 1261 //
     /*  53645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53674 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3799:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53692 */     GIR_RootConstrainSelectedInstOperands,
     /*  53693 */     // GIR_Coverage, 1261,
     /*  53693 */     GIR_EraseRootFromParent_Done,
     /*  53694 */   // Label 1159: @53694
     /*  53694 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53748), // Rule ID 1262 //
     /*  53699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53728 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3799:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53746 */     GIR_RootConstrainSelectedInstOperands,
     /*  53747 */     // GIR_Coverage, 1262,
     /*  53747 */     GIR_EraseRootFromParent_Done,
     /*  53748 */   // Label 1160: @53748
     /*  53748 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53802), // Rule ID 1263 //
     /*  53753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53782 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3799:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53800 */     GIR_RootConstrainSelectedInstOperands,
     /*  53801 */     // GIR_Coverage, 1263,
     /*  53801 */     GIR_EraseRootFromParent_Done,
     /*  53802 */   // Label 1161: @53802
     /*  53802 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(53856), // Rule ID 1264 //
     /*  53807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53836 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3799:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  53839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53854 */     GIR_RootConstrainSelectedInstOperands,
     /*  53855 */     // GIR_Coverage, 1264,
     /*  53855 */     GIR_EraseRootFromParent_Done,
     /*  53856 */   // Label 1162: @53856
     /*  53856 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(53910), // Rule ID 1265 //
     /*  53861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53890 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3799:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  53893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53895 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53908 */     GIR_RootConstrainSelectedInstOperands,
     /*  53909 */     // GIR_Coverage, 1265,
     /*  53909 */     GIR_EraseRootFromParent_Done,
     /*  53910 */   // Label 1163: @53910
     /*  53910 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(53964), // Rule ID 1266 //
     /*  53915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53944 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3803:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  53947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53962 */     GIR_RootConstrainSelectedInstOperands,
     /*  53963 */     // GIR_Coverage, 1266,
     /*  53963 */     GIR_EraseRootFromParent_Done,
     /*  53964 */   // Label 1164: @53964
     /*  53964 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54018), // Rule ID 1267 //
     /*  53969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53998 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54016 */     GIR_RootConstrainSelectedInstOperands,
     /*  54017 */     // GIR_Coverage, 1267,
     /*  54017 */     GIR_EraseRootFromParent_Done,
     /*  54018 */   // Label 1165: @54018
     /*  54018 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54072), // Rule ID 1268 //
     /*  54023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54052 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54070 */     GIR_RootConstrainSelectedInstOperands,
     /*  54071 */     // GIR_Coverage, 1268,
     /*  54071 */     GIR_EraseRootFromParent_Done,
     /*  54072 */   // Label 1166: @54072
     /*  54072 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54126), // Rule ID 1269 //
     /*  54077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54106 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3804:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54124 */     GIR_RootConstrainSelectedInstOperands,
     /*  54125 */     // GIR_Coverage, 1269,
     /*  54125 */     GIR_EraseRootFromParent_Done,
     /*  54126 */   // Label 1167: @54126
     /*  54126 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54180), // Rule ID 1270 //
     /*  54131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54160 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54178 */     GIR_RootConstrainSelectedInstOperands,
     /*  54179 */     // GIR_Coverage, 1270,
     /*  54179 */     GIR_EraseRootFromParent_Done,
     /*  54180 */   // Label 1168: @54180
     /*  54180 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54234), // Rule ID 1271 //
     /*  54185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54214 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54232 */     GIR_RootConstrainSelectedInstOperands,
     /*  54233 */     // GIR_Coverage, 1271,
     /*  54233 */     GIR_EraseRootFromParent_Done,
     /*  54234 */   // Label 1169: @54234
     /*  54234 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54288), // Rule ID 1272 //
     /*  54239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54268 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54286 */     GIR_RootConstrainSelectedInstOperands,
     /*  54287 */     // GIR_Coverage, 1272,
     /*  54287 */     GIR_EraseRootFromParent_Done,
     /*  54288 */   // Label 1170: @54288
     /*  54288 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54342), // Rule ID 1273 //
     /*  54293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54322 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54340 */     GIR_RootConstrainSelectedInstOperands,
     /*  54341 */     // GIR_Coverage, 1273,
     /*  54341 */     GIR_EraseRootFromParent_Done,
     /*  54342 */   // Label 1171: @54342
     /*  54342 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54396), // Rule ID 1274 //
     /*  54347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54376 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3805:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54394 */     GIR_RootConstrainSelectedInstOperands,
     /*  54395 */     // GIR_Coverage, 1274,
     /*  54395 */     GIR_EraseRootFromParent_Done,
     /*  54396 */   // Label 1172: @54396
     /*  54396 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54450), // Rule ID 1275 //
     /*  54401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54430 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54448 */     GIR_RootConstrainSelectedInstOperands,
     /*  54449 */     // GIR_Coverage, 1275,
     /*  54449 */     GIR_EraseRootFromParent_Done,
     /*  54450 */   // Label 1173: @54450
     /*  54450 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54504), // Rule ID 1276 //
     /*  54455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54484 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54502 */     GIR_RootConstrainSelectedInstOperands,
     /*  54503 */     // GIR_Coverage, 1276,
     /*  54503 */     GIR_EraseRootFromParent_Done,
     /*  54504 */   // Label 1174: @54504
     /*  54504 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54558), // Rule ID 1277 //
     /*  54509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54538 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3806:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54556 */     GIR_RootConstrainSelectedInstOperands,
     /*  54557 */     // GIR_Coverage, 1277,
     /*  54557 */     GIR_EraseRootFromParent_Done,
     /*  54558 */   // Label 1175: @54558
     /*  54558 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54612), // Rule ID 1278 //
     /*  54563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54592 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3806:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54610 */     GIR_RootConstrainSelectedInstOperands,
     /*  54611 */     // GIR_Coverage, 1278,
     /*  54611 */     GIR_EraseRootFromParent_Done,
     /*  54612 */   // Label 1176: @54612
     /*  54612 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54666), // Rule ID 1279 //
     /*  54617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54646 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54664 */     GIR_RootConstrainSelectedInstOperands,
     /*  54665 */     // GIR_Coverage, 1279,
     /*  54665 */     GIR_EraseRootFromParent_Done,
     /*  54666 */   // Label 1177: @54666
     /*  54666 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54720), // Rule ID 1280 //
     /*  54671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54700 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54718 */     GIR_RootConstrainSelectedInstOperands,
     /*  54719 */     // GIR_Coverage, 1280,
     /*  54719 */     GIR_EraseRootFromParent_Done,
     /*  54720 */   // Label 1178: @54720
     /*  54720 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54774), // Rule ID 1281 //
     /*  54725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54754 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54772 */     GIR_RootConstrainSelectedInstOperands,
     /*  54773 */     // GIR_Coverage, 1281,
     /*  54773 */     GIR_EraseRootFromParent_Done,
     /*  54774 */   // Label 1179: @54774
     /*  54774 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(54828), // Rule ID 1288 //
     /*  54779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54808 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3830:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54826 */     GIR_RootConstrainSelectedInstOperands,
     /*  54827 */     // GIR_Coverage, 1288,
     /*  54827 */     GIR_EraseRootFromParent_Done,
     /*  54828 */   // Label 1180: @54828
     /*  54828 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(54882), // Rule ID 1289 //
     /*  54833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54862 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3830:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  54862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  54865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54880 */     GIR_RootConstrainSelectedInstOperands,
     /*  54881 */     // GIR_Coverage, 1289,
     /*  54881 */     GIR_EraseRootFromParent_Done,
     /*  54882 */   // Label 1181: @54882
     /*  54882 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(54936), // Rule ID 1290 //
     /*  54887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54916 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3830:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  54919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54934 */     GIR_RootConstrainSelectedInstOperands,
     /*  54935 */     // GIR_Coverage, 1290,
     /*  54935 */     GIR_EraseRootFromParent_Done,
     /*  54936 */   // Label 1182: @54936
     /*  54936 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(54990), // Rule ID 1291 //
     /*  54941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54970 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3830:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  54970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  54973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54988 */     GIR_RootConstrainSelectedInstOperands,
     /*  54989 */     // GIR_Coverage, 1291,
     /*  54989 */     GIR_EraseRootFromParent_Done,
     /*  54990 */   // Label 1183: @54990
     /*  54990 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55044), // Rule ID 1298 //
     /*  54995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55024 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3840:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55042 */     GIR_RootConstrainSelectedInstOperands,
     /*  55043 */     // GIR_Coverage, 1298,
     /*  55043 */     GIR_EraseRootFromParent_Done,
     /*  55044 */   // Label 1184: @55044
     /*  55044 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55098), // Rule ID 1299 //
     /*  55049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55078 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3840:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55096 */     GIR_RootConstrainSelectedInstOperands,
     /*  55097 */     // GIR_Coverage, 1299,
     /*  55097 */     GIR_EraseRootFromParent_Done,
     /*  55098 */   // Label 1185: @55098
     /*  55098 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55152), // Rule ID 1300 //
     /*  55103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55132 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3840:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55150 */     GIR_RootConstrainSelectedInstOperands,
     /*  55151 */     // GIR_Coverage, 1300,
     /*  55151 */     GIR_EraseRootFromParent_Done,
     /*  55152 */   // Label 1186: @55152
     /*  55152 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55206), // Rule ID 1301 //
     /*  55157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55186 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3840:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55204 */     GIR_RootConstrainSelectedInstOperands,
     /*  55205 */     // GIR_Coverage, 1301,
     /*  55205 */     GIR_EraseRootFromParent_Done,
     /*  55206 */   // Label 1187: @55206
     /*  55206 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55260), // Rule ID 1302 //
     /*  55211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55240 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3843:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55258 */     GIR_RootConstrainSelectedInstOperands,
     /*  55259 */     // GIR_Coverage, 1302,
     /*  55259 */     GIR_EraseRootFromParent_Done,
     /*  55260 */   // Label 1188: @55260
     /*  55260 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55314), // Rule ID 1303 //
     /*  55265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55294 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3843:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55312 */     GIR_RootConstrainSelectedInstOperands,
     /*  55313 */     // GIR_Coverage, 1303,
     /*  55313 */     GIR_EraseRootFromParent_Done,
     /*  55314 */   // Label 1189: @55314
     /*  55314 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55368), // Rule ID 1304 //
     /*  55319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55348 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3843:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55366 */     GIR_RootConstrainSelectedInstOperands,
     /*  55367 */     // GIR_Coverage, 1304,
     /*  55367 */     GIR_EraseRootFromParent_Done,
     /*  55368 */   // Label 1190: @55368
     /*  55368 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55422), // Rule ID 1305 //
     /*  55373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55402 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3843:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55420 */     GIR_RootConstrainSelectedInstOperands,
     /*  55421 */     // GIR_Coverage, 1305,
     /*  55421 */     GIR_EraseRootFromParent_Done,
     /*  55422 */   // Label 1191: @55422
     /*  55422 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55476), // Rule ID 1306 //
     /*  55427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55456 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3843:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55474 */     GIR_RootConstrainSelectedInstOperands,
     /*  55475 */     // GIR_Coverage, 1306,
     /*  55475 */     GIR_EraseRootFromParent_Done,
     /*  55476 */   // Label 1192: @55476
     /*  55476 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55530), // Rule ID 1307 //
     /*  55481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55510 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3843:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55528 */     GIR_RootConstrainSelectedInstOperands,
     /*  55529 */     // GIR_Coverage, 1307,
     /*  55529 */     GIR_EraseRootFromParent_Done,
     /*  55530 */   // Label 1193: @55530
     /*  55530 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55584), // Rule ID 1308 //
     /*  55535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55564 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3843:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55582 */     GIR_RootConstrainSelectedInstOperands,
     /*  55583 */     // GIR_Coverage, 1308,
     /*  55583 */     GIR_EraseRootFromParent_Done,
     /*  55584 */   // Label 1194: @55584
     /*  55584 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55638), // Rule ID 1309 //
     /*  55589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55618 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3843:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55636 */     GIR_RootConstrainSelectedInstOperands,
     /*  55637 */     // GIR_Coverage, 1309,
     /*  55637 */     GIR_EraseRootFromParent_Done,
     /*  55638 */   // Label 1195: @55638
     /*  55638 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55692), // Rule ID 1310 //
     /*  55643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55672 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3844:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55690 */     GIR_RootConstrainSelectedInstOperands,
     /*  55691 */     // GIR_Coverage, 1310,
     /*  55691 */     GIR_EraseRootFromParent_Done,
     /*  55692 */   // Label 1196: @55692
     /*  55692 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55746), // Rule ID 1311 //
     /*  55697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55726 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3844:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55744 */     GIR_RootConstrainSelectedInstOperands,
     /*  55745 */     // GIR_Coverage, 1311,
     /*  55745 */     GIR_EraseRootFromParent_Done,
     /*  55746 */   // Label 1197: @55746
     /*  55746 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55800), // Rule ID 1312 //
     /*  55751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55780 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3844:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55798 */     GIR_RootConstrainSelectedInstOperands,
     /*  55799 */     // GIR_Coverage, 1312,
     /*  55799 */     GIR_EraseRootFromParent_Done,
     /*  55800 */   // Label 1198: @55800
     /*  55800 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(55854), // Rule ID 1313 //
     /*  55805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55834 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3844:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  55837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55852 */     GIR_RootConstrainSelectedInstOperands,
     /*  55853 */     // GIR_Coverage, 1313,
     /*  55853 */     GIR_EraseRootFromParent_Done,
     /*  55854 */   // Label 1199: @55854
     /*  55854 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(55908), // Rule ID 1314 //
     /*  55859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55888 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3844:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  55891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55906 */     GIR_RootConstrainSelectedInstOperands,
     /*  55907 */     // GIR_Coverage, 1314,
     /*  55907 */     GIR_EraseRootFromParent_Done,
     /*  55908 */   // Label 1200: @55908
     /*  55908 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(55962), // Rule ID 1315 //
     /*  55913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55942 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3844:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  55945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55960 */     GIR_RootConstrainSelectedInstOperands,
     /*  55961 */     // GIR_Coverage, 1315,
     /*  55961 */     GIR_EraseRootFromParent_Done,
     /*  55962 */   // Label 1201: @55962
     /*  55962 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56016), // Rule ID 1316 //
     /*  55967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55996 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3844:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  55999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56014 */     GIR_RootConstrainSelectedInstOperands,
     /*  56015 */     // GIR_Coverage, 1316,
     /*  56015 */     GIR_EraseRootFromParent_Done,
     /*  56016 */   // Label 1202: @56016
     /*  56016 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56070), // Rule ID 1317 //
     /*  56021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56050 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3844:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56068 */     GIR_RootConstrainSelectedInstOperands,
     /*  56069 */     // GIR_Coverage, 1317,
     /*  56069 */     GIR_EraseRootFromParent_Done,
     /*  56070 */   // Label 1203: @56070
     /*  56070 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56124), // Rule ID 1351 //
     /*  56075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56104 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3837:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56122 */     GIR_RootConstrainSelectedInstOperands,
     /*  56123 */     // GIR_Coverage, 1351,
     /*  56123 */     GIR_EraseRootFromParent_Done,
     /*  56124 */   // Label 1204: @56124
     /*  56124 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56178), // Rule ID 1352 //
     /*  56129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56158 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3837:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56176 */     GIR_RootConstrainSelectedInstOperands,
     /*  56177 */     // GIR_Coverage, 1352,
     /*  56177 */     GIR_EraseRootFromParent_Done,
     /*  56178 */   // Label 1205: @56178
     /*  56178 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56232), // Rule ID 1353 //
     /*  56183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3837:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56230 */     GIR_RootConstrainSelectedInstOperands,
     /*  56231 */     // GIR_Coverage, 1353,
     /*  56231 */     GIR_EraseRootFromParent_Done,
     /*  56232 */   // Label 1206: @56232
     /*  56232 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56286), // Rule ID 1354 //
     /*  56237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56266 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3837:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56284 */     GIR_RootConstrainSelectedInstOperands,
     /*  56285 */     // GIR_Coverage, 1354,
     /*  56285 */     GIR_EraseRootFromParent_Done,
     /*  56286 */   // Label 1207: @56286
     /*  56286 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56340), // Rule ID 1355 //
     /*  56291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56320 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3837:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56338 */     GIR_RootConstrainSelectedInstOperands,
     /*  56339 */     // GIR_Coverage, 1355,
     /*  56339 */     GIR_EraseRootFromParent_Done,
     /*  56340 */   // Label 1208: @56340
     /*  56340 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56394), // Rule ID 1356 //
     /*  56345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56374 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3837:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56392 */     GIR_RootConstrainSelectedInstOperands,
     /*  56393 */     // GIR_Coverage, 1356,
     /*  56393 */     GIR_EraseRootFromParent_Done,
     /*  56394 */   // Label 1209: @56394
     /*  56394 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56448), // Rule ID 1357 //
     /*  56399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56428 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3837:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56446 */     GIR_RootConstrainSelectedInstOperands,
     /*  56447 */     // GIR_Coverage, 1357,
     /*  56447 */     GIR_EraseRootFromParent_Done,
     /*  56448 */   // Label 1210: @56448
     /*  56448 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56502), // Rule ID 1358 //
     /*  56453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56482 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3837:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56500 */     GIR_RootConstrainSelectedInstOperands,
     /*  56501 */     // GIR_Coverage, 1358,
     /*  56501 */     GIR_EraseRootFromParent_Done,
     /*  56502 */   // Label 1211: @56502
     /*  56502 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56556), // Rule ID 1359 //
     /*  56507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3838:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56554 */     GIR_RootConstrainSelectedInstOperands,
     /*  56555 */     // GIR_Coverage, 1359,
     /*  56555 */     GIR_EraseRootFromParent_Done,
     /*  56556 */   // Label 1212: @56556
     /*  56556 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56610), // Rule ID 1360 //
     /*  56561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56590 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3838:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56608 */     GIR_RootConstrainSelectedInstOperands,
     /*  56609 */     // GIR_Coverage, 1360,
     /*  56609 */     GIR_EraseRootFromParent_Done,
     /*  56610 */   // Label 1213: @56610
     /*  56610 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56664), // Rule ID 1361 //
     /*  56615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56644 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3838:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56662 */     GIR_RootConstrainSelectedInstOperands,
     /*  56663 */     // GIR_Coverage, 1361,
     /*  56663 */     GIR_EraseRootFromParent_Done,
     /*  56664 */   // Label 1214: @56664
     /*  56664 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56718), // Rule ID 1362 //
     /*  56669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3838:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56716 */     GIR_RootConstrainSelectedInstOperands,
     /*  56717 */     // GIR_Coverage, 1362,
     /*  56717 */     GIR_EraseRootFromParent_Done,
     /*  56718 */   // Label 1215: @56718
     /*  56718 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56772), // Rule ID 1363 //
     /*  56723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56752 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3838:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56770 */     GIR_RootConstrainSelectedInstOperands,
     /*  56771 */     // GIR_Coverage, 1363,
     /*  56771 */     GIR_EraseRootFromParent_Done,
     /*  56772 */   // Label 1216: @56772
     /*  56772 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(56826), // Rule ID 1364 //
     /*  56777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3838:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56824 */     GIR_RootConstrainSelectedInstOperands,
     /*  56825 */     // GIR_Coverage, 1364,
     /*  56825 */     GIR_EraseRootFromParent_Done,
     /*  56826 */   // Label 1217: @56826
     /*  56826 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(56880), // Rule ID 1365 //
     /*  56831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56860 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3838:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  56863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56878 */     GIR_RootConstrainSelectedInstOperands,
     /*  56879 */     // GIR_Coverage, 1365,
     /*  56879 */     GIR_EraseRootFromParent_Done,
     /*  56880 */   // Label 1218: @56880
     /*  56880 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(56934), // Rule ID 1366 //
     /*  56885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56914 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3838:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  56917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56932 */     GIR_RootConstrainSelectedInstOperands,
     /*  56933 */     // GIR_Coverage, 1366,
     /*  56933 */     GIR_EraseRootFromParent_Done,
     /*  56934 */   // Label 1219: @56934
     /*  56934 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(56988), // Rule ID 1386 //
     /*  56939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56968 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 1386,
     /*  56987 */     GIR_EraseRootFromParent_Done,
     /*  56988 */   // Label 1220: @56988
     /*  56988 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57042), // Rule ID 1387 //
     /*  56993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57022 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57040 */     GIR_RootConstrainSelectedInstOperands,
     /*  57041 */     // GIR_Coverage, 1387,
     /*  57041 */     GIR_EraseRootFromParent_Done,
     /*  57042 */   // Label 1221: @57042
     /*  57042 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57096), // Rule ID 1388 //
     /*  57047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57094 */     GIR_RootConstrainSelectedInstOperands,
     /*  57095 */     // GIR_Coverage, 1388,
     /*  57095 */     GIR_EraseRootFromParent_Done,
     /*  57096 */   // Label 1222: @57096
     /*  57096 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57150), // Rule ID 1389 //
     /*  57101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57148 */     GIR_RootConstrainSelectedInstOperands,
     /*  57149 */     // GIR_Coverage, 1389,
     /*  57149 */     GIR_EraseRootFromParent_Done,
     /*  57150 */   // Label 1223: @57150
     /*  57150 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57204), // Rule ID 1390 //
     /*  57155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57184 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3825:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57202 */     GIR_RootConstrainSelectedInstOperands,
     /*  57203 */     // GIR_Coverage, 1390,
     /*  57203 */     GIR_EraseRootFromParent_Done,
     /*  57204 */   // Label 1224: @57204
     /*  57204 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57258), // Rule ID 1391 //
     /*  57209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57238 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3825:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57256 */     GIR_RootConstrainSelectedInstOperands,
     /*  57257 */     // GIR_Coverage, 1391,
     /*  57257 */     GIR_EraseRootFromParent_Done,
     /*  57258 */   // Label 1225: @57258
     /*  57258 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57312), // Rule ID 1392 //
     /*  57263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57292 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3825:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57310 */     GIR_RootConstrainSelectedInstOperands,
     /*  57311 */     // GIR_Coverage, 1392,
     /*  57311 */     GIR_EraseRootFromParent_Done,
     /*  57312 */   // Label 1226: @57312
     /*  57312 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57366), // Rule ID 1393 //
     /*  57317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57346 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3825:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57364 */     GIR_RootConstrainSelectedInstOperands,
     /*  57365 */     // GIR_Coverage, 1393,
     /*  57365 */     GIR_EraseRootFromParent_Done,
     /*  57366 */   // Label 1227: @57366
     /*  57366 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57420), // Rule ID 1394 //
     /*  57371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57400 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3827:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57418 */     GIR_RootConstrainSelectedInstOperands,
     /*  57419 */     // GIR_Coverage, 1394,
     /*  57419 */     GIR_EraseRootFromParent_Done,
     /*  57420 */   // Label 1228: @57420
     /*  57420 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57474), // Rule ID 1395 //
     /*  57425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57454 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3827:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57472 */     GIR_RootConstrainSelectedInstOperands,
     /*  57473 */     // GIR_Coverage, 1395,
     /*  57473 */     GIR_EraseRootFromParent_Done,
     /*  57474 */   // Label 1229: @57474
     /*  57474 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57528), // Rule ID 1396 //
     /*  57479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3827:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57526 */     GIR_RootConstrainSelectedInstOperands,
     /*  57527 */     // GIR_Coverage, 1396,
     /*  57527 */     GIR_EraseRootFromParent_Done,
     /*  57528 */   // Label 1230: @57528
     /*  57528 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57582), // Rule ID 1397 //
     /*  57533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57562 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3827:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57580 */     GIR_RootConstrainSelectedInstOperands,
     /*  57581 */     // GIR_Coverage, 1397,
     /*  57581 */     GIR_EraseRootFromParent_Done,
     /*  57582 */   // Label 1231: @57582
     /*  57582 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57636), // Rule ID 1398 //
     /*  57587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57616 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3827:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57634 */     GIR_RootConstrainSelectedInstOperands,
     /*  57635 */     // GIR_Coverage, 1398,
     /*  57635 */     GIR_EraseRootFromParent_Done,
     /*  57636 */   // Label 1232: @57636
     /*  57636 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57690), // Rule ID 1399 //
     /*  57641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57670 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3827:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57688 */     GIR_RootConstrainSelectedInstOperands,
     /*  57689 */     // GIR_Coverage, 1399,
     /*  57689 */     GIR_EraseRootFromParent_Done,
     /*  57690 */   // Label 1233: @57690
     /*  57690 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57744), // Rule ID 1400 //
     /*  57695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57724 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3827:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57742 */     GIR_RootConstrainSelectedInstOperands,
     /*  57743 */     // GIR_Coverage, 1400,
     /*  57743 */     GIR_EraseRootFromParent_Done,
     /*  57744 */   // Label 1234: @57744
     /*  57744 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57798), // Rule ID 1401 //
     /*  57749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57778 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3827:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57796 */     GIR_RootConstrainSelectedInstOperands,
     /*  57797 */     // GIR_Coverage, 1401,
     /*  57797 */     GIR_EraseRootFromParent_Done,
     /*  57798 */   // Label 1235: @57798
     /*  57798 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(57852), // Rule ID 1435 //
     /*  57803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57832 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  57835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57850 */     GIR_RootConstrainSelectedInstOperands,
     /*  57851 */     // GIR_Coverage, 1435,
     /*  57851 */     GIR_EraseRootFromParent_Done,
     /*  57852 */   // Label 1236: @57852
     /*  57852 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(57906), // Rule ID 1436 //
     /*  57857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57886 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57904 */     GIR_RootConstrainSelectedInstOperands,
     /*  57905 */     // GIR_Coverage, 1436,
     /*  57905 */     GIR_EraseRootFromParent_Done,
     /*  57906 */   // Label 1237: @57906
     /*  57906 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(57960), // Rule ID 1437 //
     /*  57911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57940 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  57943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57958 */     GIR_RootConstrainSelectedInstOperands,
     /*  57959 */     // GIR_Coverage, 1437,
     /*  57959 */     GIR_EraseRootFromParent_Done,
     /*  57960 */   // Label 1238: @57960
     /*  57960 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58014), // Rule ID 1438 //
     /*  57965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57994 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58012 */     GIR_RootConstrainSelectedInstOperands,
     /*  58013 */     // GIR_Coverage, 1438,
     /*  58013 */     GIR_EraseRootFromParent_Done,
     /*  58014 */   // Label 1239: @58014
     /*  58014 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58068), // Rule ID 1439 //
     /*  58019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58048 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3820:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58066 */     GIR_RootConstrainSelectedInstOperands,
     /*  58067 */     // GIR_Coverage, 1439,
     /*  58067 */     GIR_EraseRootFromParent_Done,
     /*  58068 */   // Label 1240: @58068
     /*  58068 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58122), // Rule ID 1440 //
     /*  58073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3820:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58120 */     GIR_RootConstrainSelectedInstOperands,
     /*  58121 */     // GIR_Coverage, 1440,
     /*  58121 */     GIR_EraseRootFromParent_Done,
     /*  58122 */   // Label 1241: @58122
     /*  58122 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58176), // Rule ID 1441 //
     /*  58127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58156 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3820:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58174 */     GIR_RootConstrainSelectedInstOperands,
     /*  58175 */     // GIR_Coverage, 1441,
     /*  58175 */     GIR_EraseRootFromParent_Done,
     /*  58176 */   // Label 1242: @58176
     /*  58176 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58230), // Rule ID 1442 //
     /*  58181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58210 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3820:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58228 */     GIR_RootConstrainSelectedInstOperands,
     /*  58229 */     // GIR_Coverage, 1442,
     /*  58229 */     GIR_EraseRootFromParent_Done,
     /*  58230 */   // Label 1243: @58230
     /*  58230 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58284), // Rule ID 1443 //
     /*  58235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3821:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58282 */     GIR_RootConstrainSelectedInstOperands,
     /*  58283 */     // GIR_Coverage, 1443,
     /*  58283 */     GIR_EraseRootFromParent_Done,
     /*  58284 */   // Label 1244: @58284
     /*  58284 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58338), // Rule ID 1444 //
     /*  58289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58318 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3821:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58336 */     GIR_RootConstrainSelectedInstOperands,
     /*  58337 */     // GIR_Coverage, 1444,
     /*  58337 */     GIR_EraseRootFromParent_Done,
     /*  58338 */   // Label 1245: @58338
     /*  58338 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58392), // Rule ID 1445 //
     /*  58343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3821:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58390 */     GIR_RootConstrainSelectedInstOperands,
     /*  58391 */     // GIR_Coverage, 1445,
     /*  58391 */     GIR_EraseRootFromParent_Done,
     /*  58392 */   // Label 1246: @58392
     /*  58392 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58446), // Rule ID 1446 //
     /*  58397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58426 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3821:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58444 */     GIR_RootConstrainSelectedInstOperands,
     /*  58445 */     // GIR_Coverage, 1446,
     /*  58445 */     GIR_EraseRootFromParent_Done,
     /*  58446 */   // Label 1247: @58446
     /*  58446 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58500), // Rule ID 1447 //
     /*  58451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58480 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3821:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58498 */     GIR_RootConstrainSelectedInstOperands,
     /*  58499 */     // GIR_Coverage, 1447,
     /*  58499 */     GIR_EraseRootFromParent_Done,
     /*  58500 */   // Label 1248: @58500
     /*  58500 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58554), // Rule ID 1448 //
     /*  58505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58534 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3821:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58552 */     GIR_RootConstrainSelectedInstOperands,
     /*  58553 */     // GIR_Coverage, 1448,
     /*  58553 */     GIR_EraseRootFromParent_Done,
     /*  58554 */   // Label 1249: @58554
     /*  58554 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58608), // Rule ID 1449 //
     /*  58559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58588 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3821:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58606 */     GIR_RootConstrainSelectedInstOperands,
     /*  58607 */     // GIR_Coverage, 1449,
     /*  58607 */     GIR_EraseRootFromParent_Done,
     /*  58608 */   // Label 1250: @58608
     /*  58608 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58662), // Rule ID 1450 //
     /*  58613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3821:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58660 */     GIR_RootConstrainSelectedInstOperands,
     /*  58661 */     // GIR_Coverage, 1450,
     /*  58661 */     GIR_EraseRootFromParent_Done,
     /*  58662 */   // Label 1251: @58662
     /*  58662 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58707), // Rule ID 1715 //
     /*  58667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58696 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3722:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58705 */     GIR_RootConstrainSelectedInstOperands,
     /*  58706 */     // GIR_Coverage, 1715,
     /*  58706 */     GIR_EraseRootFromParent_Done,
     /*  58707 */   // Label 1252: @58707
     /*  58707 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58752), // Rule ID 1716 //
     /*  58712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58741 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3723:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58750 */     GIR_RootConstrainSelectedInstOperands,
     /*  58751 */     // GIR_Coverage, 1716,
     /*  58751 */     GIR_EraseRootFromParent_Done,
     /*  58752 */   // Label 1253: @58752
     /*  58752 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58797), // Rule ID 1719 //
     /*  58757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58786 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58795 */     GIR_RootConstrainSelectedInstOperands,
     /*  58796 */     // GIR_Coverage, 1719,
     /*  58796 */     GIR_EraseRootFromParent_Done,
     /*  58797 */   // Label 1254: @58797
     /*  58797 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(58842), // Rule ID 1720 //
     /*  58802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58831 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  58834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58840 */     GIR_RootConstrainSelectedInstOperands,
     /*  58841 */     // GIR_Coverage, 1720,
     /*  58841 */     GIR_EraseRootFromParent_Done,
     /*  58842 */   // Label 1255: @58842
     /*  58842 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(58896), // Rule ID 1729 //
     /*  58847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  58855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58876 */     // (intrinsic_wo_chain:{ *:[i32] } 3585:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  58879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58881 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58894 */     GIR_RootConstrainSelectedInstOperands,
     /*  58895 */     // GIR_Coverage, 1729,
     /*  58895 */     GIR_EraseRootFromParent_Done,
     /*  58896 */   // Label 1256: @58896
     /*  58896 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(58950), // Rule ID 1730 //
     /*  58901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  58909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58930 */     // (intrinsic_wo_chain:{ *:[i32] } 3592:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  58933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58935 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58948 */     GIR_RootConstrainSelectedInstOperands,
     /*  58949 */     // GIR_Coverage, 1730,
     /*  58949 */     GIR_EraseRootFromParent_Done,
     /*  58950 */   // Label 1257: @58950
     /*  58950 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59007), // Rule ID 1853 //
     /*  58955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  58963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58984 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  58984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  58987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58989 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  58991 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  58993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59005 */     GIR_RootConstrainSelectedInstOperands,
     /*  59006 */     // GIR_Coverage, 1853,
     /*  59006 */     GIR_EraseRootFromParent_Done,
     /*  59007 */   // Label 1258: @59007
     /*  59007 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59064), // Rule ID 1860 //
     /*  59012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59041 */     // (intrinsic_wo_chain:{ *:[i32] } 3945:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59046 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59048 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59062 */     GIR_RootConstrainSelectedInstOperands,
     /*  59063 */     // GIR_Coverage, 1860,
     /*  59063 */     GIR_EraseRootFromParent_Done,
     /*  59064 */   // Label 1259: @59064
     /*  59064 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59118), // Rule ID 1907 //
     /*  59069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59098 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59116 */     GIR_RootConstrainSelectedInstOperands,
     /*  59117 */     // GIR_Coverage, 1907,
     /*  59117 */     GIR_EraseRootFromParent_Done,
     /*  59118 */   // Label 1260: @59118
     /*  59118 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59172), // Rule ID 1908 //
     /*  59123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59152 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59170 */     GIR_RootConstrainSelectedInstOperands,
     /*  59171 */     // GIR_Coverage, 1908,
     /*  59171 */     GIR_EraseRootFromParent_Done,
     /*  59172 */   // Label 1261: @59172
     /*  59172 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59226), // Rule ID 1909 //
     /*  59177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59206 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59224 */     GIR_RootConstrainSelectedInstOperands,
     /*  59225 */     // GIR_Coverage, 1909,
     /*  59225 */     GIR_EraseRootFromParent_Done,
     /*  59226 */   // Label 1262: @59226
     /*  59226 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59280), // Rule ID 1910 //
     /*  59231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59260 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 1910,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 1263: @59280
     /*  59280 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59334), // Rule ID 1984 //
     /*  59285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59314 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59319 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59321 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59332 */     GIR_RootConstrainSelectedInstOperands,
     /*  59333 */     // GIR_Coverage, 1984,
     /*  59333 */     GIR_EraseRootFromParent_Done,
     /*  59334 */   // Label 1264: @59334
     /*  59334 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59388), // Rule ID 1985 //
     /*  59339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59368 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59373 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59375 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59386 */     GIR_RootConstrainSelectedInstOperands,
     /*  59387 */     // GIR_Coverage, 1985,
     /*  59387 */     GIR_EraseRootFromParent_Done,
     /*  59388 */   // Label 1265: @59388
     /*  59388 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59442), // Rule ID 1986 //
     /*  59393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59422 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59427 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59429 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59440 */     GIR_RootConstrainSelectedInstOperands,
     /*  59441 */     // GIR_Coverage, 1986,
     /*  59441 */     GIR_EraseRootFromParent_Done,
     /*  59442 */   // Label 1266: @59442
     /*  59442 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59496), // Rule ID 1987 //
     /*  59447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59476 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59481 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59483 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59494 */     GIR_RootConstrainSelectedInstOperands,
     /*  59495 */     // GIR_Coverage, 1987,
     /*  59495 */     GIR_EraseRootFromParent_Done,
     /*  59496 */   // Label 1267: @59496
     /*  59496 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59550), // Rule ID 1988 //
     /*  59501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59530 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59535 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59537 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59548 */     GIR_RootConstrainSelectedInstOperands,
     /*  59549 */     // GIR_Coverage, 1988,
     /*  59549 */     GIR_EraseRootFromParent_Done,
     /*  59550 */   // Label 1268: @59550
     /*  59550 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59604), // Rule ID 1989 //
     /*  59555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59584 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59589 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59591 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59602 */     GIR_RootConstrainSelectedInstOperands,
     /*  59603 */     // GIR_Coverage, 1989,
     /*  59603 */     GIR_EraseRootFromParent_Done,
     /*  59604 */   // Label 1269: @59604
     /*  59604 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59661), // Rule ID 2100 //
     /*  59609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59638 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59659 */     GIR_RootConstrainSelectedInstOperands,
     /*  59660 */     // GIR_Coverage, 2100,
     /*  59660 */     GIR_EraseRootFromParent_Done,
     /*  59661 */   // Label 1270: @59661
     /*  59661 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59715), // Rule ID 2130 //
     /*  59666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59695 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59713 */     GIR_RootConstrainSelectedInstOperands,
     /*  59714 */     // GIR_Coverage, 2130,
     /*  59714 */     GIR_EraseRootFromParent_Done,
     /*  59715 */   // Label 1271: @59715
     /*  59715 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59769), // Rule ID 2131 //
     /*  59720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59749 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59767 */     GIR_RootConstrainSelectedInstOperands,
     /*  59768 */     // GIR_Coverage, 2131,
     /*  59768 */     GIR_EraseRootFromParent_Done,
     /*  59769 */   // Label 1272: @59769
     /*  59769 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59823), // Rule ID 2171 //
     /*  59774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59803 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59821 */     GIR_RootConstrainSelectedInstOperands,
     /*  59822 */     // GIR_Coverage, 2171,
     /*  59822 */     GIR_EraseRootFromParent_Done,
     /*  59823 */   // Label 1273: @59823
     /*  59823 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(59877), // Rule ID 2172 //
     /*  59828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59857 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59875 */     GIR_RootConstrainSelectedInstOperands,
     /*  59876 */     // GIR_Coverage, 2172,
     /*  59876 */     GIR_EraseRootFromParent_Done,
     /*  59877 */   // Label 1274: @59877
     /*  59877 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(59931), // Rule ID 2173 //
     /*  59882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59911 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  59914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59929 */     GIR_RootConstrainSelectedInstOperands,
     /*  59930 */     // GIR_Coverage, 2173,
     /*  59930 */     GIR_EraseRootFromParent_Done,
     /*  59931 */   // Label 1275: @59931
     /*  59931 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(59985), // Rule ID 2174 //
     /*  59936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59965 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  59968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59983 */     GIR_RootConstrainSelectedInstOperands,
     /*  59984 */     // GIR_Coverage, 2174,
     /*  59984 */     GIR_EraseRootFromParent_Done,
     /*  59985 */   // Label 1276: @59985
     /*  59985 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60039), // Rule ID 2175 //
     /*  59990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60019 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60037 */     GIR_RootConstrainSelectedInstOperands,
     /*  60038 */     // GIR_Coverage, 2175,
     /*  60038 */     GIR_EraseRootFromParent_Done,
     /*  60039 */   // Label 1277: @60039
     /*  60039 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60093), // Rule ID 2176 //
     /*  60044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60073 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60091 */     GIR_RootConstrainSelectedInstOperands,
     /*  60092 */     // GIR_Coverage, 2176,
     /*  60092 */     GIR_EraseRootFromParent_Done,
     /*  60093 */   // Label 1278: @60093
     /*  60093 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60141), // Rule ID 2513 //
     /*  60098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60127 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3753:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60139 */     GIR_RootConstrainSelectedInstOperands,
     /*  60140 */     // GIR_Coverage, 2513,
     /*  60140 */     GIR_EraseRootFromParent_Done,
     /*  60141 */   // Label 1279: @60141
     /*  60141 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60189), // Rule ID 2514 //
     /*  60146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60175 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3752:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60187 */     GIR_RootConstrainSelectedInstOperands,
     /*  60188 */     // GIR_Coverage, 2514,
     /*  60188 */     GIR_EraseRootFromParent_Done,
     /*  60189 */   // Label 1280: @60189
     /*  60189 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60237), // Rule ID 2515 //
     /*  60194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60223 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3753:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60235 */     GIR_RootConstrainSelectedInstOperands,
     /*  60236 */     // GIR_Coverage, 2515,
     /*  60236 */     GIR_EraseRootFromParent_Done,
     /*  60237 */   // Label 1281: @60237
     /*  60237 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60285), // Rule ID 2516 //
     /*  60242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60271 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3752:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60283 */     GIR_RootConstrainSelectedInstOperands,
     /*  60284 */     // GIR_Coverage, 2516,
     /*  60284 */     GIR_EraseRootFromParent_Done,
     /*  60285 */   // Label 1282: @60285
     /*  60285 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60333), // Rule ID 2517 //
     /*  60290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60319 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3753:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60331 */     GIR_RootConstrainSelectedInstOperands,
     /*  60332 */     // GIR_Coverage, 2517,
     /*  60332 */     GIR_EraseRootFromParent_Done,
     /*  60333 */   // Label 1283: @60333
     /*  60333 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60381), // Rule ID 2518 //
     /*  60338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60367 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3752:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60379 */     GIR_RootConstrainSelectedInstOperands,
     /*  60380 */     // GIR_Coverage, 2518,
     /*  60380 */     GIR_EraseRootFromParent_Done,
     /*  60381 */   // Label 1284: @60381
     /*  60381 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60429), // Rule ID 2519 //
     /*  60386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60415 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3753:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60427 */     GIR_RootConstrainSelectedInstOperands,
     /*  60428 */     // GIR_Coverage, 2519,
     /*  60428 */     GIR_EraseRootFromParent_Done,
     /*  60429 */   // Label 1285: @60429
     /*  60429 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60477), // Rule ID 2520 //
     /*  60434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60463 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3752:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60475 */     GIR_RootConstrainSelectedInstOperands,
     /*  60476 */     // GIR_Coverage, 2520,
     /*  60476 */     GIR_EraseRootFromParent_Done,
     /*  60477 */   // Label 1286: @60477
     /*  60477 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60582), // Rule ID 3105 //
     /*  60482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60511 */     // (intrinsic_wo_chain:{ *:[f32] } 3561:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60527 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60554 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60560 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60581 */     // GIR_Coverage, 3105,
     /*  60581 */     GIR_EraseRootFromParent_Done,
     /*  60582 */   // Label 1287: @60582
     /*  60582 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60687), // Rule ID 3107 //
     /*  60587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60616 */     // (intrinsic_wo_chain:{ *:[f16] } 3561:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60628 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60656 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60659 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60665 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60686 */     // GIR_Coverage, 3107,
     /*  60686 */     GIR_EraseRootFromParent_Done,
     /*  60687 */   // Label 1288: @60687
     /*  60687 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60792), // Rule ID 3109 //
     /*  60692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60721 */     // (intrinsic_wo_chain:{ *:[f32] } 3552:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60754 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60761 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60764 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60770 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60791 */     // GIR_Coverage, 3109,
     /*  60791 */     GIR_EraseRootFromParent_Done,
     /*  60792 */   // Label 1289: @60792
     /*  60792 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60897), // Rule ID 3111 //
     /*  60797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60826 */     // (intrinsic_wo_chain:{ *:[f16] } 3552:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  60854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60869 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60875 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60896 */     // GIR_Coverage, 3111,
     /*  60896 */     GIR_EraseRootFromParent_Done,
     /*  60897 */   // Label 1290: @60897
     /*  60897 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(61002), // Rule ID 3113 //
     /*  60902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60931 */     // (intrinsic_wo_chain:{ *:[f32] } 3559:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  60959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60964 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60974 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60980 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61001 */     // GIR_Coverage, 3113,
     /*  61001 */     GIR_EraseRootFromParent_Done,
     /*  61002 */   // Label 1291: @61002
     /*  61002 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61107), // Rule ID 3115 //
     /*  61007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61036 */     // (intrinsic_wo_chain:{ *:[f16] } 3559:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61048 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61079 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61085 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61106 */     // GIR_Coverage, 3115,
     /*  61106 */     GIR_EraseRootFromParent_Done,
     /*  61107 */   // Label 1292: @61107
     /*  61107 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61212), // Rule ID 3117 //
     /*  61112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61141 */     // (intrinsic_wo_chain:{ *:[f32] } 3550:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61153 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61184 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61190 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61211 */     // GIR_Coverage, 3117,
     /*  61211 */     GIR_EraseRootFromParent_Done,
     /*  61212 */   // Label 1293: @61212
     /*  61212 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61317), // Rule ID 3119 //
     /*  61217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61246 */     // (intrinsic_wo_chain:{ *:[f16] } 3550:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61289 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61295 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61316 */     // GIR_Coverage, 3119,
     /*  61316 */     GIR_EraseRootFromParent_Done,
     /*  61317 */   // Label 1294: @61317
     /*  61317 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61377), // Rule ID 3169 //
     /*  61322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61351 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61356 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61358 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61375 */     GIR_RootConstrainSelectedInstOperands,
     /*  61376 */     // GIR_Coverage, 3169,
     /*  61376 */     GIR_EraseRootFromParent_Done,
     /*  61377 */   // Label 1295: @61377
     /*  61377 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61437), // Rule ID 3171 //
     /*  61382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61411 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61416 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61418 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61435 */     GIR_RootConstrainSelectedInstOperands,
     /*  61436 */     // GIR_Coverage, 3171,
     /*  61436 */     GIR_EraseRootFromParent_Done,
     /*  61437 */   // Label 1296: @61437
     /*  61437 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61497), // Rule ID 3173 //
     /*  61442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61471 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61476 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61478 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61495 */     GIR_RootConstrainSelectedInstOperands,
     /*  61496 */     // GIR_Coverage, 3173,
     /*  61496 */     GIR_EraseRootFromParent_Done,
     /*  61497 */   // Label 1297: @61497
     /*  61497 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61557), // Rule ID 3175 //
     /*  61502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61531 */     // (intrinsic_wo_chain:{ *:[i32] } 3548:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61536 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61538 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61555 */     GIR_RootConstrainSelectedInstOperands,
     /*  61556 */     // GIR_Coverage, 3175,
     /*  61556 */     GIR_EraseRootFromParent_Done,
     /*  61557 */   // Label 1298: @61557
     /*  61557 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61617), // Rule ID 3177 //
     /*  61562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61591 */     // (intrinsic_wo_chain:{ *:[i32] } 3548:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61596 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61598 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61615 */     GIR_RootConstrainSelectedInstOperands,
     /*  61616 */     // GIR_Coverage, 3177,
     /*  61616 */     GIR_EraseRootFromParent_Done,
     /*  61617 */   // Label 1299: @61617
     /*  61617 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61677), // Rule ID 3179 //
     /*  61622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61651 */     // (intrinsic_wo_chain:{ *:[i32] } 3548:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61656 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61658 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61675 */     GIR_RootConstrainSelectedInstOperands,
     /*  61676 */     // GIR_Coverage, 3179,
     /*  61676 */     GIR_EraseRootFromParent_Done,
     /*  61677 */   // Label 1300: @61677
     /*  61677 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61752), // Rule ID 3470 //
     /*  61682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61711 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3670:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61750 */     GIR_RootConstrainSelectedInstOperands,
     /*  61751 */     // GIR_Coverage, 3470,
     /*  61751 */     GIR_EraseRootFromParent_Done,
     /*  61752 */   // Label 1301: @61752
     /*  61752 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61827), // Rule ID 3477 //
     /*  61757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61786 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3670:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61825 */     GIR_RootConstrainSelectedInstOperands,
     /*  61826 */     // GIR_Coverage, 3477,
     /*  61826 */     GIR_EraseRootFromParent_Done,
     /*  61827 */   // Label 1302: @61827
     /*  61827 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(61902), // Rule ID 3481 //
     /*  61832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61861 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3670:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  61861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  61876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61900 */     GIR_RootConstrainSelectedInstOperands,
     /*  61901 */     // GIR_Coverage, 3481,
     /*  61901 */     GIR_EraseRootFromParent_Done,
     /*  61902 */   // Label 1303: @61902
     /*  61902 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(61977), // Rule ID 3483 //
     /*  61907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61936 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  61951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61975 */     GIR_RootConstrainSelectedInstOperands,
     /*  61976 */     // GIR_Coverage, 3483,
     /*  61976 */     GIR_EraseRootFromParent_Done,
     /*  61977 */   // Label 1304: @61977
     /*  61977 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62052), // Rule ID 3485 //
     /*  61982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62011 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62050 */     GIR_RootConstrainSelectedInstOperands,
     /*  62051 */     // GIR_Coverage, 3485,
     /*  62051 */     GIR_EraseRootFromParent_Done,
     /*  62052 */   // Label 1305: @62052
     /*  62052 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(62127), // Rule ID 3487 //
     /*  62057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62125 */     GIR_RootConstrainSelectedInstOperands,
     /*  62126 */     // GIR_Coverage, 3487,
     /*  62126 */     GIR_EraseRootFromParent_Done,
     /*  62127 */   // Label 1306: @62127
     /*  62127 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62202), // Rule ID 4755 //
     /*  62132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62200 */     GIR_RootConstrainSelectedInstOperands,
     /*  62201 */     // GIR_Coverage, 4755,
     /*  62201 */     GIR_EraseRootFromParent_Done,
     /*  62202 */   // Label 1307: @62202
     /*  62202 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62277), // Rule ID 4760 //
     /*  62207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62236 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62275 */     GIR_RootConstrainSelectedInstOperands,
     /*  62276 */     // GIR_Coverage, 4760,
     /*  62276 */     GIR_EraseRootFromParent_Done,
     /*  62277 */   // Label 1308: @62277
     /*  62277 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62352), // Rule ID 4762 //
     /*  62282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62311 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62350 */     GIR_RootConstrainSelectedInstOperands,
     /*  62351 */     // GIR_Coverage, 4762,
     /*  62351 */     GIR_EraseRootFromParent_Done,
     /*  62352 */   // Label 1309: @62352
     /*  62352 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62427), // Rule ID 4764 //
     /*  62357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62386 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62425 */     GIR_RootConstrainSelectedInstOperands,
     /*  62426 */     // GIR_Coverage, 4764,
     /*  62426 */     GIR_EraseRootFromParent_Done,
     /*  62427 */   // Label 1310: @62427
     /*  62427 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62502), // Rule ID 4766 //
     /*  62432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62461 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62500 */     GIR_RootConstrainSelectedInstOperands,
     /*  62501 */     // GIR_Coverage, 4766,
     /*  62501 */     GIR_EraseRootFromParent_Done,
     /*  62502 */   // Label 1311: @62502
     /*  62502 */   GIM_Reject,
     /*  62503 */ // Label 956: @62503
     /*  62503 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(73426),
     /*  62508 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62511 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(62601), // Rule ID 3916 //
     /*  62516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62553 */     // MIs[1] Operand 1
     /*  62553 */     // No operand predicates
     /*  62553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62559 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3680:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62599 */     GIR_RootConstrainSelectedInstOperands,
     /*  62600 */     // GIR_Coverage, 3916,
     /*  62600 */     GIR_EraseRootFromParent_Done,
     /*  62601 */   // Label 1313: @62601
     /*  62601 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62691), // Rule ID 3918 //
     /*  62606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62643 */     // MIs[1] Operand 1
     /*  62643 */     // No operand predicates
     /*  62643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62649 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3680:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62689 */     GIR_RootConstrainSelectedInstOperands,
     /*  62690 */     // GIR_Coverage, 3918,
     /*  62690 */     GIR_EraseRootFromParent_Done,
     /*  62691 */   // Label 1314: @62691
     /*  62691 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62781), // Rule ID 3920 //
     /*  62696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62733 */     // MIs[1] Operand 1
     /*  62733 */     // No operand predicates
     /*  62733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62739 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62779 */     GIR_RootConstrainSelectedInstOperands,
     /*  62780 */     // GIR_Coverage, 3920,
     /*  62780 */     GIR_EraseRootFromParent_Done,
     /*  62781 */   // Label 1315: @62781
     /*  62781 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(62871), // Rule ID 3922 //
     /*  62786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62823 */     // MIs[1] Operand 1
     /*  62823 */     // No operand predicates
     /*  62823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62829 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  62844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62869 */     GIR_RootConstrainSelectedInstOperands,
     /*  62870 */     // GIR_Coverage, 3922,
     /*  62870 */     GIR_EraseRootFromParent_Done,
     /*  62871 */   // Label 1316: @62871
     /*  62871 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(62961), // Rule ID 3924 //
     /*  62876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62913 */     // MIs[1] Operand 1
     /*  62913 */     // No operand predicates
     /*  62913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62919 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  62934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62959 */     GIR_RootConstrainSelectedInstOperands,
     /*  62960 */     // GIR_Coverage, 3924,
     /*  62960 */     GIR_EraseRootFromParent_Done,
     /*  62961 */   // Label 1317: @62961
     /*  62961 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63051), // Rule ID 3926 //
     /*  62966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63003 */     // MIs[1] Operand 1
     /*  63003 */     // No operand predicates
     /*  63003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63049 */     GIR_RootConstrainSelectedInstOperands,
     /*  63050 */     // GIR_Coverage, 3926,
     /*  63050 */     GIR_EraseRootFromParent_Done,
     /*  63051 */   // Label 1318: @63051
     /*  63051 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63141), // Rule ID 3934 //
     /*  63056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63093 */     // MIs[1] Operand 1
     /*  63093 */     // No operand predicates
     /*  63093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63099 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3696:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63139 */     GIR_RootConstrainSelectedInstOperands,
     /*  63140 */     // GIR_Coverage, 3934,
     /*  63140 */     GIR_EraseRootFromParent_Done,
     /*  63141 */   // Label 1319: @63141
     /*  63141 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63231), // Rule ID 3936 //
     /*  63146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63183 */     // MIs[1] Operand 1
     /*  63183 */     // No operand predicates
     /*  63183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63189 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3696:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63206 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63229 */     GIR_RootConstrainSelectedInstOperands,
     /*  63230 */     // GIR_Coverage, 3936,
     /*  63230 */     GIR_EraseRootFromParent_Done,
     /*  63231 */   // Label 1320: @63231
     /*  63231 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(63321), // Rule ID 3938 //
     /*  63236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63273 */     // MIs[1] Operand 1
     /*  63273 */     // No operand predicates
     /*  63273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63279 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3696:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63319 */     GIR_RootConstrainSelectedInstOperands,
     /*  63320 */     // GIR_Coverage, 3938,
     /*  63320 */     GIR_EraseRootFromParent_Done,
     /*  63321 */   // Label 1321: @63321
     /*  63321 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63411), // Rule ID 3940 //
     /*  63326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63363 */     // MIs[1] Operand 1
     /*  63363 */     // No operand predicates
     /*  63363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63369 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3696:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63386 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63409 */     GIR_RootConstrainSelectedInstOperands,
     /*  63410 */     // GIR_Coverage, 3940,
     /*  63410 */     GIR_EraseRootFromParent_Done,
     /*  63411 */   // Label 1322: @63411
     /*  63411 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63501), // Rule ID 3942 //
     /*  63416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63453 */     // MIs[1] Operand 1
     /*  63453 */     // No operand predicates
     /*  63453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3696:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63499 */     GIR_RootConstrainSelectedInstOperands,
     /*  63500 */     // GIR_Coverage, 3942,
     /*  63500 */     GIR_EraseRootFromParent_Done,
     /*  63501 */   // Label 1323: @63501
     /*  63501 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63591), // Rule ID 3944 //
     /*  63506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63543 */     // MIs[1] Operand 1
     /*  63543 */     // No operand predicates
     /*  63543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63549 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3696:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63589 */     GIR_RootConstrainSelectedInstOperands,
     /*  63590 */     // GIR_Coverage, 3944,
     /*  63590 */     GIR_EraseRootFromParent_Done,
     /*  63591 */   // Label 1324: @63591
     /*  63591 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63680), // Rule ID 4042 //
     /*  63596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63636 */     // MIs[1] Operand 1
     /*  63636 */     // No operand predicates
     /*  63636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63638 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63678 */     GIR_RootConstrainSelectedInstOperands,
     /*  63679 */     // GIR_Coverage, 4042,
     /*  63679 */     GIR_EraseRootFromParent_Done,
     /*  63680 */   // Label 1325: @63680
     /*  63680 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63769), // Rule ID 4044 //
     /*  63685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63725 */     // MIs[1] Operand 1
     /*  63725 */     // No operand predicates
     /*  63725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63727 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63767 */     GIR_RootConstrainSelectedInstOperands,
     /*  63768 */     // GIR_Coverage, 4044,
     /*  63768 */     GIR_EraseRootFromParent_Done,
     /*  63769 */   // Label 1326: @63769
     /*  63769 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63858), // Rule ID 4046 //
     /*  63774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63814 */     // MIs[1] Operand 1
     /*  63814 */     // No operand predicates
     /*  63814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63816 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  63831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63856 */     GIR_RootConstrainSelectedInstOperands,
     /*  63857 */     // GIR_Coverage, 4046,
     /*  63857 */     GIR_EraseRootFromParent_Done,
     /*  63858 */   // Label 1327: @63858
     /*  63858 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(63947), // Rule ID 4048 //
     /*  63863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63903 */     // MIs[1] Operand 1
     /*  63903 */     // No operand predicates
     /*  63903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63905 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  63920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63945 */     GIR_RootConstrainSelectedInstOperands,
     /*  63946 */     // GIR_Coverage, 4048,
     /*  63946 */     GIR_EraseRootFromParent_Done,
     /*  63947 */   // Label 1328: @63947
     /*  63947 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64036), // Rule ID 4050 //
     /*  63952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63992 */     // MIs[1] Operand 1
     /*  63992 */     // No operand predicates
     /*  63992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63994 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64034 */     GIR_RootConstrainSelectedInstOperands,
     /*  64035 */     // GIR_Coverage, 4050,
     /*  64035 */     GIR_EraseRootFromParent_Done,
     /*  64036 */   // Label 1329: @64036
     /*  64036 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64125), // Rule ID 4052 //
     /*  64041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64081 */     // MIs[1] Operand 1
     /*  64081 */     // No operand predicates
     /*  64081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64083 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64123 */     GIR_RootConstrainSelectedInstOperands,
     /*  64124 */     // GIR_Coverage, 4052,
     /*  64124 */     GIR_EraseRootFromParent_Done,
     /*  64125 */   // Label 1330: @64125
     /*  64125 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64214), // Rule ID 4054 //
     /*  64130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64170 */     // MIs[1] Operand 1
     /*  64170 */     // No operand predicates
     /*  64170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64172 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64212 */     GIR_RootConstrainSelectedInstOperands,
     /*  64213 */     // GIR_Coverage, 4054,
     /*  64213 */     GIR_EraseRootFromParent_Done,
     /*  64214 */   // Label 1331: @64214
     /*  64214 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64303), // Rule ID 4056 //
     /*  64219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64259 */     // MIs[1] Operand 1
     /*  64259 */     // No operand predicates
     /*  64259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64261 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3616:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64301 */     GIR_RootConstrainSelectedInstOperands,
     /*  64302 */     // GIR_Coverage, 4056,
     /*  64302 */     GIR_EraseRootFromParent_Done,
     /*  64303 */   // Label 1332: @64303
     /*  64303 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64370), // Rule ID 3121 //
     /*  64308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64344 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64349 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64351 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64368 */     GIR_RootConstrainSelectedInstOperands,
     /*  64369 */     // GIR_Coverage, 3121,
     /*  64369 */     GIR_EraseRootFromParent_Done,
     /*  64370 */   // Label 1333: @64370
     /*  64370 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64437), // Rule ID 3123 //
     /*  64375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64411 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64416 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64418 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64435 */     GIR_RootConstrainSelectedInstOperands,
     /*  64436 */     // GIR_Coverage, 3123,
     /*  64436 */     GIR_EraseRootFromParent_Done,
     /*  64437 */   // Label 1334: @64437
     /*  64437 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64504), // Rule ID 3125 //
     /*  64442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64478 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64483 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64485 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64502 */     GIR_RootConstrainSelectedInstOperands,
     /*  64503 */     // GIR_Coverage, 3125,
     /*  64503 */     GIR_EraseRootFromParent_Done,
     /*  64504 */   // Label 1335: @64504
     /*  64504 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64571), // Rule ID 3127 //
     /*  64509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64545 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64550 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64552 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64569 */     GIR_RootConstrainSelectedInstOperands,
     /*  64570 */     // GIR_Coverage, 3127,
     /*  64570 */     GIR_EraseRootFromParent_Done,
     /*  64571 */   // Label 1336: @64571
     /*  64571 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64638), // Rule ID 3129 //
     /*  64576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64612 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64617 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64619 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64636 */     GIR_RootConstrainSelectedInstOperands,
     /*  64637 */     // GIR_Coverage, 3129,
     /*  64637 */     GIR_EraseRootFromParent_Done,
     /*  64638 */   // Label 1337: @64638
     /*  64638 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64705), // Rule ID 3131 //
     /*  64643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64679 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64684 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64686 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64703 */     GIR_RootConstrainSelectedInstOperands,
     /*  64704 */     // GIR_Coverage, 3131,
     /*  64704 */     GIR_EraseRootFromParent_Done,
     /*  64705 */   // Label 1338: @64705
     /*  64705 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64772), // Rule ID 3133 //
     /*  64710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64746 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64751 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64753 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64770 */     GIR_RootConstrainSelectedInstOperands,
     /*  64771 */     // GIR_Coverage, 3133,
     /*  64771 */     GIR_EraseRootFromParent_Done,
     /*  64772 */   // Label 1339: @64772
     /*  64772 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64839), // Rule ID 3135 //
     /*  64777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64813 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64818 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64820 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64837 */     GIR_RootConstrainSelectedInstOperands,
     /*  64838 */     // GIR_Coverage, 3135,
     /*  64838 */     GIR_EraseRootFromParent_Done,
     /*  64839 */   // Label 1340: @64839
     /*  64839 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(64906), // Rule ID 3137 //
     /*  64844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64880 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  64883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64885 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64887 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64904 */     GIR_RootConstrainSelectedInstOperands,
     /*  64905 */     // GIR_Coverage, 3137,
     /*  64905 */     GIR_EraseRootFromParent_Done,
     /*  64906 */   // Label 1341: @64906
     /*  64906 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(64973), // Rule ID 3139 //
     /*  64911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64947 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  64950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64952 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64954 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64971 */     GIR_RootConstrainSelectedInstOperands,
     /*  64972 */     // GIR_Coverage, 3139,
     /*  64972 */     GIR_EraseRootFromParent_Done,
     /*  64973 */   // Label 1342: @64973
     /*  64973 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65040), // Rule ID 3141 //
     /*  64978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65014 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65019 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65021 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65038 */     GIR_RootConstrainSelectedInstOperands,
     /*  65039 */     // GIR_Coverage, 3141,
     /*  65039 */     GIR_EraseRootFromParent_Done,
     /*  65040 */   // Label 1343: @65040
     /*  65040 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65107), // Rule ID 3143 //
     /*  65045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65081 */     // (intrinsic_wo_chain:{ *:[i32] } 3554:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65086 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65088 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65105 */     GIR_RootConstrainSelectedInstOperands,
     /*  65106 */     // GIR_Coverage, 3143,
     /*  65106 */     GIR_EraseRootFromParent_Done,
     /*  65107 */   // Label 1344: @65107
     /*  65107 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65189), // Rule ID 3548 //
     /*  65112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65148 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3600:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65187 */     GIR_RootConstrainSelectedInstOperands,
     /*  65188 */     // GIR_Coverage, 3548,
     /*  65188 */     GIR_EraseRootFromParent_Done,
     /*  65189 */   // Label 1345: @65189
     /*  65189 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65271), // Rule ID 3555 //
     /*  65194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65230 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3600:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65269 */     GIR_RootConstrainSelectedInstOperands,
     /*  65270 */     // GIR_Coverage, 3555,
     /*  65270 */     GIR_EraseRootFromParent_Done,
     /*  65271 */   // Label 1346: @65271
     /*  65271 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(65353), // Rule ID 3559 //
     /*  65276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3600:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65351 */     GIR_RootConstrainSelectedInstOperands,
     /*  65352 */     // GIR_Coverage, 3559,
     /*  65352 */     GIR_EraseRootFromParent_Done,
     /*  65353 */   // Label 1347: @65353
     /*  65353 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65435), // Rule ID 3563 //
     /*  65358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65394 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3600:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65433 */     GIR_RootConstrainSelectedInstOperands,
     /*  65434 */     // GIR_Coverage, 3563,
     /*  65434 */     GIR_EraseRootFromParent_Done,
     /*  65435 */   // Label 1348: @65435
     /*  65435 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65517), // Rule ID 3567 //
     /*  65440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3600:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65515 */     GIR_RootConstrainSelectedInstOperands,
     /*  65516 */     // GIR_Coverage, 3567,
     /*  65516 */     GIR_EraseRootFromParent_Done,
     /*  65517 */   // Label 1349: @65517
     /*  65517 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65599), // Rule ID 3571 //
     /*  65522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3600:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65597 */     GIR_RootConstrainSelectedInstOperands,
     /*  65598 */     // GIR_Coverage, 3571,
     /*  65598 */     GIR_EraseRootFromParent_Done,
     /*  65599 */   // Label 1350: @65599
     /*  65599 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65681), // Rule ID 3572 //
     /*  65604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65640 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3686:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65679 */     GIR_RootConstrainSelectedInstOperands,
     /*  65680 */     // GIR_Coverage, 3572,
     /*  65680 */     GIR_EraseRootFromParent_Done,
     /*  65681 */   // Label 1351: @65681
     /*  65681 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65763), // Rule ID 3579 //
     /*  65686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65722 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3686:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65761 */     GIR_RootConstrainSelectedInstOperands,
     /*  65762 */     // GIR_Coverage, 3579,
     /*  65762 */     GIR_EraseRootFromParent_Done,
     /*  65763 */   // Label 1352: @65763
     /*  65763 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65845), // Rule ID 3583 //
     /*  65768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3686:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65843 */     GIR_RootConstrainSelectedInstOperands,
     /*  65844 */     // GIR_Coverage, 3583,
     /*  65844 */     GIR_EraseRootFromParent_Done,
     /*  65845 */   // Label 1353: @65845
     /*  65845 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(65927), // Rule ID 3587 //
     /*  65850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65886 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3686:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  65901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65925 */     GIR_RootConstrainSelectedInstOperands,
     /*  65926 */     // GIR_Coverage, 3587,
     /*  65926 */     GIR_EraseRootFromParent_Done,
     /*  65927 */   // Label 1354: @65927
     /*  65927 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66009), // Rule ID 3591 //
     /*  65932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65968 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3686:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  65983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66007 */     GIR_RootConstrainSelectedInstOperands,
     /*  66008 */     // GIR_Coverage, 3591,
     /*  66008 */     GIR_EraseRootFromParent_Done,
     /*  66009 */   // Label 1355: @66009
     /*  66009 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66091), // Rule ID 3595 //
     /*  66014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66050 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3686:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66089 */     GIR_RootConstrainSelectedInstOperands,
     /*  66090 */     // GIR_Coverage, 3595,
     /*  66090 */     GIR_EraseRootFromParent_Done,
     /*  66091 */   // Label 1356: @66091
     /*  66091 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66173), // Rule ID 3596 //
     /*  66096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3635:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66171 */     GIR_RootConstrainSelectedInstOperands,
     /*  66172 */     // GIR_Coverage, 3596,
     /*  66172 */     GIR_EraseRootFromParent_Done,
     /*  66173 */   // Label 1357: @66173
     /*  66173 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66255), // Rule ID 3603 //
     /*  66178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66214 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3635:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66253 */     GIR_RootConstrainSelectedInstOperands,
     /*  66254 */     // GIR_Coverage, 3603,
     /*  66254 */     GIR_EraseRootFromParent_Done,
     /*  66255 */   // Label 1358: @66255
     /*  66255 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(66337), // Rule ID 3607 //
     /*  66260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66296 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3635:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66335 */     GIR_RootConstrainSelectedInstOperands,
     /*  66336 */     // GIR_Coverage, 3607,
     /*  66336 */     GIR_EraseRootFromParent_Done,
     /*  66337 */   // Label 1359: @66337
     /*  66337 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66419), // Rule ID 3611 //
     /*  66342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66378 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3635:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66417 */     GIR_RootConstrainSelectedInstOperands,
     /*  66418 */     // GIR_Coverage, 3611,
     /*  66418 */     GIR_EraseRootFromParent_Done,
     /*  66419 */   // Label 1360: @66419
     /*  66419 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66501), // Rule ID 3615 //
     /*  66424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66460 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3635:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66499 */     GIR_RootConstrainSelectedInstOperands,
     /*  66500 */     // GIR_Coverage, 3615,
     /*  66500 */     GIR_EraseRootFromParent_Done,
     /*  66501 */   // Label 1361: @66501
     /*  66501 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66583), // Rule ID 3619 //
     /*  66506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3635:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66581 */     GIR_RootConstrainSelectedInstOperands,
     /*  66582 */     // GIR_Coverage, 3619,
     /*  66582 */     GIR_EraseRootFromParent_Done,
     /*  66583 */   // Label 1362: @66583
     /*  66583 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66665), // Rule ID 3620 //
     /*  66588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66624 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66663 */     GIR_RootConstrainSelectedInstOperands,
     /*  66664 */     // GIR_Coverage, 3620,
     /*  66664 */     GIR_EraseRootFromParent_Done,
     /*  66665 */   // Label 1363: @66665
     /*  66665 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66747), // Rule ID 3623 //
     /*  66670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66706 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66745 */     GIR_RootConstrainSelectedInstOperands,
     /*  66746 */     // GIR_Coverage, 3623,
     /*  66746 */     GIR_EraseRootFromParent_Done,
     /*  66747 */   // Label 1364: @66747
     /*  66747 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66829), // Rule ID 3626 //
     /*  66752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66788 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66827 */     GIR_RootConstrainSelectedInstOperands,
     /*  66828 */     // GIR_Coverage, 3626,
     /*  66828 */     GIR_EraseRootFromParent_Done,
     /*  66829 */   // Label 1365: @66829
     /*  66829 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(66911), // Rule ID 3629 //
     /*  66834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66870 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  66885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66909 */     GIR_RootConstrainSelectedInstOperands,
     /*  66910 */     // GIR_Coverage, 3629,
     /*  66910 */     GIR_EraseRootFromParent_Done,
     /*  66911 */   // Label 1366: @66911
     /*  66911 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(66993), // Rule ID 3632 //
     /*  66916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  66967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66991 */     GIR_RootConstrainSelectedInstOperands,
     /*  66992 */     // GIR_Coverage, 3632,
     /*  66992 */     GIR_EraseRootFromParent_Done,
     /*  66993 */   // Label 1367: @66993
     /*  66993 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67075), // Rule ID 3635 //
     /*  66998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67034 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67073 */     GIR_RootConstrainSelectedInstOperands,
     /*  67074 */     // GIR_Coverage, 3635,
     /*  67074 */     GIR_EraseRootFromParent_Done,
     /*  67075 */   // Label 1368: @67075
     /*  67075 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67157), // Rule ID 4036 //
     /*  67080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67116 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3600:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67155 */     GIR_RootConstrainSelectedInstOperands,
     /*  67156 */     // GIR_Coverage, 4036,
     /*  67156 */     GIR_EraseRootFromParent_Done,
     /*  67157 */   // Label 1369: @67157
     /*  67157 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67239), // Rule ID 4038 //
     /*  67162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67198 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3600:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67237 */     GIR_RootConstrainSelectedInstOperands,
     /*  67238 */     // GIR_Coverage, 4038,
     /*  67238 */     GIR_EraseRootFromParent_Done,
     /*  67239 */   // Label 1370: @67239
     /*  67239 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67321), // Rule ID 4411 //
     /*  67244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3663:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67319 */     GIR_RootConstrainSelectedInstOperands,
     /*  67320 */     // GIR_Coverage, 4411,
     /*  67320 */     GIR_EraseRootFromParent_Done,
     /*  67321 */   // Label 1371: @67321
     /*  67321 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67403), // Rule ID 4413 //
     /*  67326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67362 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3663:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67401 */     GIR_RootConstrainSelectedInstOperands,
     /*  67402 */     // GIR_Coverage, 4413,
     /*  67402 */     GIR_EraseRootFromParent_Done,
     /*  67403 */   // Label 1372: @67403
     /*  67403 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67485), // Rule ID 4415 //
     /*  67408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3663:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67483 */     GIR_RootConstrainSelectedInstOperands,
     /*  67484 */     // GIR_Coverage, 4415,
     /*  67484 */     GIR_EraseRootFromParent_Done,
     /*  67485 */   // Label 1373: @67485
     /*  67485 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67567), // Rule ID 4417 //
     /*  67490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67526 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3663:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67565 */     GIR_RootConstrainSelectedInstOperands,
     /*  67566 */     // GIR_Coverage, 4417,
     /*  67566 */     GIR_EraseRootFromParent_Done,
     /*  67567 */   // Label 1374: @67567
     /*  67567 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67649), // Rule ID 4444 //
     /*  67572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67608 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67647 */     GIR_RootConstrainSelectedInstOperands,
     /*  67648 */     // GIR_Coverage, 4444,
     /*  67648 */     GIR_EraseRootFromParent_Done,
     /*  67649 */   // Label 1375: @67649
     /*  67649 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67731), // Rule ID 4451 //
     /*  67654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67690 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67729 */     GIR_RootConstrainSelectedInstOperands,
     /*  67730 */     // GIR_Coverage, 4451,
     /*  67730 */     GIR_EraseRootFromParent_Done,
     /*  67731 */   // Label 1376: @67731
     /*  67731 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67813), // Rule ID 4455 //
     /*  67736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67811 */     GIR_RootConstrainSelectedInstOperands,
     /*  67812 */     // GIR_Coverage, 4455,
     /*  67812 */     GIR_EraseRootFromParent_Done,
     /*  67813 */   // Label 1377: @67813
     /*  67813 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(67895), // Rule ID 4459 //
     /*  67818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67854 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  67869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67893 */     GIR_RootConstrainSelectedInstOperands,
     /*  67894 */     // GIR_Coverage, 4459,
     /*  67894 */     GIR_EraseRootFromParent_Done,
     /*  67895 */   // Label 1378: @67895
     /*  67895 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(67977), // Rule ID 4463 //
     /*  67900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67936 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  67951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67975 */     GIR_RootConstrainSelectedInstOperands,
     /*  67976 */     // GIR_Coverage, 4463,
     /*  67976 */     GIR_EraseRootFromParent_Done,
     /*  67977 */   // Label 1379: @67977
     /*  67977 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68059), // Rule ID 4467 //
     /*  67982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68057 */     GIR_RootConstrainSelectedInstOperands,
     /*  68058 */     // GIR_Coverage, 4467,
     /*  68058 */     GIR_EraseRootFromParent_Done,
     /*  68059 */   // Label 1380: @68059
     /*  68059 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68141), // Rule ID 4468 //
     /*  68064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68100 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68139 */     GIR_RootConstrainSelectedInstOperands,
     /*  68140 */     // GIR_Coverage, 4468,
     /*  68140 */     GIR_EraseRootFromParent_Done,
     /*  68141 */   // Label 1381: @68141
     /*  68141 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68223), // Rule ID 4470 //
     /*  68146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68182 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68221 */     GIR_RootConstrainSelectedInstOperands,
     /*  68222 */     // GIR_Coverage, 4470,
     /*  68222 */     GIR_EraseRootFromParent_Done,
     /*  68223 */   // Label 1382: @68223
     /*  68223 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68305), // Rule ID 4472 //
     /*  68228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68303 */     GIR_RootConstrainSelectedInstOperands,
     /*  68304 */     // GIR_Coverage, 4472,
     /*  68304 */     GIR_EraseRootFromParent_Done,
     /*  68305 */   // Label 1383: @68305
     /*  68305 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68387), // Rule ID 4474 //
     /*  68310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68346 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3695:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68385 */     GIR_RootConstrainSelectedInstOperands,
     /*  68386 */     // GIR_Coverage, 4474,
     /*  68386 */     GIR_EraseRootFromParent_Done,
     /*  68387 */   // Label 1384: @68387
     /*  68387 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68469), // Rule ID 4476 //
     /*  68392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3695:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68467 */     GIR_RootConstrainSelectedInstOperands,
     /*  68468 */     // GIR_Coverage, 4476,
     /*  68468 */     GIR_EraseRootFromParent_Done,
     /*  68469 */   // Label 1385: @68469
     /*  68469 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68551), // Rule ID 4478 //
     /*  68474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68549 */     GIR_RootConstrainSelectedInstOperands,
     /*  68550 */     // GIR_Coverage, 4478,
     /*  68550 */     GIR_EraseRootFromParent_Done,
     /*  68551 */   // Label 1386: @68551
     /*  68551 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68618), // Rule ID 4529 //
     /*  68556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68592 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3619:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68616 */     GIR_RootConstrainSelectedInstOperands,
     /*  68617 */     // GIR_Coverage, 4529,
     /*  68617 */     GIR_EraseRootFromParent_Done,
     /*  68618 */   // Label 1387: @68618
     /*  68618 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68685), // Rule ID 4535 //
     /*  68623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68659 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3619:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68683 */     GIR_RootConstrainSelectedInstOperands,
     /*  68684 */     // GIR_Coverage, 4535,
     /*  68684 */     GIR_EraseRootFromParent_Done,
     /*  68685 */   // Label 1388: @68685
     /*  68685 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68767), // Rule ID 4553 //
     /*  68690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68726 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68765 */     GIR_RootConstrainSelectedInstOperands,
     /*  68766 */     // GIR_Coverage, 4553,
     /*  68766 */     GIR_EraseRootFromParent_Done,
     /*  68767 */   // Label 1389: @68767
     /*  68767 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68849), // Rule ID 4555 //
     /*  68772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68847 */     GIR_RootConstrainSelectedInstOperands,
     /*  68848 */     // GIR_Coverage, 4555,
     /*  68848 */     GIR_EraseRootFromParent_Done,
     /*  68849 */   // Label 1390: @68849
     /*  68849 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(68931), // Rule ID 4557 //
     /*  68854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68890 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  68905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68929 */     GIR_RootConstrainSelectedInstOperands,
     /*  68930 */     // GIR_Coverage, 4557,
     /*  68930 */     GIR_EraseRootFromParent_Done,
     /*  68931 */   // Label 1391: @68931
     /*  68931 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69013), // Rule ID 4559 //
     /*  68936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68972 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  68987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69011 */     GIR_RootConstrainSelectedInstOperands,
     /*  69012 */     // GIR_Coverage, 4559,
     /*  69012 */     GIR_EraseRootFromParent_Done,
     /*  69013 */   // Label 1392: @69013
     /*  69013 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69090), // Rule ID 3904 //
     /*  69018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69059 */     // MIs[1] Operand 1
     /*  69059 */     // No operand predicates
     /*  69059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69066 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69088 */     GIR_RootConstrainSelectedInstOperands,
     /*  69089 */     // GIR_Coverage, 3904,
     /*  69089 */     GIR_EraseRootFromParent_Done,
     /*  69090 */   // Label 1393: @69090
     /*  69090 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69167), // Rule ID 3906 //
     /*  69095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69136 */     // MIs[1] Operand 1
     /*  69136 */     // No operand predicates
     /*  69136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69138 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69143 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69165 */     GIR_RootConstrainSelectedInstOperands,
     /*  69166 */     // GIR_Coverage, 3906,
     /*  69166 */     GIR_EraseRootFromParent_Done,
     /*  69167 */   // Label 1394: @69167
     /*  69167 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69244), // Rule ID 3908 //
     /*  69172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69213 */     // MIs[1] Operand 1
     /*  69213 */     // No operand predicates
     /*  69213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69220 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69242 */     GIR_RootConstrainSelectedInstOperands,
     /*  69243 */     // GIR_Coverage, 3908,
     /*  69243 */     GIR_EraseRootFromParent_Done,
     /*  69244 */   // Label 1395: @69244
     /*  69244 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69321), // Rule ID 3910 //
     /*  69249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69290 */     // MIs[1] Operand 1
     /*  69290 */     // No operand predicates
     /*  69290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69297 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69319 */     GIR_RootConstrainSelectedInstOperands,
     /*  69320 */     // GIR_Coverage, 3910,
     /*  69320 */     GIR_EraseRootFromParent_Done,
     /*  69321 */   // Label 1396: @69321
     /*  69321 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69398), // Rule ID 3912 //
     /*  69326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69367 */     // MIs[1] Operand 1
     /*  69367 */     // No operand predicates
     /*  69367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69369 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69374 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69396 */     GIR_RootConstrainSelectedInstOperands,
     /*  69397 */     // GIR_Coverage, 3912,
     /*  69397 */     GIR_EraseRootFromParent_Done,
     /*  69398 */   // Label 1397: @69398
     /*  69398 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69475), // Rule ID 3914 //
     /*  69403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69444 */     // MIs[1] Operand 1
     /*  69444 */     // No operand predicates
     /*  69444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69446 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3712:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69451 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69473 */     GIR_RootConstrainSelectedInstOperands,
     /*  69474 */     // GIR_Coverage, 3914,
     /*  69474 */     GIR_EraseRootFromParent_Done,
     /*  69475 */   // Label 1398: @69475
     /*  69475 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69566), // Rule ID 4383 //
     /*  69480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69512 */     // MIs[1] Operand 1
     /*  69512 */     // No operand predicates
     /*  69512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69522 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3610:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69564 */     GIR_RootConstrainSelectedInstOperands,
     /*  69565 */     // GIR_Coverage, 4383,
     /*  69565 */     GIR_EraseRootFromParent_Done,
     /*  69566 */   // Label 1399: @69566
     /*  69566 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69657), // Rule ID 4385 //
     /*  69571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69603 */     // MIs[1] Operand 1
     /*  69603 */     // No operand predicates
     /*  69603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69613 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3610:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69655 */     GIR_RootConstrainSelectedInstOperands,
     /*  69656 */     // GIR_Coverage, 4385,
     /*  69656 */     GIR_EraseRootFromParent_Done,
     /*  69657 */   // Label 1400: @69657
     /*  69657 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69720), // Rule ID 146 //
     /*  69662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69698 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69718 */     GIR_RootConstrainSelectedInstOperands,
     /*  69719 */     // GIR_Coverage, 146,
     /*  69719 */     GIR_EraseRootFromParent_Done,
     /*  69720 */   // Label 1401: @69720
     /*  69720 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69783), // Rule ID 469 //
     /*  69725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69761 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69781 */     GIR_RootConstrainSelectedInstOperands,
     /*  69782 */     // GIR_Coverage, 469,
     /*  69782 */     GIR_EraseRootFromParent_Done,
     /*  69783 */   // Label 1402: @69783
     /*  69783 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(69846), // Rule ID 528 //
     /*  69788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69824 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  69827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69844 */     GIR_RootConstrainSelectedInstOperands,
     /*  69845 */     // GIR_Coverage, 528,
     /*  69845 */     GIR_EraseRootFromParent_Done,
     /*  69846 */   // Label 1403: @69846
     /*  69846 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(69909), // Rule ID 529 //
     /*  69851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  69859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69887 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  69890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69907 */     GIR_RootConstrainSelectedInstOperands,
     /*  69908 */     // GIR_Coverage, 529,
     /*  69908 */     GIR_EraseRootFromParent_Done,
     /*  69909 */   // Label 1404: @69909
     /*  69909 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(69972), // Rule ID 530 //
     /*  69914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  69922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69950 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  69953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69970 */     GIR_RootConstrainSelectedInstOperands,
     /*  69971 */     // GIR_Coverage, 530,
     /*  69971 */     GIR_EraseRootFromParent_Done,
     /*  69972 */   // Label 1405: @69972
     /*  69972 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70035), // Rule ID 531 //
     /*  69977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  69985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70013 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70033 */     GIR_RootConstrainSelectedInstOperands,
     /*  70034 */     // GIR_Coverage, 531,
     /*  70034 */     GIR_EraseRootFromParent_Done,
     /*  70035 */   // Label 1406: @70035
     /*  70035 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70089), // Rule ID 951 //
     /*  70040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70076 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70087 */     GIR_RootConstrainSelectedInstOperands,
     /*  70088 */     // GIR_Coverage, 951,
     /*  70088 */     GIR_EraseRootFromParent_Done,
     /*  70089 */   // Label 1407: @70089
     /*  70089 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70143), // Rule ID 952 //
     /*  70094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70130 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3730:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70141 */     GIR_RootConstrainSelectedInstOperands,
     /*  70142 */     // GIR_Coverage, 952,
     /*  70142 */     GIR_EraseRootFromParent_Done,
     /*  70143 */   // Label 1408: @70143
     /*  70143 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70197), // Rule ID 953 //
     /*  70148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70195 */     GIR_RootConstrainSelectedInstOperands,
     /*  70196 */     // GIR_Coverage, 953,
     /*  70196 */     GIR_EraseRootFromParent_Done,
     /*  70197 */   // Label 1409: @70197
     /*  70197 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70251), // Rule ID 954 //
     /*  70202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70238 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3730:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70249 */     GIR_RootConstrainSelectedInstOperands,
     /*  70250 */     // GIR_Coverage, 954,
     /*  70250 */     GIR_EraseRootFromParent_Done,
     /*  70251 */   // Label 1410: @70251
     /*  70251 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70305), // Rule ID 955 //
     /*  70256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70292 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70303 */     GIR_RootConstrainSelectedInstOperands,
     /*  70304 */     // GIR_Coverage, 955,
     /*  70304 */     GIR_EraseRootFromParent_Done,
     /*  70305 */   // Label 1411: @70305
     /*  70305 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70359), // Rule ID 956 //
     /*  70310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70357 */     GIR_RootConstrainSelectedInstOperands,
     /*  70358 */     // GIR_Coverage, 956,
     /*  70358 */     GIR_EraseRootFromParent_Done,
     /*  70359 */   // Label 1412: @70359
     /*  70359 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70413), // Rule ID 957 //
     /*  70364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70400 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70411 */     GIR_RootConstrainSelectedInstOperands,
     /*  70412 */     // GIR_Coverage, 957,
     /*  70412 */     GIR_EraseRootFromParent_Done,
     /*  70413 */   // Label 1413: @70413
     /*  70413 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70467), // Rule ID 958 //
     /*  70418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70454 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3744:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70465 */     GIR_RootConstrainSelectedInstOperands,
     /*  70466 */     // GIR_Coverage, 958,
     /*  70466 */     GIR_EraseRootFromParent_Done,
     /*  70467 */   // Label 1414: @70467
     /*  70467 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70521), // Rule ID 959 //
     /*  70472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70508 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70519 */     GIR_RootConstrainSelectedInstOperands,
     /*  70520 */     // GIR_Coverage, 959,
     /*  70520 */     GIR_EraseRootFromParent_Done,
     /*  70521 */   // Label 1415: @70521
     /*  70521 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70584), // Rule ID 1690 //
     /*  70526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70562 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3859:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70567 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70582 */     GIR_RootConstrainSelectedInstOperands,
     /*  70583 */     // GIR_Coverage, 1690,
     /*  70583 */     GIR_EraseRootFromParent_Done,
     /*  70584 */   // Label 1416: @70584
     /*  70584 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70638), // Rule ID 1721 //
     /*  70589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70625 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70636 */     GIR_RootConstrainSelectedInstOperands,
     /*  70637 */     // GIR_Coverage, 1721,
     /*  70637 */     GIR_EraseRootFromParent_Done,
     /*  70638 */   // Label 1417: @70638
     /*  70638 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70692), // Rule ID 1722 //
     /*  70643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70690 */     GIR_RootConstrainSelectedInstOperands,
     /*  70691 */     // GIR_Coverage, 1722,
     /*  70691 */     GIR_EraseRootFromParent_Done,
     /*  70692 */   // Label 1418: @70692
     /*  70692 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70746), // Rule ID 1723 //
     /*  70697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70733 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70744 */     GIR_RootConstrainSelectedInstOperands,
     /*  70745 */     // GIR_Coverage, 1723,
     /*  70745 */     GIR_EraseRootFromParent_Done,
     /*  70746 */   // Label 1419: @70746
     /*  70746 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70800), // Rule ID 1724 //
     /*  70751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70798 */     GIR_RootConstrainSelectedInstOperands,
     /*  70799 */     // GIR_Coverage, 1724,
     /*  70799 */     GIR_EraseRootFromParent_Done,
     /*  70800 */   // Label 1420: @70800
     /*  70800 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(70863), // Rule ID 1899 //
     /*  70805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70841 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  70844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70861 */     GIR_RootConstrainSelectedInstOperands,
     /*  70862 */     // GIR_Coverage, 1899,
     /*  70862 */     GIR_EraseRootFromParent_Done,
     /*  70863 */   // Label 1421: @70863
     /*  70863 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(70926), // Rule ID 1900 //
     /*  70868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70904 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  70907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70924 */     GIR_RootConstrainSelectedInstOperands,
     /*  70925 */     // GIR_Coverage, 1900,
     /*  70925 */     GIR_EraseRootFromParent_Done,
     /*  70926 */   // Label 1422: @70926
     /*  70926 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(70989), // Rule ID 1901 //
     /*  70931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70967 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  70970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70987 */     GIR_RootConstrainSelectedInstOperands,
     /*  70988 */     // GIR_Coverage, 1901,
     /*  70988 */     GIR_EraseRootFromParent_Done,
     /*  70989 */   // Label 1423: @70989
     /*  70989 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71052), // Rule ID 1902 //
     /*  70994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71030 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71050 */     GIR_RootConstrainSelectedInstOperands,
     /*  71051 */     // GIR_Coverage, 1902,
     /*  71051 */     GIR_EraseRootFromParent_Done,
     /*  71052 */   // Label 1424: @71052
     /*  71052 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71115), // Rule ID 1990 //
     /*  71057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71093 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71098 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71113 */     GIR_RootConstrainSelectedInstOperands,
     /*  71114 */     // GIR_Coverage, 1990,
     /*  71114 */     GIR_EraseRootFromParent_Done,
     /*  71115 */   // Label 1425: @71115
     /*  71115 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71178), // Rule ID 1991 //
     /*  71120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71156 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71161 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71163 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71165 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71176 */     GIR_RootConstrainSelectedInstOperands,
     /*  71177 */     // GIR_Coverage, 1991,
     /*  71177 */     GIR_EraseRootFromParent_Done,
     /*  71178 */   // Label 1426: @71178
     /*  71178 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71241), // Rule ID 1992 //
     /*  71183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71219 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71224 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71226 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71228 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 1992,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1427: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71304), // Rule ID 1993 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71282 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71287 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71289 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71291 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71302 */     GIR_RootConstrainSelectedInstOperands,
     /*  71303 */     // GIR_Coverage, 1993,
     /*  71303 */     GIR_EraseRootFromParent_Done,
     /*  71304 */   // Label 1428: @71304
     /*  71304 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71367), // Rule ID 1994 //
     /*  71309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71345 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71350 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71352 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71354 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71365 */     GIR_RootConstrainSelectedInstOperands,
     /*  71366 */     // GIR_Coverage, 1994,
     /*  71366 */     GIR_EraseRootFromParent_Done,
     /*  71367 */   // Label 1429: @71367
     /*  71367 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71430), // Rule ID 1995 //
     /*  71372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71408 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71413 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71415 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71417 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71428 */     GIR_RootConstrainSelectedInstOperands,
     /*  71429 */     // GIR_Coverage, 1995,
     /*  71429 */     GIR_EraseRootFromParent_Done,
     /*  71430 */   // Label 1430: @71430
     /*  71430 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71493), // Rule ID 2181 //
     /*  71435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71471 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71476 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71478 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71480 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71491 */     GIR_RootConstrainSelectedInstOperands,
     /*  71492 */     // GIR_Coverage, 2181,
     /*  71492 */     GIR_EraseRootFromParent_Done,
     /*  71493 */   // Label 1431: @71493
     /*  71493 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71556), // Rule ID 2182 //
     /*  71498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71534 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71539 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71541 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71543 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71554 */     GIR_RootConstrainSelectedInstOperands,
     /*  71555 */     // GIR_Coverage, 2182,
     /*  71555 */     GIR_EraseRootFromParent_Done,
     /*  71556 */   // Label 1432: @71556
     /*  71556 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71619), // Rule ID 2183 //
     /*  71561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71597 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71602 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71604 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71606 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71617 */     GIR_RootConstrainSelectedInstOperands,
     /*  71618 */     // GIR_Coverage, 2183,
     /*  71618 */     GIR_EraseRootFromParent_Done,
     /*  71619 */   // Label 1433: @71619
     /*  71619 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71682), // Rule ID 2184 //
     /*  71624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71660 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71665 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71667 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71669 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71680 */     GIR_RootConstrainSelectedInstOperands,
     /*  71681 */     // GIR_Coverage, 2184,
     /*  71681 */     GIR_EraseRootFromParent_Done,
     /*  71682 */   // Label 1434: @71682
     /*  71682 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71745), // Rule ID 2185 //
     /*  71687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71723 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71728 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71730 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71732 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71743 */     GIR_RootConstrainSelectedInstOperands,
     /*  71744 */     // GIR_Coverage, 2185,
     /*  71744 */     GIR_EraseRootFromParent_Done,
     /*  71745 */   // Label 1435: @71745
     /*  71745 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71808), // Rule ID 2186 //
     /*  71750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71786 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71791 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71793 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71795 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71806 */     GIR_RootConstrainSelectedInstOperands,
     /*  71807 */     // GIR_Coverage, 2186,
     /*  71807 */     GIR_EraseRootFromParent_Done,
     /*  71808 */   // Label 1436: @71808
     /*  71808 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(71871), // Rule ID 2472 //
     /*  71813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71849 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  71852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71869 */     GIR_RootConstrainSelectedInstOperands,
     /*  71870 */     // GIR_Coverage, 2472,
     /*  71870 */     GIR_EraseRootFromParent_Done,
     /*  71871 */   // Label 1437: @71871
     /*  71871 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(71934), // Rule ID 2473 //
     /*  71876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  71887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  71893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  71896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71912 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  71912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  71915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71932 */     GIR_RootConstrainSelectedInstOperands,
     /*  71933 */     // GIR_Coverage, 2473,
     /*  71933 */     GIR_EraseRootFromParent_Done,
     /*  71934 */   // Label 1438: @71934
     /*  71934 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(71997), // Rule ID 2474 //
     /*  71939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  71959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71975 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3814:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  71975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  71978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71995 */     GIR_RootConstrainSelectedInstOperands,
     /*  71996 */     // GIR_Coverage, 2474,
     /*  71996 */     GIR_EraseRootFromParent_Done,
     /*  71997 */   // Label 1439: @71997
     /*  71997 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72060), // Rule ID 2475 //
     /*  72002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72058 */     GIR_RootConstrainSelectedInstOperands,
     /*  72059 */     // GIR_Coverage, 2475,
     /*  72059 */     GIR_EraseRootFromParent_Done,
     /*  72060 */   // Label 1440: @72060
     /*  72060 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72123), // Rule ID 2480 //
     /*  72065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72101 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72121 */     GIR_RootConstrainSelectedInstOperands,
     /*  72122 */     // GIR_Coverage, 2480,
     /*  72122 */     GIR_EraseRootFromParent_Done,
     /*  72123 */   // Label 1441: @72123
     /*  72123 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72186), // Rule ID 2481 //
     /*  72128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72164 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72184 */     GIR_RootConstrainSelectedInstOperands,
     /*  72185 */     // GIR_Coverage, 2481,
     /*  72185 */     GIR_EraseRootFromParent_Done,
     /*  72186 */   // Label 1442: @72186
     /*  72186 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72249), // Rule ID 2482 //
     /*  72191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72227 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72247 */     GIR_RootConstrainSelectedInstOperands,
     /*  72248 */     // GIR_Coverage, 2482,
     /*  72248 */     GIR_EraseRootFromParent_Done,
     /*  72249 */   // Label 1443: @72249
     /*  72249 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72312), // Rule ID 2483 //
     /*  72254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72290 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72310 */     GIR_RootConstrainSelectedInstOperands,
     /*  72311 */     // GIR_Coverage, 2483,
     /*  72311 */     GIR_EraseRootFromParent_Done,
     /*  72312 */   // Label 1444: @72312
     /*  72312 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72381), // Rule ID 4840 //
     /*  72317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72353 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72358 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72360 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72362 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72379 */     GIR_RootConstrainSelectedInstOperands,
     /*  72380 */     // GIR_Coverage, 4840,
     /*  72380 */     GIR_EraseRootFromParent_Done,
     /*  72381 */   // Label 1445: @72381
     /*  72381 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72450), // Rule ID 4842 //
     /*  72386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72422 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72427 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72429 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72431 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72448 */     GIR_RootConstrainSelectedInstOperands,
     /*  72449 */     // GIR_Coverage, 4842,
     /*  72449 */     GIR_EraseRootFromParent_Done,
     /*  72450 */   // Label 1446: @72450
     /*  72450 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72519), // Rule ID 4844 //
     /*  72455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72491 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72496 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72498 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72500 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72517 */     GIR_RootConstrainSelectedInstOperands,
     /*  72518 */     // GIR_Coverage, 4844,
     /*  72518 */     GIR_EraseRootFromParent_Done,
     /*  72519 */   // Label 1447: @72519
     /*  72519 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72588), // Rule ID 4846 //
     /*  72524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72560 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72565 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72567 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72569 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72586 */     GIR_RootConstrainSelectedInstOperands,
     /*  72587 */     // GIR_Coverage, 4846,
     /*  72587 */     GIR_EraseRootFromParent_Done,
     /*  72588 */   // Label 1448: @72588
     /*  72588 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72657), // Rule ID 4848 //
     /*  72593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72629 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72634 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72636 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72638 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72655 */     GIR_RootConstrainSelectedInstOperands,
     /*  72656 */     // GIR_Coverage, 4848,
     /*  72656 */     GIR_EraseRootFromParent_Done,
     /*  72657 */   // Label 1449: @72657
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72726), // Rule ID 4850 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72703 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72705 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72707 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72724 */     GIR_RootConstrainSelectedInstOperands,
     /*  72725 */     // GIR_Coverage, 4850,
     /*  72725 */     GIR_EraseRootFromParent_Done,
     /*  72726 */   // Label 1450: @72726
     /*  72726 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72795), // Rule ID 4852 //
     /*  72731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72767 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72772 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72774 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72776 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72793 */     GIR_RootConstrainSelectedInstOperands,
     /*  72794 */     // GIR_Coverage, 4852,
     /*  72794 */     GIR_EraseRootFromParent_Done,
     /*  72795 */   // Label 1451: @72795
     /*  72795 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(72864), // Rule ID 4854 //
     /*  72800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72836 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  72839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72841 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72843 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72845 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72862 */     GIR_RootConstrainSelectedInstOperands,
     /*  72863 */     // GIR_Coverage, 4854,
     /*  72863 */     GIR_EraseRootFromParent_Done,
     /*  72864 */   // Label 1452: @72864
     /*  72864 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(72933), // Rule ID 4856 //
     /*  72869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72905 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  72908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72910 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72912 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72914 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72931 */     GIR_RootConstrainSelectedInstOperands,
     /*  72932 */     // GIR_Coverage, 4856,
     /*  72932 */     GIR_EraseRootFromParent_Done,
     /*  72933 */   // Label 1453: @72933
     /*  72933 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(73002), // Rule ID 4858 //
     /*  72938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72974 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  72977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72979 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72981 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72983 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73000 */     GIR_RootConstrainSelectedInstOperands,
     /*  73001 */     // GIR_Coverage, 4858,
     /*  73001 */     GIR_EraseRootFromParent_Done,
     /*  73002 */   // Label 1454: @73002
     /*  73002 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73071), // Rule ID 4860 //
     /*  73007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73043 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73048 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73050 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73052 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73069 */     GIR_RootConstrainSelectedInstOperands,
     /*  73070 */     // GIR_Coverage, 4860,
     /*  73070 */     GIR_EraseRootFromParent_Done,
     /*  73071 */   // Label 1455: @73071
     /*  73071 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73140), // Rule ID 4862 //
     /*  73076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73112 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73117 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73119 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73121 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73138 */     GIR_RootConstrainSelectedInstOperands,
     /*  73139 */     // GIR_Coverage, 4862,
     /*  73139 */     GIR_EraseRootFromParent_Done,
     /*  73140 */   // Label 1456: @73140
     /*  73140 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73235), // Rule ID 2694 //
     /*  73145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73169 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3731:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73169 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73172 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73176 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73202 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73226 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73231 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73233 */     GIR_RootConstrainSelectedInstOperands,
     /*  73234 */     // GIR_Coverage, 2694,
     /*  73234 */     GIR_EraseRootFromParent_Done,
     /*  73235 */   // Label 1457: @73235
     /*  73235 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73330), // Rule ID 2695 //
     /*  73240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3733:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73297 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73321 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73326 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73328 */     GIR_RootConstrainSelectedInstOperands,
     /*  73329 */     // GIR_Coverage, 2695,
     /*  73329 */     GIR_EraseRootFromParent_Done,
     /*  73330 */   // Label 1458: @73330
     /*  73330 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73425), // Rule ID 2696 //
     /*  73335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73359 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73398 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73416 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73421 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73423 */     GIR_RootConstrainSelectedInstOperands,
     /*  73424 */     // GIR_Coverage, 2696,
     /*  73424 */     GIR_EraseRootFromParent_Done,
     /*  73425 */   // Label 1459: @73425
     /*  73425 */   GIM_Reject,
     /*  73426 */ // Label 1312: @73426
     /*  73426 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(76812),
     /*  73431 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73434 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(73518), // Rule ID 3727 //
     /*  73439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73479 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73516 */     GIR_RootConstrainSelectedInstOperands,
     /*  73517 */     // GIR_Coverage, 3727,
     /*  73517 */     GIR_EraseRootFromParent_Done,
     /*  73518 */   // Label 1461: @73518
     /*  73518 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73602), // Rule ID 3731 //
     /*  73523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73563 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73580 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73600 */     GIR_RootConstrainSelectedInstOperands,
     /*  73601 */     // GIR_Coverage, 3731,
     /*  73601 */     GIR_EraseRootFromParent_Done,
     /*  73602 */   // Label 1462: @73602
     /*  73602 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73686), // Rule ID 3735 //
     /*  73607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73647 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73684 */     GIR_RootConstrainSelectedInstOperands,
     /*  73685 */     // GIR_Coverage, 3735,
     /*  73685 */     GIR_EraseRootFromParent_Done,
     /*  73686 */   // Label 1463: @73686
     /*  73686 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(73770), // Rule ID 3739 //
     /*  73691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73768 */     GIR_RootConstrainSelectedInstOperands,
     /*  73769 */     // GIR_Coverage, 3739,
     /*  73769 */     GIR_EraseRootFromParent_Done,
     /*  73770 */   // Label 1464: @73770
     /*  73770 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73854), // Rule ID 3743 //
     /*  73775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73815 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  73830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73852 */     GIR_RootConstrainSelectedInstOperands,
     /*  73853 */     // GIR_Coverage, 3743,
     /*  73853 */     GIR_EraseRootFromParent_Done,
     /*  73854 */   // Label 1465: @73854
     /*  73854 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(73938), // Rule ID 3747 //
     /*  73859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73899 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  73914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73936 */     GIR_RootConstrainSelectedInstOperands,
     /*  73937 */     // GIR_Coverage, 3747,
     /*  73937 */     GIR_EraseRootFromParent_Done,
     /*  73938 */   // Label 1466: @73938
     /*  73938 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74022), // Rule ID 3751 //
     /*  73943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73983 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  73998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74020 */     GIR_RootConstrainSelectedInstOperands,
     /*  74021 */     // GIR_Coverage, 3751,
     /*  74021 */     GIR_EraseRootFromParent_Done,
     /*  74022 */   // Label 1467: @74022
     /*  74022 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74106), // Rule ID 3755 //
     /*  74027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74067 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74104 */     GIR_RootConstrainSelectedInstOperands,
     /*  74105 */     // GIR_Coverage, 3755,
     /*  74105 */     GIR_EraseRootFromParent_Done,
     /*  74106 */   // Label 1468: @74106
     /*  74106 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74195), // Rule ID 4387 //
     /*  74111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74154 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74193 */     GIR_RootConstrainSelectedInstOperands,
     /*  74194 */     // GIR_Coverage, 4387,
     /*  74194 */     GIR_EraseRootFromParent_Done,
     /*  74195 */   // Label 1469: @74195
     /*  74195 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74284), // Rule ID 4389 //
     /*  74200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74243 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74282 */     GIR_RootConstrainSelectedInstOperands,
     /*  74283 */     // GIR_Coverage, 4389,
     /*  74283 */     GIR_EraseRootFromParent_Done,
     /*  74284 */   // Label 1470: @74284
     /*  74284 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(74373), // Rule ID 4391 //
     /*  74289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74332 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74371 */     GIR_RootConstrainSelectedInstOperands,
     /*  74372 */     // GIR_Coverage, 4391,
     /*  74372 */     GIR_EraseRootFromParent_Done,
     /*  74373 */   // Label 1471: @74373
     /*  74373 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74462), // Rule ID 4393 //
     /*  74378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74421 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74460 */     GIR_RootConstrainSelectedInstOperands,
     /*  74461 */     // GIR_Coverage, 4393,
     /*  74461 */     GIR_EraseRootFromParent_Done,
     /*  74462 */   // Label 1472: @74462
     /*  74462 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74551), // Rule ID 4395 //
     /*  74467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74510 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74549 */     GIR_RootConstrainSelectedInstOperands,
     /*  74550 */     // GIR_Coverage, 4395,
     /*  74550 */     GIR_EraseRootFromParent_Done,
     /*  74551 */   // Label 1473: @74551
     /*  74551 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74640), // Rule ID 4397 //
     /*  74556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74599 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74638 */     GIR_RootConstrainSelectedInstOperands,
     /*  74639 */     // GIR_Coverage, 4397,
     /*  74639 */     GIR_EraseRootFromParent_Done,
     /*  74640 */   // Label 1474: @74640
     /*  74640 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74729), // Rule ID 4399 //
     /*  74645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74727 */     GIR_RootConstrainSelectedInstOperands,
     /*  74728 */     // GIR_Coverage, 4399,
     /*  74728 */     GIR_EraseRootFromParent_Done,
     /*  74729 */   // Label 1475: @74729
     /*  74729 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74818), // Rule ID 4401 //
     /*  74734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74777 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74816 */     GIR_RootConstrainSelectedInstOperands,
     /*  74817 */     // GIR_Coverage, 4401,
     /*  74817 */     GIR_EraseRootFromParent_Done,
     /*  74818 */   // Label 1476: @74818
     /*  74818 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(74907), // Rule ID 4403 //
     /*  74823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74866 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  74881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74905 */     GIR_RootConstrainSelectedInstOperands,
     /*  74906 */     // GIR_Coverage, 4403,
     /*  74906 */     GIR_EraseRootFromParent_Done,
     /*  74907 */   // Label 1477: @74907
     /*  74907 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(74996), // Rule ID 4405 //
     /*  74912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74955 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  74970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74994 */     GIR_RootConstrainSelectedInstOperands,
     /*  74995 */     // GIR_Coverage, 4405,
     /*  74995 */     GIR_EraseRootFromParent_Done,
     /*  74996 */   // Label 1478: @74996
     /*  74996 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75085), // Rule ID 4407 //
     /*  75001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75083 */     GIR_RootConstrainSelectedInstOperands,
     /*  75084 */     // GIR_Coverage, 4407,
     /*  75084 */     GIR_EraseRootFromParent_Done,
     /*  75085 */   // Label 1479: @75085
     /*  75085 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75174), // Rule ID 4409 //
     /*  75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75133 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75172 */     GIR_RootConstrainSelectedInstOperands,
     /*  75173 */     // GIR_Coverage, 4409,
     /*  75173 */     GIR_EraseRootFromParent_Done,
     /*  75174 */   // Label 1480: @75174
     /*  75174 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(75272), // Rule ID 4032 //
     /*  75179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75218 */     // MIs[1] Operand 1
     /*  75218 */     // No operand predicates
     /*  75218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75228 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75247 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75270 */     GIR_RootConstrainSelectedInstOperands,
     /*  75271 */     // GIR_Coverage, 4032,
     /*  75271 */     GIR_EraseRootFromParent_Done,
     /*  75272 */   // Label 1481: @75272
     /*  75272 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(75370), // Rule ID 4034 //
     /*  75277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75316 */     // MIs[1] Operand 1
     /*  75316 */     // No operand predicates
     /*  75316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75326 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75345 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75368 */     GIR_RootConstrainSelectedInstOperands,
     /*  75369 */     // GIR_Coverage, 4034,
     /*  75369 */     GIR_EraseRootFromParent_Done,
     /*  75370 */   // Label 1482: @75370
     /*  75370 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75468), // Rule ID 4541 //
     /*  75375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75414 */     // MIs[1] Operand 1
     /*  75414 */     // No operand predicates
     /*  75414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75424 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75443 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75466 */     GIR_RootConstrainSelectedInstOperands,
     /*  75467 */     // GIR_Coverage, 4541,
     /*  75467 */     GIR_EraseRootFromParent_Done,
     /*  75468 */   // Label 1483: @75468
     /*  75468 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75566), // Rule ID 4543 //
     /*  75473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75512 */     // MIs[1] Operand 1
     /*  75512 */     // No operand predicates
     /*  75512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75522 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75564 */     GIR_RootConstrainSelectedInstOperands,
     /*  75565 */     // GIR_Coverage, 4543,
     /*  75565 */     GIR_EraseRootFromParent_Done,
     /*  75566 */   // Label 1484: @75566
     /*  75566 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75664), // Rule ID 4545 //
     /*  75571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75610 */     // MIs[1] Operand 1
     /*  75610 */     // No operand predicates
     /*  75610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75620 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75639 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75662 */     GIR_RootConstrainSelectedInstOperands,
     /*  75663 */     // GIR_Coverage, 4545,
     /*  75663 */     GIR_EraseRootFromParent_Done,
     /*  75664 */   // Label 1485: @75664
     /*  75664 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75762), // Rule ID 4547 //
     /*  75669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75708 */     // MIs[1] Operand 1
     /*  75708 */     // No operand predicates
     /*  75708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75718 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75737 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75760 */     GIR_RootConstrainSelectedInstOperands,
     /*  75761 */     // GIR_Coverage, 4547,
     /*  75761 */     GIR_EraseRootFromParent_Done,
     /*  75762 */   // Label 1486: @75762
     /*  75762 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75860), // Rule ID 4549 //
     /*  75767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75806 */     // MIs[1] Operand 1
     /*  75806 */     // No operand predicates
     /*  75806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75816 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  75831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75835 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75858 */     GIR_RootConstrainSelectedInstOperands,
     /*  75859 */     // GIR_Coverage, 4549,
     /*  75859 */     GIR_EraseRootFromParent_Done,
     /*  75860 */   // Label 1487: @75860
     /*  75860 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(75958), // Rule ID 4551 //
     /*  75865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75904 */     // MIs[1] Operand 1
     /*  75904 */     // No operand predicates
     /*  75904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75914 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  75929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75933 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75956 */     GIR_RootConstrainSelectedInstOperands,
     /*  75957 */     // GIR_Coverage, 4551,
     /*  75957 */     GIR_EraseRootFromParent_Done,
     /*  75958 */   // Label 1488: @75958
     /*  75958 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(76034), // Rule ID 3037 //
     /*  75963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76006 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76015 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76032 */     GIR_RootConstrainSelectedInstOperands,
     /*  76033 */     // GIR_Coverage, 3037,
     /*  76033 */     GIR_EraseRootFromParent_Done,
     /*  76034 */   // Label 1489: @76034
     /*  76034 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76110), // Rule ID 3039 //
     /*  76039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76082 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76091 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76108 */     GIR_RootConstrainSelectedInstOperands,
     /*  76109 */     // GIR_Coverage, 3039,
     /*  76109 */     GIR_EraseRootFromParent_Done,
     /*  76110 */   // Label 1490: @76110
     /*  76110 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76186), // Rule ID 3041 //
     /*  76115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76158 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76167 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76184 */     GIR_RootConstrainSelectedInstOperands,
     /*  76185 */     // GIR_Coverage, 3041,
     /*  76185 */     GIR_EraseRootFromParent_Done,
     /*  76186 */   // Label 1491: @76186
     /*  76186 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76262), // Rule ID 3043 //
     /*  76191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76234 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76243 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76260 */     GIR_RootConstrainSelectedInstOperands,
     /*  76261 */     // GIR_Coverage, 3043,
     /*  76261 */     GIR_EraseRootFromParent_Done,
     /*  76262 */   // Label 1492: @76262
     /*  76262 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(76338), // Rule ID 3045 //
     /*  76267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76310 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76319 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76336 */     GIR_RootConstrainSelectedInstOperands,
     /*  76337 */     // GIR_Coverage, 3045,
     /*  76337 */     GIR_EraseRootFromParent_Done,
     /*  76338 */   // Label 1493: @76338
     /*  76338 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76414), // Rule ID 3047 //
     /*  76343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76386 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76395 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76412 */     GIR_RootConstrainSelectedInstOperands,
     /*  76413 */     // GIR_Coverage, 3047,
     /*  76413 */     GIR_EraseRootFromParent_Done,
     /*  76414 */   // Label 1494: @76414
     /*  76414 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76499), // Rule ID 3996 //
     /*  76419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76454 */     // MIs[1] Operand 1
     /*  76454 */     // No operand predicates
     /*  76454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76468 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3608:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76477 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76497 */     GIR_RootConstrainSelectedInstOperands,
     /*  76498 */     // GIR_Coverage, 3996,
     /*  76498 */     GIR_EraseRootFromParent_Done,
     /*  76499 */   // Label 1495: @76499
     /*  76499 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76584), // Rule ID 3999 //
     /*  76504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76539 */     // MIs[1] Operand 1
     /*  76539 */     // No operand predicates
     /*  76539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76553 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3608:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76562 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76582 */     GIR_RootConstrainSelectedInstOperands,
     /*  76583 */     // GIR_Coverage, 3999,
     /*  76583 */     GIR_EraseRootFromParent_Done,
     /*  76584 */   // Label 1496: @76584
     /*  76584 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76680), // Rule ID 2688 //
     /*  76589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76616 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3860:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76632 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76639 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76662 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76678 */     GIR_RootConstrainSelectedInstOperands,
     /*  76679 */     // GIR_Coverage, 2688,
     /*  76679 */     GIR_EraseRootFromParent_Done,
     /*  76680 */   // Label 1497: @76680
     /*  76680 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76811), // Rule ID 2689 //
     /*  76685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76712 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3857:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76742 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76749 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76756 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76762 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76798 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76809 */     GIR_RootConstrainSelectedInstOperands,
     /*  76810 */     // GIR_Coverage, 2689,
     /*  76810 */     GIR_EraseRootFromParent_Done,
     /*  76811 */   // Label 1498: @76811
     /*  76811 */   GIM_Reject,
     /*  76812 */ // Label 1460: @76812
     /*  76812 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(82118),
     /*  76817 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76820 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(76913), // Rule ID 3838 //
     /*  76825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  76872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  76887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76889 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76891 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76911 */     GIR_RootConstrainSelectedInstOperands,
     /*  76912 */     // GIR_Coverage, 3838,
     /*  76912 */     GIR_EraseRootFromParent_Done,
     /*  76913 */   // Label 1500: @76913
     /*  76913 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(77006), // Rule ID 3840 //
     /*  76918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76965 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  76965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  76980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76982 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76984 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77004 */     GIR_RootConstrainSelectedInstOperands,
     /*  77005 */     // GIR_Coverage, 3840,
     /*  77005 */     GIR_EraseRootFromParent_Done,
     /*  77006 */   // Label 1501: @77006
     /*  77006 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77099), // Rule ID 3842 //
     /*  77011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77058 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77075 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77077 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77097 */     GIR_RootConstrainSelectedInstOperands,
     /*  77098 */     // GIR_Coverage, 3842,
     /*  77098 */     GIR_EraseRootFromParent_Done,
     /*  77099 */   // Label 1502: @77099
     /*  77099 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(77192), // Rule ID 3844 //
     /*  77104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77151 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77168 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77170 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77190 */     GIR_RootConstrainSelectedInstOperands,
     /*  77191 */     // GIR_Coverage, 3844,
     /*  77191 */     GIR_EraseRootFromParent_Done,
     /*  77192 */   // Label 1503: @77192
     /*  77192 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(77285), // Rule ID 3846 //
     /*  77197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77244 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77261 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77263 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77283 */     GIR_RootConstrainSelectedInstOperands,
     /*  77284 */     // GIR_Coverage, 3846,
     /*  77284 */     GIR_EraseRootFromParent_Done,
     /*  77285 */   // Label 1504: @77285
     /*  77285 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(77378), // Rule ID 3848 //
     /*  77290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77337 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77354 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77356 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77376 */     GIR_RootConstrainSelectedInstOperands,
     /*  77377 */     // GIR_Coverage, 3848,
     /*  77377 */     GIR_EraseRootFromParent_Done,
     /*  77378 */   // Label 1505: @77378
     /*  77378 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77471), // Rule ID 3850 //
     /*  77383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77430 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77447 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77469 */     GIR_RootConstrainSelectedInstOperands,
     /*  77470 */     // GIR_Coverage, 3850,
     /*  77470 */     GIR_EraseRootFromParent_Done,
     /*  77471 */   // Label 1506: @77471
     /*  77471 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77564), // Rule ID 3852 //
     /*  77476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77523 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77540 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77542 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77562 */     GIR_RootConstrainSelectedInstOperands,
     /*  77563 */     // GIR_Coverage, 3852,
     /*  77563 */     GIR_EraseRootFromParent_Done,
     /*  77564 */   // Label 1507: @77564
     /*  77564 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77657), // Rule ID 3854 //
     /*  77569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77616 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77633 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77635 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77655 */     GIR_RootConstrainSelectedInstOperands,
     /*  77656 */     // GIR_Coverage, 3854,
     /*  77656 */     GIR_EraseRootFromParent_Done,
     /*  77657 */   // Label 1508: @77657
     /*  77657 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77750), // Rule ID 3856 //
     /*  77662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77709 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77726 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77728 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77748 */     GIR_RootConstrainSelectedInstOperands,
     /*  77749 */     // GIR_Coverage, 3856,
     /*  77749 */     GIR_EraseRootFromParent_Done,
     /*  77750 */   // Label 1509: @77750
     /*  77750 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77843), // Rule ID 3858 //
     /*  77755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77802 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77819 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77821 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77841 */     GIR_RootConstrainSelectedInstOperands,
     /*  77842 */     // GIR_Coverage, 3858,
     /*  77842 */     GIR_EraseRootFromParent_Done,
     /*  77843 */   // Label 1510: @77843
     /*  77843 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(77936), // Rule ID 3860 //
     /*  77848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  77910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77912 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77914 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77934 */     GIR_RootConstrainSelectedInstOperands,
     /*  77935 */     // GIR_Coverage, 3860,
     /*  77935 */     GIR_EraseRootFromParent_Done,
     /*  77936 */   // Label 1511: @77936
     /*  77936 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(78029), // Rule ID 3862 //
     /*  77941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77988 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78005 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78007 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78027 */     GIR_RootConstrainSelectedInstOperands,
     /*  78028 */     // GIR_Coverage, 3862,
     /*  78028 */     GIR_EraseRootFromParent_Done,
     /*  78029 */   // Label 1512: @78029
     /*  78029 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78122), // Rule ID 3864 //
     /*  78034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78081 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78098 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78100 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78120 */     GIR_RootConstrainSelectedInstOperands,
     /*  78121 */     // GIR_Coverage, 3864,
     /*  78121 */     GIR_EraseRootFromParent_Done,
     /*  78122 */   // Label 1513: @78122
     /*  78122 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78215), // Rule ID 3866 //
     /*  78127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78174 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78191 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78193 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78213 */     GIR_RootConstrainSelectedInstOperands,
     /*  78214 */     // GIR_Coverage, 3866,
     /*  78214 */     GIR_EraseRootFromParent_Done,
     /*  78215 */   // Label 1514: @78215
     /*  78215 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(78308), // Rule ID 3868 //
     /*  78220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78267 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78284 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78286 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78306 */     GIR_RootConstrainSelectedInstOperands,
     /*  78307 */     // GIR_Coverage, 3868,
     /*  78307 */     GIR_EraseRootFromParent_Done,
     /*  78308 */   // Label 1515: @78308
     /*  78308 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(78401), // Rule ID 3870 //
     /*  78313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78360 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78377 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78379 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78399 */     GIR_RootConstrainSelectedInstOperands,
     /*  78400 */     // GIR_Coverage, 3870,
     /*  78400 */     GIR_EraseRootFromParent_Done,
     /*  78401 */   // Label 1516: @78401
     /*  78401 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78494), // Rule ID 3872 //
     /*  78406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78453 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78470 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78472 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78492 */     GIR_RootConstrainSelectedInstOperands,
     /*  78493 */     // GIR_Coverage, 3872,
     /*  78493 */     GIR_EraseRootFromParent_Done,
     /*  78494 */   // Label 1517: @78494
     /*  78494 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78587), // Rule ID 3874 //
     /*  78499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78546 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78563 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78565 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78585 */     GIR_RootConstrainSelectedInstOperands,
     /*  78586 */     // GIR_Coverage, 3874,
     /*  78586 */     GIR_EraseRootFromParent_Done,
     /*  78587 */   // Label 1518: @78587
     /*  78587 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78680), // Rule ID 3876 //
     /*  78592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78639 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78656 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78658 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78678 */     GIR_RootConstrainSelectedInstOperands,
     /*  78679 */     // GIR_Coverage, 3876,
     /*  78679 */     GIR_EraseRootFromParent_Done,
     /*  78680 */   // Label 1519: @78680
     /*  78680 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78773), // Rule ID 3878 //
     /*  78685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78749 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78751 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78771 */     GIR_RootConstrainSelectedInstOperands,
     /*  78772 */     // GIR_Coverage, 3878,
     /*  78772 */     GIR_EraseRootFromParent_Done,
     /*  78773 */   // Label 1520: @78773
     /*  78773 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78866), // Rule ID 3880 //
     /*  78778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78825 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  78840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78842 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78844 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78864 */     GIR_RootConstrainSelectedInstOperands,
     /*  78865 */     // GIR_Coverage, 3880,
     /*  78865 */     GIR_EraseRootFromParent_Done,
     /*  78866 */   // Label 1521: @78866
     /*  78866 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(78959), // Rule ID 3882 //
     /*  78871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78918 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3702:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  78933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78935 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78937 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78957 */     GIR_RootConstrainSelectedInstOperands,
     /*  78958 */     // GIR_Coverage, 3882,
     /*  78958 */     GIR_EraseRootFromParent_Done,
     /*  78959 */   // Label 1522: @78959
     /*  78959 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79052), // Rule ID 3884 //
     /*  78964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79011 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79028 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79030 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79050 */     GIR_RootConstrainSelectedInstOperands,
     /*  79051 */     // GIR_Coverage, 3884,
     /*  79051 */     GIR_EraseRootFromParent_Done,
     /*  79052 */   // Label 1523: @79052
     /*  79052 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79130), // Rule ID 4489 //
     /*  79057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79104 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79128 */     GIR_RootConstrainSelectedInstOperands,
     /*  79129 */     // GIR_Coverage, 4489,
     /*  79129 */     GIR_EraseRootFromParent_Done,
     /*  79130 */   // Label 1524: @79130
     /*  79130 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79208), // Rule ID 4491 //
     /*  79135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79182 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79206 */     GIR_RootConstrainSelectedInstOperands,
     /*  79207 */     // GIR_Coverage, 4491,
     /*  79207 */     GIR_EraseRootFromParent_Done,
     /*  79208 */   // Label 1525: @79208
     /*  79208 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79286), // Rule ID 4493 //
     /*  79213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79260 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79284 */     GIR_RootConstrainSelectedInstOperands,
     /*  79285 */     // GIR_Coverage, 4493,
     /*  79285 */     GIR_EraseRootFromParent_Done,
     /*  79286 */   // Label 1526: @79286
     /*  79286 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(79364), // Rule ID 4495 //
     /*  79291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79338 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79362 */     GIR_RootConstrainSelectedInstOperands,
     /*  79363 */     // GIR_Coverage, 4495,
     /*  79363 */     GIR_EraseRootFromParent_Done,
     /*  79364 */   // Label 1527: @79364
     /*  79364 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79442), // Rule ID 4497 //
     /*  79369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79440 */     GIR_RootConstrainSelectedInstOperands,
     /*  79441 */     // GIR_Coverage, 4497,
     /*  79441 */     GIR_EraseRootFromParent_Done,
     /*  79442 */   // Label 1528: @79442
     /*  79442 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79520), // Rule ID 4499 //
     /*  79447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79494 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79518 */     GIR_RootConstrainSelectedInstOperands,
     /*  79519 */     // GIR_Coverage, 4499,
     /*  79519 */     GIR_EraseRootFromParent_Done,
     /*  79520 */   // Label 1529: @79520
     /*  79520 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79598), // Rule ID 4501 //
     /*  79525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79572 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79596 */     GIR_RootConstrainSelectedInstOperands,
     /*  79597 */     // GIR_Coverage, 4501,
     /*  79597 */     GIR_EraseRootFromParent_Done,
     /*  79598 */   // Label 1530: @79598
     /*  79598 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79676), // Rule ID 4503 //
     /*  79603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79650 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79674 */     GIR_RootConstrainSelectedInstOperands,
     /*  79675 */     // GIR_Coverage, 4503,
     /*  79675 */     GIR_EraseRootFromParent_Done,
     /*  79676 */   // Label 1531: @79676
     /*  79676 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79754), // Rule ID 4505 //
     /*  79681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79728 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79752 */     GIR_RootConstrainSelectedInstOperands,
     /*  79753 */     // GIR_Coverage, 4505,
     /*  79753 */     GIR_EraseRootFromParent_Done,
     /*  79754 */   // Label 1532: @79754
     /*  79754 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79832), // Rule ID 4507 //
     /*  79759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79806 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79830 */     GIR_RootConstrainSelectedInstOperands,
     /*  79831 */     // GIR_Coverage, 4507,
     /*  79831 */     GIR_EraseRootFromParent_Done,
     /*  79832 */   // Label 1533: @79832
     /*  79832 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(79910), // Rule ID 4509 //
     /*  79837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79884 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  79887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79908 */     GIR_RootConstrainSelectedInstOperands,
     /*  79909 */     // GIR_Coverage, 4509,
     /*  79909 */     GIR_EraseRootFromParent_Done,
     /*  79910 */   // Label 1534: @79910
     /*  79910 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(79988), // Rule ID 4511 //
     /*  79915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79962 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  79965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79986 */     GIR_RootConstrainSelectedInstOperands,
     /*  79987 */     // GIR_Coverage, 4511,
     /*  79987 */     GIR_EraseRootFromParent_Done,
     /*  79988 */   // Label 1535: @79988
     /*  79988 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80066), // Rule ID 4701 //
     /*  79993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80040 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80045 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80047 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80064 */     GIR_RootConstrainSelectedInstOperands,
     /*  80065 */     // GIR_Coverage, 4701,
     /*  80065 */     GIR_EraseRootFromParent_Done,
     /*  80066 */   // Label 1536: @80066
     /*  80066 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80144), // Rule ID 4703 //
     /*  80071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80118 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80123 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80125 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80142 */     GIR_RootConstrainSelectedInstOperands,
     /*  80143 */     // GIR_Coverage, 4703,
     /*  80143 */     GIR_EraseRootFromParent_Done,
     /*  80144 */   // Label 1537: @80144
     /*  80144 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80222), // Rule ID 4705 //
     /*  80149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80196 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80201 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80203 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80220 */     GIR_RootConstrainSelectedInstOperands,
     /*  80221 */     // GIR_Coverage, 4705,
     /*  80221 */     GIR_EraseRootFromParent_Done,
     /*  80222 */   // Label 1538: @80222
     /*  80222 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80300), // Rule ID 4707 //
     /*  80227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80274 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80279 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80281 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80298 */     GIR_RootConstrainSelectedInstOperands,
     /*  80299 */     // GIR_Coverage, 4707,
     /*  80299 */     GIR_EraseRootFromParent_Done,
     /*  80300 */   // Label 1539: @80300
     /*  80300 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(80378), // Rule ID 4709 //
     /*  80305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80352 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80357 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80359 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80376 */     GIR_RootConstrainSelectedInstOperands,
     /*  80377 */     // GIR_Coverage, 4709,
     /*  80377 */     GIR_EraseRootFromParent_Done,
     /*  80378 */   // Label 1540: @80378
     /*  80378 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80456), // Rule ID 4711 //
     /*  80383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80430 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80435 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80437 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80454 */     GIR_RootConstrainSelectedInstOperands,
     /*  80455 */     // GIR_Coverage, 4711,
     /*  80455 */     GIR_EraseRootFromParent_Done,
     /*  80456 */   // Label 1541: @80456
     /*  80456 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80534), // Rule ID 4713 //
     /*  80461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80508 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80513 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80515 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80532 */     GIR_RootConstrainSelectedInstOperands,
     /*  80533 */     // GIR_Coverage, 4713,
     /*  80533 */     GIR_EraseRootFromParent_Done,
     /*  80534 */   // Label 1542: @80534
     /*  80534 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80612), // Rule ID 4715 //
     /*  80539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80586 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80591 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80593 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80610 */     GIR_RootConstrainSelectedInstOperands,
     /*  80611 */     // GIR_Coverage, 4715,
     /*  80611 */     GIR_EraseRootFromParent_Done,
     /*  80612 */   // Label 1543: @80612
     /*  80612 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80690), // Rule ID 4717 //
     /*  80617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80664 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80669 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80671 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80688 */     GIR_RootConstrainSelectedInstOperands,
     /*  80689 */     // GIR_Coverage, 4717,
     /*  80689 */     GIR_EraseRootFromParent_Done,
     /*  80690 */   // Label 1544: @80690
     /*  80690 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80768), // Rule ID 4719 //
     /*  80695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80742 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80747 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80749 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80766 */     GIR_RootConstrainSelectedInstOperands,
     /*  80767 */     // GIR_Coverage, 4719,
     /*  80767 */     GIR_EraseRootFromParent_Done,
     /*  80768 */   // Label 1545: @80768
     /*  80768 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80846), // Rule ID 4721 //
     /*  80773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80825 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80827 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80844 */     GIR_RootConstrainSelectedInstOperands,
     /*  80845 */     // GIR_Coverage, 4721,
     /*  80845 */     GIR_EraseRootFromParent_Done,
     /*  80846 */   // Label 1546: @80846
     /*  80846 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(80924), // Rule ID 4723 //
     /*  80851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80898 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  80901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80903 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80905 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80922 */     GIR_RootConstrainSelectedInstOperands,
     /*  80923 */     // GIR_Coverage, 4723,
     /*  80923 */     GIR_EraseRootFromParent_Done,
     /*  80924 */   // Label 1547: @80924
     /*  80924 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81002), // Rule ID 4725 //
     /*  80929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80976 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  80979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80981 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80983 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81000 */     GIR_RootConstrainSelectedInstOperands,
     /*  81001 */     // GIR_Coverage, 4725,
     /*  81001 */     GIR_EraseRootFromParent_Done,
     /*  81002 */   // Label 1548: @81002
     /*  81002 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81080), // Rule ID 4727 //
     /*  81007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81054 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81059 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81061 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81078 */     GIR_RootConstrainSelectedInstOperands,
     /*  81079 */     // GIR_Coverage, 4727,
     /*  81079 */     GIR_EraseRootFromParent_Done,
     /*  81080 */   // Label 1549: @81080
     /*  81080 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81158), // Rule ID 4729 //
     /*  81085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81132 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81137 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81139 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81156 */     GIR_RootConstrainSelectedInstOperands,
     /*  81157 */     // GIR_Coverage, 4729,
     /*  81157 */     GIR_EraseRootFromParent_Done,
     /*  81158 */   // Label 1550: @81158
     /*  81158 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81236), // Rule ID 4731 //
     /*  81163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81210 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81215 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81217 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81234 */     GIR_RootConstrainSelectedInstOperands,
     /*  81235 */     // GIR_Coverage, 4731,
     /*  81235 */     GIR_EraseRootFromParent_Done,
     /*  81236 */   // Label 1551: @81236
     /*  81236 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81314), // Rule ID 4733 //
     /*  81241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81288 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81293 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81295 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81312 */     GIR_RootConstrainSelectedInstOperands,
     /*  81313 */     // GIR_Coverage, 4733,
     /*  81313 */     GIR_EraseRootFromParent_Done,
     /*  81314 */   // Label 1552: @81314
     /*  81314 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81392), // Rule ID 4735 //
     /*  81319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81366 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81371 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81373 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81390 */     GIR_RootConstrainSelectedInstOperands,
     /*  81391 */     // GIR_Coverage, 4735,
     /*  81391 */     GIR_EraseRootFromParent_Done,
     /*  81392 */   // Label 1553: @81392
     /*  81392 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81470), // Rule ID 4737 //
     /*  81397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81444 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81449 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81451 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81468 */     GIR_RootConstrainSelectedInstOperands,
     /*  81469 */     // GIR_Coverage, 4737,
     /*  81469 */     GIR_EraseRootFromParent_Done,
     /*  81470 */   // Label 1554: @81470
     /*  81470 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81548), // Rule ID 4739 //
     /*  81475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81522 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81527 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81529 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81546 */     GIR_RootConstrainSelectedInstOperands,
     /*  81547 */     // GIR_Coverage, 4739,
     /*  81547 */     GIR_EraseRootFromParent_Done,
     /*  81548 */   // Label 1555: @81548
     /*  81548 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81626), // Rule ID 4741 //
     /*  81553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81600 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81605 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81607 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81624 */     GIR_RootConstrainSelectedInstOperands,
     /*  81625 */     // GIR_Coverage, 4741,
     /*  81625 */     GIR_EraseRootFromParent_Done,
     /*  81626 */   // Label 1556: @81626
     /*  81626 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81704), // Rule ID 4743 //
     /*  81631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81678 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81683 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81685 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81702 */     GIR_RootConstrainSelectedInstOperands,
     /*  81703 */     // GIR_Coverage, 4743,
     /*  81703 */     GIR_EraseRootFromParent_Done,
     /*  81704 */   // Label 1557: @81704
     /*  81704 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81782), // Rule ID 4745 //
     /*  81709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81756 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81761 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81763 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81780 */     GIR_RootConstrainSelectedInstOperands,
     /*  81781 */     // GIR_Coverage, 4745,
     /*  81781 */     GIR_EraseRootFromParent_Done,
     /*  81782 */   // Label 1558: @81782
     /*  81782 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81860), // Rule ID 4747 //
     /*  81787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81834 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  81837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81839 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81841 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81858 */     GIR_RootConstrainSelectedInstOperands,
     /*  81859 */     // GIR_Coverage, 4747,
     /*  81859 */     GIR_EraseRootFromParent_Done,
     /*  81860 */   // Label 1559: @81860
     /*  81860 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(81996), // Rule ID 2690 //
     /*  81865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  81873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81895 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3861:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  81898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  81912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  81916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  81925 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  81928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  81932 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  81935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  81939 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  81942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81945 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  81948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  81953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  81976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81978 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  81980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81983 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  81985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  81988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81994 */     GIR_RootConstrainSelectedInstOperands,
     /*  81995 */     // GIR_Coverage, 2690,
     /*  81995 */     GIR_EraseRootFromParent_Done,
     /*  81996 */   // Label 1560: @81996
     /*  81996 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82117), // Rule ID 2691 //
     /*  82001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82031 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3858:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82047 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82054 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82061 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82068 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82104 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82115 */     GIR_RootConstrainSelectedInstOperands,
     /*  82116 */     // GIR_Coverage, 2691,
     /*  82116 */     GIR_EraseRootFromParent_Done,
     /*  82117 */   // Label 1561: @82117
     /*  82117 */   GIM_Reject,
     /*  82118 */ // Label 1499: @82118
     /*  82118 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(87011),
     /*  82123 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82126 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82214), // Rule ID 3181 //
     /*  82131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82180 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82184 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82188 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82193 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82195 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82212 */     GIR_RootConstrainSelectedInstOperands,
     /*  82213 */     // GIR_Coverage, 3181,
     /*  82213 */     GIR_EraseRootFromParent_Done,
     /*  82214 */   // Label 1563: @82214
     /*  82214 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(82302), // Rule ID 3185 //
     /*  82219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82268 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82272 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82276 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82281 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82283 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82300 */     GIR_RootConstrainSelectedInstOperands,
     /*  82301 */     // GIR_Coverage, 3185,
     /*  82301 */     GIR_EraseRootFromParent_Done,
     /*  82302 */   // Label 1564: @82302
     /*  82302 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(82390), // Rule ID 3189 //
     /*  82307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82356 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82360 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82364 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82369 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82371 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82388 */     GIR_RootConstrainSelectedInstOperands,
     /*  82389 */     // GIR_Coverage, 3189,
     /*  82389 */     GIR_EraseRootFromParent_Done,
     /*  82390 */   // Label 1565: @82390
     /*  82390 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(82478), // Rule ID 3193 //
     /*  82395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82444 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82448 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82452 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82457 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82459 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82476 */     GIR_RootConstrainSelectedInstOperands,
     /*  82477 */     // GIR_Coverage, 3193,
     /*  82477 */     GIR_EraseRootFromParent_Done,
     /*  82478 */   // Label 1566: @82478
     /*  82478 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82566), // Rule ID 3197 //
     /*  82483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82532 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82536 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82540 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82545 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82547 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82564 */     GIR_RootConstrainSelectedInstOperands,
     /*  82565 */     // GIR_Coverage, 3197,
     /*  82565 */     GIR_EraseRootFromParent_Done,
     /*  82566 */   // Label 1567: @82566
     /*  82566 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82654), // Rule ID 3201 //
     /*  82571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82620 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82624 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82628 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82633 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82635 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82652 */     GIR_RootConstrainSelectedInstOperands,
     /*  82653 */     // GIR_Coverage, 3201,
     /*  82653 */     GIR_EraseRootFromParent_Done,
     /*  82654 */   // Label 1568: @82654
     /*  82654 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82742), // Rule ID 3205 //
     /*  82659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82708 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82712 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82716 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82721 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82723 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82740 */     GIR_RootConstrainSelectedInstOperands,
     /*  82741 */     // GIR_Coverage, 3205,
     /*  82741 */     GIR_EraseRootFromParent_Done,
     /*  82742 */   // Label 1569: @82742
     /*  82742 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82830), // Rule ID 3209 //
     /*  82747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82796 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82800 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82804 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82809 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82811 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82828 */     GIR_RootConstrainSelectedInstOperands,
     /*  82829 */     // GIR_Coverage, 3209,
     /*  82829 */     GIR_EraseRootFromParent_Done,
     /*  82830 */   // Label 1570: @82830
     /*  82830 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(82918), // Rule ID 3213 //
     /*  82835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82884 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82888 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82892 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  82895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82897 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82899 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82916 */     GIR_RootConstrainSelectedInstOperands,
     /*  82917 */     // GIR_Coverage, 3213,
     /*  82917 */     GIR_EraseRootFromParent_Done,
     /*  82918 */   // Label 1571: @82918
     /*  82918 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(83006), // Rule ID 3217 //
     /*  82923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82972 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82976 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82980 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  82983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82985 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82987 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83004 */     GIR_RootConstrainSelectedInstOperands,
     /*  83005 */     // GIR_Coverage, 3217,
     /*  83005 */     GIR_EraseRootFromParent_Done,
     /*  83006 */   // Label 1572: @83006
     /*  83006 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83094), // Rule ID 3221 //
     /*  83011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83060 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83064 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83068 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83073 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83075 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83092 */     GIR_RootConstrainSelectedInstOperands,
     /*  83093 */     // GIR_Coverage, 3221,
     /*  83093 */     GIR_EraseRootFromParent_Done,
     /*  83094 */   // Label 1573: @83094
     /*  83094 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83182), // Rule ID 3225 //
     /*  83099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83148 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83152 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83156 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83161 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83163 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83180 */     GIR_RootConstrainSelectedInstOperands,
     /*  83181 */     // GIR_Coverage, 3225,
     /*  83181 */     GIR_EraseRootFromParent_Done,
     /*  83182 */   // Label 1574: @83182
     /*  83182 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83270), // Rule ID 3229 //
     /*  83187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83236 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83240 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83244 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83249 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83251 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83268 */     GIR_RootConstrainSelectedInstOperands,
     /*  83269 */     // GIR_Coverage, 3229,
     /*  83269 */     GIR_EraseRootFromParent_Done,
     /*  83270 */   // Label 1575: @83270
     /*  83270 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(83358), // Rule ID 3233 //
     /*  83275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83324 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83328 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83332 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83337 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83339 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83356 */     GIR_RootConstrainSelectedInstOperands,
     /*  83357 */     // GIR_Coverage, 3233,
     /*  83357 */     GIR_EraseRootFromParent_Done,
     /*  83358 */   // Label 1576: @83358
     /*  83358 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83446), // Rule ID 3237 //
     /*  83363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83412 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83416 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83420 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83425 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83427 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83444 */     GIR_RootConstrainSelectedInstOperands,
     /*  83445 */     // GIR_Coverage, 3237,
     /*  83445 */     GIR_EraseRootFromParent_Done,
     /*  83446 */   // Label 1577: @83446
     /*  83446 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83536), // Rule ID 3183 //
     /*  83451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83500 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83504 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83508 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83513 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83515 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83517 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83534 */     GIR_RootConstrainSelectedInstOperands,
     /*  83535 */     // GIR_Coverage, 3183,
     /*  83535 */     GIR_EraseRootFromParent_Done,
     /*  83536 */   // Label 1578: @83536
     /*  83536 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83626), // Rule ID 3187 //
     /*  83541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83590 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83594 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83598 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83603 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83605 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83607 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83624 */     GIR_RootConstrainSelectedInstOperands,
     /*  83625 */     // GIR_Coverage, 3187,
     /*  83625 */     GIR_EraseRootFromParent_Done,
     /*  83626 */   // Label 1579: @83626
     /*  83626 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83716), // Rule ID 3191 //
     /*  83631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83680 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83684 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83688 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83693 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83695 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83697 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83714 */     GIR_RootConstrainSelectedInstOperands,
     /*  83715 */     // GIR_Coverage, 3191,
     /*  83715 */     GIR_EraseRootFromParent_Done,
     /*  83716 */   // Label 1580: @83716
     /*  83716 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83806), // Rule ID 3195 //
     /*  83721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83770 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83774 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83778 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83783 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83785 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83787 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83804 */     GIR_RootConstrainSelectedInstOperands,
     /*  83805 */     // GIR_Coverage, 3195,
     /*  83805 */     GIR_EraseRootFromParent_Done,
     /*  83806 */   // Label 1581: @83806
     /*  83806 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(83896), // Rule ID 3199 //
     /*  83811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83860 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83864 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83868 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  83871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83873 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83875 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83877 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83894 */     GIR_RootConstrainSelectedInstOperands,
     /*  83895 */     // GIR_Coverage, 3199,
     /*  83895 */     GIR_EraseRootFromParent_Done,
     /*  83896 */   // Label 1582: @83896
     /*  83896 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(83986), // Rule ID 3203 //
     /*  83901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83950 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83954 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83958 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  83961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83963 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83965 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83967 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83984 */     GIR_RootConstrainSelectedInstOperands,
     /*  83985 */     // GIR_Coverage, 3203,
     /*  83985 */     GIR_EraseRootFromParent_Done,
     /*  83986 */   // Label 1583: @83986
     /*  83986 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84076), // Rule ID 3207 //
     /*  83991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84040 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84044 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84048 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84053 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84055 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84057 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84074 */     GIR_RootConstrainSelectedInstOperands,
     /*  84075 */     // GIR_Coverage, 3207,
     /*  84075 */     GIR_EraseRootFromParent_Done,
     /*  84076 */   // Label 1584: @84076
     /*  84076 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84166), // Rule ID 3211 //
     /*  84081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84130 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84134 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84138 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84143 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84145 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84147 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84164 */     GIR_RootConstrainSelectedInstOperands,
     /*  84165 */     // GIR_Coverage, 3211,
     /*  84165 */     GIR_EraseRootFromParent_Done,
     /*  84166 */   // Label 1585: @84166
     /*  84166 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84256), // Rule ID 3215 //
     /*  84171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84220 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84224 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84228 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84235 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84237 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84254 */     GIR_RootConstrainSelectedInstOperands,
     /*  84255 */     // GIR_Coverage, 3215,
     /*  84255 */     GIR_EraseRootFromParent_Done,
     /*  84256 */   // Label 1586: @84256
     /*  84256 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(84346), // Rule ID 3219 //
     /*  84261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84310 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84314 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84318 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84323 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84325 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84327 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84344 */     GIR_RootConstrainSelectedInstOperands,
     /*  84345 */     // GIR_Coverage, 3219,
     /*  84345 */     GIR_EraseRootFromParent_Done,
     /*  84346 */   // Label 1587: @84346
     /*  84346 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84436), // Rule ID 3223 //
     /*  84351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84400 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84404 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84408 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84413 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84415 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84417 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84434 */     GIR_RootConstrainSelectedInstOperands,
     /*  84435 */     // GIR_Coverage, 3223,
     /*  84435 */     GIR_EraseRootFromParent_Done,
     /*  84436 */   // Label 1588: @84436
     /*  84436 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84526), // Rule ID 3227 //
     /*  84441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84490 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84494 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84498 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84503 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84505 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84507 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84524 */     GIR_RootConstrainSelectedInstOperands,
     /*  84525 */     // GIR_Coverage, 3227,
     /*  84525 */     GIR_EraseRootFromParent_Done,
     /*  84526 */   // Label 1589: @84526
     /*  84526 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84616), // Rule ID 3231 //
     /*  84531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84580 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84584 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84588 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84593 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84595 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84597 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84614 */     GIR_RootConstrainSelectedInstOperands,
     /*  84615 */     // GIR_Coverage, 3231,
     /*  84615 */     GIR_EraseRootFromParent_Done,
     /*  84616 */   // Label 1590: @84616
     /*  84616 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84706), // Rule ID 3235 //
     /*  84621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84670 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84674 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84678 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84683 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84685 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84687 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84704 */     GIR_RootConstrainSelectedInstOperands,
     /*  84705 */     // GIR_Coverage, 3235,
     /*  84705 */     GIR_EraseRootFromParent_Done,
     /*  84706 */   // Label 1591: @84706
     /*  84706 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84796), // Rule ID 3239 //
     /*  84711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84760 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84764 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84768 */     // (intrinsic_wo_chain:{ *:[i32] } 3655:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84773 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84775 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84777 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84794 */     GIR_RootConstrainSelectedInstOperands,
     /*  84795 */     // GIR_Coverage, 3239,
     /*  84795 */     GIR_EraseRootFromParent_Done,
     /*  84796 */   // Label 1592: @84796
     /*  84796 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(84883), // Rule ID 4335 //
     /*  84801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84855 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  84858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84860 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84862 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84864 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84881 */     GIR_RootConstrainSelectedInstOperands,
     /*  84882 */     // GIR_Coverage, 4335,
     /*  84882 */     GIR_EraseRootFromParent_Done,
     /*  84883 */   // Label 1593: @84883
     /*  84883 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(84970), // Rule ID 4337 //
     /*  84888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  84896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  84902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  84905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84942 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  84942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  84945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84947 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84949 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84951 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84968 */     GIR_RootConstrainSelectedInstOperands,
     /*  84969 */     // GIR_Coverage, 4337,
     /*  84969 */     GIR_EraseRootFromParent_Done,
     /*  84970 */   // Label 1594: @84970
     /*  84970 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85057), // Rule ID 4339 //
     /*  84975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  84983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  84992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85029 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85034 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85036 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85038 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85055 */     GIR_RootConstrainSelectedInstOperands,
     /*  85056 */     // GIR_Coverage, 4339,
     /*  85056 */     GIR_EraseRootFromParent_Done,
     /*  85057 */   // Label 1595: @85057
     /*  85057 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85144), // Rule ID 4341 //
     /*  85062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85116 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85121 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85123 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85125 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85142 */     GIR_RootConstrainSelectedInstOperands,
     /*  85143 */     // GIR_Coverage, 4341,
     /*  85143 */     GIR_EraseRootFromParent_Done,
     /*  85144 */   // Label 1596: @85144
     /*  85144 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85231), // Rule ID 4343 //
     /*  85149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85203 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85208 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85210 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85212 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85229 */     GIR_RootConstrainSelectedInstOperands,
     /*  85230 */     // GIR_Coverage, 4343,
     /*  85230 */     GIR_EraseRootFromParent_Done,
     /*  85231 */   // Label 1597: @85231
     /*  85231 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(85318), // Rule ID 4345 //
     /*  85236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85290 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85295 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85297 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85299 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85316 */     GIR_RootConstrainSelectedInstOperands,
     /*  85317 */     // GIR_Coverage, 4345,
     /*  85317 */     GIR_EraseRootFromParent_Done,
     /*  85318 */   // Label 1598: @85318
     /*  85318 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85405), // Rule ID 4347 //
     /*  85323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85377 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85382 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85384 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85386 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85403 */     GIR_RootConstrainSelectedInstOperands,
     /*  85404 */     // GIR_Coverage, 4347,
     /*  85404 */     GIR_EraseRootFromParent_Done,
     /*  85405 */   // Label 1599: @85405
     /*  85405 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85492), // Rule ID 4349 //
     /*  85410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85469 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85471 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85473 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85490 */     GIR_RootConstrainSelectedInstOperands,
     /*  85491 */     // GIR_Coverage, 4349,
     /*  85491 */     GIR_EraseRootFromParent_Done,
     /*  85492 */   // Label 1600: @85492
     /*  85492 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85579), // Rule ID 4351 //
     /*  85497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85551 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85556 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85558 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85560 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85577 */     GIR_RootConstrainSelectedInstOperands,
     /*  85578 */     // GIR_Coverage, 4351,
     /*  85578 */     GIR_EraseRootFromParent_Done,
     /*  85579 */   // Label 1601: @85579
     /*  85579 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85666), // Rule ID 4353 //
     /*  85584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85638 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85643 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85645 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85647 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85664 */     GIR_RootConstrainSelectedInstOperands,
     /*  85665 */     // GIR_Coverage, 4353,
     /*  85665 */     GIR_EraseRootFromParent_Done,
     /*  85666 */   // Label 1602: @85666
     /*  85666 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85753), // Rule ID 4355 //
     /*  85671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85725 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85730 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85732 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85734 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85751 */     GIR_RootConstrainSelectedInstOperands,
     /*  85752 */     // GIR_Coverage, 4355,
     /*  85752 */     GIR_EraseRootFromParent_Done,
     /*  85753 */   // Label 1603: @85753
     /*  85753 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85840), // Rule ID 4357 //
     /*  85758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85812 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85817 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85819 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85821 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85838 */     GIR_RootConstrainSelectedInstOperands,
     /*  85839 */     // GIR_Coverage, 4357,
     /*  85839 */     GIR_EraseRootFromParent_Done,
     /*  85840 */   // Label 1604: @85840
     /*  85840 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85927), // Rule ID 4359 //
     /*  85845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85899 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  85902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85904 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85906 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85908 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85925 */     GIR_RootConstrainSelectedInstOperands,
     /*  85926 */     // GIR_Coverage, 4359,
     /*  85926 */     GIR_EraseRootFromParent_Done,
     /*  85927 */   // Label 1605: @85927
     /*  85927 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(86014), // Rule ID 4361 //
     /*  85932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85986 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  85989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85991 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85993 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85995 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86012 */     GIR_RootConstrainSelectedInstOperands,
     /*  86013 */     // GIR_Coverage, 4361,
     /*  86013 */     GIR_EraseRootFromParent_Done,
     /*  86014 */   // Label 1606: @86014
     /*  86014 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86101), // Rule ID 4363 //
     /*  86019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86078 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86080 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86082 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86099 */     GIR_RootConstrainSelectedInstOperands,
     /*  86100 */     // GIR_Coverage, 4363,
     /*  86100 */     GIR_EraseRootFromParent_Done,
     /*  86101 */   // Label 1607: @86101
     /*  86101 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86188), // Rule ID 4365 //
     /*  86106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86160 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86165 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86167 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86169 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86186 */     GIR_RootConstrainSelectedInstOperands,
     /*  86187 */     // GIR_Coverage, 4365,
     /*  86187 */     GIR_EraseRootFromParent_Done,
     /*  86188 */   // Label 1608: @86188
     /*  86188 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86275), // Rule ID 4367 //
     /*  86193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86247 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86252 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86254 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86256 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86273 */     GIR_RootConstrainSelectedInstOperands,
     /*  86274 */     // GIR_Coverage, 4367,
     /*  86274 */     GIR_EraseRootFromParent_Done,
     /*  86275 */   // Label 1609: @86275
     /*  86275 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(86362), // Rule ID 4369 //
     /*  86280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86334 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86339 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86341 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86343 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86360 */     GIR_RootConstrainSelectedInstOperands,
     /*  86361 */     // GIR_Coverage, 4369,
     /*  86361 */     GIR_EraseRootFromParent_Done,
     /*  86362 */   // Label 1610: @86362
     /*  86362 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86449), // Rule ID 4371 //
     /*  86367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86421 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86426 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86428 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86430 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86447 */     GIR_RootConstrainSelectedInstOperands,
     /*  86448 */     // GIR_Coverage, 4371,
     /*  86448 */     GIR_EraseRootFromParent_Done,
     /*  86449 */   // Label 1611: @86449
     /*  86449 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86536), // Rule ID 4373 //
     /*  86454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86513 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86515 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86517 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86534 */     GIR_RootConstrainSelectedInstOperands,
     /*  86535 */     // GIR_Coverage, 4373,
     /*  86535 */     GIR_EraseRootFromParent_Done,
     /*  86536 */   // Label 1612: @86536
     /*  86536 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86623), // Rule ID 4375 //
     /*  86541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86595 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86600 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86602 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86604 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86621 */     GIR_RootConstrainSelectedInstOperands,
     /*  86622 */     // GIR_Coverage, 4375,
     /*  86622 */     GIR_EraseRootFromParent_Done,
     /*  86623 */   // Label 1613: @86623
     /*  86623 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86710), // Rule ID 4377 //
     /*  86628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86682 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86687 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86689 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86691 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86708 */     GIR_RootConstrainSelectedInstOperands,
     /*  86709 */     // GIR_Coverage, 4377,
     /*  86709 */     GIR_EraseRootFromParent_Done,
     /*  86710 */   // Label 1614: @86710
     /*  86710 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86797), // Rule ID 4379 //
     /*  86715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86769 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86774 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86776 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86778 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86795 */     GIR_RootConstrainSelectedInstOperands,
     /*  86796 */     // GIR_Coverage, 4379,
     /*  86796 */     GIR_EraseRootFromParent_Done,
     /*  86797 */   // Label 1615: @86797
     /*  86797 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86884), // Rule ID 4381 //
     /*  86802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  86859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86861 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86863 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86865 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86882 */     GIR_RootConstrainSelectedInstOperands,
     /*  86883 */     // GIR_Coverage, 4381,
     /*  86883 */     GIR_EraseRootFromParent_Done,
     /*  86884 */   // Label 1616: @86884
     /*  86884 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(87010), // Rule ID 2692 //
     /*  86889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  86897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  86900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  86903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  86906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  86909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  86912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  86915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  86918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  86922 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3862:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  86922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  86925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  86929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  86938 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  86941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  86945 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  86948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  86952 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  86955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  86959 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  86962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  86967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  86990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86992 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  86994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86997 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  86999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87008 */     GIR_RootConstrainSelectedInstOperands,
     /*  87009 */     // GIR_Coverage, 2692,
     /*  87009 */     GIR_EraseRootFromParent_Done,
     /*  87010 */   // Label 1617: @87010
     /*  87010 */   GIM_Reject,
     /*  87011 */ // Label 1562: @87011
     /*  87011 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(91305),
     /*  87016 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87019 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87024 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87131), // Rule ID 3758 //
     /*  87029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87050 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87053 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87080 */     // MIs[1] Operand 1
     /*  87080 */     // No operand predicates
     /*  87080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87107 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87129 */     GIR_RootConstrainSelectedInstOperands,
     /*  87130 */     // GIR_Coverage, 3758,
     /*  87130 */     GIR_EraseRootFromParent_Done,
     /*  87131 */   // Label 1619: @87131
     /*  87131 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(87238), // Rule ID 3760 //
     /*  87136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87157 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87160 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87187 */     // MIs[1] Operand 1
     /*  87187 */     // No operand predicates
     /*  87187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87209 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87214 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87236 */     GIR_RootConstrainSelectedInstOperands,
     /*  87237 */     // GIR_Coverage, 3760,
     /*  87237 */     GIR_EraseRootFromParent_Done,
     /*  87238 */   // Label 1620: @87238
     /*  87238 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(87345), // Rule ID 3762 //
     /*  87243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87264 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87267 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87294 */     // MIs[1] Operand 1
     /*  87294 */     // No operand predicates
     /*  87294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87316 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87321 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87343 */     GIR_RootConstrainSelectedInstOperands,
     /*  87344 */     // GIR_Coverage, 3762,
     /*  87344 */     GIR_EraseRootFromParent_Done,
     /*  87345 */   // Label 1621: @87345
     /*  87345 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(87452), // Rule ID 3764 //
     /*  87350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87371 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87374 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87401 */     // MIs[1] Operand 1
     /*  87401 */     // No operand predicates
     /*  87401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87428 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87450 */     GIR_RootConstrainSelectedInstOperands,
     /*  87451 */     // GIR_Coverage, 3764,
     /*  87451 */     GIR_EraseRootFromParent_Done,
     /*  87452 */   // Label 1622: @87452
     /*  87452 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87559), // Rule ID 3766 //
     /*  87457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87478 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87481 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87508 */     // MIs[1] Operand 1
     /*  87508 */     // No operand predicates
     /*  87508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87530 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87535 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87557 */     GIR_RootConstrainSelectedInstOperands,
     /*  87558 */     // GIR_Coverage, 3766,
     /*  87558 */     GIR_EraseRootFromParent_Done,
     /*  87559 */   // Label 1623: @87559
     /*  87559 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87666), // Rule ID 3768 //
     /*  87564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87585 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87588 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87615 */     // MIs[1] Operand 1
     /*  87615 */     // No operand predicates
     /*  87615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87637 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87642 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87664 */     GIR_RootConstrainSelectedInstOperands,
     /*  87665 */     // GIR_Coverage, 3768,
     /*  87665 */     GIR_EraseRootFromParent_Done,
     /*  87666 */   // Label 1624: @87666
     /*  87666 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87773), // Rule ID 3770 //
     /*  87671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87692 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87695 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87722 */     // MIs[1] Operand 1
     /*  87722 */     // No operand predicates
     /*  87722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87749 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87771 */     GIR_RootConstrainSelectedInstOperands,
     /*  87772 */     // GIR_Coverage, 3770,
     /*  87772 */     GIR_EraseRootFromParent_Done,
     /*  87773 */   // Label 1625: @87773
     /*  87773 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87880), // Rule ID 3772 //
     /*  87778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87799 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87802 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87829 */     // MIs[1] Operand 1
     /*  87829 */     // No operand predicates
     /*  87829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87851 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87856 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87878 */     GIR_RootConstrainSelectedInstOperands,
     /*  87879 */     // GIR_Coverage, 3772,
     /*  87879 */     GIR_EraseRootFromParent_Done,
     /*  87880 */   // Label 1626: @87880
     /*  87880 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(87987), // Rule ID 3774 //
     /*  87885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87906 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87909 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87936 */     // MIs[1] Operand 1
     /*  87936 */     // No operand predicates
     /*  87936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87958 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  87961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87963 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87985 */     GIR_RootConstrainSelectedInstOperands,
     /*  87986 */     // GIR_Coverage, 3774,
     /*  87986 */     GIR_EraseRootFromParent_Done,
     /*  87987 */   // Label 1627: @87987
     /*  87987 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(88094), // Rule ID 3776 //
     /*  87992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88013 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88016 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88043 */     // MIs[1] Operand 1
     /*  88043 */     // No operand predicates
     /*  88043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88065 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88070 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88092 */     GIR_RootConstrainSelectedInstOperands,
     /*  88093 */     // GIR_Coverage, 3776,
     /*  88093 */     GIR_EraseRootFromParent_Done,
     /*  88094 */   // Label 1628: @88094
     /*  88094 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(88201), // Rule ID 3778 //
     /*  88099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88120 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88123 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88150 */     // MIs[1] Operand 1
     /*  88150 */     // No operand predicates
     /*  88150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88172 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88177 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88199 */     GIR_RootConstrainSelectedInstOperands,
     /*  88200 */     // GIR_Coverage, 3778,
     /*  88200 */     GIR_EraseRootFromParent_Done,
     /*  88201 */   // Label 1629: @88201
     /*  88201 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(88308), // Rule ID 3780 //
     /*  88206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88227 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88230 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88257 */     // MIs[1] Operand 1
     /*  88257 */     // No operand predicates
     /*  88257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88279 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88284 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88306 */     GIR_RootConstrainSelectedInstOperands,
     /*  88307 */     // GIR_Coverage, 3780,
     /*  88307 */     GIR_EraseRootFromParent_Done,
     /*  88308 */   // Label 1630: @88308
     /*  88308 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(88415), // Rule ID 3782 //
     /*  88313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88334 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88337 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88364 */     // MIs[1] Operand 1
     /*  88364 */     // No operand predicates
     /*  88364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88386 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88391 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88413 */     GIR_RootConstrainSelectedInstOperands,
     /*  88414 */     // GIR_Coverage, 3782,
     /*  88414 */     GIR_EraseRootFromParent_Done,
     /*  88415 */   // Label 1631: @88415
     /*  88415 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88522), // Rule ID 3784 //
     /*  88420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88441 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88444 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88471 */     // MIs[1] Operand 1
     /*  88471 */     // No operand predicates
     /*  88471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88493 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88498 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88520 */     GIR_RootConstrainSelectedInstOperands,
     /*  88521 */     // GIR_Coverage, 3784,
     /*  88521 */     GIR_EraseRootFromParent_Done,
     /*  88522 */   // Label 1632: @88522
     /*  88522 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88629), // Rule ID 3786 //
     /*  88527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88548 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88551 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88578 */     // MIs[1] Operand 1
     /*  88578 */     // No operand predicates
     /*  88578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88600 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88605 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88627 */     GIR_RootConstrainSelectedInstOperands,
     /*  88628 */     // GIR_Coverage, 3786,
     /*  88628 */     GIR_EraseRootFromParent_Done,
     /*  88629 */   // Label 1633: @88629
     /*  88629 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88736), // Rule ID 3788 //
     /*  88634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88655 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88658 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88685 */     // MIs[1] Operand 1
     /*  88685 */     // No operand predicates
     /*  88685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88707 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88712 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88734 */     GIR_RootConstrainSelectedInstOperands,
     /*  88735 */     // GIR_Coverage, 3788,
     /*  88735 */     GIR_EraseRootFromParent_Done,
     /*  88736 */   // Label 1634: @88736
     /*  88736 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88843), // Rule ID 3790 //
     /*  88741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88762 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88765 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88792 */     // MIs[1] Operand 1
     /*  88792 */     // No operand predicates
     /*  88792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88819 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88841 */     GIR_RootConstrainSelectedInstOperands,
     /*  88842 */     // GIR_Coverage, 3790,
     /*  88842 */     GIR_EraseRootFromParent_Done,
     /*  88843 */   // Label 1635: @88843
     /*  88843 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(88950), // Rule ID 3792 //
     /*  88848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88869 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88872 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88899 */     // MIs[1] Operand 1
     /*  88899 */     // No operand predicates
     /*  88899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88921 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  88924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88926 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88948 */     GIR_RootConstrainSelectedInstOperands,
     /*  88949 */     // GIR_Coverage, 3792,
     /*  88949 */     GIR_EraseRootFromParent_Done,
     /*  88950 */   // Label 1636: @88950
     /*  88950 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(89057), // Rule ID 3794 //
     /*  88955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88976 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88979 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89006 */     // MIs[1] Operand 1
     /*  89006 */     // No operand predicates
     /*  89006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89028 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89033 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89055 */     GIR_RootConstrainSelectedInstOperands,
     /*  89056 */     // GIR_Coverage, 3794,
     /*  89056 */     GIR_EraseRootFromParent_Done,
     /*  89057 */   // Label 1637: @89057
     /*  89057 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89164), // Rule ID 3796 //
     /*  89062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89083 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89086 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89113 */     // MIs[1] Operand 1
     /*  89113 */     // No operand predicates
     /*  89113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89135 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89140 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89162 */     GIR_RootConstrainSelectedInstOperands,
     /*  89163 */     // GIR_Coverage, 3796,
     /*  89163 */     GIR_EraseRootFromParent_Done,
     /*  89164 */   // Label 1638: @89164
     /*  89164 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(89271), // Rule ID 3798 //
     /*  89169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89190 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89193 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89220 */     // MIs[1] Operand 1
     /*  89220 */     // No operand predicates
     /*  89220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89247 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89269 */     GIR_RootConstrainSelectedInstOperands,
     /*  89270 */     // GIR_Coverage, 3798,
     /*  89270 */     GIR_EraseRootFromParent_Done,
     /*  89271 */   // Label 1639: @89271
     /*  89271 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(89378), // Rule ID 3800 //
     /*  89276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89297 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89300 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89327 */     // MIs[1] Operand 1
     /*  89327 */     // No operand predicates
     /*  89327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89349 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89354 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89376 */     GIR_RootConstrainSelectedInstOperands,
     /*  89377 */     // GIR_Coverage, 3800,
     /*  89377 */     GIR_EraseRootFromParent_Done,
     /*  89378 */   // Label 1640: @89378
     /*  89378 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89485), // Rule ID 3802 //
     /*  89383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89404 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89407 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89434 */     // MIs[1] Operand 1
     /*  89434 */     // No operand predicates
     /*  89434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89461 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89483 */     GIR_RootConstrainSelectedInstOperands,
     /*  89484 */     // GIR_Coverage, 3802,
     /*  89484 */     GIR_EraseRootFromParent_Done,
     /*  89485 */   // Label 1641: @89485
     /*  89485 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89592), // Rule ID 3804 //
     /*  89490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89511 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89514 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89541 */     // MIs[1] Operand 1
     /*  89541 */     // No operand predicates
     /*  89541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89563 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89568 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89590 */     GIR_RootConstrainSelectedInstOperands,
     /*  89591 */     // GIR_Coverage, 3804,
     /*  89591 */     GIR_EraseRootFromParent_Done,
     /*  89592 */   // Label 1642: @89592
     /*  89592 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89699), // Rule ID 3806 //
     /*  89597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89618 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89621 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89648 */     // MIs[1] Operand 1
     /*  89648 */     // No operand predicates
     /*  89648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89670 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89675 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89697 */     GIR_RootConstrainSelectedInstOperands,
     /*  89698 */     // GIR_Coverage, 3806,
     /*  89698 */     GIR_EraseRootFromParent_Done,
     /*  89699 */   // Label 1643: @89699
     /*  89699 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89806), // Rule ID 3808 //
     /*  89704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89725 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89728 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89755 */     // MIs[1] Operand 1
     /*  89755 */     // No operand predicates
     /*  89755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89777 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89782 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89804 */     GIR_RootConstrainSelectedInstOperands,
     /*  89805 */     // GIR_Coverage, 3808,
     /*  89805 */     GIR_EraseRootFromParent_Done,
     /*  89806 */   // Label 1644: @89806
     /*  89806 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89913), // Rule ID 3810 //
     /*  89811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89832 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89835 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89862 */     // MIs[1] Operand 1
     /*  89862 */     // No operand predicates
     /*  89862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89884 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  89887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89889 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89911 */     GIR_RootConstrainSelectedInstOperands,
     /*  89912 */     // GIR_Coverage, 3810,
     /*  89912 */     GIR_EraseRootFromParent_Done,
     /*  89913 */   // Label 1645: @89913
     /*  89913 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90020), // Rule ID 3812 //
     /*  89918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89939 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89942 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89969 */     // MIs[1] Operand 1
     /*  89969 */     // No operand predicates
     /*  89969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89991 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  89994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89996 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90018 */     GIR_RootConstrainSelectedInstOperands,
     /*  90019 */     // GIR_Coverage, 3812,
     /*  90019 */     GIR_EraseRootFromParent_Done,
     /*  90020 */   // Label 1646: @90020
     /*  90020 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90127), // Rule ID 3814 //
     /*  90025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90046 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90049 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90076 */     // MIs[1] Operand 1
     /*  90076 */     // No operand predicates
     /*  90076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90098 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90103 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90125 */     GIR_RootConstrainSelectedInstOperands,
     /*  90126 */     // GIR_Coverage, 3814,
     /*  90126 */     GIR_EraseRootFromParent_Done,
     /*  90127 */   // Label 1647: @90127
     /*  90127 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(90234), // Rule ID 3816 //
     /*  90132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90153 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90156 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90183 */     // MIs[1] Operand 1
     /*  90183 */     // No operand predicates
     /*  90183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90205 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90210 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90232 */     GIR_RootConstrainSelectedInstOperands,
     /*  90233 */     // GIR_Coverage, 3816,
     /*  90233 */     GIR_EraseRootFromParent_Done,
     /*  90234 */   // Label 1648: @90234
     /*  90234 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(90341), // Rule ID 3818 //
     /*  90239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90260 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90263 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90290 */     // MIs[1] Operand 1
     /*  90290 */     // No operand predicates
     /*  90290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90317 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90339 */     GIR_RootConstrainSelectedInstOperands,
     /*  90340 */     // GIR_Coverage, 3818,
     /*  90340 */     GIR_EraseRootFromParent_Done,
     /*  90341 */   // Label 1649: @90341
     /*  90341 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90448), // Rule ID 3820 //
     /*  90346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90367 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90370 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90397 */     // MIs[1] Operand 1
     /*  90397 */     // No operand predicates
     /*  90397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90419 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90424 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90446 */     GIR_RootConstrainSelectedInstOperands,
     /*  90447 */     // GIR_Coverage, 3820,
     /*  90447 */     GIR_EraseRootFromParent_Done,
     /*  90448 */   // Label 1650: @90448
     /*  90448 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90555), // Rule ID 3822 //
     /*  90453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90474 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90477 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90504 */     // MIs[1] Operand 1
     /*  90504 */     // No operand predicates
     /*  90504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90526 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90531 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90553 */     GIR_RootConstrainSelectedInstOperands,
     /*  90554 */     // GIR_Coverage, 3822,
     /*  90554 */     GIR_EraseRootFromParent_Done,
     /*  90555 */   // Label 1651: @90555
     /*  90555 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90662), // Rule ID 3824 //
     /*  90560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90581 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90584 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90611 */     // MIs[1] Operand 1
     /*  90611 */     // No operand predicates
     /*  90611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90633 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90638 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90660 */     GIR_RootConstrainSelectedInstOperands,
     /*  90661 */     // GIR_Coverage, 3824,
     /*  90661 */     GIR_EraseRootFromParent_Done,
     /*  90662 */   // Label 1652: @90662
     /*  90662 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90769), // Rule ID 3826 //
     /*  90667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90688 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90691 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90718 */     // MIs[1] Operand 1
     /*  90718 */     // No operand predicates
     /*  90718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90740 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90745 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90767 */     GIR_RootConstrainSelectedInstOperands,
     /*  90768 */     // GIR_Coverage, 3826,
     /*  90768 */     GIR_EraseRootFromParent_Done,
     /*  90769 */   // Label 1653: @90769
     /*  90769 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90876), // Rule ID 3828 //
     /*  90774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90795 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90798 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90825 */     // MIs[1] Operand 1
     /*  90825 */     // No operand predicates
     /*  90825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90847 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  90850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90852 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90874 */     GIR_RootConstrainSelectedInstOperands,
     /*  90875 */     // GIR_Coverage, 3828,
     /*  90875 */     GIR_EraseRootFromParent_Done,
     /*  90876 */   // Label 1654: @90876
     /*  90876 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(90983), // Rule ID 3830 //
     /*  90881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90902 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90905 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90932 */     // MIs[1] Operand 1
     /*  90932 */     // No operand predicates
     /*  90932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90954 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  90957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90959 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90981 */     GIR_RootConstrainSelectedInstOperands,
     /*  90982 */     // GIR_Coverage, 3830,
     /*  90982 */     GIR_EraseRootFromParent_Done,
     /*  90983 */   // Label 1655: @90983
     /*  90983 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91090), // Rule ID 3832 //
     /*  90988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91009 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91012 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91039 */     // MIs[1] Operand 1
     /*  91039 */     // No operand predicates
     /*  91039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91066 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91088 */     GIR_RootConstrainSelectedInstOperands,
     /*  91089 */     // GIR_Coverage, 3832,
     /*  91089 */     GIR_EraseRootFromParent_Done,
     /*  91090 */   // Label 1656: @91090
     /*  91090 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91197), // Rule ID 3834 //
     /*  91095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91116 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91119 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91146 */     // MIs[1] Operand 1
     /*  91146 */     // No operand predicates
     /*  91146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91173 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91195 */     GIR_RootConstrainSelectedInstOperands,
     /*  91196 */     // GIR_Coverage, 3834,
     /*  91196 */     GIR_EraseRootFromParent_Done,
     /*  91197 */   // Label 1657: @91197
     /*  91197 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91304), // Rule ID 3836 //
     /*  91202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91223 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91226 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91253 */     // MIs[1] Operand 1
     /*  91253 */     // No operand predicates
     /*  91253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91275 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91280 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91302 */     GIR_RootConstrainSelectedInstOperands,
     /*  91303 */     // GIR_Coverage, 3836,
     /*  91303 */     GIR_EraseRootFromParent_Done,
     /*  91304 */   // Label 1658: @91304
     /*  91304 */   GIM_Reject,
     /*  91305 */ // Label 1618: @91305
     /*  91305 */ GIM_Reject,
     /*  91306 */ // Label 16: @91306
     /*  91306 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91363),
     /*  91311 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91314 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91319 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91336), // Rule ID 245 //
     /*  91324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91327 */     // (intrinsic_void 3494:{ *:[iPTR] })  =>  (CLREX)
     /*  91327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91334 */     GIR_RootConstrainSelectedInstOperands,
     /*  91335 */     // GIR_Coverage, 245,
     /*  91335 */     GIR_EraseRootFromParent_Done,
     /*  91336 */   // Label 1660: @91336
     /*  91336 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91362), // Rule ID 574 //
     /*  91341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91344 */     // (intrinsic_void 3494:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91360 */     GIR_RootConstrainSelectedInstOperands,
     /*  91361 */     // GIR_Coverage, 574,
     /*  91361 */     GIR_EraseRootFromParent_Done,
     /*  91362 */   // Label 1661: @91362
     /*  91362 */   GIM_Reject,
     /*  91363 */ // Label 1659: @91363
     /*  91363 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(92165),
     /*  91368 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91371 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91407), // Rule ID 344 //
     /*  91376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91384 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91387 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91398 */     // (intrinsic_void 3931:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91405 */     GIR_RootConstrainSelectedInstOperands,
     /*  91406 */     // GIR_Coverage, 344,
     /*  91406 */     GIR_EraseRootFromParent_Done,
     /*  91407 */   // Label 1663: @91407
     /*  91407 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91459), // Rule ID 2 //
     /*  91412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91420 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91435 */     // MIs[1] Operand 1
     /*  91435 */     // No operand predicates
     /*  91435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91437 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91457 */     GIR_RootConstrainSelectedInstOperands,
     /*  91458 */     // GIR_Coverage, 2,
     /*  91458 */     GIR_EraseRootFromParent_Done,
     /*  91459 */   // Label 1664: @91459
     /*  91459 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91511), // Rule ID 10 //
     /*  91464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91472 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91487 */     // MIs[1] Operand 1
     /*  91487 */     // No operand predicates
     /*  91487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91489 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91509 */     GIR_RootConstrainSelectedInstOperands,
     /*  91510 */     // GIR_Coverage, 10,
     /*  91510 */     GIR_EraseRootFromParent_Done,
     /*  91511 */   // Label 1665: @91511
     /*  91511 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91554), // Rule ID 11 //
     /*  91516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91524 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91539 */     // MIs[1] Operand 1
     /*  91539 */     // No operand predicates
     /*  91539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91541 */     // (intrinsic_void 3931:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91552 */     GIR_RootConstrainSelectedInstOperands,
     /*  91553 */     // GIR_Coverage, 11,
     /*  91553 */     GIR_EraseRootFromParent_Done,
     /*  91554 */   // Label 1666: @91554
     /*  91554 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91597), // Rule ID 228 //
     /*  91559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91567 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91582 */     // MIs[1] Operand 1
     /*  91582 */     // No operand predicates
     /*  91582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91584 */     // (intrinsic_void 3508:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91595 */     GIR_RootConstrainSelectedInstOperands,
     /*  91596 */     // GIR_Coverage, 228,
     /*  91596 */     GIR_EraseRootFromParent_Done,
     /*  91597 */   // Label 1667: @91597
     /*  91597 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91640), // Rule ID 229 //
     /*  91602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91610 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91625 */     // MIs[1] Operand 1
     /*  91625 */     // No operand predicates
     /*  91625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91627 */     // (intrinsic_void 3509:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91638 */     GIR_RootConstrainSelectedInstOperands,
     /*  91639 */     // GIR_Coverage, 229,
     /*  91639 */     GIR_EraseRootFromParent_Done,
     /*  91640 */   // Label 1668: @91640
     /*  91640 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91683), // Rule ID 230 //
     /*  91645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91653 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91668 */     // MIs[1] Operand 1
     /*  91668 */     // No operand predicates
     /*  91668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91670 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91681 */     GIR_RootConstrainSelectedInstOperands,
     /*  91682 */     // GIR_Coverage, 230,
     /*  91682 */     GIR_EraseRootFromParent_Done,
     /*  91683 */   // Label 1669: @91683
     /*  91683 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91735), // Rule ID 276 //
     /*  91688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91696 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91711 */     // MIs[1] Operand 1
     /*  91711 */     // No operand predicates
     /*  91711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91713 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91733 */     GIR_RootConstrainSelectedInstOperands,
     /*  91734 */     // GIR_Coverage, 276,
     /*  91734 */     GIR_EraseRootFromParent_Done,
     /*  91735 */   // Label 1670: @91735
     /*  91735 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91778), // Rule ID 343 //
     /*  91740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91748 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91763 */     // MIs[1] Operand 1
     /*  91763 */     // No operand predicates
     /*  91763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91765 */     // (intrinsic_void 3931:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91776 */     GIR_RootConstrainSelectedInstOperands,
     /*  91777 */     // GIR_Coverage, 343,
     /*  91777 */     GIR_EraseRootFromParent_Done,
     /*  91778 */   // Label 1671: @91778
     /*  91778 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91821), // Rule ID 494 //
     /*  91783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91791 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91806 */     // MIs[1] Operand 1
     /*  91806 */     // No operand predicates
     /*  91806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91808 */     // (intrinsic_void 3931:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91819 */     GIR_RootConstrainSelectedInstOperands,
     /*  91820 */     // GIR_Coverage, 494,
     /*  91820 */     GIR_EraseRootFromParent_Done,
     /*  91821 */   // Label 1672: @91821
     /*  91821 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91873), // Rule ID 559 //
     /*  91826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91834 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91849 */     // MIs[1] Operand 1
     /*  91849 */     // No operand predicates
     /*  91849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91851 */     // (intrinsic_void 3508:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  91851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  91854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91871 */     GIR_RootConstrainSelectedInstOperands,
     /*  91872 */     // GIR_Coverage, 559,
     /*  91872 */     GIR_EraseRootFromParent_Done,
     /*  91873 */   // Label 1673: @91873
     /*  91873 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91925), // Rule ID 560 //
     /*  91878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91886 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91901 */     // MIs[1] Operand 1
     /*  91901 */     // No operand predicates
     /*  91901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91903 */     // (intrinsic_void 3509:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  91903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  91906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91923 */     GIR_RootConstrainSelectedInstOperands,
     /*  91924 */     // GIR_Coverage, 560,
     /*  91924 */     GIR_EraseRootFromParent_Done,
     /*  91925 */   // Label 1674: @91925
     /*  91925 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91977), // Rule ID 561 //
     /*  91930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91938 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91953 */     // MIs[1] Operand 1
     /*  91953 */     // No operand predicates
     /*  91953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91955 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  91955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  91958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91975 */     GIR_RootConstrainSelectedInstOperands,
     /*  91976 */     // GIR_Coverage, 561,
     /*  91976 */     GIR_EraseRootFromParent_Done,
     /*  91977 */   // Label 1675: @91977
     /*  91977 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92029), // Rule ID 579 //
     /*  91982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91990 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92005 */     // MIs[1] Operand 1
     /*  92005 */     // No operand predicates
     /*  92005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92007 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92027 */     GIR_RootConstrainSelectedInstOperands,
     /*  92028 */     // GIR_Coverage, 579,
     /*  92028 */     GIR_EraseRootFromParent_Done,
     /*  92029 */   // Label 1676: @92029
     /*  92029 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92081), // Rule ID 580 //
     /*  92034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92042 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92057 */     // MIs[1] Operand 1
     /*  92057 */     // No operand predicates
     /*  92057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92059 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92079 */     GIR_RootConstrainSelectedInstOperands,
     /*  92080 */     // GIR_Coverage, 580,
     /*  92080 */     GIR_EraseRootFromParent_Done,
     /*  92081 */   // Label 1677: @92081
     /*  92081 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92121), // Rule ID 725 //
     /*  92086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92101 */     // (intrinsic_w_chain:{ *:[i32] } 3510:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92119 */     GIR_RootConstrainSelectedInstOperands,
     /*  92120 */     // GIR_Coverage, 725,
     /*  92120 */     GIR_EraseRootFromParent_Done,
     /*  92121 */   // Label 1678: @92121
     /*  92121 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92164), // Rule ID 726 //
     /*  92126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92134 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92141 */     // (intrinsic_void 3875:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92162 */     GIR_RootConstrainSelectedInstOperands,
     /*  92163 */     // GIR_Coverage, 726,
     /*  92163 */     GIR_EraseRootFromParent_Done,
     /*  92164 */   // Label 1679: @92164
     /*  92164 */   GIM_Reject,
     /*  92165 */ // Label 1662: @92165
     /*  92165 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92208), // Rule ID 604 //
     /*  92170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92173 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92176 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92181 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92195 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92200 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92206 */   GIR_RootConstrainSelectedInstOperands,
     /*  92207 */   // GIR_Coverage, 604,
     /*  92207 */   GIR_EraseRootFromParent_Done,
     /*  92208 */ // Label 1680: @92208
     /*  92208 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94199),
     /*  92213 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92216 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92270), // Rule ID 5051 //
     /*  92221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92251 */     // MIs[1] Operand 1
     /*  92251 */     // No operand predicates
     /*  92251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92253 */     // (intrinsic_w_chain:{ *:[v4i32] } 3643:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92258 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92268 */     GIR_RootConstrainSelectedInstOperands,
     /*  92269 */     // GIR_Coverage, 5051,
     /*  92269 */     GIR_EraseRootFromParent_Done,
     /*  92270 */   // Label 1682: @92270
     /*  92270 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92324), // Rule ID 5057 //
     /*  92275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92305 */     // MIs[1] Operand 1
     /*  92305 */     // No operand predicates
     /*  92305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92307 */     // (intrinsic_w_chain:{ *:[v4f32] } 3643:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92312 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92322 */     GIR_RootConstrainSelectedInstOperands,
     /*  92323 */     // GIR_Coverage, 5057,
     /*  92323 */     GIR_EraseRootFromParent_Done,
     /*  92324 */   // Label 1683: @92324
     /*  92324 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92378), // Rule ID 5059 //
     /*  92329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92359 */     // MIs[1] Operand 1
     /*  92359 */     // No operand predicates
     /*  92359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92361 */     // (intrinsic_w_chain:{ *:[v2i64] } 3643:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92366 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92376 */     GIR_RootConstrainSelectedInstOperands,
     /*  92377 */     // GIR_Coverage, 5059,
     /*  92377 */     GIR_EraseRootFromParent_Done,
     /*  92378 */   // Label 1684: @92378
     /*  92378 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92432), // Rule ID 5061 //
     /*  92383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92413 */     // MIs[1] Operand 1
     /*  92413 */     // No operand predicates
     /*  92413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92415 */     // (intrinsic_w_chain:{ *:[v2f64] } 3643:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92420 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92430 */     GIR_RootConstrainSelectedInstOperands,
     /*  92431 */     // GIR_Coverage, 5061,
     /*  92431 */     GIR_EraseRootFromParent_Done,
     /*  92432 */   // Label 1685: @92432
     /*  92432 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92474), // Rule ID 1741 //
     /*  92437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92452 */     // MIs[0] size
     /*  92452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92459 */     // (intrinsic_w_chain:{ *:[i32] } 3906:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92464 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92472 */     GIR_RootConstrainSelectedInstOperands,
     /*  92473 */     // GIR_Coverage, 1741,
     /*  92473 */     GIR_EraseRootFromParent_Done,
     /*  92474 */   // Label 1686: @92474
     /*  92474 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92528), // Rule ID 5053 //
     /*  92479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92484 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92505 */     // MIs[1] Operand 1
     /*  92505 */     // No operand predicates
     /*  92505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92511 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92514 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92516 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92526 */     GIR_RootConstrainSelectedInstOperands,
     /*  92527 */     // GIR_Coverage, 5053,
     /*  92527 */     GIR_EraseRootFromParent_Done,
     /*  92528 */   // Label 1687: @92528
     /*  92528 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92582), // Rule ID 5063 //
     /*  92533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92538 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92559 */     // MIs[1] Operand 1
     /*  92559 */     // No operand predicates
     /*  92559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92565 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92568 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92570 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92580 */     GIR_RootConstrainSelectedInstOperands,
     /*  92581 */     // GIR_Coverage, 5063,
     /*  92581 */     GIR_EraseRootFromParent_Done,
     /*  92582 */   // Label 1688: @92582
     /*  92582 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92636), // Rule ID 5067 //
     /*  92587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92592 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92613 */     // MIs[1] Operand 1
     /*  92613 */     // No operand predicates
     /*  92613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92619 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92622 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92624 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92634 */     GIR_RootConstrainSelectedInstOperands,
     /*  92635 */     // GIR_Coverage, 5067,
     /*  92635 */     GIR_EraseRootFromParent_Done,
     /*  92636 */   // Label 1689: @92636
     /*  92636 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92690), // Rule ID 5071 //
     /*  92641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92646 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92667 */     // MIs[1] Operand 1
     /*  92667 */     // No operand predicates
     /*  92667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92673 */     // (intrinsic_void 3716:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92676 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92678 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92688 */     GIR_RootConstrainSelectedInstOperands,
     /*  92689 */     // GIR_Coverage, 5071,
     /*  92689 */     GIR_EraseRootFromParent_Done,
     /*  92690 */   // Label 1690: @92690
     /*  92690 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92748), // Rule ID 3 //
     /*  92695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92724 */     // (intrinsic_w_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92746 */     GIR_RootConstrainSelectedInstOperands,
     /*  92747 */     // GIR_Coverage, 3,
     /*  92747 */     GIR_EraseRootFromParent_Done,
     /*  92748 */   // Label 1691: @92748
     /*  92748 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92806), // Rule ID 121 //
     /*  92753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92782 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92804 */     GIR_RootConstrainSelectedInstOperands,
     /*  92805 */     // GIR_Coverage, 121,
     /*  92805 */     GIR_EraseRootFromParent_Done,
     /*  92806 */   // Label 1692: @92806
     /*  92806 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92864), // Rule ID 122 //
     /*  92811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92840 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  92843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92862 */     GIR_RootConstrainSelectedInstOperands,
     /*  92863 */     // GIR_Coverage, 122,
     /*  92863 */     GIR_EraseRootFromParent_Done,
     /*  92864 */   // Label 1693: @92864
     /*  92864 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92922), // Rule ID 123 //
     /*  92869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  92877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92898 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  92901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92920 */     GIR_RootConstrainSelectedInstOperands,
     /*  92921 */     // GIR_Coverage, 123,
     /*  92921 */     GIR_EraseRootFromParent_Done,
     /*  92922 */   // Label 1694: @92922
     /*  92922 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92980), // Rule ID 124 //
     /*  92927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  92935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92956 */     // (intrinsic_w_chain:{ *:[i32] } 3909:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  92959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92978 */     GIR_RootConstrainSelectedInstOperands,
     /*  92979 */     // GIR_Coverage, 124,
     /*  92979 */     GIR_EraseRootFromParent_Done,
     /*  92980 */   // Label 1695: @92980
     /*  92980 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93038), // Rule ID 125 //
     /*  92985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  92993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93014 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93036 */     GIR_RootConstrainSelectedInstOperands,
     /*  93037 */     // GIR_Coverage, 125,
     /*  93037 */     GIR_EraseRootFromParent_Done,
     /*  93038 */   // Label 1696: @93038
     /*  93038 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93096), // Rule ID 126 //
     /*  93043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93072 */     // (intrinsic_w_chain:{ *:[i32] } 3911:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93094 */     GIR_RootConstrainSelectedInstOperands,
     /*  93095 */     // GIR_Coverage, 126,
     /*  93095 */     GIR_EraseRootFromParent_Done,
     /*  93096 */   // Label 1697: @93096
     /*  93096 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93154), // Rule ID 127 //
     /*  93101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93130 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93152 */     GIR_RootConstrainSelectedInstOperands,
     /*  93153 */     // GIR_Coverage, 127,
     /*  93153 */     GIR_EraseRootFromParent_Done,
     /*  93154 */   // Label 1698: @93154
     /*  93154 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93212), // Rule ID 128 //
     /*  93159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93188 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93210 */     GIR_RootConstrainSelectedInstOperands,
     /*  93211 */     // GIR_Coverage, 128,
     /*  93211 */     GIR_EraseRootFromParent_Done,
     /*  93212 */   // Label 1699: @93212
     /*  93212 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93270), // Rule ID 129 //
     /*  93217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93246 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93268 */     GIR_RootConstrainSelectedInstOperands,
     /*  93269 */     // GIR_Coverage, 129,
     /*  93269 */     GIR_EraseRootFromParent_Done,
     /*  93270 */   // Label 1700: @93270
     /*  93270 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93328), // Rule ID 130 //
     /*  93275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93304 */     // (intrinsic_w_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93326 */     GIR_RootConstrainSelectedInstOperands,
     /*  93327 */     // GIR_Coverage, 130,
     /*  93327 */     GIR_EraseRootFromParent_Done,
     /*  93328 */   // Label 1701: @93328
     /*  93328 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93386), // Rule ID 131 //
     /*  93333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93362 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93384 */     GIR_RootConstrainSelectedInstOperands,
     /*  93385 */     // GIR_Coverage, 131,
     /*  93385 */     GIR_EraseRootFromParent_Done,
     /*  93386 */   // Label 1702: @93386
     /*  93386 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93444), // Rule ID 132 //
     /*  93391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93420 */     // (intrinsic_w_chain:{ *:[i32] } 3944:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93442 */     GIR_RootConstrainSelectedInstOperands,
     /*  93443 */     // GIR_Coverage, 132,
     /*  93443 */     GIR_EraseRootFromParent_Done,
     /*  93444 */   // Label 1703: @93444
     /*  93444 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93502), // Rule ID 431 //
     /*  93449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93478 */     // (intrinsic_w_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93500 */     GIR_RootConstrainSelectedInstOperands,
     /*  93501 */     // GIR_Coverage, 431,
     /*  93501 */     GIR_EraseRootFromParent_Done,
     /*  93502 */   // Label 1704: @93502
     /*  93502 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93560), // Rule ID 444 //
     /*  93507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93536 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93558 */     GIR_RootConstrainSelectedInstOperands,
     /*  93559 */     // GIR_Coverage, 444,
     /*  93559 */     GIR_EraseRootFromParent_Done,
     /*  93560 */   // Label 1705: @93560
     /*  93560 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93618), // Rule ID 445 //
     /*  93565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93594 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93616 */     GIR_RootConstrainSelectedInstOperands,
     /*  93617 */     // GIR_Coverage, 445,
     /*  93617 */     GIR_EraseRootFromParent_Done,
     /*  93618 */   // Label 1706: @93618
     /*  93618 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93676), // Rule ID 446 //
     /*  93623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93652 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93674 */     GIR_RootConstrainSelectedInstOperands,
     /*  93675 */     // GIR_Coverage, 446,
     /*  93675 */     GIR_EraseRootFromParent_Done,
     /*  93676 */   // Label 1707: @93676
     /*  93676 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93734), // Rule ID 447 //
     /*  93681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93710 */     // (intrinsic_w_chain:{ *:[i32] } 3909:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93732 */     GIR_RootConstrainSelectedInstOperands,
     /*  93733 */     // GIR_Coverage, 447,
     /*  93733 */     GIR_EraseRootFromParent_Done,
     /*  93734 */   // Label 1708: @93734
     /*  93734 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93792), // Rule ID 448 //
     /*  93739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93768 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93790 */     GIR_RootConstrainSelectedInstOperands,
     /*  93791 */     // GIR_Coverage, 448,
     /*  93791 */     GIR_EraseRootFromParent_Done,
     /*  93792 */   // Label 1709: @93792
     /*  93792 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93850), // Rule ID 449 //
     /*  93797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93826 */     // (intrinsic_w_chain:{ *:[i32] } 3911:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  93829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93848 */     GIR_RootConstrainSelectedInstOperands,
     /*  93849 */     // GIR_Coverage, 449,
     /*  93849 */     GIR_EraseRootFromParent_Done,
     /*  93850 */   // Label 1710: @93850
     /*  93850 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93908), // Rule ID 450 //
     /*  93855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93884 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  93887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93906 */     GIR_RootConstrainSelectedInstOperands,
     /*  93907 */     // GIR_Coverage, 450,
     /*  93907 */     GIR_EraseRootFromParent_Done,
     /*  93908 */   // Label 1711: @93908
     /*  93908 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(93966), // Rule ID 451 //
     /*  93913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93942 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  93945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93964 */     GIR_RootConstrainSelectedInstOperands,
     /*  93965 */     // GIR_Coverage, 451,
     /*  93965 */     GIR_EraseRootFromParent_Done,
     /*  93966 */   // Label 1712: @93966
     /*  93966 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94024), // Rule ID 452 //
     /*  93971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94000 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94022 */     GIR_RootConstrainSelectedInstOperands,
     /*  94023 */     // GIR_Coverage, 452,
     /*  94023 */     GIR_EraseRootFromParent_Done,
     /*  94024 */   // Label 1713: @94024
     /*  94024 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94082), // Rule ID 453 //
     /*  94029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94058 */     // (intrinsic_w_chain:{ *:[i32] } 3942:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94080 */     GIR_RootConstrainSelectedInstOperands,
     /*  94081 */     // GIR_Coverage, 453,
     /*  94081 */     GIR_EraseRootFromParent_Done,
     /*  94082 */   // Label 1714: @94082
     /*  94082 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94140), // Rule ID 454 //
     /*  94087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94116 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94138 */     GIR_RootConstrainSelectedInstOperands,
     /*  94139 */     // GIR_Coverage, 454,
     /*  94139 */     GIR_EraseRootFromParent_Done,
     /*  94140 */   // Label 1715: @94140
     /*  94140 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(94198), // Rule ID 455 //
     /*  94145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94174 */     // (intrinsic_w_chain:{ *:[i32] } 3944:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94196 */     GIR_RootConstrainSelectedInstOperands,
     /*  94197 */     // GIR_Coverage, 455,
     /*  94197 */     GIR_EraseRootFromParent_Done,
     /*  94198 */   // Label 1716: @94198
     /*  94198 */   GIM_Reject,
     /*  94199 */ // Label 1681: @94199
     /*  94199 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94445),
     /*  94204 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94207 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94212 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94270), // Rule ID 5055 //
     /*  94217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94245 */     // MIs[1] Operand 1
     /*  94245 */     // No operand predicates
     /*  94245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94251 */     // (intrinsic_w_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94256 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94258 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94268 */     GIR_RootConstrainSelectedInstOperands,
     /*  94269 */     // GIR_Coverage, 5055,
     /*  94269 */     GIR_EraseRootFromParent_Done,
     /*  94270 */   // Label 1718: @94270
     /*  94270 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94328), // Rule ID 5065 //
     /*  94275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94303 */     // MIs[1] Operand 1
     /*  94303 */     // No operand predicates
     /*  94303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94309 */     // (intrinsic_w_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94314 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94316 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94326 */     GIR_RootConstrainSelectedInstOperands,
     /*  94327 */     // GIR_Coverage, 5065,
     /*  94327 */     GIR_EraseRootFromParent_Done,
     /*  94328 */   // Label 1719: @94328
     /*  94328 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94386), // Rule ID 5069 //
     /*  94333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94361 */     // MIs[1] Operand 1
     /*  94361 */     // No operand predicates
     /*  94361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94367 */     // (intrinsic_w_chain:{ *:[v2i64] } 3718:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94372 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94374 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94384 */     GIR_RootConstrainSelectedInstOperands,
     /*  94385 */     // GIR_Coverage, 5069,
     /*  94385 */     GIR_EraseRootFromParent_Done,
     /*  94386 */   // Label 1720: @94386
     /*  94386 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94444), // Rule ID 5073 //
     /*  94391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94419 */     // MIs[1] Operand 1
     /*  94419 */     // No operand predicates
     /*  94419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94425 */     // (intrinsic_w_chain:{ *:[v2i64] } 3718:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94430 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94432 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94442 */     GIR_RootConstrainSelectedInstOperands,
     /*  94443 */     // GIR_Coverage, 5073,
     /*  94443 */     GIR_EraseRootFromParent_Done,
     /*  94444 */   // Label 1721: @94444
     /*  94444 */   GIM_Reject,
     /*  94445 */ // Label 1717: @94445
     /*  94445 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(95616),
     /*  94450 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94453 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(94514), // Rule ID 4943 //
     /*  94458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94475 */     // MIs[0] base
     /*  94475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94499 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94502 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94504 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94506 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94512 */     GIR_RootConstrainSelectedInstOperands,
     /*  94513 */     // GIR_Coverage, 4943,
     /*  94513 */     GIR_EraseRootFromParent_Done,
     /*  94514 */   // Label 1723: @94514
     /*  94514 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94575), // Rule ID 4944 //
     /*  94519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94536 */     // MIs[0] base
     /*  94536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94560 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94563 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94565 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94567 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94573 */     GIR_RootConstrainSelectedInstOperands,
     /*  94574 */     // GIR_Coverage, 4944,
     /*  94574 */     GIR_EraseRootFromParent_Done,
     /*  94575 */   // Label 1724: @94575
     /*  94575 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94636), // Rule ID 4947 //
     /*  94580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94597 */     // MIs[0] base
     /*  94597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94621 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94624 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94626 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94628 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94634 */     GIR_RootConstrainSelectedInstOperands,
     /*  94635 */     // GIR_Coverage, 4947,
     /*  94635 */     GIR_EraseRootFromParent_Done,
     /*  94636 */   // Label 1725: @94636
     /*  94636 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(94697), // Rule ID 5027 //
     /*  94641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94658 */     // MIs[0] base
     /*  94658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94682 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94685 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94687 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94689 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94695 */     GIR_RootConstrainSelectedInstOperands,
     /*  94696 */     // GIR_Coverage, 5027,
     /*  94696 */     GIR_EraseRootFromParent_Done,
     /*  94697 */   // Label 1726: @94697
     /*  94697 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94758), // Rule ID 5029 //
     /*  94702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94719 */     // MIs[0] base
     /*  94719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94743 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94746 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94748 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94750 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94756 */     GIR_RootConstrainSelectedInstOperands,
     /*  94757 */     // GIR_Coverage, 5029,
     /*  94757 */     GIR_EraseRootFromParent_Done,
     /*  94758 */   // Label 1727: @94758
     /*  94758 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94819), // Rule ID 5031 //
     /*  94763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94780 */     // MIs[0] base
     /*  94780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94804 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94807 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94809 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94811 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94817 */     GIR_RootConstrainSelectedInstOperands,
     /*  94818 */     // GIR_Coverage, 5031,
     /*  94818 */     GIR_EraseRootFromParent_Done,
     /*  94819 */   // Label 1728: @94819
     /*  94819 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(94880), // Rule ID 5032 //
     /*  94824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94841 */     // MIs[0] base
     /*  94841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94865 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94868 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94870 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94872 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94878 */     GIR_RootConstrainSelectedInstOperands,
     /*  94879 */     // GIR_Coverage, 5032,
     /*  94879 */     GIR_EraseRootFromParent_Done,
     /*  94880 */   // Label 1729: @94880
     /*  94880 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(94941), // Rule ID 5035 //
     /*  94885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94902 */     // MIs[0] base
     /*  94902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94926 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  94929 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94931 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94933 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94939 */     GIR_RootConstrainSelectedInstOperands,
     /*  94940 */     // GIR_Coverage, 5035,
     /*  94940 */     GIR_EraseRootFromParent_Done,
     /*  94941 */   // Label 1730: @94941
     /*  94941 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95002), // Rule ID 5036 //
     /*  94946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94963 */     // MIs[0] base
     /*  94963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94987 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  94990 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94992 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94994 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95000 */     GIR_RootConstrainSelectedInstOperands,
     /*  95001 */     // GIR_Coverage, 5036,
     /*  95001 */     GIR_EraseRootFromParent_Done,
     /*  95002 */   // Label 1731: @95002
     /*  95002 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95063), // Rule ID 5039 //
     /*  95007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95024 */     // MIs[0] base
     /*  95024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95048 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95051 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95053 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95055 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95061 */     GIR_RootConstrainSelectedInstOperands,
     /*  95062 */     // GIR_Coverage, 5039,
     /*  95062 */     GIR_EraseRootFromParent_Done,
     /*  95063 */   // Label 1732: @95063
     /*  95063 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95124), // Rule ID 5040 //
     /*  95068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95085 */     // MIs[0] base
     /*  95085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95109 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95112 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95114 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95116 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95122 */     GIR_RootConstrainSelectedInstOperands,
     /*  95123 */     // GIR_Coverage, 5040,
     /*  95123 */     GIR_EraseRootFromParent_Done,
     /*  95124 */   // Label 1733: @95124
     /*  95124 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95185), // Rule ID 5043 //
     /*  95129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95146 */     // MIs[0] base
     /*  95146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95170 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95173 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95175 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95177 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95183 */     GIR_RootConstrainSelectedInstOperands,
     /*  95184 */     // GIR_Coverage, 5043,
     /*  95184 */     GIR_EraseRootFromParent_Done,
     /*  95185 */   // Label 1734: @95185
     /*  95185 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95246), // Rule ID 5044 //
     /*  95190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95207 */     // MIs[0] base
     /*  95207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95231 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95234 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95236 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95238 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95244 */     GIR_RootConstrainSelectedInstOperands,
     /*  95245 */     // GIR_Coverage, 5044,
     /*  95245 */     GIR_EraseRootFromParent_Done,
     /*  95246 */   // Label 1735: @95246
     /*  95246 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95307), // Rule ID 5047 //
     /*  95251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95268 */     // MIs[0] base
     /*  95268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95292 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95295 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95297 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95299 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95305 */     GIR_RootConstrainSelectedInstOperands,
     /*  95306 */     // GIR_Coverage, 5047,
     /*  95306 */     GIR_EraseRootFromParent_Done,
     /*  95307 */   // Label 1736: @95307
     /*  95307 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95368), // Rule ID 5048 //
     /*  95312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95329 */     // MIs[0] base
     /*  95329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95353 */     // (intrinsic_void 3720:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95356 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95358 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95360 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95366 */     GIR_RootConstrainSelectedInstOperands,
     /*  95367 */     // GIR_Coverage, 5048,
     /*  95367 */     GIR_EraseRootFromParent_Done,
     /*  95368 */   // Label 1737: @95368
     /*  95368 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95432), // Rule ID 258 //
     /*  95373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95387 */     // MIs[0] cop
     /*  95387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95390 */     // MIs[0] opc1
     /*  95390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95401 */     // MIs[0] CRm
     /*  95401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95404 */     // (intrinsic_void 3524:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95407 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95409 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95415 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95430 */     GIR_RootConstrainSelectedInstOperands,
     /*  95431 */     // GIR_Coverage, 258,
     /*  95431 */     GIR_EraseRootFromParent_Done,
     /*  95432 */   // Label 1738: @95432
     /*  95432 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95487), // Rule ID 259 //
     /*  95437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95451 */     // MIs[0] cop
     /*  95451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95454 */     // MIs[0] opc1
     /*  95454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95465 */     // MIs[0] CRm
     /*  95465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95468 */     // (intrinsic_void 3525:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95471 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95473 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95479 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95485 */     GIR_RootConstrainSelectedInstOperands,
     /*  95486 */     // GIR_Coverage, 259,
     /*  95486 */     GIR_EraseRootFromParent_Done,
     /*  95487 */   // Label 1739: @95487
     /*  95487 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95551), // Rule ID 596 //
     /*  95492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95506 */     // MIs[0] cop
     /*  95506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95509 */     // MIs[0] opc1
     /*  95509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95520 */     // MIs[0] CRm
     /*  95520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95523 */     // (intrinsic_void 3524:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95526 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95528 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95534 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95549 */     GIR_RootConstrainSelectedInstOperands,
     /*  95550 */     // GIR_Coverage, 596,
     /*  95550 */     GIR_EraseRootFromParent_Done,
     /*  95551 */   // Label 1740: @95551
     /*  95551 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95615), // Rule ID 597 //
     /*  95556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95570 */     // MIs[0] cop
     /*  95570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95573 */     // MIs[0] opc1
     /*  95573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95584 */     // MIs[0] CRm
     /*  95584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95587 */     // (intrinsic_void 3525:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95590 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95592 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95598 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95613 */     GIR_RootConstrainSelectedInstOperands,
     /*  95614 */     // GIR_Coverage, 597,
     /*  95614 */     GIR_EraseRootFromParent_Done,
     /*  95615 */   // Label 1741: @95615
     /*  95615 */   GIM_Reject,
     /*  95616 */ // Label 1722: @95616
     /*  95616 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(98967),
     /*  95621 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95624 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(95685), // Rule ID 246 //
     /*  95629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95637 */     // MIs[0] cop
     /*  95637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95640 */     // MIs[0] opc1
     /*  95640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95643 */     // MIs[0] CRd
     /*  95643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95646 */     // MIs[0] CRn
     /*  95646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95649 */     // MIs[0] CRm
     /*  95649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95652 */     // MIs[0] opc2
     /*  95652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95655 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95658 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95662 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95664 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95666 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95668 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95683 */     GIR_RootConstrainSelectedInstOperands,
     /*  95684 */     // GIR_Coverage, 246,
     /*  95684 */     GIR_EraseRootFromParent_Done,
     /*  95685 */   // Label 1743: @95685
     /*  95685 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95737), // Rule ID 247 //
     /*  95690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95698 */     // MIs[0] cop
     /*  95698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95701 */     // MIs[0] opc1
     /*  95701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95704 */     // MIs[0] CRd
     /*  95704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95707 */     // MIs[0] CRn
     /*  95707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95710 */     // MIs[0] CRm
     /*  95710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95713 */     // MIs[0] opc2
     /*  95713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95716 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95719 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95721 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95723 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95725 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95727 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95729 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95735 */     GIR_RootConstrainSelectedInstOperands,
     /*  95736 */     // GIR_Coverage, 247,
     /*  95736 */     GIR_EraseRootFromParent_Done,
     /*  95737 */   // Label 1744: @95737
     /*  95737 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95798), // Rule ID 598 //
     /*  95742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95750 */     // MIs[0] cop
     /*  95750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95753 */     // MIs[0] opc1
     /*  95753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95756 */     // MIs[0] CRd
     /*  95756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95759 */     // MIs[0] CRn
     /*  95759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95762 */     // MIs[0] CRm
     /*  95762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95765 */     // MIs[0] opc2
     /*  95765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95768 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95771 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95773 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95775 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95777 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95779 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95781 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95796 */     GIR_RootConstrainSelectedInstOperands,
     /*  95797 */     // GIR_Coverage, 598,
     /*  95797 */     GIR_EraseRootFromParent_Done,
     /*  95798 */   // Label 1745: @95798
     /*  95798 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(95859), // Rule ID 599 //
     /*  95803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95811 */     // MIs[0] cop
     /*  95811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95814 */     // MIs[0] opc1
     /*  95814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95817 */     // MIs[0] CRd
     /*  95817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95820 */     // MIs[0] CRn
     /*  95820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95823 */     // MIs[0] CRm
     /*  95823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95826 */     // MIs[0] opc2
     /*  95826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95829 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  95832 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95834 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95836 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95838 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95840 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95842 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95857 */     GIR_RootConstrainSelectedInstOperands,
     /*  95858 */     // GIR_Coverage, 599,
     /*  95858 */     GIR_EraseRootFromParent_Done,
     /*  95859 */   // Label 1746: @95859
     /*  95859 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(95927), // Rule ID 4937 //
     /*  95864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95888 */     // MIs[0] base
     /*  95888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95912 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  95915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95917 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95919 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95925 */     GIR_RootConstrainSelectedInstOperands,
     /*  95926 */     // GIR_Coverage, 4937,
     /*  95926 */     GIR_EraseRootFromParent_Done,
     /*  95927 */   // Label 1747: @95927
     /*  95927 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(95995), // Rule ID 4938 //
     /*  95932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95956 */     // MIs[0] base
     /*  95956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95980 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  95983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95985 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95987 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95993 */     GIR_RootConstrainSelectedInstOperands,
     /*  95994 */     // GIR_Coverage, 4938,
     /*  95994 */     GIR_EraseRootFromParent_Done,
     /*  95995 */   // Label 1748: @95995
     /*  95995 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96063), // Rule ID 4941 //
     /*  96000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96024 */     // MIs[0] base
     /*  96024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96048 */     // (intrinsic_w_chain:{ *:[v16i8] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96053 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96055 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96061 */     GIR_RootConstrainSelectedInstOperands,
     /*  96062 */     // GIR_Coverage, 4941,
     /*  96062 */     GIR_EraseRootFromParent_Done,
     /*  96063 */   // Label 1749: @96063
     /*  96063 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96131), // Rule ID 4949 //
     /*  96068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96092 */     // MIs[0] base
     /*  96092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96116 */     // (intrinsic_w_chain:{ *:[v16i8] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96121 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96123 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96129 */     GIR_RootConstrainSelectedInstOperands,
     /*  96130 */     // GIR_Coverage, 4949,
     /*  96130 */     GIR_EraseRootFromParent_Done,
     /*  96131 */   // Label 1750: @96131
     /*  96131 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96199), // Rule ID 4951 //
     /*  96136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96160 */     // MIs[0] base
     /*  96160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96184 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96189 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96191 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96197 */     GIR_RootConstrainSelectedInstOperands,
     /*  96198 */     // GIR_Coverage, 4951,
     /*  96198 */     GIR_EraseRootFromParent_Done,
     /*  96199 */   // Label 1751: @96199
     /*  96199 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96267), // Rule ID 4953 //
     /*  96204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96228 */     // MIs[0] base
     /*  96228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96252 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96257 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96259 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96265 */     GIR_RootConstrainSelectedInstOperands,
     /*  96266 */     // GIR_Coverage, 4953,
     /*  96266 */     GIR_EraseRootFromParent_Done,
     /*  96267 */   // Label 1752: @96267
     /*  96267 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96335), // Rule ID 4955 //
     /*  96272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96296 */     // MIs[0] base
     /*  96296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96320 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96325 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96327 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96333 */     GIR_RootConstrainSelectedInstOperands,
     /*  96334 */     // GIR_Coverage, 4955,
     /*  96334 */     GIR_EraseRootFromParent_Done,
     /*  96335 */   // Label 1753: @96335
     /*  96335 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96403), // Rule ID 4957 //
     /*  96340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96364 */     // MIs[0] base
     /*  96364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96388 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96393 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96395 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96401 */     GIR_RootConstrainSelectedInstOperands,
     /*  96402 */     // GIR_Coverage, 4957,
     /*  96402 */     GIR_EraseRootFromParent_Done,
     /*  96403 */   // Label 1754: @96403
     /*  96403 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96471), // Rule ID 4959 //
     /*  96408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96432 */     // MIs[0] base
     /*  96432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96456 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96461 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96463 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96469 */     GIR_RootConstrainSelectedInstOperands,
     /*  96470 */     // GIR_Coverage, 4959,
     /*  96470 */     GIR_EraseRootFromParent_Done,
     /*  96471 */   // Label 1755: @96471
     /*  96471 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96539), // Rule ID 4960 //
     /*  96476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96500 */     // MIs[0] base
     /*  96500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96524 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96529 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96531 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96537 */     GIR_RootConstrainSelectedInstOperands,
     /*  96538 */     // GIR_Coverage, 4960,
     /*  96538 */     GIR_EraseRootFromParent_Done,
     /*  96539 */   // Label 1756: @96539
     /*  96539 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96607), // Rule ID 4963 //
     /*  96544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96568 */     // MIs[0] base
     /*  96568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96592 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96597 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96599 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96605 */     GIR_RootConstrainSelectedInstOperands,
     /*  96606 */     // GIR_Coverage, 4963,
     /*  96606 */     GIR_EraseRootFromParent_Done,
     /*  96607 */   // Label 1757: @96607
     /*  96607 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96675), // Rule ID 4964 //
     /*  96612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96636 */     // MIs[0] base
     /*  96636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96660 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96665 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96667 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96673 */     GIR_RootConstrainSelectedInstOperands,
     /*  96674 */     // GIR_Coverage, 4964,
     /*  96674 */     GIR_EraseRootFromParent_Done,
     /*  96675 */   // Label 1758: @96675
     /*  96675 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96743), // Rule ID 4967 //
     /*  96680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96704 */     // MIs[0] base
     /*  96704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96728 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96733 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96735 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96741 */     GIR_RootConstrainSelectedInstOperands,
     /*  96742 */     // GIR_Coverage, 4967,
     /*  96742 */     GIR_EraseRootFromParent_Done,
     /*  96743 */   // Label 1759: @96743
     /*  96743 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96811), // Rule ID 4968 //
     /*  96748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96772 */     // MIs[0] base
     /*  96772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96796 */     // (intrinsic_w_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96801 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96803 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96809 */     GIR_RootConstrainSelectedInstOperands,
     /*  96810 */     // GIR_Coverage, 4968,
     /*  96810 */     GIR_EraseRootFromParent_Done,
     /*  96811 */   // Label 1760: @96811
     /*  96811 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(96879), // Rule ID 4971 //
     /*  96816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96840 */     // MIs[0] base
     /*  96840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96864 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96869 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96871 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96877 */     GIR_RootConstrainSelectedInstOperands,
     /*  96878 */     // GIR_Coverage, 4971,
     /*  96878 */     GIR_EraseRootFromParent_Done,
     /*  96879 */   // Label 1761: @96879
     /*  96879 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(96947), // Rule ID 4972 //
     /*  96884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96908 */     // MIs[0] base
     /*  96908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96932 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96937 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96939 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96945 */     GIR_RootConstrainSelectedInstOperands,
     /*  96946 */     // GIR_Coverage, 4972,
     /*  96946 */     GIR_EraseRootFromParent_Done,
     /*  96947 */   // Label 1762: @96947
     /*  96947 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97015), // Rule ID 4975 //
     /*  96952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96976 */     // MIs[0] base
     /*  96976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97000 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97005 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97007 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97013 */     GIR_RootConstrainSelectedInstOperands,
     /*  97014 */     // GIR_Coverage, 4975,
     /*  97014 */     GIR_EraseRootFromParent_Done,
     /*  97015 */   // Label 1763: @97015
     /*  97015 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97083), // Rule ID 4976 //
     /*  97020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97044 */     // MIs[0] base
     /*  97044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97068 */     // (intrinsic_w_chain:{ *:[v8f16] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97073 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97075 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97081 */     GIR_RootConstrainSelectedInstOperands,
     /*  97082 */     // GIR_Coverage, 4976,
     /*  97082 */     GIR_EraseRootFromParent_Done,
     /*  97083 */   // Label 1764: @97083
     /*  97083 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97151), // Rule ID 4979 //
     /*  97088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97112 */     // MIs[0] base
     /*  97112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97136 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97141 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97143 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97149 */     GIR_RootConstrainSelectedInstOperands,
     /*  97150 */     // GIR_Coverage, 4979,
     /*  97150 */     GIR_EraseRootFromParent_Done,
     /*  97151 */   // Label 1765: @97151
     /*  97151 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97219), // Rule ID 4980 //
     /*  97156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97180 */     // MIs[0] base
     /*  97180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97204 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97209 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97211 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97217 */     GIR_RootConstrainSelectedInstOperands,
     /*  97218 */     // GIR_Coverage, 4980,
     /*  97218 */     GIR_EraseRootFromParent_Done,
     /*  97219 */   // Label 1766: @97219
     /*  97219 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97287), // Rule ID 4983 //
     /*  97224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97248 */     // MIs[0] base
     /*  97248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97272 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97277 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97279 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97285 */     GIR_RootConstrainSelectedInstOperands,
     /*  97286 */     // GIR_Coverage, 4983,
     /*  97286 */     GIR_EraseRootFromParent_Done,
     /*  97287 */   // Label 1767: @97287
     /*  97287 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97355), // Rule ID 4984 //
     /*  97292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97316 */     // MIs[0] base
     /*  97316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97340 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97345 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97347 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97353 */     GIR_RootConstrainSelectedInstOperands,
     /*  97354 */     // GIR_Coverage, 4984,
     /*  97354 */     GIR_EraseRootFromParent_Done,
     /*  97355 */   // Label 1768: @97355
     /*  97355 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97423), // Rule ID 4987 //
     /*  97360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97384 */     // MIs[0] base
     /*  97384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97408 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97413 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97415 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97421 */     GIR_RootConstrainSelectedInstOperands,
     /*  97422 */     // GIR_Coverage, 4987,
     /*  97422 */     GIR_EraseRootFromParent_Done,
     /*  97423 */   // Label 1769: @97423
     /*  97423 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97491), // Rule ID 4988 //
     /*  97428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97452 */     // MIs[0] base
     /*  97452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97476 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97481 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97483 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97489 */     GIR_RootConstrainSelectedInstOperands,
     /*  97490 */     // GIR_Coverage, 4988,
     /*  97490 */     GIR_EraseRootFromParent_Done,
     /*  97491 */   // Label 1770: @97491
     /*  97491 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97559), // Rule ID 4991 //
     /*  97496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97520 */     // MIs[0] base
     /*  97520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97544 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97549 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97551 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97557 */     GIR_RootConstrainSelectedInstOperands,
     /*  97558 */     // GIR_Coverage, 4991,
     /*  97558 */     GIR_EraseRootFromParent_Done,
     /*  97559 */   // Label 1771: @97559
     /*  97559 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97627), // Rule ID 4992 //
     /*  97564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97588 */     // MIs[0] base
     /*  97588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97612 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97617 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97619 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97625 */     GIR_RootConstrainSelectedInstOperands,
     /*  97626 */     // GIR_Coverage, 4992,
     /*  97626 */     GIR_EraseRootFromParent_Done,
     /*  97627 */   // Label 1772: @97627
     /*  97627 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97695), // Rule ID 4995 //
     /*  97632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97656 */     // MIs[0] base
     /*  97656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97680 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97685 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97687 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97693 */     GIR_RootConstrainSelectedInstOperands,
     /*  97694 */     // GIR_Coverage, 4995,
     /*  97694 */     GIR_EraseRootFromParent_Done,
     /*  97695 */   // Label 1773: @97695
     /*  97695 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97763), // Rule ID 4996 //
     /*  97700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97724 */     // MIs[0] base
     /*  97724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97748 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97753 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97755 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97761 */     GIR_RootConstrainSelectedInstOperands,
     /*  97762 */     // GIR_Coverage, 4996,
     /*  97762 */     GIR_EraseRootFromParent_Done,
     /*  97763 */   // Label 1774: @97763
     /*  97763 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97831), // Rule ID 4999 //
     /*  97768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97792 */     // MIs[0] base
     /*  97792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97816 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97821 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97823 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97829 */     GIR_RootConstrainSelectedInstOperands,
     /*  97830 */     // GIR_Coverage, 4999,
     /*  97830 */     GIR_EraseRootFromParent_Done,
     /*  97831 */   // Label 1775: @97831
     /*  97831 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97899), // Rule ID 5000 //
     /*  97836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97860 */     // MIs[0] base
     /*  97860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97884 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97889 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97891 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97897 */     GIR_RootConstrainSelectedInstOperands,
     /*  97898 */     // GIR_Coverage, 5000,
     /*  97898 */     GIR_EraseRootFromParent_Done,
     /*  97899 */   // Label 1776: @97899
     /*  97899 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97967), // Rule ID 5003 //
     /*  97904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97928 */     // MIs[0] base
     /*  97928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97952 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97957 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97959 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97965 */     GIR_RootConstrainSelectedInstOperands,
     /*  97966 */     // GIR_Coverage, 5003,
     /*  97966 */     GIR_EraseRootFromParent_Done,
     /*  97967 */   // Label 1777: @97967
     /*  97967 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98035), // Rule ID 5004 //
     /*  97972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97996 */     // MIs[0] base
     /*  97996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98020 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98025 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98027 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98033 */     GIR_RootConstrainSelectedInstOperands,
     /*  98034 */     // GIR_Coverage, 5004,
     /*  98034 */     GIR_EraseRootFromParent_Done,
     /*  98035 */   // Label 1778: @98035
     /*  98035 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98103), // Rule ID 5007 //
     /*  98040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98064 */     // MIs[0] base
     /*  98064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98088 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98093 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98095 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98101 */     GIR_RootConstrainSelectedInstOperands,
     /*  98102 */     // GIR_Coverage, 5007,
     /*  98102 */     GIR_EraseRootFromParent_Done,
     /*  98103 */   // Label 1779: @98103
     /*  98103 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98171), // Rule ID 5008 //
     /*  98108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98132 */     // MIs[0] base
     /*  98132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98156 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98161 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98163 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98169 */     GIR_RootConstrainSelectedInstOperands,
     /*  98170 */     // GIR_Coverage, 5008,
     /*  98170 */     GIR_EraseRootFromParent_Done,
     /*  98171 */   // Label 1780: @98171
     /*  98171 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98239), // Rule ID 5011 //
     /*  98176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98200 */     // MIs[0] base
     /*  98200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98224 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98229 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98231 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98237 */     GIR_RootConstrainSelectedInstOperands,
     /*  98238 */     // GIR_Coverage, 5011,
     /*  98238 */     GIR_EraseRootFromParent_Done,
     /*  98239 */   // Label 1781: @98239
     /*  98239 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98307), // Rule ID 5012 //
     /*  98244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98268 */     // MIs[0] base
     /*  98268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98292 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98297 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98299 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98305 */     GIR_RootConstrainSelectedInstOperands,
     /*  98306 */     // GIR_Coverage, 5012,
     /*  98306 */     GIR_EraseRootFromParent_Done,
     /*  98307 */   // Label 1782: @98307
     /*  98307 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98375), // Rule ID 5015 //
     /*  98312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98336 */     // MIs[0] base
     /*  98336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98360 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98365 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98367 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98373 */     GIR_RootConstrainSelectedInstOperands,
     /*  98374 */     // GIR_Coverage, 5015,
     /*  98374 */     GIR_EraseRootFromParent_Done,
     /*  98375 */   // Label 1783: @98375
     /*  98375 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98443), // Rule ID 5016 //
     /*  98380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98404 */     // MIs[0] base
     /*  98404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98428 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98433 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98435 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98441 */     GIR_RootConstrainSelectedInstOperands,
     /*  98442 */     // GIR_Coverage, 5016,
     /*  98442 */     GIR_EraseRootFromParent_Done,
     /*  98443 */   // Label 1784: @98443
     /*  98443 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98511), // Rule ID 5019 //
     /*  98448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98472 */     // MIs[0] base
     /*  98472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98496 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98501 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98503 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98509 */     GIR_RootConstrainSelectedInstOperands,
     /*  98510 */     // GIR_Coverage, 5019,
     /*  98510 */     GIR_EraseRootFromParent_Done,
     /*  98511 */   // Label 1785: @98511
     /*  98511 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98579), // Rule ID 5020 //
     /*  98516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98540 */     // MIs[0] base
     /*  98540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98564 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98569 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98571 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98577 */     GIR_RootConstrainSelectedInstOperands,
     /*  98578 */     // GIR_Coverage, 5020,
     /*  98578 */     GIR_EraseRootFromParent_Done,
     /*  98579 */   // Label 1786: @98579
     /*  98579 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98647), // Rule ID 5023 //
     /*  98584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98608 */     // MIs[0] base
     /*  98608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98632 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98637 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98639 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98645 */     GIR_RootConstrainSelectedInstOperands,
     /*  98646 */     // GIR_Coverage, 5023,
     /*  98646 */     GIR_EraseRootFromParent_Done,
     /*  98647 */   // Label 1787: @98647
     /*  98647 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98715), // Rule ID 5024 //
     /*  98652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98676 */     // MIs[0] base
     /*  98676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98700 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98705 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98707 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98713 */     GIR_RootConstrainSelectedInstOperands,
     /*  98714 */     // GIR_Coverage, 5024,
     /*  98714 */     GIR_EraseRootFromParent_Done,
     /*  98715 */   // Label 1788: @98715
     /*  98715 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98780), // Rule ID 256 //
     /*  98720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98731 */     // MIs[0] cop
     /*  98731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98734 */     // MIs[0] opc1
     /*  98734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98741 */     // MIs[0] CRn
     /*  98741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98744 */     // MIs[0] CRm
     /*  98744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98747 */     // MIs[0] opc2
     /*  98747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98750 */     // (intrinsic_void 3522:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98753 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98755 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98759 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98761 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98763 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98778 */     GIR_RootConstrainSelectedInstOperands,
     /*  98779 */     // GIR_Coverage, 256,
     /*  98779 */     GIR_EraseRootFromParent_Done,
     /*  98780 */   // Label 1789: @98780
     /*  98780 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98836), // Rule ID 257 //
     /*  98785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98796 */     // MIs[0] cop
     /*  98796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98799 */     // MIs[0] opc1
     /*  98799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98806 */     // MIs[0] CRn
     /*  98806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98809 */     // MIs[0] CRm
     /*  98809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98812 */     // MIs[0] opc2
     /*  98812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98815 */     // (intrinsic_void 3523:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98818 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98820 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98824 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98826 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98828 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98834 */     GIR_RootConstrainSelectedInstOperands,
     /*  98835 */     // GIR_Coverage, 257,
     /*  98835 */     GIR_EraseRootFromParent_Done,
     /*  98836 */   // Label 1790: @98836
     /*  98836 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98901), // Rule ID 594 //
     /*  98841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98852 */     // MIs[0] cop
     /*  98852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98855 */     // MIs[0] opc1
     /*  98855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98862 */     // MIs[0] CRn
     /*  98862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98865 */     // MIs[0] CRm
     /*  98865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98868 */     // MIs[0] opc2
     /*  98868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98871 */     // (intrinsic_void 3522:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  98874 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98876 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98880 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98882 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98884 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98899 */     GIR_RootConstrainSelectedInstOperands,
     /*  98900 */     // GIR_Coverage, 594,
     /*  98900 */     GIR_EraseRootFromParent_Done,
     /*  98901 */   // Label 1791: @98901
     /*  98901 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98966), // Rule ID 595 //
     /*  98906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  98909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98917 */     // MIs[0] cop
     /*  98917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98920 */     // MIs[0] opc1
     /*  98920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98927 */     // MIs[0] CRn
     /*  98927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98930 */     // MIs[0] CRm
     /*  98930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98933 */     // MIs[0] opc2
     /*  98933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98936 */     // (intrinsic_void 3523:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  98939 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98941 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98945 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98947 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98949 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98964 */     GIR_RootConstrainSelectedInstOperands,
     /*  98965 */     // GIR_Coverage, 595,
     /*  98965 */     GIR_EraseRootFromParent_Done,
     /*  98966 */   // Label 1792: @98966
     /*  98966 */   GIM_Reject,
     /*  98967 */ // Label 1742: @98967
     /*  98967 */ GIM_Reject,
     /*  98968 */ // Label 17: @98968
     /*  98968 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1796*/ GIMT_Encode4(99125),
     /*  98979 */ /*GILLT_v2s64*//*Label 1793*/ GIMT_Encode4(99011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98991 */ /*GILLT_v4s32*//*Label 1794*/ GIMT_Encode4(99049), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99007 */ /*GILLT_v8s16*//*Label 1795*/ GIMT_Encode4(99087),
     /*  99011 */ // Label 1793: @99011
     /*  99011 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(99048), // Rule ID 2668 //
     /*  99016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99030 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99035 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99040 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99046 */   GIR_RootConstrainSelectedInstOperands,
     /*  99047 */   // GIR_Coverage, 2668,
     /*  99047 */   GIR_EraseRootFromParent_Done,
     /*  99048 */ // Label 1797: @99048
     /*  99048 */ GIM_Reject,
     /*  99049 */ // Label 1794: @99049
     /*  99049 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(99086), // Rule ID 2667 //
     /*  99054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99068 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99078 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99084 */   GIR_RootConstrainSelectedInstOperands,
     /*  99085 */   // GIR_Coverage, 2667,
     /*  99085 */   GIR_EraseRootFromParent_Done,
     /*  99086 */ // Label 1798: @99086
     /*  99086 */ GIM_Reject,
     /*  99087 */ // Label 1795: @99087
     /*  99087 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(99124), // Rule ID 2666 //
     /*  99092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99106 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99111 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99116 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99122 */   GIR_RootConstrainSelectedInstOperands,
     /*  99123 */   // GIR_Coverage, 2666,
     /*  99123 */   GIR_EraseRootFromParent_Done,
     /*  99124 */ // Label 1799: @99124
     /*  99124 */ GIM_Reject,
     /*  99125 */ // Label 1796: @99125
     /*  99125 */ GIM_Reject,
     /*  99126 */ // Label 18: @99126
     /*  99126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1803*/ GIMT_Encode4(99283),
     /*  99137 */ /*GILLT_v2s32*//*Label 1800*/ GIMT_Encode4(99169), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99149 */ /*GILLT_v4s16*//*Label 1801*/ GIMT_Encode4(99207), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99165 */ /*GILLT_v8s8*//*Label 1802*/ GIMT_Encode4(99245),
     /*  99169 */ // Label 1800: @99169
     /*  99169 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(99206), // Rule ID 1588 //
     /*  99174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99188 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99193 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99198 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99204 */   GIR_RootConstrainSelectedInstOperands,
     /*  99205 */   // GIR_Coverage, 1588,
     /*  99205 */   GIR_EraseRootFromParent_Done,
     /*  99206 */ // Label 1804: @99206
     /*  99206 */ GIM_Reject,
     /*  99207 */ // Label 1801: @99207
     /*  99207 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(99244), // Rule ID 1587 //
     /*  99212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99226 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99231 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99236 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99242 */   GIR_RootConstrainSelectedInstOperands,
     /*  99243 */   // GIR_Coverage, 1587,
     /*  99243 */   GIR_EraseRootFromParent_Done,
     /*  99244 */ // Label 1805: @99244
     /*  99244 */ GIM_Reject,
     /*  99245 */ // Label 1802: @99245
     /*  99245 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(99282), // Rule ID 1586 //
     /*  99250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99264 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99269 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99280 */   GIR_RootConstrainSelectedInstOperands,
     /*  99281 */   // GIR_Coverage, 1586,
     /*  99281 */   GIR_EraseRootFromParent_Done,
     /*  99282 */ // Label 1806: @99282
     /*  99282 */ GIM_Reject,
     /*  99283 */ // Label 1803: @99283
     /*  99283 */ GIM_Reject,
     /*  99284 */ // Label 19: @99284
     /*  99284 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(99604),
     /*  99289 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99292 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99333), // Rule ID 404 //
     /*  99297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99300 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99308 */     // MIs[0] Operand 1
     /*  99308 */     // No operand predicates
     /*  99308 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99331 */     GIR_RootConstrainSelectedInstOperands,
     /*  99332 */     // GIR_Coverage, 404,
     /*  99332 */     GIR_EraseRootFromParent_Done,
     /*  99333 */   // Label 1808: @99333
     /*  99333 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99374), // Rule ID 57 //
     /*  99338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99341 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99349 */     // MIs[0] Operand 1
     /*  99349 */     // No operand predicates
     /*  99349 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99372 */     GIR_RootConstrainSelectedInstOperands,
     /*  99373 */     // GIR_Coverage, 57,
     /*  99373 */     GIR_EraseRootFromParent_Done,
     /*  99374 */   // Label 1809: @99374
     /*  99374 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99409), // Rule ID 58 //
     /*  99379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99382 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99390 */     // MIs[0] Operand 1
     /*  99390 */     // No operand predicates
     /*  99390 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99407 */     GIR_RootConstrainSelectedInstOperands,
     /*  99408 */     // GIR_Coverage, 58,
     /*  99408 */     GIR_EraseRootFromParent_Done,
     /*  99409 */   // Label 1810: @99409
     /*  99409 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99452), // Rule ID 168 //
     /*  99414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99417 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99425 */     // MIs[0] Operand 1
     /*  99425 */     // No operand predicates
     /*  99425 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99430 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99450 */     GIR_RootConstrainSelectedInstOperands,
     /*  99451 */     // GIR_Coverage, 168,
     /*  99451 */     GIR_EraseRootFromParent_Done,
     /*  99452 */   // Label 1811: @99452
     /*  99452 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99478), // Rule ID 268 //
     /*  99457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99460 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99468 */     // MIs[0] Operand 1
     /*  99468 */     // No operand predicates
     /*  99468 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99476 */     GIR_RootConstrainSelectedInstOperands,
     /*  99477 */     // GIR_Coverage, 268,
     /*  99477 */     GIR_EraseRootFromParent_Done,
     /*  99478 */   // Label 1812: @99478
     /*  99478 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99519), // Rule ID 322 //
     /*  99483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99486 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99494 */     // MIs[0] Operand 1
     /*  99494 */     // No operand predicates
     /*  99494 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99517 */     GIR_RootConstrainSelectedInstOperands,
     /*  99518 */     // GIR_Coverage, 322,
     /*  99518 */     GIR_EraseRootFromParent_Done,
     /*  99519 */   // Label 1813: @99519
     /*  99519 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99554), // Rule ID 405 //
     /*  99524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99527 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99535 */     // MIs[0] Operand 1
     /*  99535 */     // No operand predicates
     /*  99535 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99552 */     GIR_RootConstrainSelectedInstOperands,
     /*  99553 */     // GIR_Coverage, 405,
     /*  99553 */     GIR_EraseRootFromParent_Done,
     /*  99554 */   // Label 1814: @99554
     /*  99554 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99603),
     /*  99559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99563 */     GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99584), // Rule ID 353 //
     /*  99568 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99571 */       // MIs[0] Operand 1
     /*  99571 */       // No operand predicates
     /*  99571 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99571 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99574 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99576 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99579 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99582 */       GIR_RootConstrainSelectedInstOperands,
     /*  99583 */       // GIR_Coverage, 353,
     /*  99583 */       GIR_EraseRootFromParent_Done,
     /*  99584 */     // Label 1816: @99584
     /*  99584 */     GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99602), // Rule ID 582 //
     /*  99589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99592 */       // MIs[0] Operand 1
     /*  99592 */       // No operand predicates
     /*  99592 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99592 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99595 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99597 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99600 */       GIR_RootConstrainSelectedInstOperands,
     /*  99601 */       // GIR_Coverage, 582,
     /*  99601 */       GIR_EraseRootFromParent_Done,
     /*  99602 */     // Label 1817: @99602
     /*  99602 */     GIM_Reject,
     /*  99603 */   // Label 1815: @99603
     /*  99603 */   GIM_Reject,
     /*  99604 */ // Label 1807: @99604
     /*  99604 */ GIM_Reject,
     /*  99605 */ // Label 20: @99605
     /*  99605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1820*/ GIMT_Encode4(99700),
     /*  99616 */ /*GILLT_s32*//*Label 1818*/ GIMT_Encode4(99624),
     /*  99620 */ /*GILLT_s64*//*Label 1819*/ GIMT_Encode4(99662),
     /*  99624 */ // Label 1818: @99624
     /*  99624 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99661), // Rule ID 728 //
     /*  99629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99636 */   // MIs[0] Operand 1
     /*  99636 */   // No operand predicates
     /*  99636 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99640 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99645 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99653 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99659 */   GIR_RootConstrainSelectedInstOperands,
     /*  99660 */   // GIR_Coverage, 728,
     /*  99660 */   GIR_EraseRootFromParent_Done,
     /*  99661 */ // Label 1821: @99661
     /*  99661 */ GIM_Reject,
     /*  99662 */ // Label 1819: @99662
     /*  99662 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99699), // Rule ID 727 //
     /*  99667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99674 */   // MIs[0] Operand 1
     /*  99674 */   // No operand predicates
     /*  99674 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99678 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99683 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99691 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99697 */   GIR_RootConstrainSelectedInstOperands,
     /*  99698 */   // GIR_Coverage, 727,
     /*  99698 */   GIR_EraseRootFromParent_Done,
     /*  99699 */ // Label 1822: @99699
     /*  99699 */ GIM_Reject,
     /*  99700 */ // Label 1820: @99700
     /*  99700 */ GIM_Reject,
     /*  99701 */ // Label 21: @99701
     /*  99701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1826*/ GIMT_Encode4(99858),
     /*  99712 */ /*GILLT_v2s64*//*Label 1823*/ GIMT_Encode4(99744), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99724 */ /*GILLT_v4s32*//*Label 1824*/ GIMT_Encode4(99782), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99740 */ /*GILLT_v8s16*//*Label 1825*/ GIMT_Encode4(99820),
     /*  99744 */ // Label 1823: @99744
     /*  99744 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(99781), // Rule ID 1600 //
     /*  99749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99763 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99768 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99773 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99779 */   GIR_RootConstrainSelectedInstOperands,
     /*  99780 */   // GIR_Coverage, 1600,
     /*  99780 */   GIR_EraseRootFromParent_Done,
     /*  99781 */ // Label 1827: @99781
     /*  99781 */ GIM_Reject,
     /*  99782 */ // Label 1824: @99782
     /*  99782 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(99819), // Rule ID 1599 //
     /*  99787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99801 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99806 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99811 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99817 */   GIR_RootConstrainSelectedInstOperands,
     /*  99818 */   // GIR_Coverage, 1599,
     /*  99818 */   GIR_EraseRootFromParent_Done,
     /*  99819 */ // Label 1828: @99819
     /*  99819 */ GIM_Reject,
     /*  99820 */ // Label 1825: @99820
     /*  99820 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(99857), // Rule ID 1598 //
     /*  99825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99839 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /*  99842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99844 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99849 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99855 */   GIR_RootConstrainSelectedInstOperands,
     /*  99856 */   // GIR_Coverage, 1598,
     /*  99856 */   GIR_EraseRootFromParent_Done,
     /*  99857 */ // Label 1829: @99857
     /*  99857 */ GIM_Reject,
     /*  99858 */ // Label 1826: @99858
     /*  99858 */ GIM_Reject,
     /*  99859 */ // Label 22: @99859
     /*  99859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1833*/ GIMT_Encode4(100463),
     /*  99870 */ /*GILLT_s32*//*Label 1830*/ GIMT_Encode4(99918), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99898 */ /*GILLT_v4s32*//*Label 1831*/ GIMT_Encode4(100210), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99914 */ /*GILLT_v8s16*//*Label 1832*/ GIMT_Encode4(100393),
     /*  99918 */ // Label 1830: @99918
     /*  99918 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(100209),
     /*  99923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  99926 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(99971), // Rule ID 340 //
     /*  99931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99942 */     // MIs[0] Operand 2
     /*  99942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99953 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /*  99956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99969 */     GIR_RootConstrainSelectedInstOperands,
     /*  99970 */     // GIR_Coverage, 340,
     /*  99970 */     GIR_EraseRootFromParent_Done,
     /*  99971 */   // Label 1835: @99971
     /*  99971 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(100016), // Rule ID 341 //
     /*  99976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99987 */     // MIs[0] Operand 2
     /*  99987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99998 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100014 */     GIR_RootConstrainSelectedInstOperands,
     /* 100015 */     // GIR_Coverage, 341,
     /* 100015 */     GIR_EraseRootFromParent_Done,
     /* 100016 */   // Label 1836: @100016
     /* 100016 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(100064), // Rule ID 2002 //
     /* 100021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100032 */     // MIs[0] Operand 2
     /* 100032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100043 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100062 */     GIR_RootConstrainSelectedInstOperands,
     /* 100063 */     // GIR_Coverage, 2002,
     /* 100063 */     GIR_EraseRootFromParent_Done,
     /* 100064 */   // Label 1837: @100064
     /* 100064 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100112), // Rule ID 2003 //
     /* 100069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100080 */     // MIs[0] Operand 2
     /* 100080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100091 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100110 */     GIR_RootConstrainSelectedInstOperands,
     /* 100111 */     // GIR_Coverage, 2003,
     /* 100111 */     GIR_EraseRootFromParent_Done,
     /* 100112 */   // Label 1838: @100112
     /* 100112 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(100160), // Rule ID 2241 //
     /* 100117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100128 */     // MIs[0] Operand 2
     /* 100128 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100139 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100158 */     GIR_RootConstrainSelectedInstOperands,
     /* 100159 */     // GIR_Coverage, 2241,
     /* 100159 */     GIR_EraseRootFromParent_Done,
     /* 100160 */   // Label 1839: @100160
     /* 100160 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(100208), // Rule ID 2242 //
     /* 100165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100176 */     // MIs[0] Operand 2
     /* 100176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100187 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100206 */     GIR_RootConstrainSelectedInstOperands,
     /* 100207 */     // GIR_Coverage, 2242,
     /* 100207 */     GIR_EraseRootFromParent_Done,
     /* 100208 */   // Label 1840: @100208
     /* 100208 */   GIM_Reject,
     /* 100209 */ // Label 1834: @100209
     /* 100209 */ GIM_Reject,
     /* 100210 */ // Label 1831: @100210
     /* 100210 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(100392),
     /* 100215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100226 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100284), // Rule ID 3713 //
     /* 100231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100234 */     // MIs[0] Operand 2
     /* 100234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100245 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100282 */     GIR_RootConstrainSelectedInstOperands,
     /* 100283 */     // GIR_Coverage, 3713,
     /* 100283 */     GIR_EraseRootFromParent_Done,
     /* 100284 */   // Label 1842: @100284
     /* 100284 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100391), // Rule ID 3715 //
     /* 100289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100292 */     // MIs[0] Operand 2
     /* 100292 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100303 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100315 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100318 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100322 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100346 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100352 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100358 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100389 */     GIR_RootConstrainSelectedInstOperands,
     /* 100390 */     // GIR_Coverage, 3715,
     /* 100390 */     GIR_EraseRootFromParent_Done,
     /* 100391 */   // Label 1843: @100391
     /* 100391 */   GIM_Reject,
     /* 100392 */ // Label 1841: @100392
     /* 100392 */ GIM_Reject,
     /* 100393 */ // Label 1832: @100393
     /* 100393 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100462), // Rule ID 3714 //
     /* 100398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100412 */   // MIs[0] Operand 2
     /* 100412 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100423 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100460 */   GIR_RootConstrainSelectedInstOperands,
     /* 100461 */   // GIR_Coverage, 3714,
     /* 100461 */   GIR_EraseRootFromParent_Done,
     /* 100462 */ // Label 1844: @100462
     /* 100462 */ GIM_Reject,
     /* 100463 */ // Label 1833: @100463
     /* 100463 */ GIM_Reject,
     /* 100464 */ // Label 23: @100464
     /* 100464 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1848*/ GIMT_Encode4(100621),
     /* 100475 */ /*GILLT_v2s64*//*Label 1845*/ GIMT_Encode4(100507), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100487 */ /*GILLT_v4s32*//*Label 1846*/ GIMT_Encode4(100545), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100503 */ /*GILLT_v8s16*//*Label 1847*/ GIMT_Encode4(100583),
     /* 100507 */ // Label 1845: @100507
     /* 100507 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(100544), // Rule ID 1603 //
     /* 100512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100526 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100531 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100536 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100542 */   GIR_RootConstrainSelectedInstOperands,
     /* 100543 */   // GIR_Coverage, 1603,
     /* 100543 */   GIR_EraseRootFromParent_Done,
     /* 100544 */ // Label 1849: @100544
     /* 100544 */ GIM_Reject,
     /* 100545 */ // Label 1846: @100545
     /* 100545 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100582), // Rule ID 1602 //
     /* 100550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100564 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100569 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100574 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100580 */   GIR_RootConstrainSelectedInstOperands,
     /* 100581 */   // GIR_Coverage, 1602,
     /* 100581 */   GIR_EraseRootFromParent_Done,
     /* 100582 */ // Label 1850: @100582
     /* 100582 */ GIM_Reject,
     /* 100583 */ // Label 1847: @100583
     /* 100583 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(100620), // Rule ID 1601 //
     /* 100588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100602 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100607 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100618 */   GIR_RootConstrainSelectedInstOperands,
     /* 100619 */   // GIR_Coverage, 1601,
     /* 100619 */   GIR_EraseRootFromParent_Done,
     /* 100620 */ // Label 1851: @100620
     /* 100620 */ GIM_Reject,
     /* 100621 */ // Label 1848: @100621
     /* 100621 */ GIM_Reject,
     /* 100622 */ // Label 24: @100622
     /* 100622 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(100837),
     /* 100627 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100636 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100693), // Rule ID 470 //
     /* 100641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100664 */     // MIs[1] Operand 1
     /* 100664 */     // No operand predicates
     /* 100664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100666 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100691 */     GIR_RootConstrainSelectedInstOperands,
     /* 100692 */     // GIR_Coverage, 470,
     /* 100692 */     GIR_EraseRootFromParent_Done,
     /* 100693 */   // Label 1853: @100693
     /* 100693 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100790),
     /* 100698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100706 */     GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100751), // Rule ID 318 //
     /* 100711 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100714 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100718 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100722 */       // MIs[1] Operand 1
     /* 100722 */       // No operand predicates
     /* 100722 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100724 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100724 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100727 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100729 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100735 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100737 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100740 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100743 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100749 */       GIR_RootConstrainSelectedInstOperands,
     /* 100750 */       // GIR_Coverage, 318,
     /* 100750 */       GIR_EraseRootFromParent_Done,
     /* 100751 */     // Label 1855: @100751
     /* 100751 */     GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100789), // Rule ID 319 //
     /* 100756 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100759 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100763 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100763 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100766 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100768 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100774 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100776 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100778 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100781 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100787 */       GIR_RootConstrainSelectedInstOperands,
     /* 100788 */       // GIR_Coverage, 319,
     /* 100788 */       GIR_EraseRootFromParent_Done,
     /* 100789 */     // Label 1856: @100789
     /* 100789 */     GIM_Reject,
     /* 100790 */   // Label 1854: @100790
     /* 100790 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100836), // Rule ID 471 //
     /* 100795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100810 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100834 */     GIR_RootConstrainSelectedInstOperands,
     /* 100835 */     // GIR_Coverage, 471,
     /* 100835 */     GIR_EraseRootFromParent_Done,
     /* 100836 */   // Label 1857: @100836
     /* 100836 */   GIM_Reject,
     /* 100837 */ // Label 1852: @100837
     /* 100837 */ GIM_Reject,
     /* 100838 */ // Label 25: @100838
     /* 100838 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100945),
     /* 100843 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100852 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100898), // Rule ID 321 //
     /* 100857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100872 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 100875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100896 */     GIR_RootConstrainSelectedInstOperands,
     /* 100897 */     // GIR_Coverage, 321,
     /* 100897 */     GIR_EraseRootFromParent_Done,
     /* 100898 */   // Label 1859: @100898
     /* 100898 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100944), // Rule ID 473 //
     /* 100903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100918 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 100921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100942 */     GIR_RootConstrainSelectedInstOperands,
     /* 100943 */     // GIR_Coverage, 473,
     /* 100943 */     GIR_EraseRootFromParent_Done,
     /* 100944 */   // Label 1860: @100944
     /* 100944 */   GIM_Reject,
     /* 100945 */ // Label 1858: @100945
     /* 100945 */ GIM_Reject,
     /* 100946 */ // Label 26: @100946
     /* 100946 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101218),
     /* 100951 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100960 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101015), // Rule ID 201 //
     /* 100965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100995 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 100995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 100998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101013 */     GIR_RootConstrainSelectedInstOperands,
     /* 101014 */     // GIR_Coverage, 201,
     /* 101014 */     GIR_EraseRootFromParent_Done,
     /* 101015 */   // Label 1862: @101015
     /* 101015 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101070), // Rule ID 328 //
     /* 101020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101050 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101068 */     GIR_RootConstrainSelectedInstOperands,
     /* 101069 */     // GIR_Coverage, 328,
     /* 101069 */     GIR_EraseRootFromParent_Done,
     /* 101070 */   // Label 1863: @101070
     /* 101070 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101125), // Rule ID 538 //
     /* 101075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101105 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101123 */     GIR_RootConstrainSelectedInstOperands,
     /* 101124 */     // GIR_Coverage, 538,
     /* 101124 */     GIR_EraseRootFromParent_Done,
     /* 101125 */   // Label 1864: @101125
     /* 101125 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101171), // Rule ID 312 //
     /* 101130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101145 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101169 */     GIR_RootConstrainSelectedInstOperands,
     /* 101170 */     // GIR_Coverage, 312,
     /* 101170 */     GIR_EraseRootFromParent_Done,
     /* 101171 */   // Label 1865: @101171
     /* 101171 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101217), // Rule ID 475 //
     /* 101176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101191 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101215 */     GIR_RootConstrainSelectedInstOperands,
     /* 101216 */     // GIR_Coverage, 475,
     /* 101216 */     GIR_EraseRootFromParent_Done,
     /* 101217 */   // Label 1866: @101217
     /* 101217 */   GIM_Reject,
     /* 101218 */ // Label 1861: @101218
     /* 101218 */ GIM_Reject,
     /* 101219 */ // Label 27: @101219
     /* 101219 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101550),
     /* 101224 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101233 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101288), // Rule ID 200 //
     /* 101238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101268 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101286 */     GIR_RootConstrainSelectedInstOperands,
     /* 101287 */     // GIR_Coverage, 200,
     /* 101287 */     GIR_EraseRootFromParent_Done,
     /* 101288 */   // Label 1868: @101288
     /* 101288 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(101343), // Rule ID 327 //
     /* 101293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101323 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101341 */     GIR_RootConstrainSelectedInstOperands,
     /* 101342 */     // GIR_Coverage, 327,
     /* 101342 */     GIR_EraseRootFromParent_Done,
     /* 101343 */   // Label 1869: @101343
     /* 101343 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101457),
     /* 101348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101352 */     GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101403), // Rule ID 537 //
     /* 101357 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101360 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101364 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101368 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101372 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101377 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101381 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101383 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101383 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101386 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101388 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101392 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101395 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101401 */       GIR_RootConstrainSelectedInstOperands,
     /* 101402 */       // GIR_Coverage, 537,
     /* 101402 */       GIR_EraseRootFromParent_Done,
     /* 101403 */     // Label 1871: @101403
     /* 101403 */     GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101456), // Rule ID 476 //
     /* 101408 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101411 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101415 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101419 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101423 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101427 */       // MIs[1] Operand 1
     /* 101427 */       // No operand predicates
     /* 101427 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101429 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101429 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101432 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101434 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101436 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101439 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101442 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101448 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101454 */       GIR_RootConstrainSelectedInstOperands,
     /* 101455 */       // GIR_Coverage, 476,
     /* 101455 */       GIR_EraseRootFromParent_Done,
     /* 101456 */     // Label 1872: @101456
     /* 101456 */     GIM_Reject,
     /* 101457 */   // Label 1870: @101457
     /* 101457 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101503), // Rule ID 329 //
     /* 101462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101477 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101501 */     GIR_RootConstrainSelectedInstOperands,
     /* 101502 */     // GIR_Coverage, 329,
     /* 101502 */     GIR_EraseRootFromParent_Done,
     /* 101503 */   // Label 1873: @101503
     /* 101503 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101549), // Rule ID 477 //
     /* 101508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101523 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101547 */     GIR_RootConstrainSelectedInstOperands,
     /* 101548 */     // GIR_Coverage, 477,
     /* 101548 */     GIR_EraseRootFromParent_Done,
     /* 101549 */   // Label 1874: @101549
     /* 101549 */   GIM_Reject,
     /* 101550 */ // Label 1867: @101550
     /* 101550 */ GIM_Reject,
     /* 101551 */ // Label 28: @101551
     /* 101551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1878*/ GIMT_Encode4(101798),
     /* 101562 */ /*GILLT_v4s32*//*Label 1875*/ GIMT_Encode4(101594), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101578 */ /*GILLT_v8s16*//*Label 1876*/ GIMT_Encode4(101662), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101590 */ /*GILLT_v16s8*//*Label 1877*/ GIMT_Encode4(101730),
     /* 101594 */ // Label 1875: @101594
     /* 101594 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(101661), // Rule ID 4464 //
     /* 101599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101620 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101637 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101639 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101644 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101659 */   GIR_RootConstrainSelectedInstOperands,
     /* 101660 */   // GIR_Coverage, 4464,
     /* 101660 */   GIR_EraseRootFromParent_Done,
     /* 101661 */ // Label 1879: @101661
     /* 101661 */ GIM_Reject,
     /* 101662 */ // Label 1876: @101662
     /* 101662 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101729), // Rule ID 4460 //
     /* 101667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101688 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101707 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101712 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101718 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101727 */   GIR_RootConstrainSelectedInstOperands,
     /* 101728 */   // GIR_Coverage, 4460,
     /* 101728 */   GIR_EraseRootFromParent_Done,
     /* 101729 */ // Label 1880: @101729
     /* 101729 */ GIM_Reject,
     /* 101730 */ // Label 1877: @101730
     /* 101730 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101797), // Rule ID 4456 //
     /* 101735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101756 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101773 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101775 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101780 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101786 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101795 */   GIR_RootConstrainSelectedInstOperands,
     /* 101796 */   // GIR_Coverage, 4456,
     /* 101796 */   GIR_EraseRootFromParent_Done,
     /* 101797 */ // Label 1881: @101797
     /* 101797 */ GIM_Reject,
     /* 101798 */ // Label 1878: @101798
     /* 101798 */ GIM_Reject,
     /* 101799 */ // Label 29: @101799
     /* 101799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1886*/ GIMT_Encode4(102167),
     /* 101810 */ /*GILLT_s32*//*Label 1882*/ GIMT_Encode4(101870), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101838 */ /*GILLT_v4s32*//*Label 1883*/ GIMT_Encode4(101963), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101854 */ /*GILLT_v8s16*//*Label 1884*/ GIMT_Encode4(102031), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101866 */ /*GILLT_v16s8*//*Label 1885*/ GIMT_Encode4(102099),
     /* 101870 */ // Label 1882: @101870
     /* 101870 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101962),
     /* 101875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101881 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101921), // Rule ID 178 //
     /* 101886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101901 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 101901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 101904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101919 */     GIR_RootConstrainSelectedInstOperands,
     /* 101920 */     // GIR_Coverage, 178,
     /* 101920 */     GIR_EraseRootFromParent_Done,
     /* 101921 */   // Label 1888: @101921
     /* 101921 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101961), // Rule ID 507 //
     /* 101926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 101929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101941 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 101944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101959 */     GIR_RootConstrainSelectedInstOperands,
     /* 101960 */     // GIR_Coverage, 507,
     /* 101960 */     GIR_EraseRootFromParent_Done,
     /* 101961 */   // Label 1889: @101961
     /* 101961 */   GIM_Reject,
     /* 101962 */ // Label 1887: @101962
     /* 101962 */ GIM_Reject,
     /* 101963 */ // Label 1883: @101963
     /* 101963 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(102030), // Rule ID 4452 //
     /* 101968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101989 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102006 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102008 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102013 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102019 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102028 */   GIR_RootConstrainSelectedInstOperands,
     /* 102029 */   // GIR_Coverage, 4452,
     /* 102029 */   GIR_EraseRootFromParent_Done,
     /* 102030 */ // Label 1890: @102030
     /* 102030 */ GIM_Reject,
     /* 102031 */ // Label 1884: @102031
     /* 102031 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102098), // Rule ID 4448 //
     /* 102036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102057 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102074 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102076 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102081 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102096 */   GIR_RootConstrainSelectedInstOperands,
     /* 102097 */   // GIR_Coverage, 4448,
     /* 102097 */   GIR_EraseRootFromParent_Done,
     /* 102098 */ // Label 1891: @102098
     /* 102098 */ GIM_Reject,
     /* 102099 */ // Label 1885: @102099
     /* 102099 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102166), // Rule ID 4445 //
     /* 102104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102125 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102142 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102144 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102149 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102155 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102164 */   GIR_RootConstrainSelectedInstOperands,
     /* 102165 */   // GIR_Coverage, 4445,
     /* 102165 */   GIR_EraseRootFromParent_Done,
     /* 102166 */ // Label 1892: @102166
     /* 102166 */ GIM_Reject,
     /* 102167 */ // Label 1886: @102167
     /* 102167 */ GIM_Reject,
     /* 102168 */ // Label 30: @102168
     /* 102168 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1901*/ GIMT_Encode4(102812),
     /* 102179 */ /*GILLT_s64*//*Label 1893*/ GIMT_Encode4(102235), GIMT_Encode4(0),
     /* 102187 */ /*GILLT_v2s32*//*Label 1894*/ GIMT_Encode4(102282),
     /* 102191 */ /*GILLT_v2s64*//*Label 1895*/ GIMT_Encode4(102329), GIMT_Encode4(0),
     /* 102199 */ /*GILLT_v4s16*//*Label 1896*/ GIMT_Encode4(102376),
     /* 102203 */ /*GILLT_v4s32*//*Label 1897*/ GIMT_Encode4(102423), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102215 */ /*GILLT_v8s8*//*Label 1898*/ GIMT_Encode4(102537),
     /* 102219 */ /*GILLT_v8s16*//*Label 1899*/ GIMT_Encode4(102584), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102231 */ /*GILLT_v16s8*//*Label 1900*/ GIMT_Encode4(102698),
     /* 102235 */ // Label 1893: @102235
     /* 102235 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102281), // Rule ID 830 //
     /* 102240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102261 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102266 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102268 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102273 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102279 */   GIR_RootConstrainSelectedInstOperands,
     /* 102280 */   // GIR_Coverage, 830,
     /* 102280 */   GIR_EraseRootFromParent_Done,
     /* 102281 */ // Label 1902: @102281
     /* 102281 */ GIM_Reject,
     /* 102282 */ // Label 1894: @102282
     /* 102282 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102328), // Rule ID 825 //
     /* 102287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102308 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102313 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102315 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102320 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102326 */   GIR_RootConstrainSelectedInstOperands,
     /* 102327 */   // GIR_Coverage, 825,
     /* 102327 */   GIR_EraseRootFromParent_Done,
     /* 102328 */ // Label 1903: @102328
     /* 102328 */ GIM_Reject,
     /* 102329 */ // Label 1895: @102329
     /* 102329 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102375), // Rule ID 831 //
     /* 102334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102355 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102360 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102362 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102367 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102373 */   GIR_RootConstrainSelectedInstOperands,
     /* 102374 */   // GIR_Coverage, 831,
     /* 102374 */   GIR_EraseRootFromParent_Done,
     /* 102375 */ // Label 1904: @102375
     /* 102375 */ GIM_Reject,
     /* 102376 */ // Label 1896: @102376
     /* 102376 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102422), // Rule ID 824 //
     /* 102381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102402 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102407 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102409 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102420 */   GIR_RootConstrainSelectedInstOperands,
     /* 102421 */   // GIR_Coverage, 824,
     /* 102421 */   GIR_EraseRootFromParent_Done,
     /* 102422 */ // Label 1905: @102422
     /* 102422 */ GIM_Reject,
     /* 102423 */ // Label 1897: @102423
     /* 102423 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102536),
     /* 102428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102434 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102474), // Rule ID 827 //
     /* 102439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102454 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102472 */     GIR_RootConstrainSelectedInstOperands,
     /* 102473 */     // GIR_Coverage, 827,
     /* 102473 */     GIR_EraseRootFromParent_Done,
     /* 102474 */   // Label 1907: @102474
     /* 102474 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102535), // Rule ID 3527 //
     /* 102479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102494 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102533 */     GIR_RootConstrainSelectedInstOperands,
     /* 102534 */     // GIR_Coverage, 3527,
     /* 102534 */     GIR_EraseRootFromParent_Done,
     /* 102535 */   // Label 1908: @102535
     /* 102535 */   GIM_Reject,
     /* 102536 */ // Label 1906: @102536
     /* 102536 */ GIM_Reject,
     /* 102537 */ // Label 1898: @102537
     /* 102537 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102583), // Rule ID 828 //
     /* 102542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102563 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102568 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102570 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102575 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102581 */   GIR_RootConstrainSelectedInstOperands,
     /* 102582 */   // GIR_Coverage, 828,
     /* 102582 */   GIR_EraseRootFromParent_Done,
     /* 102583 */ // Label 1909: @102583
     /* 102583 */ GIM_Reject,
     /* 102584 */ // Label 1899: @102584
     /* 102584 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102697),
     /* 102589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102595 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102635), // Rule ID 826 //
     /* 102600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102615 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102633 */     GIR_RootConstrainSelectedInstOperands,
     /* 102634 */     // GIR_Coverage, 826,
     /* 102634 */     GIR_EraseRootFromParent_Done,
     /* 102635 */   // Label 1911: @102635
     /* 102635 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102696), // Rule ID 3524 //
     /* 102640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102655 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102694 */     GIR_RootConstrainSelectedInstOperands,
     /* 102695 */     // GIR_Coverage, 3524,
     /* 102695 */     GIR_EraseRootFromParent_Done,
     /* 102696 */   // Label 1912: @102696
     /* 102696 */   GIM_Reject,
     /* 102697 */ // Label 1910: @102697
     /* 102697 */ GIM_Reject,
     /* 102698 */ // Label 1900: @102698
     /* 102698 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102811),
     /* 102703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102709 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102749), // Rule ID 829 //
     /* 102714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102729 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102747 */     GIR_RootConstrainSelectedInstOperands,
     /* 102748 */     // GIR_Coverage, 829,
     /* 102748 */     GIR_EraseRootFromParent_Done,
     /* 102749 */   // Label 1914: @102749
     /* 102749 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102810), // Rule ID 3521 //
     /* 102754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102769 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102808 */     GIR_RootConstrainSelectedInstOperands,
     /* 102809 */     // GIR_Coverage, 3521,
     /* 102809 */     GIR_EraseRootFromParent_Done,
     /* 102810 */   // Label 1915: @102810
     /* 102810 */   GIM_Reject,
     /* 102811 */ // Label 1913: @102811
     /* 102811 */ GIM_Reject,
     /* 102812 */ // Label 1901: @102812
     /* 102812 */ GIM_Reject,
     /* 102813 */ // Label 31: @102813
     /* 102813 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1925*/ GIMT_Encode4(104112),
     /* 102824 */ /*GILLT_s32*//*Label 1916*/ GIMT_Encode4(102884),
     /* 102828 */ /*GILLT_s64*//*Label 1917*/ GIMT_Encode4(103225), GIMT_Encode4(0),
     /* 102836 */ /*GILLT_v2s32*//*Label 1918*/ GIMT_Encode4(103272),
     /* 102840 */ /*GILLT_v2s64*//*Label 1919*/ GIMT_Encode4(103319), GIMT_Encode4(0),
     /* 102848 */ /*GILLT_v4s16*//*Label 1920*/ GIMT_Encode4(103520),
     /* 102852 */ /*GILLT_v4s32*//*Label 1921*/ GIMT_Encode4(103567), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102864 */ /*GILLT_v8s8*//*Label 1922*/ GIMT_Encode4(103837),
     /* 102868 */ /*GILLT_v8s16*//*Label 1923*/ GIMT_Encode4(103884), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102880 */ /*GILLT_v16s8*//*Label 1924*/ GIMT_Encode4(103998),
     /* 102884 */ // Label 1916: @102884
     /* 102884 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103224),
     /* 102889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102895 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(102957), // Rule ID 5654 //
     /* 102900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102924 */     // MIs[1] Rn
     /* 102924 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102935 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 102938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102955 */     GIR_RootConstrainSelectedInstOperands,
     /* 102956 */     // GIR_Coverage, 5654,
     /* 102956 */     GIR_EraseRootFromParent_Done,
     /* 102957 */   // Label 1927: @102957
     /* 102957 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103019), // Rule ID 5688 //
     /* 102962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102986 */     // MIs[1] Rn
     /* 102986 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102997 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103017 */     GIR_RootConstrainSelectedInstOperands,
     /* 103018 */     // GIR_Coverage, 5688,
     /* 103018 */     GIR_EraseRootFromParent_Done,
     /* 103019 */   // Label 1928: @103019
     /* 103019 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103081), // Rule ID 1870 //
     /* 103024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103052 */     // MIs[1] Rn
     /* 103052 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103059 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103079 */     GIR_RootConstrainSelectedInstOperands,
     /* 103080 */     // GIR_Coverage, 1870,
     /* 103080 */     GIR_EraseRootFromParent_Done,
     /* 103081 */   // Label 1929: @103081
     /* 103081 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103143), // Rule ID 2136 //
     /* 103086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103114 */     // MIs[1] Rn
     /* 103114 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103121 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103141 */     GIR_RootConstrainSelectedInstOperands,
     /* 103142 */     // GIR_Coverage, 2136,
     /* 103142 */     GIR_EraseRootFromParent_Done,
     /* 103143 */   // Label 1930: @103143
     /* 103143 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103183), // Rule ID 1868 //
     /* 103148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103163 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103168 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103170 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103181 */     GIR_RootConstrainSelectedInstOperands,
     /* 103182 */     // GIR_Coverage, 1868,
     /* 103182 */     GIR_EraseRootFromParent_Done,
     /* 103183 */   // Label 1931: @103183
     /* 103183 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103223), // Rule ID 2134 //
     /* 103188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103203 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103221 */     GIR_RootConstrainSelectedInstOperands,
     /* 103222 */     // GIR_Coverage, 2134,
     /* 103222 */     GIR_EraseRootFromParent_Done,
     /* 103223 */   // Label 1932: @103223
     /* 103223 */   GIM_Reject,
     /* 103224 */ // Label 1926: @103224
     /* 103224 */ GIM_Reject,
     /* 103225 */ // Label 1917: @103225
     /* 103225 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103271), // Rule ID 822 //
     /* 103230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103251 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103256 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103258 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103263 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103269 */   GIR_RootConstrainSelectedInstOperands,
     /* 103270 */   // GIR_Coverage, 822,
     /* 103270 */   GIR_EraseRootFromParent_Done,
     /* 103271 */ // Label 1933: @103271
     /* 103271 */ GIM_Reject,
     /* 103272 */ // Label 1918: @103272
     /* 103272 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103318), // Rule ID 817 //
     /* 103277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103298 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103303 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103305 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103310 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103316 */   GIR_RootConstrainSelectedInstOperands,
     /* 103317 */   // GIR_Coverage, 817,
     /* 103317 */   GIR_EraseRootFromParent_Done,
     /* 103318 */ // Label 1934: @103318
     /* 103318 */ GIM_Reject,
     /* 103319 */ // Label 1919: @103319
     /* 103319 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103519),
     /* 103324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103334 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103408), // Rule ID 5745 //
     /* 103339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103350 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103353 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103362 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103382 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103406 */     GIR_RootConstrainSelectedInstOperands,
     /* 103407 */     // GIR_Coverage, 5745,
     /* 103407 */     GIR_EraseRootFromParent_Done,
     /* 103408 */   // Label 1936: @103408
     /* 103408 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103482), // Rule ID 2489 //
     /* 103413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103456 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103480 */     GIR_RootConstrainSelectedInstOperands,
     /* 103481 */     // GIR_Coverage, 2489,
     /* 103481 */     GIR_EraseRootFromParent_Done,
     /* 103482 */   // Label 1937: @103482
     /* 103482 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103518), // Rule ID 823 //
     /* 103487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103498 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103516 */     GIR_RootConstrainSelectedInstOperands,
     /* 103517 */     // GIR_Coverage, 823,
     /* 103517 */     GIR_EraseRootFromParent_Done,
     /* 103518 */   // Label 1938: @103518
     /* 103518 */   GIM_Reject,
     /* 103519 */ // Label 1935: @103519
     /* 103519 */ GIM_Reject,
     /* 103520 */ // Label 1920: @103520
     /* 103520 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103566), // Rule ID 816 //
     /* 103525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103546 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103551 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103553 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103558 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103564 */   GIR_RootConstrainSelectedInstOperands,
     /* 103565 */   // GIR_Coverage, 816,
     /* 103565 */   GIR_EraseRootFromParent_Done,
     /* 103566 */ // Label 1939: @103566
     /* 103566 */ GIM_Reject,
     /* 103567 */ // Label 1921: @103567
     /* 103567 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103836),
     /* 103572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103578 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103656), // Rule ID 5744 //
     /* 103583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103598 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103601 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103610 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103630 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103654 */     GIR_RootConstrainSelectedInstOperands,
     /* 103655 */     // GIR_Coverage, 5744,
     /* 103655 */     GIR_EraseRootFromParent_Done,
     /* 103656 */   // Label 1941: @103656
     /* 103656 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103734), // Rule ID 2488 //
     /* 103661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103680 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103683 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103692 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103708 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103732 */     GIR_RootConstrainSelectedInstOperands,
     /* 103733 */     // GIR_Coverage, 2488,
     /* 103733 */     GIR_EraseRootFromParent_Done,
     /* 103734 */   // Label 1942: @103734
     /* 103734 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103774), // Rule ID 819 //
     /* 103739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103754 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103772 */     GIR_RootConstrainSelectedInstOperands,
     /* 103773 */     // GIR_Coverage, 819,
     /* 103773 */     GIR_EraseRootFromParent_Done,
     /* 103774 */   // Label 1943: @103774
     /* 103774 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(103835), // Rule ID 3518 //
     /* 103779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103794 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103833 */     GIR_RootConstrainSelectedInstOperands,
     /* 103834 */     // GIR_Coverage, 3518,
     /* 103834 */     GIR_EraseRootFromParent_Done,
     /* 103835 */   // Label 1944: @103835
     /* 103835 */   GIM_Reject,
     /* 103836 */ // Label 1940: @103836
     /* 103836 */ GIM_Reject,
     /* 103837 */ // Label 1922: @103837
     /* 103837 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103883), // Rule ID 820 //
     /* 103842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 103848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 103851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103863 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 103863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 103866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103868 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103870 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103875 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103881 */   GIR_RootConstrainSelectedInstOperands,
     /* 103882 */   // GIR_Coverage, 820,
     /* 103882 */   GIR_EraseRootFromParent_Done,
     /* 103883 */ // Label 1945: @103883
     /* 103883 */ GIM_Reject,
     /* 103884 */ // Label 1923: @103884
     /* 103884 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(103997),
     /* 103889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103895 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(103935), // Rule ID 818 //
     /* 103900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103915 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 103915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 103918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103933 */     GIR_RootConstrainSelectedInstOperands,
     /* 103934 */     // GIR_Coverage, 818,
     /* 103934 */     GIR_EraseRootFromParent_Done,
     /* 103935 */   // Label 1947: @103935
     /* 103935 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(103996), // Rule ID 3515 //
     /* 103940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103955 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 103955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 103970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103994 */     GIR_RootConstrainSelectedInstOperands,
     /* 103995 */     // GIR_Coverage, 3515,
     /* 103995 */     GIR_EraseRootFromParent_Done,
     /* 103996 */   // Label 1948: @103996
     /* 103996 */   GIM_Reject,
     /* 103997 */ // Label 1946: @103997
     /* 103997 */ GIM_Reject,
     /* 103998 */ // Label 1924: @103998
     /* 103998 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104111),
     /* 104003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104009 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104049), // Rule ID 821 //
     /* 104014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104029 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104047 */     GIR_RootConstrainSelectedInstOperands,
     /* 104048 */     // GIR_Coverage, 821,
     /* 104048 */     GIR_EraseRootFromParent_Done,
     /* 104049 */   // Label 1950: @104049
     /* 104049 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104110), // Rule ID 3512 //
     /* 104054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104069 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104108 */     GIR_RootConstrainSelectedInstOperands,
     /* 104109 */     // GIR_Coverage, 3512,
     /* 104109 */     GIR_EraseRootFromParent_Done,
     /* 104110 */   // Label 1951: @104110
     /* 104110 */   GIM_Reject,
     /* 104111 */ // Label 1949: @104111
     /* 104111 */ GIM_Reject,
     /* 104112 */ // Label 1925: @104112
     /* 104112 */ GIM_Reject,
     /* 104113 */ // Label 32: @104113
     /* 104113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1960*/ GIMT_Encode4(104757),
     /* 104124 */ /*GILLT_s64*//*Label 1952*/ GIMT_Encode4(104180), GIMT_Encode4(0),
     /* 104132 */ /*GILLT_v2s32*//*Label 1953*/ GIMT_Encode4(104227),
     /* 104136 */ /*GILLT_v2s64*//*Label 1954*/ GIMT_Encode4(104274), GIMT_Encode4(0),
     /* 104144 */ /*GILLT_v4s16*//*Label 1955*/ GIMT_Encode4(104321),
     /* 104148 */ /*GILLT_v4s32*//*Label 1956*/ GIMT_Encode4(104368), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104160 */ /*GILLT_v8s8*//*Label 1957*/ GIMT_Encode4(104482),
     /* 104164 */ /*GILLT_v8s16*//*Label 1958*/ GIMT_Encode4(104529), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104176 */ /*GILLT_v16s8*//*Label 1959*/ GIMT_Encode4(104643),
     /* 104180 */ // Label 1952: @104180
     /* 104180 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(104226), // Rule ID 1022 //
     /* 104185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104206 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104211 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104213 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104218 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104224 */   GIR_RootConstrainSelectedInstOperands,
     /* 104225 */   // GIR_Coverage, 1022,
     /* 104225 */   GIR_EraseRootFromParent_Done,
     /* 104226 */ // Label 1961: @104226
     /* 104226 */ GIM_Reject,
     /* 104227 */ // Label 1953: @104227
     /* 104227 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(104273), // Rule ID 1017 //
     /* 104232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104253 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104258 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104260 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104265 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104271 */   GIR_RootConstrainSelectedInstOperands,
     /* 104272 */   // GIR_Coverage, 1017,
     /* 104272 */   GIR_EraseRootFromParent_Done,
     /* 104273 */ // Label 1962: @104273
     /* 104273 */ GIM_Reject,
     /* 104274 */ // Label 1954: @104274
     /* 104274 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104320), // Rule ID 1023 //
     /* 104279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104300 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104307 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104312 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104318 */   GIR_RootConstrainSelectedInstOperands,
     /* 104319 */   // GIR_Coverage, 1023,
     /* 104319 */   GIR_EraseRootFromParent_Done,
     /* 104320 */ // Label 1963: @104320
     /* 104320 */ GIM_Reject,
     /* 104321 */ // Label 1955: @104321
     /* 104321 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104367), // Rule ID 1016 //
     /* 104326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104347 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104352 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104354 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104359 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104365 */   GIR_RootConstrainSelectedInstOperands,
     /* 104366 */   // GIR_Coverage, 1016,
     /* 104366 */   GIR_EraseRootFromParent_Done,
     /* 104367 */ // Label 1964: @104367
     /* 104367 */ GIM_Reject,
     /* 104368 */ // Label 1956: @104368
     /* 104368 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104481),
     /* 104373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104379 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104419), // Rule ID 1019 //
     /* 104384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104399 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104417 */     GIR_RootConstrainSelectedInstOperands,
     /* 104418 */     // GIR_Coverage, 1019,
     /* 104418 */     GIR_EraseRootFromParent_Done,
     /* 104419 */   // Label 1966: @104419
     /* 104419 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104480), // Rule ID 3545 //
     /* 104424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104439 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104478 */     GIR_RootConstrainSelectedInstOperands,
     /* 104479 */     // GIR_Coverage, 3545,
     /* 104479 */     GIR_EraseRootFromParent_Done,
     /* 104480 */   // Label 1967: @104480
     /* 104480 */   GIM_Reject,
     /* 104481 */ // Label 1965: @104481
     /* 104481 */ GIM_Reject,
     /* 104482 */ // Label 1957: @104482
     /* 104482 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104528), // Rule ID 1020 //
     /* 104487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104508 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104513 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104515 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104520 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104526 */   GIR_RootConstrainSelectedInstOperands,
     /* 104527 */   // GIR_Coverage, 1020,
     /* 104527 */   GIR_EraseRootFromParent_Done,
     /* 104528 */ // Label 1968: @104528
     /* 104528 */ GIM_Reject,
     /* 104529 */ // Label 1958: @104529
     /* 104529 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104642),
     /* 104534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104540 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104580), // Rule ID 1018 //
     /* 104545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104560 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104578 */     GIR_RootConstrainSelectedInstOperands,
     /* 104579 */     // GIR_Coverage, 1018,
     /* 104579 */     GIR_EraseRootFromParent_Done,
     /* 104580 */   // Label 1970: @104580
     /* 104580 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104641), // Rule ID 3542 //
     /* 104585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104600 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104639 */     GIR_RootConstrainSelectedInstOperands,
     /* 104640 */     // GIR_Coverage, 3542,
     /* 104640 */     GIR_EraseRootFromParent_Done,
     /* 104641 */   // Label 1971: @104641
     /* 104641 */   GIM_Reject,
     /* 104642 */ // Label 1969: @104642
     /* 104642 */ GIM_Reject,
     /* 104643 */ // Label 1959: @104643
     /* 104643 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104756),
     /* 104648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104654 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104694), // Rule ID 1021 //
     /* 104659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104674 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104692 */     GIR_RootConstrainSelectedInstOperands,
     /* 104693 */     // GIR_Coverage, 1021,
     /* 104693 */     GIR_EraseRootFromParent_Done,
     /* 104694 */   // Label 1973: @104694
     /* 104694 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104755), // Rule ID 3539 //
     /* 104699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104714 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104753 */     GIR_RootConstrainSelectedInstOperands,
     /* 104754 */     // GIR_Coverage, 3539,
     /* 104754 */     GIR_EraseRootFromParent_Done,
     /* 104755 */   // Label 1974: @104755
     /* 104755 */   GIM_Reject,
     /* 104756 */ // Label 1972: @104756
     /* 104756 */ GIM_Reject,
     /* 104757 */ // Label 1960: @104757
     /* 104757 */ GIM_Reject,
     /* 104758 */ // Label 33: @104758
     /* 104758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1984*/ GIMT_Encode4(105777),
     /* 104769 */ /*GILLT_s32*//*Label 1975*/ GIMT_Encode4(104829),
     /* 104773 */ /*GILLT_s64*//*Label 1976*/ GIMT_Encode4(105046), GIMT_Encode4(0),
     /* 104781 */ /*GILLT_v2s32*//*Label 1977*/ GIMT_Encode4(105093),
     /* 104785 */ /*GILLT_v2s64*//*Label 1978*/ GIMT_Encode4(105140), GIMT_Encode4(0),
     /* 104793 */ /*GILLT_v4s16*//*Label 1979*/ GIMT_Encode4(105263),
     /* 104797 */ /*GILLT_v4s32*//*Label 1980*/ GIMT_Encode4(105310), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104809 */ /*GILLT_v8s8*//*Label 1981*/ GIMT_Encode4(105502),
     /* 104813 */ /*GILLT_v8s16*//*Label 1982*/ GIMT_Encode4(105549), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104825 */ /*GILLT_v16s8*//*Label 1983*/ GIMT_Encode4(105663),
     /* 104829 */ // Label 1975: @104829
     /* 104829 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105045),
     /* 104834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104840 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(104902), // Rule ID 1871 //
     /* 104845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104873 */     // MIs[1] Rn
     /* 104873 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104880 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 104883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104900 */     GIR_RootConstrainSelectedInstOperands,
     /* 104901 */     // GIR_Coverage, 1871,
     /* 104901 */     GIR_EraseRootFromParent_Done,
     /* 104902 */   // Label 1986: @104902
     /* 104902 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(104964), // Rule ID 2137 //
     /* 104907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104935 */     // MIs[1] Rn
     /* 104935 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104942 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 104945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104962 */     GIR_RootConstrainSelectedInstOperands,
     /* 104963 */     // GIR_Coverage, 2137,
     /* 104963 */     GIR_EraseRootFromParent_Done,
     /* 104964 */   // Label 1987: @104964
     /* 104964 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105004), // Rule ID 1869 //
     /* 104969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104984 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 104984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 104987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104989 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 104991 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 104993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105002 */     GIR_RootConstrainSelectedInstOperands,
     /* 105003 */     // GIR_Coverage, 1869,
     /* 105003 */     GIR_EraseRootFromParent_Done,
     /* 105004 */   // Label 1988: @105004
     /* 105004 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105044), // Rule ID 2135 //
     /* 105009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105024 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105042 */     GIR_RootConstrainSelectedInstOperands,
     /* 105043 */     // GIR_Coverage, 2135,
     /* 105043 */     GIR_EraseRootFromParent_Done,
     /* 105044 */   // Label 1989: @105044
     /* 105044 */   GIM_Reject,
     /* 105045 */ // Label 1985: @105045
     /* 105045 */ GIM_Reject,
     /* 105046 */ // Label 1976: @105046
     /* 105046 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105092), // Rule ID 1014 //
     /* 105051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105072 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105077 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105079 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105090 */   GIR_RootConstrainSelectedInstOperands,
     /* 105091 */   // GIR_Coverage, 1014,
     /* 105091 */   GIR_EraseRootFromParent_Done,
     /* 105092 */ // Label 1990: @105092
     /* 105092 */ GIM_Reject,
     /* 105093 */ // Label 1977: @105093
     /* 105093 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105139), // Rule ID 1009 //
     /* 105098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105119 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105124 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105126 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105131 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105137 */   GIR_RootConstrainSelectedInstOperands,
     /* 105138 */   // GIR_Coverage, 1009,
     /* 105138 */   GIR_EraseRootFromParent_Done,
     /* 105139 */ // Label 1991: @105139
     /* 105139 */ GIM_Reject,
     /* 105140 */ // Label 1978: @105140
     /* 105140 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105262),
     /* 105145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105159 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105229), // Rule ID 2496 //
     /* 105164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105203 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105208 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105227 */     GIR_RootConstrainSelectedInstOperands,
     /* 105228 */     // GIR_Coverage, 2496,
     /* 105228 */     GIR_EraseRootFromParent_Done,
     /* 105229 */   // Label 1993: @105229
     /* 105229 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105261), // Rule ID 1015 //
     /* 105234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105241 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105259 */     GIR_RootConstrainSelectedInstOperands,
     /* 105260 */     // GIR_Coverage, 1015,
     /* 105260 */     GIR_EraseRootFromParent_Done,
     /* 105261 */   // Label 1994: @105261
     /* 105261 */   GIM_Reject,
     /* 105262 */ // Label 1992: @105262
     /* 105262 */ GIM_Reject,
     /* 105263 */ // Label 1979: @105263
     /* 105263 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105309), // Rule ID 1008 //
     /* 105268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105289 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105294 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105296 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105301 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105307 */   GIR_RootConstrainSelectedInstOperands,
     /* 105308 */   // GIR_Coverage, 1008,
     /* 105308 */   GIR_EraseRootFromParent_Done,
     /* 105309 */ // Label 1995: @105309
     /* 105309 */ GIM_Reject,
     /* 105310 */ // Label 1980: @105310
     /* 105310 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105501),
     /* 105315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105321 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105399), // Rule ID 2495 //
     /* 105326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105345 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105348 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105357 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105373 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105397 */     GIR_RootConstrainSelectedInstOperands,
     /* 105398 */     // GIR_Coverage, 2495,
     /* 105398 */     GIR_EraseRootFromParent_Done,
     /* 105399 */   // Label 1997: @105399
     /* 105399 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105439), // Rule ID 1011 //
     /* 105404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105419 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105437 */     GIR_RootConstrainSelectedInstOperands,
     /* 105438 */     // GIR_Coverage, 1011,
     /* 105438 */     GIR_EraseRootFromParent_Done,
     /* 105439 */   // Label 1998: @105439
     /* 105439 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105500), // Rule ID 3536 //
     /* 105444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105459 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105498 */     GIR_RootConstrainSelectedInstOperands,
     /* 105499 */     // GIR_Coverage, 3536,
     /* 105499 */     GIR_EraseRootFromParent_Done,
     /* 105500 */   // Label 1999: @105500
     /* 105500 */   GIM_Reject,
     /* 105501 */ // Label 1996: @105501
     /* 105501 */ GIM_Reject,
     /* 105502 */ // Label 1981: @105502
     /* 105502 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105548), // Rule ID 1012 //
     /* 105507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105528 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105533 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105535 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105546 */   GIR_RootConstrainSelectedInstOperands,
     /* 105547 */   // GIR_Coverage, 1012,
     /* 105547 */   GIR_EraseRootFromParent_Done,
     /* 105548 */ // Label 2000: @105548
     /* 105548 */ GIM_Reject,
     /* 105549 */ // Label 1982: @105549
     /* 105549 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105662),
     /* 105554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105560 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105600), // Rule ID 1010 //
     /* 105565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105580 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105598 */     GIR_RootConstrainSelectedInstOperands,
     /* 105599 */     // GIR_Coverage, 1010,
     /* 105599 */     GIR_EraseRootFromParent_Done,
     /* 105600 */   // Label 2002: @105600
     /* 105600 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105661), // Rule ID 3533 //
     /* 105605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105620 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105659 */     GIR_RootConstrainSelectedInstOperands,
     /* 105660 */     // GIR_Coverage, 3533,
     /* 105660 */     GIR_EraseRootFromParent_Done,
     /* 105661 */   // Label 2003: @105661
     /* 105661 */   GIM_Reject,
     /* 105662 */ // Label 2001: @105662
     /* 105662 */ GIM_Reject,
     /* 105663 */ // Label 1983: @105663
     /* 105663 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105776),
     /* 105668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105674 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105714), // Rule ID 1013 //
     /* 105679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105694 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105712 */     GIR_RootConstrainSelectedInstOperands,
     /* 105713 */     // GIR_Coverage, 1013,
     /* 105713 */     GIR_EraseRootFromParent_Done,
     /* 105714 */   // Label 2005: @105714
     /* 105714 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105775), // Rule ID 3530 //
     /* 105719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105734 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105773 */     GIR_RootConstrainSelectedInstOperands,
     /* 105774 */     // GIR_Coverage, 3530,
     /* 105774 */     GIR_EraseRootFromParent_Done,
     /* 105775 */   // Label 2006: @105775
     /* 105775 */   GIM_Reject,
     /* 105776 */ // Label 2004: @105776
     /* 105776 */ GIM_Reject,
     /* 105777 */ // Label 1984: @105777
     /* 105777 */ GIM_Reject,
     /* 105778 */ // Label 34: @105778
     /* 105778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2014*/ GIMT_Encode4(108130),
     /* 105789 */ /*GILLT_s16*//*Label 2007*/ GIMT_Encode4(105841),
     /* 105793 */ /*GILLT_s32*//*Label 2008*/ GIMT_Encode4(105888),
     /* 105797 */ /*GILLT_s64*//*Label 2009*/ GIMT_Encode4(107483), GIMT_Encode4(0),
     /* 105805 */ /*GILLT_v2s32*//*Label 2010*/ GIMT_Encode4(107530), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105817 */ /*GILLT_v4s16*//*Label 2011*/ GIMT_Encode4(107577),
     /* 105821 */ /*GILLT_v4s32*//*Label 2012*/ GIMT_Encode4(107762), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105837 */ /*GILLT_v8s16*//*Label 2013*/ GIMT_Encode4(107876),
     /* 105841 */ // Label 2007: @105841
     /* 105841 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(105887), // Rule ID 614 //
     /* 105846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 105849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 105852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 105855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105867 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 105867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 105870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 105872 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 105874 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 105876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105879 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105885 */   GIR_RootConstrainSelectedInstOperands,
     /* 105886 */   // GIR_Coverage, 614,
     /* 105886 */   GIR_EraseRootFromParent_Done,
     /* 105887 */ // Label 2015: @105887
     /* 105887 */ GIM_Reject,
     /* 105888 */ // Label 2008: @105888
     /* 105888 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107482),
     /* 105893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105903 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(106231), // Rule ID 5921 //
     /* 105908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 105911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 105919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105943 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 105943 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 105946 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105950 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 105957 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 105960 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105964 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105969 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 105972 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105977 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 105980 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105984 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105989 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 105992 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 105996 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 105999 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106004 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106009 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106014 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106017 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106021 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106028 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106031 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106035 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106040 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106043 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106048 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106051 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106055 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106060 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106063 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106067 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106070 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106075 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106080 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106085 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106088 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106092 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106099 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106102 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106106 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106111 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106114 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106119 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106122 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106126 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106131 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106134 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106138 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106141 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106146 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106151 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106168 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106171 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106174 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106177 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106180 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106230 */     // GIR_Coverage, 5921,
     /* 106230 */     GIR_EraseRootFromParent_Done,
     /* 106231 */   // Label 2017: @106231
     /* 106231 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(106559), // Rule ID 5922 //
     /* 106236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106271 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106271 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106274 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106278 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106285 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106288 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106292 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106297 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106300 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106305 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106308 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106312 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106317 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106320 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106324 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106327 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106332 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106337 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106342 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106345 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106349 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106356 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106359 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106363 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106368 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106371 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106376 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106379 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106383 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106388 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106391 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106395 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106398 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106403 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106408 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106413 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106416 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106420 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106427 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106430 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106434 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106439 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106442 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106459 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106462 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106466 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106469 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106474 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106479 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106496 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106499 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106502 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106505 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106508 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106558 */     // GIR_Coverage, 5922,
     /* 106558 */     GIR_EraseRootFromParent_Done,
     /* 106559 */   // Label 2018: @106559
     /* 106559 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106887), // Rule ID 2700 //
     /* 106564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106599 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106599 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106602 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106606 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106613 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106616 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106620 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106625 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106628 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106633 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106636 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106640 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106645 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106648 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106652 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106655 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106660 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106665 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106670 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106673 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106677 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106684 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106687 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106691 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106696 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106699 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106704 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106707 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106711 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106716 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106719 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106723 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106726 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106731 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106736 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106741 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106744 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106748 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106755 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106758 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106762 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106767 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106770 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106787 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106790 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106794 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106797 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106802 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106807 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106812 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106815 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106819 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106824 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106827 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106830 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106836 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106856 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106886 */     // GIR_Coverage, 2700,
     /* 106886 */     GIR_EraseRootFromParent_Done,
     /* 106887 */   // Label 2019: @106887
     /* 106887 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107215), // Rule ID 2702 //
     /* 106892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106927 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106927 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106930 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106934 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106941 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106944 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106948 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106953 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106956 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106961 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106964 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106968 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106973 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106976 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106980 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106983 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106988 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106993 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106998 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107001 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107005 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107012 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107015 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107019 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107024 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107027 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107032 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107035 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107039 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107044 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107047 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107051 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107054 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107059 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107064 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107069 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107072 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107076 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107083 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107086 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107090 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107095 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107098 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107103 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107106 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107110 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107115 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107118 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107125 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107130 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107135 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107140 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107143 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107147 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107152 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107155 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107158 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107164 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107184 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107214 */     // GIR_Coverage, 2702,
     /* 107214 */     GIR_EraseRootFromParent_Done,
     /* 107215 */   // Label 2020: @107215
     /* 107215 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107251), // Rule ID 613 //
     /* 107220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107231 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107249 */     GIR_RootConstrainSelectedInstOperands,
     /* 107250 */     // GIR_Coverage, 613,
     /* 107250 */     GIR_EraseRootFromParent_Done,
     /* 107251 */   // Label 2021: @107251
     /* 107251 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107481), // Rule ID 2697 //
     /* 107256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107267 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107267 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107270 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107274 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107281 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107284 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107288 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107293 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107296 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107301 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107304 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107308 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107313 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107316 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107320 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107323 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107333 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107338 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107341 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107345 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107352 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107355 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107359 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107364 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107367 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107372 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107375 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107379 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107384 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107387 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107391 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107394 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107404 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107421 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107424 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107427 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107430 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107463 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107480 */     // GIR_Coverage, 2697,
     /* 107480 */     GIR_EraseRootFromParent_Done,
     /* 107481 */   // Label 2022: @107481
     /* 107481 */   GIM_Reject,
     /* 107482 */ // Label 2016: @107482
     /* 107482 */ GIM_Reject,
     /* 107483 */ // Label 2009: @107483
     /* 107483 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107529), // Rule ID 612 //
     /* 107488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107509 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107514 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107516 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107521 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107527 */   GIR_RootConstrainSelectedInstOperands,
     /* 107528 */   // GIR_Coverage, 612,
     /* 107528 */   GIR_EraseRootFromParent_Done,
     /* 107529 */ // Label 2023: @107529
     /* 107529 */ GIM_Reject,
     /* 107530 */ // Label 2010: @107530
     /* 107530 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107576), // Rule ID 764 //
     /* 107535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107556 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107561 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107563 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107568 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107574 */   GIR_RootConstrainSelectedInstOperands,
     /* 107575 */   // GIR_Coverage, 764,
     /* 107575 */   GIR_EraseRootFromParent_Done,
     /* 107576 */ // Label 2024: @107576
     /* 107576 */ GIM_Reject,
     /* 107577 */ // Label 2011: @107577
     /* 107577 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107761),
     /* 107582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107592 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107658), // Rule ID 5584 //
     /* 107597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107632 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107656 */     GIR_RootConstrainSelectedInstOperands,
     /* 107657 */     // GIR_Coverage, 5584,
     /* 107657 */     GIR_EraseRootFromParent_Done,
     /* 107658 */   // Label 2026: @107658
     /* 107658 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107724), // Rule ID 945 //
     /* 107663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107698 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107722 */     GIR_RootConstrainSelectedInstOperands,
     /* 107723 */     // GIR_Coverage, 945,
     /* 107723 */     GIR_EraseRootFromParent_Done,
     /* 107724 */   // Label 2027: @107724
     /* 107724 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107760), // Rule ID 766 //
     /* 107729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107740 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107758 */     GIR_RootConstrainSelectedInstOperands,
     /* 107759 */     // GIR_Coverage, 766,
     /* 107759 */     GIR_EraseRootFromParent_Done,
     /* 107760 */   // Label 2028: @107760
     /* 107760 */   GIM_Reject,
     /* 107761 */ // Label 2025: @107761
     /* 107761 */ GIM_Reject,
     /* 107762 */ // Label 2012: @107762
     /* 107762 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107875),
     /* 107767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107773 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107813), // Rule ID 765 //
     /* 107778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107793 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107811 */     GIR_RootConstrainSelectedInstOperands,
     /* 107812 */     // GIR_Coverage, 765,
     /* 107812 */     GIR_EraseRootFromParent_Done,
     /* 107813 */   // Label 2030: @107813
     /* 107813 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107874), // Rule ID 4016 //
     /* 107818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107833 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 107833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 107848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107872 */     GIR_RootConstrainSelectedInstOperands,
     /* 107873 */     // GIR_Coverage, 4016,
     /* 107873 */     GIR_EraseRootFromParent_Done,
     /* 107874 */   // Label 2031: @107874
     /* 107874 */   GIM_Reject,
     /* 107875 */ // Label 2029: @107875
     /* 107875 */ GIM_Reject,
     /* 107876 */ // Label 2013: @107876
     /* 107876 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(108129),
     /* 107881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107887 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107957), // Rule ID 5585 //
     /* 107892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107931 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107955 */     GIR_RootConstrainSelectedInstOperands,
     /* 107956 */     // GIR_Coverage, 5585,
     /* 107956 */     GIR_EraseRootFromParent_Done,
     /* 107957 */   // Label 2033: @107957
     /* 107957 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108027), // Rule ID 946 //
     /* 107962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108001 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108025 */     GIR_RootConstrainSelectedInstOperands,
     /* 108026 */     // GIR_Coverage, 946,
     /* 108026 */     GIR_EraseRootFromParent_Done,
     /* 108027 */   // Label 2034: @108027
     /* 108027 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108067), // Rule ID 767 //
     /* 108032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108047 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108065 */     GIR_RootConstrainSelectedInstOperands,
     /* 108066 */     // GIR_Coverage, 767,
     /* 108066 */     GIR_EraseRootFromParent_Done,
     /* 108067 */   // Label 2035: @108067
     /* 108067 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108128), // Rule ID 4020 //
     /* 108072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108087 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108126 */     GIR_RootConstrainSelectedInstOperands,
     /* 108127 */     // GIR_Coverage, 4020,
     /* 108127 */     GIR_EraseRootFromParent_Done,
     /* 108128 */   // Label 2036: @108128
     /* 108128 */   GIM_Reject,
     /* 108129 */ // Label 2032: @108129
     /* 108129 */ GIM_Reject,
     /* 108130 */ // Label 2014: @108130
     /* 108130 */ GIM_Reject,
     /* 108131 */ // Label 35: @108131
     /* 108131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2044*/ GIMT_Encode4(109807),
     /* 108142 */ /*GILLT_s16*//*Label 2037*/ GIMT_Encode4(108194),
     /* 108146 */ /*GILLT_s32*//*Label 2038*/ GIMT_Encode4(108241),
     /* 108150 */ /*GILLT_s64*//*Label 2039*/ GIMT_Encode4(109168), GIMT_Encode4(0),
     /* 108158 */ /*GILLT_v2s32*//*Label 2040*/ GIMT_Encode4(109215), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108170 */ /*GILLT_v4s16*//*Label 2041*/ GIMT_Encode4(109262),
     /* 108174 */ /*GILLT_v4s32*//*Label 2042*/ GIMT_Encode4(109439), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108190 */ /*GILLT_v8s16*//*Label 2043*/ GIMT_Encode4(109553),
     /* 108194 */ // Label 2037: @108194
     /* 108194 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108240), // Rule ID 617 //
     /* 108199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108220 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108227 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108232 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108238 */   GIR_RootConstrainSelectedInstOperands,
     /* 108239 */   // GIR_Coverage, 617,
     /* 108239 */   GIR_EraseRootFromParent_Done,
     /* 108240 */ // Label 2045: @108240
     /* 108240 */ GIM_Reject,
     /* 108241 */ // Label 2038: @108241
     /* 108241 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109167),
     /* 108246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108260 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108584), // Rule ID 2701 //
     /* 108265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108296 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108296 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108299 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108303 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108310 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108313 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108317 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108322 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108325 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108330 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108333 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108337 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108342 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108345 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108349 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108352 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108357 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108362 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108367 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108370 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108374 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108381 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108384 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108388 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108393 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108396 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108401 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108404 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108408 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108413 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108416 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108420 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108423 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108428 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108433 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108438 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108441 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108445 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108452 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108455 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108459 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108464 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108467 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108472 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108475 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108479 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108484 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108487 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108491 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108494 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108499 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108504 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108509 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108512 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108516 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108521 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108524 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108527 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108530 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108533 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108553 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108566 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108583 */     // GIR_Coverage, 2701,
     /* 108583 */     GIR_EraseRootFromParent_Done,
     /* 108584 */   // Label 2047: @108584
     /* 108584 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(108908), // Rule ID 2703 //
     /* 108589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108620 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108620 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108623 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108627 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108634 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108637 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108641 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108646 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108649 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108654 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108657 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108661 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108666 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108669 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108673 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108676 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108681 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108686 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108691 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108694 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108698 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108705 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108708 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108712 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108717 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108720 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108725 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108728 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108732 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108737 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108740 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108744 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108747 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108752 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108757 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108762 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108765 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108769 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108776 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108779 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108783 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108788 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108791 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108808 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108811 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108815 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108818 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108823 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108828 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 108840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108845 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108848 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108851 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108854 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108857 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108877 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108890 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108907 */     // GIR_Coverage, 2703,
     /* 108907 */     GIR_EraseRootFromParent_Done,
     /* 108908 */   // Label 2048: @108908
     /* 108908 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108940), // Rule ID 616 //
     /* 108913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 108916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108920 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 108920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 108923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108938 */     GIR_RootConstrainSelectedInstOperands,
     /* 108939 */     // GIR_Coverage, 616,
     /* 108939 */     GIR_EraseRootFromParent_Done,
     /* 108940 */   // Label 2049: @108940
     /* 108940 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109166), // Rule ID 2698 //
     /* 108945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 108948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108952 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108952 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108955 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108959 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108966 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108969 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108973 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108978 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108981 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108986 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108989 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108993 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108998 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109001 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109005 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109008 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109013 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109018 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109023 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109026 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109030 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109037 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109040 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109044 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109049 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109052 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109057 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109060 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109064 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109069 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109072 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109076 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109079 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109084 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109089 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109106 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109109 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109112 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109115 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109148 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109165 */     // GIR_Coverage, 2698,
     /* 109165 */     GIR_EraseRootFromParent_Done,
     /* 109166 */   // Label 2050: @109166
     /* 109166 */   GIM_Reject,
     /* 109167 */ // Label 2046: @109167
     /* 109167 */ GIM_Reject,
     /* 109168 */ // Label 2039: @109168
     /* 109168 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109214), // Rule ID 615 //
     /* 109173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109194 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109199 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109212 */   GIR_RootConstrainSelectedInstOperands,
     /* 109213 */   // GIR_Coverage, 615,
     /* 109213 */   GIR_EraseRootFromParent_Done,
     /* 109214 */ // Label 2051: @109214
     /* 109214 */ GIM_Reject,
     /* 109215 */ // Label 2040: @109215
     /* 109215 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109261), // Rule ID 968 //
     /* 109220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109241 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109246 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109248 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109253 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109259 */   GIR_RootConstrainSelectedInstOperands,
     /* 109260 */   // GIR_Coverage, 968,
     /* 109260 */   GIR_EraseRootFromParent_Done,
     /* 109261 */ // Label 2052: @109261
     /* 109261 */ GIM_Reject,
     /* 109262 */ // Label 2041: @109262
     /* 109262 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109438),
     /* 109267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109281 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109343), // Rule ID 923 //
     /* 109286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109317 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109341 */     GIR_RootConstrainSelectedInstOperands,
     /* 109342 */     // GIR_Coverage, 923,
     /* 109342 */     GIR_EraseRootFromParent_Done,
     /* 109343 */   // Label 2054: @109343
     /* 109343 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109405), // Rule ID 949 //
     /* 109348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109379 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109403 */     GIR_RootConstrainSelectedInstOperands,
     /* 109404 */     // GIR_Coverage, 949,
     /* 109404 */     GIR_EraseRootFromParent_Done,
     /* 109405 */   // Label 2055: @109405
     /* 109405 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109437), // Rule ID 970 //
     /* 109410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109417 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109435 */     GIR_RootConstrainSelectedInstOperands,
     /* 109436 */     // GIR_Coverage, 970,
     /* 109436 */     GIR_EraseRootFromParent_Done,
     /* 109437 */   // Label 2056: @109437
     /* 109437 */   GIM_Reject,
     /* 109438 */ // Label 2053: @109438
     /* 109438 */ GIM_Reject,
     /* 109439 */ // Label 2042: @109439
     /* 109439 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109552),
     /* 109444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109450 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109490), // Rule ID 969 //
     /* 109455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109470 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109488 */     GIR_RootConstrainSelectedInstOperands,
     /* 109489 */     // GIR_Coverage, 969,
     /* 109489 */     GIR_EraseRootFromParent_Done,
     /* 109490 */   // Label 2058: @109490
     /* 109490 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109551), // Rule ID 4024 //
     /* 109495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109510 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109549 */     GIR_RootConstrainSelectedInstOperands,
     /* 109550 */     // GIR_Coverage, 4024,
     /* 109550 */     GIR_EraseRootFromParent_Done,
     /* 109551 */   // Label 2059: @109551
     /* 109551 */   GIM_Reject,
     /* 109552 */ // Label 2057: @109552
     /* 109552 */ GIM_Reject,
     /* 109553 */ // Label 2043: @109553
     /* 109553 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109806),
     /* 109558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109564 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109634), // Rule ID 924 //
     /* 109569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109608 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109632 */     GIR_RootConstrainSelectedInstOperands,
     /* 109633 */     // GIR_Coverage, 924,
     /* 109633 */     GIR_EraseRootFromParent_Done,
     /* 109634 */   // Label 2061: @109634
     /* 109634 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109704), // Rule ID 950 //
     /* 109639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109678 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109702 */     GIR_RootConstrainSelectedInstOperands,
     /* 109703 */     // GIR_Coverage, 950,
     /* 109703 */     GIR_EraseRootFromParent_Done,
     /* 109704 */   // Label 2062: @109704
     /* 109704 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109744), // Rule ID 971 //
     /* 109709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109724 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109742 */     GIR_RootConstrainSelectedInstOperands,
     /* 109743 */     // GIR_Coverage, 971,
     /* 109743 */     GIR_EraseRootFromParent_Done,
     /* 109744 */   // Label 2063: @109744
     /* 109744 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109805), // Rule ID 4028 //
     /* 109749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109764 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109803 */     GIR_RootConstrainSelectedInstOperands,
     /* 109804 */     // GIR_Coverage, 4028,
     /* 109804 */     GIR_EraseRootFromParent_Done,
     /* 109805 */   // Label 2064: @109805
     /* 109805 */   GIM_Reject,
     /* 109806 */ // Label 2060: @109806
     /* 109806 */ GIM_Reject,
     /* 109807 */ // Label 2044: @109807
     /* 109807 */ GIM_Reject,
     /* 109808 */ // Label 36: @109808
     /* 109808 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2072*/ GIMT_Encode4(110788),
     /* 109819 */ /*GILLT_s16*//*Label 2065*/ GIMT_Encode4(109871),
     /* 109823 */ /*GILLT_s32*//*Label 2066*/ GIMT_Encode4(109918),
     /* 109827 */ /*GILLT_s64*//*Label 2067*/ GIMT_Encode4(110307), GIMT_Encode4(0),
     /* 109835 */ /*GILLT_v2s32*//*Label 2068*/ GIMT_Encode4(110466), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109847 */ /*GILLT_v4s16*//*Label 2069*/ GIMT_Encode4(110513),
     /* 109851 */ /*GILLT_v4s32*//*Label 2070*/ GIMT_Encode4(110560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109867 */ /*GILLT_v8s16*//*Label 2071*/ GIMT_Encode4(110674),
     /* 109871 */ // Label 2065: @109871
     /* 109871 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(109917), // Rule ID 623 //
     /* 109876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 109879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 109885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109897 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 109897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 109900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109902 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109904 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109909 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109915 */   GIR_RootConstrainSelectedInstOperands,
     /* 109916 */   // GIR_Coverage, 623,
     /* 109916 */   GIR_EraseRootFromParent_Done,
     /* 109917 */ // Label 2073: @109917
     /* 109917 */ GIM_Reject,
     /* 109918 */ // Label 2066: @109918
     /* 109918 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110306),
     /* 109923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109933 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109986), // Rule ID 2302 //
     /* 109938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109964 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109973 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 109975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109984 */     GIR_RootConstrainSelectedInstOperands,
     /* 109985 */     // GIR_Coverage, 2302,
     /* 109985 */     GIR_EraseRootFromParent_Done,
     /* 109986 */   // Label 2075: @109986
     /* 109986 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110039), // Rule ID 5711 //
     /* 109991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110017 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110026 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110037 */     GIR_RootConstrainSelectedInstOperands,
     /* 110038 */     // GIR_Coverage, 5711,
     /* 110038 */     GIR_EraseRootFromParent_Done,
     /* 110039 */   // Label 2076: @110039
     /* 110039 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110075), // Rule ID 622 //
     /* 110044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110055 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110073 */     GIR_RootConstrainSelectedInstOperands,
     /* 110074 */     // GIR_Coverage, 622,
     /* 110074 */     GIR_EraseRootFromParent_Done,
     /* 110075 */   // Label 2077: @110075
     /* 110075 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110305), // Rule ID 2699 //
     /* 110080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110091 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110091 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110094 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110098 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110105 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110108 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110112 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110117 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110120 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110125 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110128 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110132 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110137 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110140 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110144 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110147 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110152 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110157 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110162 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110165 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110169 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110176 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110179 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110183 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110188 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110191 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110196 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110199 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110203 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110208 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110211 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110215 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110218 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110223 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110228 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110233 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110236 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110240 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110245 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110248 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110251 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110254 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110274 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110287 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110304 */     // GIR_Coverage, 2699,
     /* 110304 */     GIR_EraseRootFromParent_Done,
     /* 110305 */   // Label 2078: @110305
     /* 110305 */   GIM_Reject,
     /* 110306 */ // Label 2074: @110306
     /* 110306 */ GIM_Reject,
     /* 110307 */ // Label 2067: @110307
     /* 110307 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110465),
     /* 110312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110322 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110375), // Rule ID 2301 //
     /* 110327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110353 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110362 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110373 */     GIR_RootConstrainSelectedInstOperands,
     /* 110374 */     // GIR_Coverage, 2301,
     /* 110374 */     GIR_EraseRootFromParent_Done,
     /* 110375 */   // Label 2080: @110375
     /* 110375 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110428), // Rule ID 5710 //
     /* 110380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110406 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110415 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110426 */     GIR_RootConstrainSelectedInstOperands,
     /* 110427 */     // GIR_Coverage, 5710,
     /* 110427 */     GIR_EraseRootFromParent_Done,
     /* 110428 */   // Label 2081: @110428
     /* 110428 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110464), // Rule ID 621 //
     /* 110433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110444 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110462 */     GIR_RootConstrainSelectedInstOperands,
     /* 110463 */     // GIR_Coverage, 621,
     /* 110463 */     GIR_EraseRootFromParent_Done,
     /* 110464 */   // Label 2082: @110464
     /* 110464 */   GIM_Reject,
     /* 110465 */ // Label 2079: @110465
     /* 110465 */ GIM_Reject,
     /* 110466 */ // Label 2068: @110466
     /* 110466 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110512), // Rule ID 843 //
     /* 110471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110492 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110497 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110499 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110504 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110510 */   GIR_RootConstrainSelectedInstOperands,
     /* 110511 */   // GIR_Coverage, 843,
     /* 110511 */   GIR_EraseRootFromParent_Done,
     /* 110512 */ // Label 2083: @110512
     /* 110512 */ GIM_Reject,
     /* 110513 */ // Label 2069: @110513
     /* 110513 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110559), // Rule ID 845 //
     /* 110518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110539 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110544 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110546 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110551 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110557 */   GIR_RootConstrainSelectedInstOperands,
     /* 110558 */   // GIR_Coverage, 845,
     /* 110558 */   GIR_EraseRootFromParent_Done,
     /* 110559 */ // Label 2084: @110559
     /* 110559 */ GIM_Reject,
     /* 110560 */ // Label 2070: @110560
     /* 110560 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110673),
     /* 110565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110571 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110611), // Rule ID 844 //
     /* 110576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110591 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110609 */     GIR_RootConstrainSelectedInstOperands,
     /* 110610 */     // GIR_Coverage, 844,
     /* 110610 */     GIR_EraseRootFromParent_Done,
     /* 110611 */   // Label 2086: @110611
     /* 110611 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110672), // Rule ID 3988 //
     /* 110616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110631 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110670 */     GIR_RootConstrainSelectedInstOperands,
     /* 110671 */     // GIR_Coverage, 3988,
     /* 110671 */     GIR_EraseRootFromParent_Done,
     /* 110672 */   // Label 2087: @110672
     /* 110672 */   GIM_Reject,
     /* 110673 */ // Label 2085: @110673
     /* 110673 */ GIM_Reject,
     /* 110674 */ // Label 2071: @110674
     /* 110674 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110787),
     /* 110679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110685 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110725), // Rule ID 846 //
     /* 110690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110705 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110723 */     GIR_RootConstrainSelectedInstOperands,
     /* 110724 */     // GIR_Coverage, 846,
     /* 110724 */     GIR_EraseRootFromParent_Done,
     /* 110725 */   // Label 2089: @110725
     /* 110725 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110786), // Rule ID 3992 //
     /* 110730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110745 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110784 */     GIR_RootConstrainSelectedInstOperands,
     /* 110785 */     // GIR_Coverage, 3992,
     /* 110785 */     GIR_EraseRootFromParent_Done,
     /* 110786 */   // Label 2090: @110786
     /* 110786 */   GIM_Reject,
     /* 110787 */ // Label 2088: @110787
     /* 110787 */ GIM_Reject,
     /* 110788 */ // Label 2072: @110788
     /* 110788 */ GIM_Reject,
     /* 110789 */ // Label 37: @110789
     /* 110789 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2098*/ GIMT_Encode4(112879),
     /* 110800 */ /*GILLT_s16*//*Label 2091*/ GIMT_Encode4(110852),
     /* 110804 */ /*GILLT_s32*//*Label 2092*/ GIMT_Encode4(111239),
     /* 110808 */ /*GILLT_s64*//*Label 2093*/ GIMT_Encode4(111626), GIMT_Encode4(0),
     /* 110816 */ /*GILLT_v2s32*//*Label 2094*/ GIMT_Encode4(112013), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110828 */ /*GILLT_v4s16*//*Label 2095*/ GIMT_Encode4(112193),
     /* 110832 */ /*GILLT_v4s32*//*Label 2096*/ GIMT_Encode4(112249), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110848 */ /*GILLT_v8s16*//*Label 2097*/ GIMT_Encode4(112627),
     /* 110852 */ // Label 2091: @110852
     /* 110852 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111238),
     /* 110857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110863 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 110866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110870 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(110944), // Rule ID 2406 //
     /* 110875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110918 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110942 */     GIR_RootConstrainSelectedInstOperands,
     /* 110943 */     // GIR_Coverage, 2406,
     /* 110943 */     GIR_EraseRootFromParent_Done,
     /* 110944 */   // Label 2100: @110944
     /* 110944 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111018), // Rule ID 5719 //
     /* 110949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110992 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111016 */     GIR_RootConstrainSelectedInstOperands,
     /* 111017 */     // GIR_Coverage, 5719,
     /* 111017 */     GIR_EraseRootFromParent_Done,
     /* 111018 */   // Label 2101: @111018
     /* 111018 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111077), // Rule ID 2398 //
     /* 111023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111053 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111075 */     GIR_RootConstrainSelectedInstOperands,
     /* 111076 */     // GIR_Coverage, 2398,
     /* 111076 */     GIR_EraseRootFromParent_Done,
     /* 111077 */   // Label 2102: @111077
     /* 111077 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111136), // Rule ID 5716 //
     /* 111082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111112 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111134 */     GIR_RootConstrainSelectedInstOperands,
     /* 111135 */     // GIR_Coverage, 5716,
     /* 111135 */     GIR_EraseRootFromParent_Done,
     /* 111136 */   // Label 2103: @111136
     /* 111136 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111195), // Rule ID 2411 //
     /* 111141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111171 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111193 */     GIR_RootConstrainSelectedInstOperands,
     /* 111194 */     // GIR_Coverage, 2411,
     /* 111194 */     GIR_EraseRootFromParent_Done,
     /* 111195 */   // Label 2104: @111195
     /* 111195 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111237), // Rule ID 2392 //
     /* 111200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111215 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111235 */     GIR_RootConstrainSelectedInstOperands,
     /* 111236 */     // GIR_Coverage, 2392,
     /* 111236 */     GIR_EraseRootFromParent_Done,
     /* 111237 */   // Label 2105: @111237
     /* 111237 */   GIM_Reject,
     /* 111238 */ // Label 2099: @111238
     /* 111238 */ GIM_Reject,
     /* 111239 */ // Label 2092: @111239
     /* 111239 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111625),
     /* 111244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111257 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111331), // Rule ID 2405 //
     /* 111262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111305 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111329 */     GIR_RootConstrainSelectedInstOperands,
     /* 111330 */     // GIR_Coverage, 2405,
     /* 111330 */     GIR_EraseRootFromParent_Done,
     /* 111331 */   // Label 2107: @111331
     /* 111331 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111405), // Rule ID 5718 //
     /* 111336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111379 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111403 */     GIR_RootConstrainSelectedInstOperands,
     /* 111404 */     // GIR_Coverage, 5718,
     /* 111404 */     GIR_EraseRootFromParent_Done,
     /* 111405 */   // Label 2108: @111405
     /* 111405 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111464), // Rule ID 2397 //
     /* 111410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111440 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111462 */     GIR_RootConstrainSelectedInstOperands,
     /* 111463 */     // GIR_Coverage, 2397,
     /* 111463 */     GIR_EraseRootFromParent_Done,
     /* 111464 */   // Label 2109: @111464
     /* 111464 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111523), // Rule ID 5715 //
     /* 111469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111499 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111521 */     GIR_RootConstrainSelectedInstOperands,
     /* 111522 */     // GIR_Coverage, 5715,
     /* 111522 */     GIR_EraseRootFromParent_Done,
     /* 111523 */   // Label 2110: @111523
     /* 111523 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111582), // Rule ID 2410 //
     /* 111528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111558 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111580 */     GIR_RootConstrainSelectedInstOperands,
     /* 111581 */     // GIR_Coverage, 2410,
     /* 111581 */     GIR_EraseRootFromParent_Done,
     /* 111582 */   // Label 2111: @111582
     /* 111582 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111624), // Rule ID 2391 //
     /* 111587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111602 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111622 */     GIR_RootConstrainSelectedInstOperands,
     /* 111623 */     // GIR_Coverage, 2391,
     /* 111623 */     GIR_EraseRootFromParent_Done,
     /* 111624 */   // Label 2112: @111624
     /* 111624 */   GIM_Reject,
     /* 111625 */ // Label 2106: @111625
     /* 111625 */ GIM_Reject,
     /* 111626 */ // Label 2093: @111626
     /* 111626 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(112012),
     /* 111631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111644 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111718), // Rule ID 2404 //
     /* 111649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111692 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111716 */     GIR_RootConstrainSelectedInstOperands,
     /* 111717 */     // GIR_Coverage, 2404,
     /* 111717 */     GIR_EraseRootFromParent_Done,
     /* 111718 */   // Label 2114: @111718
     /* 111718 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111792), // Rule ID 5717 //
     /* 111723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111766 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111790 */     GIR_RootConstrainSelectedInstOperands,
     /* 111791 */     // GIR_Coverage, 5717,
     /* 111791 */     GIR_EraseRootFromParent_Done,
     /* 111792 */   // Label 2115: @111792
     /* 111792 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111851), // Rule ID 2396 //
     /* 111797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111827 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111849 */     GIR_RootConstrainSelectedInstOperands,
     /* 111850 */     // GIR_Coverage, 2396,
     /* 111850 */     GIR_EraseRootFromParent_Done,
     /* 111851 */   // Label 2116: @111851
     /* 111851 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(111910), // Rule ID 5714 //
     /* 111856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111886 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111908 */     GIR_RootConstrainSelectedInstOperands,
     /* 111909 */     // GIR_Coverage, 5714,
     /* 111909 */     GIR_EraseRootFromParent_Done,
     /* 111910 */   // Label 2117: @111910
     /* 111910 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111969), // Rule ID 2409 //
     /* 111915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111945 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 111948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 111954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111967 */     GIR_RootConstrainSelectedInstOperands,
     /* 111968 */     // GIR_Coverage, 2409,
     /* 111968 */     GIR_EraseRootFromParent_Done,
     /* 111969 */   // Label 2118: @111969
     /* 111969 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112011), // Rule ID 2390 //
     /* 111974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111989 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 111992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112009 */     GIR_RootConstrainSelectedInstOperands,
     /* 112010 */     // GIR_Coverage, 2390,
     /* 112010 */     GIR_EraseRootFromParent_Done,
     /* 112011 */   // Label 2119: @112011
     /* 112011 */   GIM_Reject,
     /* 112012 */ // Label 2113: @112012
     /* 112012 */ GIM_Reject,
     /* 112013 */ // Label 2094: @112013
     /* 112013 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112192),
     /* 112018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112031 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112090), // Rule ID 2503 //
     /* 112036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112066 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112071 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112088 */     GIR_RootConstrainSelectedInstOperands,
     /* 112089 */     // GIR_Coverage, 2503,
     /* 112089 */     GIR_EraseRootFromParent_Done,
     /* 112090 */   // Label 2121: @112090
     /* 112090 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112149), // Rule ID 5757 //
     /* 112095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112125 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112147 */     GIR_RootConstrainSelectedInstOperands,
     /* 112148 */     // GIR_Coverage, 5757,
     /* 112148 */     GIR_EraseRootFromParent_Done,
     /* 112149 */   // Label 2122: @112149
     /* 112149 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112191), // Rule ID 2501 //
     /* 112154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112169 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112174 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112189 */     GIR_RootConstrainSelectedInstOperands,
     /* 112190 */     // GIR_Coverage, 2501,
     /* 112190 */     GIR_EraseRootFromParent_Done,
     /* 112191 */   // Label 2123: @112191
     /* 112191 */   GIM_Reject,
     /* 112192 */ // Label 2120: @112192
     /* 112192 */ GIM_Reject,
     /* 112193 */ // Label 2095: @112193
     /* 112193 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112248), // Rule ID 2499 //
     /* 112198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112226 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112231 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112233 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112235 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112246 */   GIR_RootConstrainSelectedInstOperands,
     /* 112247 */   // GIR_Coverage, 2499,
     /* 112247 */   GIR_EraseRootFromParent_Done,
     /* 112248 */ // Label 2124: @112248
     /* 112248 */ GIM_Reject,
     /* 112249 */ // Label 2096: @112249
     /* 112249 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112626),
     /* 112254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112263 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112326), // Rule ID 2504 //
     /* 112268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112302 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112307 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112324 */     GIR_RootConstrainSelectedInstOperands,
     /* 112325 */     // GIR_Coverage, 2504,
     /* 112325 */     GIR_EraseRootFromParent_Done,
     /* 112326 */   // Label 2126: @112326
     /* 112326 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112395), // Rule ID 4002 //
     /* 112331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112365 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112370 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112376 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112393 */     GIR_RootConstrainSelectedInstOperands,
     /* 112394 */     // GIR_Coverage, 4002,
     /* 112394 */     GIR_EraseRootFromParent_Done,
     /* 112395 */   // Label 2127: @112395
     /* 112395 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112458), // Rule ID 5758 //
     /* 112400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112434 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112439 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112456 */     GIR_RootConstrainSelectedInstOperands,
     /* 112457 */     // GIR_Coverage, 5758,
     /* 112457 */     GIR_EraseRootFromParent_Done,
     /* 112458 */   // Label 2128: @112458
     /* 112458 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112527), // Rule ID 6038 //
     /* 112463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112497 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112502 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112508 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112525 */     GIR_RootConstrainSelectedInstOperands,
     /* 112526 */     // GIR_Coverage, 6038,
     /* 112526 */     GIR_EraseRootFromParent_Done,
     /* 112527 */   // Label 2129: @112527
     /* 112527 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112573), // Rule ID 2502 //
     /* 112532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112551 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112556 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112571 */     GIR_RootConstrainSelectedInstOperands,
     /* 112572 */     // GIR_Coverage, 2502,
     /* 112572 */     GIR_EraseRootFromParent_Done,
     /* 112573 */   // Label 2130: @112573
     /* 112573 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112625), // Rule ID 4006 //
     /* 112578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112597 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112602 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112604 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112606 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112623 */     GIR_RootConstrainSelectedInstOperands,
     /* 112624 */     // GIR_Coverage, 4006,
     /* 112624 */     GIR_EraseRootFromParent_Done,
     /* 112625 */   // Label 2131: @112625
     /* 112625 */   GIM_Reject,
     /* 112626 */ // Label 2125: @112626
     /* 112626 */ GIM_Reject,
     /* 112627 */ // Label 2097: @112627
     /* 112627 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112878),
     /* 112632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112641 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112710), // Rule ID 4012 //
     /* 112646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112680 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112685 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112691 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112708 */     GIR_RootConstrainSelectedInstOperands,
     /* 112709 */     // GIR_Coverage, 4012,
     /* 112709 */     GIR_EraseRootFromParent_Done,
     /* 112710 */   // Label 2133: @112710
     /* 112710 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112779), // Rule ID 6040 //
     /* 112715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112749 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112754 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112760 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112777 */     GIR_RootConstrainSelectedInstOperands,
     /* 112778 */     // GIR_Coverage, 6040,
     /* 112778 */     GIR_EraseRootFromParent_Done,
     /* 112779 */   // Label 2134: @112779
     /* 112779 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112825), // Rule ID 2500 //
     /* 112784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112803 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112808 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112823 */     GIR_RootConstrainSelectedInstOperands,
     /* 112824 */     // GIR_Coverage, 2500,
     /* 112824 */     GIR_EraseRootFromParent_Done,
     /* 112825 */   // Label 2135: @112825
     /* 112825 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112877), // Rule ID 4009 //
     /* 112830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112849 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 112852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112854 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112856 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112858 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112875 */     GIR_RootConstrainSelectedInstOperands,
     /* 112876 */     // GIR_Coverage, 4009,
     /* 112876 */     GIR_EraseRootFromParent_Done,
     /* 112877 */   // Label 2136: @112877
     /* 112877 */   GIM_Reject,
     /* 112878 */ // Label 2132: @112878
     /* 112878 */ GIM_Reject,
     /* 112879 */ // Label 2098: @112879
     /* 112879 */ GIM_Reject,
     /* 112880 */ // Label 38: @112880
     /* 112880 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2140*/ GIMT_Encode4(113044),
     /* 112891 */ /*GILLT_s16*//*Label 2137*/ GIMT_Encode4(112903),
     /* 112895 */ /*GILLT_s32*//*Label 2138*/ GIMT_Encode4(112950),
     /* 112899 */ /*GILLT_s64*//*Label 2139*/ GIMT_Encode4(112997),
     /* 112903 */ // Label 2137: @112903
     /* 112903 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112949), // Rule ID 620 //
     /* 112908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 112917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112929 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 112932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112934 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112936 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112941 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112947 */   GIR_RootConstrainSelectedInstOperands,
     /* 112948 */   // GIR_Coverage, 620,
     /* 112948 */   GIR_EraseRootFromParent_Done,
     /* 112949 */ // Label 2141: @112949
     /* 112949 */ GIM_Reject,
     /* 112950 */ // Label 2138: @112950
     /* 112950 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112996), // Rule ID 619 //
     /* 112955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 112958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 112964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112976 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 112976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 112979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112981 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112983 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112988 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112994 */   GIR_RootConstrainSelectedInstOperands,
     /* 112995 */   // GIR_Coverage, 619,
     /* 112995 */   GIR_EraseRootFromParent_Done,
     /* 112996 */ // Label 2142: @112996
     /* 112996 */ GIM_Reject,
     /* 112997 */ // Label 2139: @112997
     /* 112997 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113043), // Rule ID 618 //
     /* 113002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113023 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113028 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113030 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113035 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113041 */   GIR_RootConstrainSelectedInstOperands,
     /* 113042 */   // GIR_Coverage, 618,
     /* 113042 */   GIR_EraseRootFromParent_Done,
     /* 113043 */ // Label 2143: @113043
     /* 113043 */ GIM_Reject,
     /* 113044 */ // Label 2140: @113044
     /* 113044 */ GIM_Reject,
     /* 113045 */ // Label 39: @113045
     /* 113045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2151*/ GIMT_Encode4(114575),
     /* 113056 */ /*GILLT_s16*//*Label 2144*/ GIMT_Encode4(113108),
     /* 113060 */ /*GILLT_s32*//*Label 2145*/ GIMT_Encode4(113455),
     /* 113064 */ /*GILLT_s64*//*Label 2146*/ GIMT_Encode4(113954), GIMT_Encode4(0),
     /* 113072 */ /*GILLT_v2s32*//*Label 2147*/ GIMT_Encode4(114301), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113084 */ /*GILLT_v4s16*//*Label 2148*/ GIMT_Encode4(114339),
     /* 113088 */ /*GILLT_v4s32*//*Label 2149*/ GIMT_Encode4(114377), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113104 */ /*GILLT_v8s16*//*Label 2150*/ GIMT_Encode4(114476),
     /* 113108 */ // Label 2144: @113108
     /* 113108 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113454),
     /* 113113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113120 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113205), // Rule ID 2414 //
     /* 113125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113177 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113203 */     GIR_RootConstrainSelectedInstOperands,
     /* 113204 */     // GIR_Coverage, 2414,
     /* 113204 */     GIR_EraseRootFromParent_Done,
     /* 113205 */   // Label 2153: @113205
     /* 113205 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113290), // Rule ID 5722 //
     /* 113210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113262 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113288 */     GIR_RootConstrainSelectedInstOperands,
     /* 113289 */     // GIR_Coverage, 5722,
     /* 113289 */     GIR_EraseRootFromParent_Done,
     /* 113290 */   // Label 2154: @113290
     /* 113290 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113363), // Rule ID 2403 //
     /* 113295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113314 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113335 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113361 */     GIR_RootConstrainSelectedInstOperands,
     /* 113362 */     // GIR_Coverage, 2403,
     /* 113362 */     GIR_EraseRootFromParent_Done,
     /* 113363 */   // Label 2155: @113363
     /* 113363 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113423), // Rule ID 626 //
     /* 113368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113399 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113421 */     GIR_RootConstrainSelectedInstOperands,
     /* 113422 */     // GIR_Coverage, 626,
     /* 113422 */     GIR_EraseRootFromParent_Done,
     /* 113423 */   // Label 2156: @113423
     /* 113423 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113453), // Rule ID 664 //
     /* 113428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113435 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113451 */     GIR_RootConstrainSelectedInstOperands,
     /* 113452 */     // GIR_Coverage, 664,
     /* 113452 */     GIR_EraseRootFromParent_Done,
     /* 113453 */   // Label 2157: @113453
     /* 113453 */   GIM_Reject,
     /* 113454 */ // Label 2152: @113454
     /* 113454 */ GIM_Reject,
     /* 113455 */ // Label 2145: @113455
     /* 113455 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113953),
     /* 113460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113467 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113552), // Rule ID 2413 //
     /* 113472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113491 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113524 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113550 */     GIR_RootConstrainSelectedInstOperands,
     /* 113551 */     // GIR_Coverage, 2413,
     /* 113551 */     GIR_EraseRootFromParent_Done,
     /* 113552 */   // Label 2159: @113552
     /* 113552 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113637), // Rule ID 5721 //
     /* 113557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113576 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113609 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113635 */     GIR_RootConstrainSelectedInstOperands,
     /* 113636 */     // GIR_Coverage, 5721,
     /* 113636 */     GIR_EraseRootFromParent_Done,
     /* 113637 */   // Label 2160: @113637
     /* 113637 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113710), // Rule ID 2402 //
     /* 113642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113661 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113682 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113708 */     GIR_RootConstrainSelectedInstOperands,
     /* 113709 */     // GIR_Coverage, 2402,
     /* 113709 */     GIR_EraseRootFromParent_Done,
     /* 113710 */   // Label 2161: @113710
     /* 113710 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113770), // Rule ID 625 //
     /* 113715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113746 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113768 */     GIR_RootConstrainSelectedInstOperands,
     /* 113769 */     // GIR_Coverage, 625,
     /* 113769 */     GIR_EraseRootFromParent_Done,
     /* 113770 */   // Label 2162: @113770
     /* 113770 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113800), // Rule ID 663 //
     /* 113775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113782 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113798 */     GIR_RootConstrainSelectedInstOperands,
     /* 113799 */     // GIR_Coverage, 663,
     /* 113799 */     GIR_EraseRootFromParent_Done,
     /* 113800 */   // Label 2163: @113800
     /* 113800 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113952), // Rule ID 2705 //
     /* 113805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113812 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113812 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113815 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113819 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 113826 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 113829 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113833 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113838 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 113841 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 113849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 113853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113858 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 113861 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 113865 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 113868 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113873 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113878 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113883 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 113886 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 113890 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113895 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 113898 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 113901 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 113912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113934 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 113941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113951 */     // GIR_Coverage, 2705,
     /* 113951 */     GIR_EraseRootFromParent_Done,
     /* 113952 */   // Label 2164: @113952
     /* 113952 */   GIM_Reject,
     /* 113953 */ // Label 2158: @113953
     /* 113953 */ GIM_Reject,
     /* 113954 */ // Label 2146: @113954
     /* 113954 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114300),
     /* 113959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113966 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114051), // Rule ID 2412 //
     /* 113971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113990 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114023 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114049 */     GIR_RootConstrainSelectedInstOperands,
     /* 114050 */     // GIR_Coverage, 2412,
     /* 114050 */     GIR_EraseRootFromParent_Done,
     /* 114051 */   // Label 2166: @114051
     /* 114051 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114136), // Rule ID 5720 //
     /* 114056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114075 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114108 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114134 */     GIR_RootConstrainSelectedInstOperands,
     /* 114135 */     // GIR_Coverage, 5720,
     /* 114135 */     GIR_EraseRootFromParent_Done,
     /* 114136 */   // Label 2167: @114136
     /* 114136 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114209), // Rule ID 2401 //
     /* 114141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114181 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114207 */     GIR_RootConstrainSelectedInstOperands,
     /* 114208 */     // GIR_Coverage, 2401,
     /* 114208 */     GIR_EraseRootFromParent_Done,
     /* 114209 */   // Label 2168: @114209
     /* 114209 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114269), // Rule ID 624 //
     /* 114214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114245 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114267 */     GIR_RootConstrainSelectedInstOperands,
     /* 114268 */     // GIR_Coverage, 624,
     /* 114268 */     GIR_EraseRootFromParent_Done,
     /* 114269 */   // Label 2169: @114269
     /* 114269 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114299), // Rule ID 662 //
     /* 114274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114281 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114297 */     GIR_RootConstrainSelectedInstOperands,
     /* 114298 */     // GIR_Coverage, 662,
     /* 114298 */     GIR_EraseRootFromParent_Done,
     /* 114299 */   // Label 2170: @114299
     /* 114299 */   GIM_Reject,
     /* 114300 */ // Label 2165: @114300
     /* 114300 */ GIM_Reject,
     /* 114301 */ // Label 2147: @114301
     /* 114301 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114338), // Rule ID 1530 //
     /* 114306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114320 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114336 */   GIR_RootConstrainSelectedInstOperands,
     /* 114337 */   // GIR_Coverage, 1530,
     /* 114337 */   GIR_EraseRootFromParent_Done,
     /* 114338 */ // Label 2171: @114338
     /* 114338 */ GIM_Reject,
     /* 114339 */ // Label 2148: @114339
     /* 114339 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114376), // Rule ID 1532 //
     /* 114344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114358 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114374 */   GIR_RootConstrainSelectedInstOperands,
     /* 114375 */   // GIR_Coverage, 1532,
     /* 114375 */   GIR_EraseRootFromParent_Done,
     /* 114376 */ // Label 2172: @114376
     /* 114376 */ GIM_Reject,
     /* 114377 */ // Label 2149: @114377
     /* 114377 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114475),
     /* 114382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114385 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114419), // Rule ID 1531 //
     /* 114390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114401 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114417 */     GIR_RootConstrainSelectedInstOperands,
     /* 114418 */     // GIR_Coverage, 1531,
     /* 114418 */     GIR_EraseRootFromParent_Done,
     /* 114419 */   // Label 2174: @114419
     /* 114419 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114474), // Rule ID 4116 //
     /* 114424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114435 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114452 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114472 */     GIR_RootConstrainSelectedInstOperands,
     /* 114473 */     // GIR_Coverage, 4116,
     /* 114473 */     GIR_EraseRootFromParent_Done,
     /* 114474 */   // Label 2175: @114474
     /* 114474 */   GIM_Reject,
     /* 114475 */ // Label 2173: @114475
     /* 114475 */ GIM_Reject,
     /* 114476 */ // Label 2150: @114476
     /* 114476 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114574),
     /* 114481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114484 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114518), // Rule ID 1533 //
     /* 114489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114500 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114516 */     GIR_RootConstrainSelectedInstOperands,
     /* 114517 */     // GIR_Coverage, 1533,
     /* 114517 */     GIR_EraseRootFromParent_Done,
     /* 114518 */   // Label 2177: @114518
     /* 114518 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114573), // Rule ID 4114 //
     /* 114523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114534 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114551 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114571 */     GIR_RootConstrainSelectedInstOperands,
     /* 114572 */     // GIR_Coverage, 4114,
     /* 114572 */     GIR_EraseRootFromParent_Done,
     /* 114573 */   // Label 2178: @114573
     /* 114573 */   GIM_Reject,
     /* 114574 */ // Label 2176: @114574
     /* 114574 */ GIM_Reject,
     /* 114575 */ // Label 2151: @114575
     /* 114575 */ GIM_Reject,
     /* 114576 */ // Label 40: @114576
     /* 114576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2182*/ GIMT_Encode4(114811),
     /* 114587 */ /*GILLT_s32*//*Label 2179*/ GIMT_Encode4(114619),
     /* 114591 */ /*GILLT_s64*//*Label 2180*/ GIMT_Encode4(114679), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114615 */ /*GILLT_v4s32*//*Label 2181*/ GIMT_Encode4(114776),
     /* 114619 */ // Label 2179: @114619
     /* 114619 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(114678), // Rule ID 2303 //
     /* 114624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114638 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114650 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114670 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114676 */   GIR_RootConstrainSelectedInstOperands,
     /* 114677 */   // GIR_Coverage, 2303,
     /* 114677 */   GIR_EraseRootFromParent_Done,
     /* 114678 */ // Label 2183: @114678
     /* 114678 */ GIM_Reject,
     /* 114679 */ // Label 2180: @114679
     /* 114679 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(114716), // Rule ID 660 //
     /* 114684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114698 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114703 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114714 */   GIR_RootConstrainSelectedInstOperands,
     /* 114715 */   // GIR_Coverage, 660,
     /* 114715 */   GIR_EraseRootFromParent_Done,
     /* 114716 */ // Label 2184: @114716
     /* 114716 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(114775), // Rule ID 2313 //
     /* 114721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114735 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114747 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114767 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114773 */   GIR_RootConstrainSelectedInstOperands,
     /* 114774 */   // GIR_Coverage, 2313,
     /* 114774 */   GIR_EraseRootFromParent_Done,
     /* 114775 */ // Label 2185: @114775
     /* 114775 */ GIM_Reject,
     /* 114776 */ // Label 2181: @114776
     /* 114776 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(114810), // Rule ID 2670 //
     /* 114781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114792 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114797 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114802 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114808 */   GIR_RootConstrainSelectedInstOperands,
     /* 114809 */   // GIR_Coverage, 2670,
     /* 114809 */   GIR_EraseRootFromParent_Done,
     /* 114810 */ // Label 2186: @114810
     /* 114810 */ GIM_Reject,
     /* 114811 */ // Label 2182: @114811
     /* 114811 */ GIM_Reject,
     /* 114812 */ // Label 41: @114812
     /* 114812 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2190*/ GIMT_Encode4(115083),
     /* 114823 */ /*GILLT_s16*//*Label 2187*/ GIMT_Encode4(114855),
     /* 114827 */ /*GILLT_s32*//*Label 2188*/ GIMT_Encode4(115010), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114851 */ /*GILLT_v4s16*//*Label 2189*/ GIMT_Encode4(115048),
     /* 114855 */ // Label 2187: @114855
     /* 114855 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(114932), // Rule ID 2305 //
     /* 114860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114874 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 114874 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114877 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114881 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 114895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114900 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114907 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114910 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114931 */   // GIR_Coverage, 2305,
     /* 114931 */   GIR_EraseRootFromParent_Done,
     /* 114932 */ // Label 2191: @114932
     /* 114932 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(115009), // Rule ID 2315 //
     /* 114937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114951 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 114951 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114954 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114958 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 114972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114977 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 114984 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114987 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115008 */   // GIR_Coverage, 2315,
     /* 115008 */   GIR_EraseRootFromParent_Done,
     /* 115009 */ // Label 2192: @115009
     /* 115009 */ GIM_Reject,
     /* 115010 */ // Label 2188: @115010
     /* 115010 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(115047), // Rule ID 661 //
     /* 115015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115029 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115034 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115039 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115045 */   GIR_RootConstrainSelectedInstOperands,
     /* 115046 */   // GIR_Coverage, 661,
     /* 115046 */   GIR_EraseRootFromParent_Done,
     /* 115047 */ // Label 2193: @115047
     /* 115047 */ GIM_Reject,
     /* 115048 */ // Label 2189: @115048
     /* 115048 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(115082), // Rule ID 2669 //
     /* 115053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115064 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115074 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115080 */   GIR_RootConstrainSelectedInstOperands,
     /* 115081 */   // GIR_Coverage, 2669,
     /* 115081 */   GIR_EraseRootFromParent_Done,
     /* 115082 */ // Label 2194: @115082
     /* 115082 */ GIM_Reject,
     /* 115083 */ // Label 2190: @115083
     /* 115083 */ GIM_Reject,
     /* 115084 */ // Label 42: @115084
     /* 115084 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2202*/ GIMT_Encode4(116417),
     /* 115095 */ /*GILLT_s32*//*Label 2195*/ GIMT_Encode4(115143), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115107 */ /*GILLT_v2s32*//*Label 2196*/ GIMT_Encode4(116037), GIMT_Encode4(0),
     /* 115115 */ /*GILLT_v4s1*//*Label 2197*/ GIMT_Encode4(116075),
     /* 115119 */ /*GILLT_v4s16*//*Label 2198*/ GIMT_Encode4(116128),
     /* 115123 */ /*GILLT_v4s32*//*Label 2199*/ GIMT_Encode4(116166), GIMT_Encode4(0),
     /* 115131 */ /*GILLT_v8s1*//*Label 2200*/ GIMT_Encode4(116265), GIMT_Encode4(0),
     /* 115139 */ /*GILLT_v8s16*//*Label 2201*/ GIMT_Encode4(116318),
     /* 115143 */ // Label 2195: @115143
     /* 115143 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(115209), // Rule ID 2323 //
     /* 115148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115158 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115166 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115170 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115177 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115189 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115208 */   // GIR_Coverage, 2323,
     /* 115208 */   GIR_EraseRootFromParent_Done,
     /* 115209 */ // Label 2203: @115209
     /* 115209 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(115275), // Rule ID 2325 //
     /* 115214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115224 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115228 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115232 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115236 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115241 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115243 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115255 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115274 */   // GIR_Coverage, 2325,
     /* 115274 */   GIR_EraseRootFromParent_Done,
     /* 115275 */ // Label 2204: @115275
     /* 115275 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115341), // Rule ID 2327 //
     /* 115280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115290 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115294 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115298 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115302 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115309 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115340 */   // GIR_Coverage, 2327,
     /* 115340 */   GIR_EraseRootFromParent_Done,
     /* 115341 */ // Label 2205: @115341
     /* 115341 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115407), // Rule ID 2329 //
     /* 115346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115364 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115375 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115387 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115406 */   // GIR_Coverage, 2329,
     /* 115406 */   GIR_EraseRootFromParent_Done,
     /* 115407 */ // Label 2206: @115407
     /* 115407 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115473), // Rule ID 2331 //
     /* 115412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115430 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115434 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115441 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115453 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115472 */   // GIR_Coverage, 2331,
     /* 115472 */   GIR_EraseRootFromParent_Done,
     /* 115473 */ // Label 2207: @115473
     /* 115473 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115539), // Rule ID 2333 //
     /* 115478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115496 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115500 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115507 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115519 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115538 */   // GIR_Coverage, 2333,
     /* 115538 */   GIR_EraseRootFromParent_Done,
     /* 115539 */ // Label 2208: @115539
     /* 115539 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115605), // Rule ID 2317 //
     /* 115544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115562 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115566 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115573 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115585 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115604 */   // GIR_Coverage, 2317,
     /* 115604 */   GIR_EraseRootFromParent_Done,
     /* 115605 */ // Label 2209: @115605
     /* 115605 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115671), // Rule ID 2319 //
     /* 115610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115628 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115632 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115637 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115639 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115651 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115670 */   // GIR_Coverage, 2319,
     /* 115670 */   GIR_EraseRootFromParent_Done,
     /* 115671 */ // Label 2210: @115671
     /* 115671 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115737), // Rule ID 2321 //
     /* 115676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115686 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115690 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115694 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115698 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115705 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115736 */   // GIR_Coverage, 2321,
     /* 115736 */   GIR_EraseRootFromParent_Done,
     /* 115737 */ // Label 2211: @115737
     /* 115737 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115797), // Rule ID 2352 //
     /* 115742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115756 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115772 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115775 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115796 */   // GIR_Coverage, 2352,
     /* 115796 */   GIR_EraseRootFromParent_Done,
     /* 115797 */ // Label 2212: @115797
     /* 115797 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115857), // Rule ID 2356 //
     /* 115802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115816 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115828 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115832 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115835 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115856 */   // GIR_Coverage, 2356,
     /* 115856 */   GIR_EraseRootFromParent_Done,
     /* 115857 */ // Label 2213: @115857
     /* 115857 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115917), // Rule ID 2360 //
     /* 115862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115876 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 115883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115892 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115895 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115916 */   // GIR_Coverage, 2360,
     /* 115916 */   GIR_EraseRootFromParent_Done,
     /* 115917 */ // Label 2214: @115917
     /* 115917 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116036), // Rule ID 2710 //
     /* 115922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 115925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115936 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 115936 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 115939 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115943 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115950 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 115953 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115957 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115962 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 115965 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115969 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 115972 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115977 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115982 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 115990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 115994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115999 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116002 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116005 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116018 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116035 */   // GIR_Coverage, 2710,
     /* 116035 */   GIR_EraseRootFromParent_Done,
     /* 116036 */ // Label 2215: @116036
     /* 116036 */ GIM_Reject,
     /* 116037 */ // Label 2196: @116037
     /* 116037 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116074), // Rule ID 1604 //
     /* 116042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116056 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116061 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116072 */   GIR_RootConstrainSelectedInstOperands,
     /* 116073 */   // GIR_Coverage, 1604,
     /* 116073 */   GIR_EraseRootFromParent_Done,
     /* 116074 */ // Label 2216: @116074
     /* 116074 */ GIM_Reject,
     /* 116075 */ // Label 2197: @116075
     /* 116075 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116127), // Rule ID 5105 //
     /* 116080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116094 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116099 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116101 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116113 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116119 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116125 */   GIR_RootConstrainSelectedInstOperands,
     /* 116126 */   // GIR_Coverage, 5105,
     /* 116126 */   GIR_EraseRootFromParent_Done,
     /* 116127 */ // Label 2217: @116127
     /* 116127 */ GIM_Reject,
     /* 116128 */ // Label 2198: @116128
     /* 116128 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116165), // Rule ID 1612 //
     /* 116133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116147 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116152 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116157 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116163 */   GIR_RootConstrainSelectedInstOperands,
     /* 116164 */   // GIR_Coverage, 1612,
     /* 116164 */   GIR_EraseRootFromParent_Done,
     /* 116165 */ // Label 2218: @116165
     /* 116165 */ GIM_Reject,
     /* 116166 */ // Label 2199: @116166
     /* 116166 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116264),
     /* 116171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116174 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116208), // Rule ID 1608 //
     /* 116179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116190 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116206 */     GIR_RootConstrainSelectedInstOperands,
     /* 116207 */     // GIR_Coverage, 1608,
     /* 116207 */     GIR_EraseRootFromParent_Done,
     /* 116208 */   // Label 2220: @116208
     /* 116208 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116263), // Rule ID 4094 //
     /* 116213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116224 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116261 */     GIR_RootConstrainSelectedInstOperands,
     /* 116262 */     // GIR_Coverage, 4094,
     /* 116262 */     GIR_EraseRootFromParent_Done,
     /* 116263 */   // Label 2221: @116263
     /* 116263 */   GIM_Reject,
     /* 116264 */ // Label 2219: @116264
     /* 116264 */ GIM_Reject,
     /* 116265 */ // Label 2200: @116265
     /* 116265 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116317), // Rule ID 5106 //
     /* 116270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116284 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116289 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116291 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116303 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116309 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116315 */   GIR_RootConstrainSelectedInstOperands,
     /* 116316 */   // GIR_Coverage, 5106,
     /* 116316 */   GIR_EraseRootFromParent_Done,
     /* 116317 */ // Label 2222: @116317
     /* 116317 */ GIM_Reject,
     /* 116318 */ // Label 2201: @116318
     /* 116318 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116416),
     /* 116323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116326 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116360), // Rule ID 1616 //
     /* 116331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116342 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116358 */     GIR_RootConstrainSelectedInstOperands,
     /* 116359 */     // GIR_Coverage, 1616,
     /* 116359 */     GIR_EraseRootFromParent_Done,
     /* 116360 */   // Label 2224: @116360
     /* 116360 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116415), // Rule ID 4090 //
     /* 116365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116376 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116413 */     GIR_RootConstrainSelectedInstOperands,
     /* 116414 */     // GIR_Coverage, 4090,
     /* 116414 */     GIR_EraseRootFromParent_Done,
     /* 116415 */   // Label 2225: @116415
     /* 116415 */   GIM_Reject,
     /* 116416 */ // Label 2223: @116416
     /* 116416 */ GIM_Reject,
     /* 116417 */ // Label 2202: @116417
     /* 116417 */ GIM_Reject,
     /* 116418 */ // Label 43: @116418
     /* 116418 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2233*/ GIMT_Encode4(117751),
     /* 116429 */ /*GILLT_s32*//*Label 2226*/ GIMT_Encode4(116477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116441 */ /*GILLT_v2s32*//*Label 2227*/ GIMT_Encode4(117371), GIMT_Encode4(0),
     /* 116449 */ /*GILLT_v4s1*//*Label 2228*/ GIMT_Encode4(117409),
     /* 116453 */ /*GILLT_v4s16*//*Label 2229*/ GIMT_Encode4(117462),
     /* 116457 */ /*GILLT_v4s32*//*Label 2230*/ GIMT_Encode4(117500), GIMT_Encode4(0),
     /* 116465 */ /*GILLT_v8s1*//*Label 2231*/ GIMT_Encode4(117599), GIMT_Encode4(0),
     /* 116473 */ /*GILLT_v8s16*//*Label 2232*/ GIMT_Encode4(117652),
     /* 116477 */ // Label 2226: @116477
     /* 116477 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(116543), // Rule ID 2324 //
     /* 116482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116500 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116504 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116509 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116511 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116542 */   // GIR_Coverage, 2324,
     /* 116542 */   GIR_EraseRootFromParent_Done,
     /* 116543 */ // Label 2234: @116543
     /* 116543 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(116609), // Rule ID 2326 //
     /* 116548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116558 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116566 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116577 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116589 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116608 */   // GIR_Coverage, 2326,
     /* 116608 */   GIR_EraseRootFromParent_Done,
     /* 116609 */ // Label 2235: @116609
     /* 116609 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(116675), // Rule ID 2328 //
     /* 116614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116632 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116636 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116643 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116674 */   // GIR_Coverage, 2328,
     /* 116674 */   GIR_EraseRootFromParent_Done,
     /* 116675 */ // Label 2236: @116675
     /* 116675 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(116741), // Rule ID 2330 //
     /* 116680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116690 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116694 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116698 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116702 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116707 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116709 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116721 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116740 */   // GIR_Coverage, 2330,
     /* 116740 */   GIR_EraseRootFromParent_Done,
     /* 116741 */ // Label 2237: @116741
     /* 116741 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116807), // Rule ID 2332 //
     /* 116746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116764 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116768 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116775 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116806 */   // GIR_Coverage, 2332,
     /* 116806 */   GIR_EraseRootFromParent_Done,
     /* 116807 */ // Label 2238: @116807
     /* 116807 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(116873), // Rule ID 2334 //
     /* 116812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116830 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116834 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116841 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 116848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116853 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116872 */   // GIR_Coverage, 2334,
     /* 116872 */   GIR_EraseRootFromParent_Done,
     /* 116873 */ // Label 2239: @116873
     /* 116873 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(116939), // Rule ID 2318 //
     /* 116878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116896 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116900 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116907 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 116914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116919 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116938 */   // GIR_Coverage, 2318,
     /* 116938 */   GIR_EraseRootFromParent_Done,
     /* 116939 */ // Label 2240: @116939
     /* 116939 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117005), // Rule ID 2320 //
     /* 116944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116966 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116973 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 116980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116999 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117004 */   // GIR_Coverage, 2320,
     /* 117004 */   GIR_EraseRootFromParent_Done,
     /* 117005 */ // Label 2241: @117005
     /* 117005 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117071), // Rule ID 2322 //
     /* 117010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117032 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117039 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117051 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117070 */   // GIR_Coverage, 2322,
     /* 117070 */   GIR_EraseRootFromParent_Done,
     /* 117071 */ // Label 2242: @117071
     /* 117071 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117131), // Rule ID 2362 //
     /* 117076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117090 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117102 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117106 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117109 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117130 */   // GIR_Coverage, 2362,
     /* 117130 */   GIR_EraseRootFromParent_Done,
     /* 117131 */ // Label 2243: @117131
     /* 117131 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117191), // Rule ID 2366 //
     /* 117136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117150 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117162 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117166 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117169 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117185 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117190 */   // GIR_Coverage, 2366,
     /* 117190 */   GIR_EraseRootFromParent_Done,
     /* 117191 */ // Label 2244: @117191
     /* 117191 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117251), // Rule ID 2370 //
     /* 117196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117210 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117222 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117226 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117229 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117250 */   // GIR_Coverage, 2370,
     /* 117250 */   GIR_EraseRootFromParent_Done,
     /* 117251 */ // Label 2245: @117251
     /* 117251 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117370), // Rule ID 2711 //
     /* 117256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117270 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117270 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117273 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117277 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117284 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117287 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117291 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117296 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117299 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117303 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117306 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117311 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117336 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117339 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117352 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117369 */   // GIR_Coverage, 2711,
     /* 117369 */   GIR_EraseRootFromParent_Done,
     /* 117370 */ // Label 2246: @117370
     /* 117370 */ GIM_Reject,
     /* 117371 */ // Label 2227: @117371
     /* 117371 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117408), // Rule ID 1605 //
     /* 117376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117390 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117395 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117400 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117406 */   GIR_RootConstrainSelectedInstOperands,
     /* 117407 */   // GIR_Coverage, 1605,
     /* 117407 */   GIR_EraseRootFromParent_Done,
     /* 117408 */ // Label 2247: @117408
     /* 117408 */ GIM_Reject,
     /* 117409 */ // Label 2228: @117409
     /* 117409 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117461), // Rule ID 5103 //
     /* 117414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117428 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117433 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117435 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117447 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117453 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117459 */   GIR_RootConstrainSelectedInstOperands,
     /* 117460 */   // GIR_Coverage, 5103,
     /* 117460 */   GIR_EraseRootFromParent_Done,
     /* 117461 */ // Label 2248: @117461
     /* 117461 */ GIM_Reject,
     /* 117462 */ // Label 2229: @117462
     /* 117462 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117499), // Rule ID 1613 //
     /* 117467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117481 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117486 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117491 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117497 */   GIR_RootConstrainSelectedInstOperands,
     /* 117498 */   // GIR_Coverage, 1613,
     /* 117498 */   GIR_EraseRootFromParent_Done,
     /* 117499 */ // Label 2249: @117499
     /* 117499 */ GIM_Reject,
     /* 117500 */ // Label 2230: @117500
     /* 117500 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117598),
     /* 117505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117508 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117542), // Rule ID 1609 //
     /* 117513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117524 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117540 */     GIR_RootConstrainSelectedInstOperands,
     /* 117541 */     // GIR_Coverage, 1609,
     /* 117541 */     GIR_EraseRootFromParent_Done,
     /* 117542 */   // Label 2251: @117542
     /* 117542 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117597), // Rule ID 4096 //
     /* 117547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117558 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117595 */     GIR_RootConstrainSelectedInstOperands,
     /* 117596 */     // GIR_Coverage, 4096,
     /* 117596 */     GIR_EraseRootFromParent_Done,
     /* 117597 */   // Label 2252: @117597
     /* 117597 */   GIM_Reject,
     /* 117598 */ // Label 2250: @117598
     /* 117598 */ GIM_Reject,
     /* 117599 */ // Label 2231: @117599
     /* 117599 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117651), // Rule ID 5104 //
     /* 117604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117618 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117623 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117625 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117637 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117643 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117649 */   GIR_RootConstrainSelectedInstOperands,
     /* 117650 */   // GIR_Coverage, 5104,
     /* 117650 */   GIR_EraseRootFromParent_Done,
     /* 117651 */ // Label 2253: @117651
     /* 117651 */ GIM_Reject,
     /* 117652 */ // Label 2232: @117652
     /* 117652 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117750),
     /* 117657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117660 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117694), // Rule ID 1617 //
     /* 117665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117676 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117692 */     GIR_RootConstrainSelectedInstOperands,
     /* 117693 */     // GIR_Coverage, 1617,
     /* 117693 */     GIR_EraseRootFromParent_Done,
     /* 117694 */   // Label 2255: @117694
     /* 117694 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117749), // Rule ID 4092 //
     /* 117699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117710 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117747 */     GIR_RootConstrainSelectedInstOperands,
     /* 117748 */     // GIR_Coverage, 4092,
     /* 117748 */     GIR_EraseRootFromParent_Done,
     /* 117749 */   // Label 2256: @117749
     /* 117749 */   GIM_Reject,
     /* 117750 */ // Label 2254: @117750
     /* 117750 */ GIM_Reject,
     /* 117751 */ // Label 2233: @117751
     /* 117751 */ GIM_Reject,
     /* 117752 */ // Label 44: @117752
     /* 117752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2264*/ GIMT_Encode4(118403),
     /* 117763 */ /*GILLT_s16*//*Label 2257*/ GIMT_Encode4(117815),
     /* 117767 */ /*GILLT_s32*//*Label 2258*/ GIMT_Encode4(117875),
     /* 117771 */ /*GILLT_s64*//*Label 2259*/ GIMT_Encode4(118069), GIMT_Encode4(0),
     /* 117779 */ /*GILLT_v2s32*//*Label 2260*/ GIMT_Encode4(118129), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117791 */ /*GILLT_v4s16*//*Label 2261*/ GIMT_Encode4(118167),
     /* 117795 */ /*GILLT_v4s32*//*Label 2262*/ GIMT_Encode4(118205), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117811 */ /*GILLT_v8s16*//*Label 2263*/ GIMT_Encode4(118304),
     /* 117815 */ // Label 2257: @117815
     /* 117815 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(117874), // Rule ID 2346 //
     /* 117820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117834 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 117858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117872 */   GIR_RootConstrainSelectedInstOperands,
     /* 117873 */   // GIR_Coverage, 2346,
     /* 117873 */   GIR_EraseRootFromParent_Done,
     /* 117874 */ // Label 2265: @117874
     /* 117874 */ GIM_Reject,
     /* 117875 */ // Label 2258: @117875
     /* 117875 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(118068),
     /* 117880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117891 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(117939), // Rule ID 2344 //
     /* 117896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117899 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 117923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117937 */     GIR_RootConstrainSelectedInstOperands,
     /* 117938 */     // GIR_Coverage, 2344,
     /* 117938 */     GIR_EraseRootFromParent_Done,
     /* 117939 */   // Label 2267: @117939
     /* 117939 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118067), // Rule ID 2712 //
     /* 117944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117947 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117947 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117950 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117954 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117959 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117963 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117968 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117971 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117975 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117994 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117997 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118000 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118036 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118066 */     // GIR_Coverage, 2712,
     /* 118066 */     GIR_EraseRootFromParent_Done,
     /* 118067 */   // Label 2268: @118067
     /* 118067 */   GIM_Reject,
     /* 118068 */ // Label 2266: @118068
     /* 118068 */ GIM_Reject,
     /* 118069 */ // Label 2259: @118069
     /* 118069 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118128), // Rule ID 2342 //
     /* 118074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118088 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118100 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118104 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118120 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118126 */   GIR_RootConstrainSelectedInstOperands,
     /* 118127 */   // GIR_Coverage, 2342,
     /* 118127 */   GIR_EraseRootFromParent_Done,
     /* 118128 */ // Label 2269: @118128
     /* 118128 */ GIM_Reject,
     /* 118129 */ // Label 2260: @118129
     /* 118129 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118166), // Rule ID 1606 //
     /* 118134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118148 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118153 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118158 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118164 */   GIR_RootConstrainSelectedInstOperands,
     /* 118165 */   // GIR_Coverage, 1606,
     /* 118165 */   GIR_EraseRootFromParent_Done,
     /* 118166 */ // Label 2270: @118166
     /* 118166 */ GIM_Reject,
     /* 118167 */ // Label 2261: @118167
     /* 118167 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118204), // Rule ID 1614 //
     /* 118172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118186 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118191 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118196 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118202 */   GIR_RootConstrainSelectedInstOperands,
     /* 118203 */   // GIR_Coverage, 1614,
     /* 118203 */   GIR_EraseRootFromParent_Done,
     /* 118204 */ // Label 2271: @118204
     /* 118204 */ GIM_Reject,
     /* 118205 */ // Label 2262: @118205
     /* 118205 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(118303),
     /* 118210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118213 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(118247), // Rule ID 1610 //
     /* 118218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118229 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118245 */     GIR_RootConstrainSelectedInstOperands,
     /* 118246 */     // GIR_Coverage, 1610,
     /* 118246 */     GIR_EraseRootFromParent_Done,
     /* 118247 */   // Label 2273: @118247
     /* 118247 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(118302), // Rule ID 4102 //
     /* 118252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118263 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118300 */     GIR_RootConstrainSelectedInstOperands,
     /* 118301 */     // GIR_Coverage, 4102,
     /* 118301 */     GIR_EraseRootFromParent_Done,
     /* 118302 */   // Label 2274: @118302
     /* 118302 */   GIM_Reject,
     /* 118303 */ // Label 2272: @118303
     /* 118303 */ GIM_Reject,
     /* 118304 */ // Label 2263: @118304
     /* 118304 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(118402),
     /* 118309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118312 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118346), // Rule ID 1618 //
     /* 118317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118328 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118344 */     GIR_RootConstrainSelectedInstOperands,
     /* 118345 */     // GIR_Coverage, 1618,
     /* 118345 */     GIR_EraseRootFromParent_Done,
     /* 118346 */   // Label 2276: @118346
     /* 118346 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118401), // Rule ID 4098 //
     /* 118351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118362 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118399 */     GIR_RootConstrainSelectedInstOperands,
     /* 118400 */     // GIR_Coverage, 4098,
     /* 118400 */     GIR_EraseRootFromParent_Done,
     /* 118401 */   // Label 2277: @118401
     /* 118401 */   GIM_Reject,
     /* 118402 */ // Label 2275: @118402
     /* 118402 */ GIM_Reject,
     /* 118403 */ // Label 2264: @118403
     /* 118403 */ GIM_Reject,
     /* 118404 */ // Label 45: @118404
     /* 118404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2285*/ GIMT_Encode4(119055),
     /* 118415 */ /*GILLT_s16*//*Label 2278*/ GIMT_Encode4(118467),
     /* 118419 */ /*GILLT_s32*//*Label 2279*/ GIMT_Encode4(118527),
     /* 118423 */ /*GILLT_s64*//*Label 2280*/ GIMT_Encode4(118721), GIMT_Encode4(0),
     /* 118431 */ /*GILLT_v2s32*//*Label 2281*/ GIMT_Encode4(118781), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118443 */ /*GILLT_v4s16*//*Label 2282*/ GIMT_Encode4(118819),
     /* 118447 */ /*GILLT_v4s32*//*Label 2283*/ GIMT_Encode4(118857), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118463 */ /*GILLT_v8s16*//*Label 2284*/ GIMT_Encode4(118956),
     /* 118467 */ // Label 2278: @118467
     /* 118467 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(118526), // Rule ID 2351 //
     /* 118472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118486 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118518 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118524 */   GIR_RootConstrainSelectedInstOperands,
     /* 118525 */   // GIR_Coverage, 2351,
     /* 118525 */   GIR_EraseRootFromParent_Done,
     /* 118526 */ // Label 2286: @118526
     /* 118526 */ GIM_Reject,
     /* 118527 */ // Label 2279: @118527
     /* 118527 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(118720),
     /* 118532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118543 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(118591), // Rule ID 2349 //
     /* 118548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118551 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118589 */     GIR_RootConstrainSelectedInstOperands,
     /* 118590 */     // GIR_Coverage, 2349,
     /* 118590 */     GIR_EraseRootFromParent_Done,
     /* 118591 */   // Label 2288: @118591
     /* 118591 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(118719), // Rule ID 2713 //
     /* 118596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118599 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118599 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118602 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118606 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118611 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118615 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118646 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118649 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118652 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118688 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118718 */     // GIR_Coverage, 2713,
     /* 118718 */     GIR_EraseRootFromParent_Done,
     /* 118719 */   // Label 2289: @118719
     /* 118719 */   GIM_Reject,
     /* 118720 */ // Label 2287: @118720
     /* 118720 */ GIM_Reject,
     /* 118721 */ // Label 2280: @118721
     /* 118721 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118780), // Rule ID 2347 //
     /* 118726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118740 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118752 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118778 */   GIR_RootConstrainSelectedInstOperands,
     /* 118779 */   // GIR_Coverage, 2347,
     /* 118779 */   GIR_EraseRootFromParent_Done,
     /* 118780 */ // Label 2290: @118780
     /* 118780 */ GIM_Reject,
     /* 118781 */ // Label 2281: @118781
     /* 118781 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(118818), // Rule ID 1607 //
     /* 118786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118800 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118805 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118810 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118816 */   GIR_RootConstrainSelectedInstOperands,
     /* 118817 */   // GIR_Coverage, 1607,
     /* 118817 */   GIR_EraseRootFromParent_Done,
     /* 118818 */ // Label 2291: @118818
     /* 118818 */ GIM_Reject,
     /* 118819 */ // Label 2282: @118819
     /* 118819 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(118856), // Rule ID 1615 //
     /* 118824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118838 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 118841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118843 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118848 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118854 */   GIR_RootConstrainSelectedInstOperands,
     /* 118855 */   // GIR_Coverage, 1615,
     /* 118855 */   GIR_EraseRootFromParent_Done,
     /* 118856 */ // Label 2292: @118856
     /* 118856 */ GIM_Reject,
     /* 118857 */ // Label 2283: @118857
     /* 118857 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(118955),
     /* 118862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118865 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(118899), // Rule ID 1611 //
     /* 118870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118881 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 118884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118897 */     GIR_RootConstrainSelectedInstOperands,
     /* 118898 */     // GIR_Coverage, 1611,
     /* 118898 */     GIR_EraseRootFromParent_Done,
     /* 118899 */   // Label 2294: @118899
     /* 118899 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(118954), // Rule ID 4104 //
     /* 118904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118915 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 118930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118952 */     GIR_RootConstrainSelectedInstOperands,
     /* 118953 */     // GIR_Coverage, 4104,
     /* 118953 */     GIR_EraseRootFromParent_Done,
     /* 118954 */   // Label 2295: @118954
     /* 118954 */   GIM_Reject,
     /* 118955 */ // Label 2293: @118955
     /* 118955 */ GIM_Reject,
     /* 118956 */ // Label 2284: @118956
     /* 118956 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(119054),
     /* 118961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118964 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(118998), // Rule ID 1619 //
     /* 118969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118980 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 118983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118996 */     GIR_RootConstrainSelectedInstOperands,
     /* 118997 */     // GIR_Coverage, 1619,
     /* 118997 */     GIR_EraseRootFromParent_Done,
     /* 118998 */   // Label 2297: @118998
     /* 118998 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(119053), // Rule ID 4100 //
     /* 119003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119014 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119051 */     GIR_RootConstrainSelectedInstOperands,
     /* 119052 */     // GIR_Coverage, 4100,
     /* 119052 */     GIR_EraseRootFromParent_Done,
     /* 119053 */   // Label 2298: @119053
     /* 119053 */   GIM_Reject,
     /* 119054 */ // Label 2296: @119054
     /* 119054 */ GIM_Reject,
     /* 119055 */ // Label 2285: @119055
     /* 119055 */ GIM_Reject,
     /* 119056 */ // Label 46: @119056
     /* 119056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2306*/ GIMT_Encode4(119831),
     /* 119067 */ /*GILLT_s16*//*Label 2299*/ GIMT_Encode4(119119),
     /* 119071 */ /*GILLT_s32*//*Label 2300*/ GIMT_Encode4(119157),
     /* 119075 */ /*GILLT_s64*//*Label 2301*/ GIMT_Encode4(119349), GIMT_Encode4(0),
     /* 119083 */ /*GILLT_v2s32*//*Label 2302*/ GIMT_Encode4(119387), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119095 */ /*GILLT_v4s16*//*Label 2303*/ GIMT_Encode4(119425),
     /* 119099 */ /*GILLT_v4s32*//*Label 2304*/ GIMT_Encode4(119463), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119115 */ /*GILLT_v8s16*//*Label 2305*/ GIMT_Encode4(119647),
     /* 119119 */ // Label 2299: @119119
     /* 119119 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(119156), // Rule ID 653 //
     /* 119124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119138 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119143 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119154 */   GIR_RootConstrainSelectedInstOperands,
     /* 119155 */   // GIR_Coverage, 653,
     /* 119155 */   GIR_EraseRootFromParent_Done,
     /* 119156 */ // Label 2307: @119156
     /* 119156 */ GIM_Reject,
     /* 119157 */ // Label 2300: @119157
     /* 119157 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(119348),
     /* 119162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119173 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119199), // Rule ID 652 //
     /* 119178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119181 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119197 */     GIR_RootConstrainSelectedInstOperands,
     /* 119198 */     // GIR_Coverage, 652,
     /* 119198 */     GIR_EraseRootFromParent_Done,
     /* 119199 */   // Label 2309: @119199
     /* 119199 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(119347), // Rule ID 2704 //
     /* 119204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119207 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119207 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119210 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119214 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119221 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119224 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119228 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119233 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119236 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119253 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119256 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119260 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119263 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119268 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119273 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119290 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119293 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119296 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119329 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119346 */     // GIR_Coverage, 2704,
     /* 119346 */     GIR_EraseRootFromParent_Done,
     /* 119347 */   // Label 2310: @119347
     /* 119347 */   GIM_Reject,
     /* 119348 */ // Label 2308: @119348
     /* 119348 */ GIM_Reject,
     /* 119349 */ // Label 2301: @119349
     /* 119349 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119386), // Rule ID 651 //
     /* 119354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119368 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119373 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119378 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119384 */   GIR_RootConstrainSelectedInstOperands,
     /* 119385 */   // GIR_Coverage, 651,
     /* 119385 */   GIR_EraseRootFromParent_Done,
     /* 119386 */ // Label 2311: @119386
     /* 119386 */ GIM_Reject,
     /* 119387 */ // Label 2302: @119387
     /* 119387 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119424), // Rule ID 1514 //
     /* 119392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119406 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119411 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119416 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119422 */   GIR_RootConstrainSelectedInstOperands,
     /* 119423 */   // GIR_Coverage, 1514,
     /* 119423 */   GIR_EraseRootFromParent_Done,
     /* 119424 */ // Label 2312: @119424
     /* 119424 */ GIM_Reject,
     /* 119425 */ // Label 2303: @119425
     /* 119425 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119462), // Rule ID 1516 //
     /* 119430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119444 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119449 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119454 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119460 */   GIR_RootConstrainSelectedInstOperands,
     /* 119461 */   // GIR_Coverage, 1516,
     /* 119461 */   GIR_EraseRootFromParent_Done,
     /* 119462 */ // Label 2313: @119462
     /* 119462 */ GIM_Reject,
     /* 119463 */ // Label 2304: @119463
     /* 119463 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119646),
     /* 119468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119471 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119556), // Rule ID 4041 //
     /* 119476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119511 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119554 */     GIR_RootConstrainSelectedInstOperands,
     /* 119555 */     // GIR_Coverage, 4041,
     /* 119555 */     GIR_EraseRootFromParent_Done,
     /* 119556 */   // Label 2315: @119556
     /* 119556 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119590), // Rule ID 1515 //
     /* 119561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119572 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119588 */     GIR_RootConstrainSelectedInstOperands,
     /* 119589 */     // GIR_Coverage, 1515,
     /* 119589 */     GIR_EraseRootFromParent_Done,
     /* 119590 */   // Label 2316: @119590
     /* 119590 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119645), // Rule ID 4112 //
     /* 119595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119606 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119623 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119643 */     GIR_RootConstrainSelectedInstOperands,
     /* 119644 */     // GIR_Coverage, 4112,
     /* 119644 */     GIR_EraseRootFromParent_Done,
     /* 119645 */   // Label 2317: @119645
     /* 119645 */   GIM_Reject,
     /* 119646 */ // Label 2314: @119646
     /* 119646 */ GIM_Reject,
     /* 119647 */ // Label 2305: @119647
     /* 119647 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119830),
     /* 119652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119655 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119740), // Rule ID 4040 //
     /* 119660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119695 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119738 */     GIR_RootConstrainSelectedInstOperands,
     /* 119739 */     // GIR_Coverage, 4040,
     /* 119739 */     GIR_EraseRootFromParent_Done,
     /* 119740 */   // Label 2319: @119740
     /* 119740 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119774), // Rule ID 1517 //
     /* 119745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119756 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119772 */     GIR_RootConstrainSelectedInstOperands,
     /* 119773 */     // GIR_Coverage, 1517,
     /* 119773 */     GIR_EraseRootFromParent_Done,
     /* 119774 */   // Label 2320: @119774
     /* 119774 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(119829), // Rule ID 4110 //
     /* 119779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119790 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119807 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119827 */     GIR_RootConstrainSelectedInstOperands,
     /* 119828 */     // GIR_Coverage, 4110,
     /* 119828 */     GIR_EraseRootFromParent_Done,
     /* 119829 */   // Label 2321: @119829
     /* 119829 */   GIM_Reject,
     /* 119830 */ // Label 2318: @119830
     /* 119830 */ GIM_Reject,
     /* 119831 */ // Label 2306: @119831
     /* 119831 */ GIM_Reject,
     /* 119832 */ // Label 47: @119832
     /* 119832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2329*/ GIMT_Encode4(120423),
     /* 119843 */ /*GILLT_s16*//*Label 2322*/ GIMT_Encode4(119895),
     /* 119847 */ /*GILLT_s32*//*Label 2323*/ GIMT_Encode4(119929),
     /* 119851 */ /*GILLT_s64*//*Label 2324*/ GIMT_Encode4(119963), GIMT_Encode4(0),
     /* 119859 */ /*GILLT_v2s32*//*Label 2325*/ GIMT_Encode4(119997), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119871 */ /*GILLT_v4s16*//*Label 2326*/ GIMT_Encode4(120031),
     /* 119875 */ /*GILLT_v4s32*//*Label 2327*/ GIMT_Encode4(120065), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119891 */ /*GILLT_v8s16*//*Label 2328*/ GIMT_Encode4(120244),
     /* 119895 */ // Label 2322: @119895
     /* 119895 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(119928), // Rule ID 642 //
     /* 119900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 119909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119921 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 119921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 119926 */   GIR_RootConstrainSelectedInstOperands,
     /* 119927 */   // GIR_Coverage, 642,
     /* 119927 */   GIR_Done,
     /* 119928 */ // Label 2330: @119928
     /* 119928 */ GIM_Reject,
     /* 119929 */ // Label 2323: @119929
     /* 119929 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(119962), // Rule ID 643 //
     /* 119934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 119943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119955 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 119955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 119960 */   GIR_RootConstrainSelectedInstOperands,
     /* 119961 */   // GIR_Coverage, 643,
     /* 119961 */   GIR_Done,
     /* 119962 */ // Label 2331: @119962
     /* 119962 */ GIM_Reject,
     /* 119963 */ // Label 2324: @119963
     /* 119963 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(119996), // Rule ID 644 //
     /* 119968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 119971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 119977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119989 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 119989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 119994 */   GIR_RootConstrainSelectedInstOperands,
     /* 119995 */   // GIR_Coverage, 644,
     /* 119995 */   GIR_Done,
     /* 119996 */ // Label 2332: @119996
     /* 119996 */ GIM_Reject,
     /* 119997 */ // Label 2325: @119997
     /* 119997 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(120030), // Rule ID 1233 //
     /* 120002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120023 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120028 */   GIR_RootConstrainSelectedInstOperands,
     /* 120029 */   // GIR_Coverage, 1233,
     /* 120029 */   GIR_Done,
     /* 120030 */ // Label 2333: @120030
     /* 120030 */ GIM_Reject,
     /* 120031 */ // Label 2326: @120031
     /* 120031 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120064), // Rule ID 1235 //
     /* 120036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120057 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120062 */   GIR_RootConstrainSelectedInstOperands,
     /* 120063 */   // GIR_Coverage, 1235,
     /* 120063 */   GIR_Done,
     /* 120064 */ // Label 2334: @120064
     /* 120064 */ GIM_Reject,
     /* 120065 */ // Label 2327: @120065
     /* 120065 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120243),
     /* 120070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120076 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120154), // Rule ID 4122 //
     /* 120081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120124 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120152 */     GIR_RootConstrainSelectedInstOperands,
     /* 120153 */     // GIR_Coverage, 4122,
     /* 120153 */     GIR_EraseRootFromParent_Done,
     /* 120154 */   // Label 2336: @120154
     /* 120154 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(120181), // Rule ID 1234 //
     /* 120159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120174 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120179 */     GIR_RootConstrainSelectedInstOperands,
     /* 120180 */     // GIR_Coverage, 1234,
     /* 120180 */     GIR_Done,
     /* 120181 */   // Label 2337: @120181
     /* 120181 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(120242), // Rule ID 3288 //
     /* 120186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120201 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120240 */     GIR_RootConstrainSelectedInstOperands,
     /* 120241 */     // GIR_Coverage, 3288,
     /* 120241 */     GIR_EraseRootFromParent_Done,
     /* 120242 */   // Label 2338: @120242
     /* 120242 */   GIM_Reject,
     /* 120243 */ // Label 2335: @120243
     /* 120243 */ GIM_Reject,
     /* 120244 */ // Label 2328: @120244
     /* 120244 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(120422),
     /* 120249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120255 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120333), // Rule ID 4124 //
     /* 120260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120303 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120331 */     GIR_RootConstrainSelectedInstOperands,
     /* 120332 */     // GIR_Coverage, 4124,
     /* 120332 */     GIR_EraseRootFromParent_Done,
     /* 120333 */   // Label 2340: @120333
     /* 120333 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120360), // Rule ID 1236 //
     /* 120338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120353 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120358 */     GIR_RootConstrainSelectedInstOperands,
     /* 120359 */     // GIR_Coverage, 1236,
     /* 120359 */     GIR_Done,
     /* 120360 */   // Label 2341: @120360
     /* 120360 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120421), // Rule ID 3291 //
     /* 120365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120380 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120419 */     GIR_RootConstrainSelectedInstOperands,
     /* 120420 */     // GIR_Coverage, 3291,
     /* 120420 */     GIR_EraseRootFromParent_Done,
     /* 120421 */   // Label 2342: @120421
     /* 120421 */   GIM_Reject,
     /* 120422 */ // Label 2339: @120422
     /* 120422 */ GIM_Reject,
     /* 120423 */ // Label 2329: @120423
     /* 120423 */ GIM_Reject,
     /* 120424 */ // Label 48: @120424
     /* 120424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2350*/ GIMT_Encode4(121015),
     /* 120435 */ /*GILLT_s16*//*Label 2343*/ GIMT_Encode4(120487),
     /* 120439 */ /*GILLT_s32*//*Label 2344*/ GIMT_Encode4(120521),
     /* 120443 */ /*GILLT_s64*//*Label 2345*/ GIMT_Encode4(120555), GIMT_Encode4(0),
     /* 120451 */ /*GILLT_v2s32*//*Label 2346*/ GIMT_Encode4(120589), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120463 */ /*GILLT_v4s16*//*Label 2347*/ GIMT_Encode4(120623),
     /* 120467 */ /*GILLT_v4s32*//*Label 2348*/ GIMT_Encode4(120657), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120483 */ /*GILLT_v8s16*//*Label 2349*/ GIMT_Encode4(120836),
     /* 120487 */ // Label 2343: @120487
     /* 120487 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(120520), // Rule ID 639 //
     /* 120492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120513 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120518 */   GIR_RootConstrainSelectedInstOperands,
     /* 120519 */   // GIR_Coverage, 639,
     /* 120519 */   GIR_Done,
     /* 120520 */ // Label 2351: @120520
     /* 120520 */ GIM_Reject,
     /* 120521 */ // Label 2344: @120521
     /* 120521 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120554), // Rule ID 640 //
     /* 120526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120547 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120552 */   GIR_RootConstrainSelectedInstOperands,
     /* 120553 */   // GIR_Coverage, 640,
     /* 120553 */   GIR_Done,
     /* 120554 */ // Label 2352: @120554
     /* 120554 */ GIM_Reject,
     /* 120555 */ // Label 2345: @120555
     /* 120555 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(120588), // Rule ID 641 //
     /* 120560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120581 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120586 */   GIR_RootConstrainSelectedInstOperands,
     /* 120587 */   // GIR_Coverage, 641,
     /* 120587 */   GIR_Done,
     /* 120588 */ // Label 2353: @120588
     /* 120588 */ GIM_Reject,
     /* 120589 */ // Label 2346: @120589
     /* 120589 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(120622), // Rule ID 1213 //
     /* 120594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120615 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120620 */   GIR_RootConstrainSelectedInstOperands,
     /* 120621 */   // GIR_Coverage, 1213,
     /* 120621 */   GIR_Done,
     /* 120622 */ // Label 2354: @120622
     /* 120622 */ GIM_Reject,
     /* 120623 */ // Label 2347: @120623
     /* 120623 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120656), // Rule ID 1215 //
     /* 120628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120649 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120654 */   GIR_RootConstrainSelectedInstOperands,
     /* 120655 */   // GIR_Coverage, 1215,
     /* 120655 */   GIR_Done,
     /* 120656 */ // Label 2355: @120656
     /* 120656 */ GIM_Reject,
     /* 120657 */ // Label 2348: @120657
     /* 120657 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120835),
     /* 120662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120668 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120746), // Rule ID 4118 //
     /* 120673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120716 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120744 */     GIR_RootConstrainSelectedInstOperands,
     /* 120745 */     // GIR_Coverage, 4118,
     /* 120745 */     GIR_EraseRootFromParent_Done,
     /* 120746 */   // Label 2357: @120746
     /* 120746 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120773), // Rule ID 1214 //
     /* 120751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120766 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120771 */     GIR_RootConstrainSelectedInstOperands,
     /* 120772 */     // GIR_Coverage, 1214,
     /* 120772 */     GIR_Done,
     /* 120773 */   // Label 2358: @120773
     /* 120773 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(120834), // Rule ID 3030 //
     /* 120778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120793 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120832 */     GIR_RootConstrainSelectedInstOperands,
     /* 120833 */     // GIR_Coverage, 3030,
     /* 120833 */     GIR_EraseRootFromParent_Done,
     /* 120834 */   // Label 2359: @120834
     /* 120834 */   GIM_Reject,
     /* 120835 */ // Label 2356: @120835
     /* 120835 */ GIM_Reject,
     /* 120836 */ // Label 2349: @120836
     /* 120836 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(121014),
     /* 120841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120847 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(120925), // Rule ID 4120 //
     /* 120852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120895 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 120898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120923 */     GIR_RootConstrainSelectedInstOperands,
     /* 120924 */     // GIR_Coverage, 4120,
     /* 120924 */     GIR_EraseRootFromParent_Done,
     /* 120925 */   // Label 2361: @120925
     /* 120925 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(120952), // Rule ID 1216 //
     /* 120930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120945 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 120950 */     GIR_RootConstrainSelectedInstOperands,
     /* 120951 */     // GIR_Coverage, 1216,
     /* 120951 */     GIR_Done,
     /* 120952 */   // Label 2362: @120952
     /* 120952 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(121013), // Rule ID 3285 //
     /* 120957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120972 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 120987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121011 */     GIR_RootConstrainSelectedInstOperands,
     /* 121012 */     // GIR_Coverage, 3285,
     /* 121012 */     GIR_EraseRootFromParent_Done,
     /* 121013 */   // Label 2363: @121013
     /* 121013 */   GIM_Reject,
     /* 121014 */ // Label 2360: @121014
     /* 121014 */ GIM_Reject,
     /* 121015 */ // Label 2350: @121015
     /* 121015 */ GIM_Reject,
     /* 121016 */ // Label 49: @121016
     /* 121016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2370*/ GIMT_Encode4(121749),
     /* 121027 */ /*GILLT_s16*//*Label 2364*/ GIMT_Encode4(121079),
     /* 121031 */ /*GILLT_s32*//*Label 2365*/ GIMT_Encode4(121320), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121043 */ /*GILLT_v2s32*//*Label 2366*/ GIMT_Encode4(121561), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121055 */ /*GILLT_v4s16*//*Label 2367*/ GIMT_Encode4(121608),
     /* 121059 */ /*GILLT_v4s32*//*Label 2368*/ GIMT_Encode4(121655), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121075 */ /*GILLT_v8s16*//*Label 2369*/ GIMT_Encode4(121702),
     /* 121079 */ // Label 2364: @121079
     /* 121079 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(121319), // Rule ID 2707 //
     /* 121084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121105 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121105 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121108 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121112 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121119 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121122 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121126 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121131 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121134 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121139 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121142 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121146 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121151 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121154 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121158 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121161 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121166 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121171 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121176 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121179 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121183 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121190 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121193 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121197 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121202 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121205 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121210 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121213 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121217 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121222 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121225 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121229 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121232 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121237 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121242 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121247 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121250 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121254 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121259 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121262 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121265 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121268 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121288 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121301 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121313 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121318 */   // GIR_Coverage, 2707,
     /* 121318 */   GIR_EraseRootFromParent_Done,
     /* 121319 */ // Label 2371: @121319
     /* 121319 */ GIM_Reject,
     /* 121320 */ // Label 2365: @121320
     /* 121320 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(121560), // Rule ID 2709 //
     /* 121325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121346 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121346 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121349 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121353 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121360 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121363 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121367 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121372 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121375 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121380 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121383 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121387 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121392 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121395 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121399 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121402 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121407 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121412 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121417 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121420 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121424 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121431 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121434 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121438 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121443 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121446 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121463 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121466 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121470 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121473 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121478 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121483 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121488 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121491 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121495 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121500 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121503 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121506 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121509 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121529 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121532 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121542 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121559 */   // GIR_Coverage, 2709,
     /* 121559 */   GIR_EraseRootFromParent_Done,
     /* 121560 */ // Label 2372: @121560
     /* 121560 */ GIM_Reject,
     /* 121561 */ // Label 2366: @121561
     /* 121561 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(121607), // Rule ID 1229 //
     /* 121566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121587 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121592 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121594 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121599 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121605 */   GIR_RootConstrainSelectedInstOperands,
     /* 121606 */   // GIR_Coverage, 1229,
     /* 121606 */   GIR_EraseRootFromParent_Done,
     /* 121607 */ // Label 2373: @121607
     /* 121607 */ GIM_Reject,
     /* 121608 */ // Label 2367: @121608
     /* 121608 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(121654), // Rule ID 1231 //
     /* 121613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121634 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121639 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121641 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121646 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121652 */   GIR_RootConstrainSelectedInstOperands,
     /* 121653 */   // GIR_Coverage, 1231,
     /* 121653 */   GIR_EraseRootFromParent_Done,
     /* 121654 */ // Label 2374: @121654
     /* 121654 */ GIM_Reject,
     /* 121655 */ // Label 2368: @121655
     /* 121655 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121701), // Rule ID 1230 //
     /* 121660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121681 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121686 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121688 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121693 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121699 */   GIR_RootConstrainSelectedInstOperands,
     /* 121700 */   // GIR_Coverage, 1230,
     /* 121700 */   GIR_EraseRootFromParent_Done,
     /* 121701 */ // Label 2375: @121701
     /* 121701 */ GIM_Reject,
     /* 121702 */ // Label 2369: @121702
     /* 121702 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121748), // Rule ID 1232 //
     /* 121707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121728 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121733 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121735 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121740 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121746 */   GIR_RootConstrainSelectedInstOperands,
     /* 121747 */   // GIR_Coverage, 1232,
     /* 121747 */   GIR_EraseRootFromParent_Done,
     /* 121748 */ // Label 2376: @121748
     /* 121748 */ GIM_Reject,
     /* 121749 */ // Label 2370: @121749
     /* 121749 */ GIM_Reject,
     /* 121750 */ // Label 50: @121750
     /* 121750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2383*/ GIMT_Encode4(122483),
     /* 121761 */ /*GILLT_s16*//*Label 2377*/ GIMT_Encode4(121813),
     /* 121765 */ /*GILLT_s32*//*Label 2378*/ GIMT_Encode4(122054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121777 */ /*GILLT_v2s32*//*Label 2379*/ GIMT_Encode4(122295), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121789 */ /*GILLT_v4s16*//*Label 2380*/ GIMT_Encode4(122342),
     /* 121793 */ /*GILLT_v4s32*//*Label 2381*/ GIMT_Encode4(122389), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121809 */ /*GILLT_v8s16*//*Label 2382*/ GIMT_Encode4(122436),
     /* 121813 */ // Label 2377: @121813
     /* 121813 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(122053), // Rule ID 2706 //
     /* 121818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121839 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121839 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121842 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121846 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121853 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121856 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121860 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121865 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121868 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121873 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121876 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121880 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121885 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121888 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121892 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121895 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121900 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121905 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121910 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121913 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121917 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121924 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121927 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121931 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121936 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121939 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121944 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121947 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121951 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121956 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121959 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121963 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121966 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121971 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121976 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121981 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121984 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 121988 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121993 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121996 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121999 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122002 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122022 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122035 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122052 */   // GIR_Coverage, 2706,
     /* 122052 */   GIR_EraseRootFromParent_Done,
     /* 122053 */ // Label 2384: @122053
     /* 122053 */ GIM_Reject,
     /* 122054 */ // Label 2378: @122054
     /* 122054 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(122294), // Rule ID 2708 //
     /* 122059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122080 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122080 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122083 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122087 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122094 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122097 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122101 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122106 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122109 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122114 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122117 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122121 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122126 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122129 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122133 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122136 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122141 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122146 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122151 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122154 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122158 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122165 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122168 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122172 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122177 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122180 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122185 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122188 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122192 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122197 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122200 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122204 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122212 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122217 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122222 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122225 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122229 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122234 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122237 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122240 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122243 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122263 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122266 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122276 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122293 */   // GIR_Coverage, 2708,
     /* 122293 */   GIR_EraseRootFromParent_Done,
     /* 122294 */ // Label 2385: @122294
     /* 122294 */ GIM_Reject,
     /* 122295 */ // Label 2379: @122295
     /* 122295 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(122341), // Rule ID 1209 //
     /* 122300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122321 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122326 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122328 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122339 */   GIR_RootConstrainSelectedInstOperands,
     /* 122340 */   // GIR_Coverage, 1209,
     /* 122340 */   GIR_EraseRootFromParent_Done,
     /* 122341 */ // Label 2386: @122341
     /* 122341 */ GIM_Reject,
     /* 122342 */ // Label 2380: @122342
     /* 122342 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122388), // Rule ID 1211 //
     /* 122347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122368 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122373 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122375 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122386 */   GIR_RootConstrainSelectedInstOperands,
     /* 122387 */   // GIR_Coverage, 1211,
     /* 122387 */   GIR_EraseRootFromParent_Done,
     /* 122388 */ // Label 2387: @122388
     /* 122388 */ GIM_Reject,
     /* 122389 */ // Label 2381: @122389
     /* 122389 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122435), // Rule ID 1210 //
     /* 122394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122415 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122420 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122422 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122427 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122433 */   GIR_RootConstrainSelectedInstOperands,
     /* 122434 */   // GIR_Coverage, 1210,
     /* 122434 */   GIR_EraseRootFromParent_Done,
     /* 122435 */ // Label 2388: @122435
     /* 122435 */ GIM_Reject,
     /* 122436 */ // Label 2382: @122436
     /* 122436 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122482), // Rule ID 1212 //
     /* 122441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122462 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122467 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122469 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122474 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122480 */   GIR_RootConstrainSelectedInstOperands,
     /* 122481 */   // GIR_Coverage, 1212,
     /* 122481 */   GIR_EraseRootFromParent_Done,
     /* 122482 */ // Label 2389: @122482
     /* 122482 */ GIM_Reject,
     /* 122483 */ // Label 2383: @122483
     /* 122483 */ GIM_Reject,
     /* 122484 */ // Label 51: @122484
     /* 122484 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122516), // Rule ID 2419 //
     /* 122489 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122496 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122504 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122514 */   GIR_RootConstrainSelectedInstOperands,
     /* 122515 */   // GIR_Coverage, 2419,
     /* 122515 */   GIR_EraseRootFromParent_Done,
     /* 122516 */ // Label 2390: @122516
     /* 122516 */ GIM_Reject,
     /* 122517 */ // Label 52: @122517
     /* 122517 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122552), // Rule ID 2420 //
     /* 122522 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122529 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122532 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122537 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122543 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122550 */   GIR_RootConstrainSelectedInstOperands,
     /* 122551 */   // GIR_Coverage, 2420,
     /* 122551 */   GIR_EraseRootFromParent_Done,
     /* 122552 */ // Label 2391: @122552
     /* 122552 */ GIM_Reject,
     /* 122553 */ // Label 53: @122553
     /* 122553 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122617), // Rule ID 2421 //
     /* 122558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122561 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122573 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122576 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122579 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122585 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122602 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122608 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122615 */   GIR_RootConstrainSelectedInstOperands,
     /* 122616 */   // GIR_Coverage, 2421,
     /* 122616 */   GIR_EraseRootFromParent_Done,
     /* 122617 */ // Label 2392: @122617
     /* 122617 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122681), // Rule ID 2422 //
     /* 122622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122625 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122637 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122643 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122646 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122649 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122666 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122672 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122679 */   GIR_RootConstrainSelectedInstOperands,
     /* 122680 */   // GIR_Coverage, 2422,
     /* 122680 */   GIR_EraseRootFromParent_Done,
     /* 122681 */ // Label 2393: @122681
     /* 122681 */ GIM_Reject,
     /* 122682 */ // Label 54: @122682
     /* 122682 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122714), // Rule ID 2423 //
     /* 122687 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122694 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122712 */   GIR_RootConstrainSelectedInstOperands,
     /* 122713 */   // GIR_Coverage, 2423,
     /* 122713 */   GIR_EraseRootFromParent_Done,
     /* 122714 */ // Label 2394: @122714
     /* 122714 */ GIM_Reject,
     /* 122715 */ // Label 55: @122715
     /* 122715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2401*/ GIMT_Encode4(123257),
     /* 122726 */ /*GILLT_v2s32*//*Label 2395*/ GIMT_Encode4(122774), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122738 */ /*GILLT_v4s16*//*Label 2396*/ GIMT_Encode4(122821),
     /* 122742 */ /*GILLT_v4s32*//*Label 2397*/ GIMT_Encode4(122868), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122754 */ /*GILLT_v8s8*//*Label 2398*/ GIMT_Encode4(122982),
     /* 122758 */ /*GILLT_v8s16*//*Label 2399*/ GIMT_Encode4(123029), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122770 */ /*GILLT_v16s8*//*Label 2400*/ GIMT_Encode4(123143),
     /* 122774 */ // Label 2395: @122774
     /* 122774 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(122820), // Rule ID 1218 //
     /* 122779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122800 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122805 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122807 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122812 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122818 */   GIR_RootConstrainSelectedInstOperands,
     /* 122819 */   // GIR_Coverage, 1218,
     /* 122819 */   GIR_EraseRootFromParent_Done,
     /* 122820 */ // Label 2402: @122820
     /* 122820 */ GIM_Reject,
     /* 122821 */ // Label 2396: @122821
     /* 122821 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(122867), // Rule ID 1217 //
     /* 122826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122847 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 122847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 122850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122852 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122854 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122865 */   GIR_RootConstrainSelectedInstOperands,
     /* 122866 */   // GIR_Coverage, 1217,
     /* 122866 */   GIR_EraseRootFromParent_Done,
     /* 122867 */ // Label 2403: @122867
     /* 122867 */ GIM_Reject,
     /* 122868 */ // Label 2397: @122868
     /* 122868 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(122981),
     /* 122873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122879 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(122919), // Rule ID 1220 //
     /* 122884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122899 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 122899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 122902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122917 */     GIR_RootConstrainSelectedInstOperands,
     /* 122918 */     // GIR_Coverage, 1220,
     /* 122918 */     GIR_EraseRootFromParent_Done,
     /* 122919 */   // Label 2405: @122919
     /* 122919 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(122980), // Rule ID 3300 //
     /* 122924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122939 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 122939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 122954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122978 */     GIR_RootConstrainSelectedInstOperands,
     /* 122979 */     // GIR_Coverage, 3300,
     /* 122979 */     GIR_EraseRootFromParent_Done,
     /* 122980 */   // Label 2406: @122980
     /* 122980 */   GIM_Reject,
     /* 122981 */ // Label 2404: @122981
     /* 122981 */ GIM_Reject,
     /* 122982 */ // Label 2398: @122982
     /* 122982 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123028), // Rule ID 1221 //
     /* 122987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 122993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 122996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123008 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123013 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123015 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123020 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123026 */   GIR_RootConstrainSelectedInstOperands,
     /* 123027 */   // GIR_Coverage, 1221,
     /* 123027 */   GIR_EraseRootFromParent_Done,
     /* 123028 */ // Label 2407: @123028
     /* 123028 */ GIM_Reject,
     /* 123029 */ // Label 2399: @123029
     /* 123029 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(123142),
     /* 123034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123040 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(123080), // Rule ID 1219 //
     /* 123045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123060 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123078 */     GIR_RootConstrainSelectedInstOperands,
     /* 123079 */     // GIR_Coverage, 1219,
     /* 123079 */     GIR_EraseRootFromParent_Done,
     /* 123080 */   // Label 2409: @123080
     /* 123080 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(123141), // Rule ID 3297 //
     /* 123085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123100 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123139 */     GIR_RootConstrainSelectedInstOperands,
     /* 123140 */     // GIR_Coverage, 3297,
     /* 123140 */     GIR_EraseRootFromParent_Done,
     /* 123141 */   // Label 2410: @123141
     /* 123141 */   GIM_Reject,
     /* 123142 */ // Label 2408: @123142
     /* 123142 */ GIM_Reject,
     /* 123143 */ // Label 2400: @123143
     /* 123143 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(123256),
     /* 123148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123154 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(123194), // Rule ID 1222 //
     /* 123159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123174 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123192 */     GIR_RootConstrainSelectedInstOperands,
     /* 123193 */     // GIR_Coverage, 1222,
     /* 123193 */     GIR_EraseRootFromParent_Done,
     /* 123194 */   // Label 2412: @123194
     /* 123194 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(123255), // Rule ID 3294 //
     /* 123199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123214 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123253 */     GIR_RootConstrainSelectedInstOperands,
     /* 123254 */     // GIR_Coverage, 3294,
     /* 123254 */     GIR_EraseRootFromParent_Done,
     /* 123255 */   // Label 2413: @123255
     /* 123255 */   GIM_Reject,
     /* 123256 */ // Label 2411: @123256
     /* 123256 */ GIM_Reject,
     /* 123257 */ // Label 2401: @123257
     /* 123257 */ GIM_Reject,
     /* 123258 */ // Label 56: @123258
     /* 123258 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2420*/ GIMT_Encode4(123800),
     /* 123269 */ /*GILLT_v2s32*//*Label 2414*/ GIMT_Encode4(123317), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123281 */ /*GILLT_v4s16*//*Label 2415*/ GIMT_Encode4(123364),
     /* 123285 */ /*GILLT_v4s32*//*Label 2416*/ GIMT_Encode4(123411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123297 */ /*GILLT_v8s8*//*Label 2417*/ GIMT_Encode4(123525),
     /* 123301 */ /*GILLT_v8s16*//*Label 2418*/ GIMT_Encode4(123572), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123313 */ /*GILLT_v16s8*//*Label 2419*/ GIMT_Encode4(123686),
     /* 123317 */ // Label 2414: @123317
     /* 123317 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(123363), // Rule ID 1198 //
     /* 123322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123343 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123348 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123350 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123361 */   GIR_RootConstrainSelectedInstOperands,
     /* 123362 */   // GIR_Coverage, 1198,
     /* 123362 */   GIR_EraseRootFromParent_Done,
     /* 123363 */ // Label 2421: @123363
     /* 123363 */ GIM_Reject,
     /* 123364 */ // Label 2415: @123364
     /* 123364 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123410), // Rule ID 1197 //
     /* 123369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123390 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123395 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123397 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123402 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123408 */   GIR_RootConstrainSelectedInstOperands,
     /* 123409 */   // GIR_Coverage, 1197,
     /* 123409 */   GIR_EraseRootFromParent_Done,
     /* 123410 */ // Label 2422: @123410
     /* 123410 */ GIM_Reject,
     /* 123411 */ // Label 2416: @123411
     /* 123411 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123524),
     /* 123416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123422 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123462), // Rule ID 1200 //
     /* 123427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123442 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123460 */     GIR_RootConstrainSelectedInstOperands,
     /* 123461 */     // GIR_Coverage, 1200,
     /* 123461 */     GIR_EraseRootFromParent_Done,
     /* 123462 */   // Label 2424: @123462
     /* 123462 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123523), // Rule ID 3318 //
     /* 123467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123482 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123521 */     GIR_RootConstrainSelectedInstOperands,
     /* 123522 */     // GIR_Coverage, 3318,
     /* 123522 */     GIR_EraseRootFromParent_Done,
     /* 123523 */   // Label 2425: @123523
     /* 123523 */   GIM_Reject,
     /* 123524 */ // Label 2423: @123524
     /* 123524 */ GIM_Reject,
     /* 123525 */ // Label 2417: @123525
     /* 123525 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123571), // Rule ID 1201 //
     /* 123530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123551 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123556 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123558 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123563 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123569 */   GIR_RootConstrainSelectedInstOperands,
     /* 123570 */   // GIR_Coverage, 1201,
     /* 123570 */   GIR_EraseRootFromParent_Done,
     /* 123571 */ // Label 2426: @123571
     /* 123571 */ GIM_Reject,
     /* 123572 */ // Label 2418: @123572
     /* 123572 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123685),
     /* 123577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123583 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123623), // Rule ID 1199 //
     /* 123588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123603 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123621 */     GIR_RootConstrainSelectedInstOperands,
     /* 123622 */     // GIR_Coverage, 1199,
     /* 123622 */     GIR_EraseRootFromParent_Done,
     /* 123623 */   // Label 2428: @123623
     /* 123623 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123684), // Rule ID 3315 //
     /* 123628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123643 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123682 */     GIR_RootConstrainSelectedInstOperands,
     /* 123683 */     // GIR_Coverage, 3315,
     /* 123683 */     GIR_EraseRootFromParent_Done,
     /* 123684 */   // Label 2429: @123684
     /* 123684 */   GIM_Reject,
     /* 123685 */ // Label 2427: @123685
     /* 123685 */ GIM_Reject,
     /* 123686 */ // Label 2419: @123686
     /* 123686 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123799),
     /* 123691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123697 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123737), // Rule ID 1202 //
     /* 123702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123717 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123735 */     GIR_RootConstrainSelectedInstOperands,
     /* 123736 */     // GIR_Coverage, 1202,
     /* 123736 */     GIR_EraseRootFromParent_Done,
     /* 123737 */   // Label 2431: @123737
     /* 123737 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123798), // Rule ID 3312 //
     /* 123742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123757 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123796 */     GIR_RootConstrainSelectedInstOperands,
     /* 123797 */     // GIR_Coverage, 3312,
     /* 123797 */     GIR_EraseRootFromParent_Done,
     /* 123798 */   // Label 2432: @123798
     /* 123798 */   GIM_Reject,
     /* 123799 */ // Label 2430: @123799
     /* 123799 */ GIM_Reject,
     /* 123800 */ // Label 2420: @123800
     /* 123800 */ GIM_Reject,
     /* 123801 */ // Label 57: @123801
     /* 123801 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2439*/ GIMT_Encode4(124721),
     /* 123812 */ /*GILLT_v2s32*//*Label 2433*/ GIMT_Encode4(123860), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123824 */ /*GILLT_v4s16*//*Label 2434*/ GIMT_Encode4(123907),
     /* 123828 */ /*GILLT_v4s32*//*Label 2435*/ GIMT_Encode4(123954), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123840 */ /*GILLT_v8s8*//*Label 2436*/ GIMT_Encode4(124194),
     /* 123844 */ /*GILLT_v8s16*//*Label 2437*/ GIMT_Encode4(124241), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123856 */ /*GILLT_v16s8*//*Label 2438*/ GIMT_Encode4(124481),
     /* 123860 */ // Label 2433: @123860
     /* 123860 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(123906), // Rule ID 1224 //
     /* 123865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123886 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 123889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123891 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123893 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123898 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123904 */   GIR_RootConstrainSelectedInstOperands,
     /* 123905 */   // GIR_Coverage, 1224,
     /* 123905 */   GIR_EraseRootFromParent_Done,
     /* 123906 */ // Label 2440: @123906
     /* 123906 */ GIM_Reject,
     /* 123907 */ // Label 2434: @123907
     /* 123907 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(123953), // Rule ID 1223 //
     /* 123912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123933 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 123936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123938 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123940 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123945 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123951 */   GIR_RootConstrainSelectedInstOperands,
     /* 123952 */   // GIR_Coverage, 1223,
     /* 123952 */   GIR_EraseRootFromParent_Done,
     /* 123953 */ // Label 2441: @123953
     /* 123953 */ GIM_Reject,
     /* 123954 */ // Label 2435: @123954
     /* 123954 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(124193),
     /* 123959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123965 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(124028), // Rule ID 6027 //
     /* 123970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124000 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124026 */     GIR_RootConstrainSelectedInstOperands,
     /* 124027 */     // GIR_Coverage, 6027,
     /* 124027 */     GIR_EraseRootFromParent_Done,
     /* 124028 */   // Label 2443: @124028
     /* 124028 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124091), // Rule ID 3697 //
     /* 124033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124063 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124089 */     GIR_RootConstrainSelectedInstOperands,
     /* 124090 */     // GIR_Coverage, 3697,
     /* 124090 */     GIR_EraseRootFromParent_Done,
     /* 124091 */   // Label 2444: @124091
     /* 124091 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124131), // Rule ID 1226 //
     /* 124096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124111 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124129 */     GIR_RootConstrainSelectedInstOperands,
     /* 124130 */     // GIR_Coverage, 1226,
     /* 124130 */     GIR_EraseRootFromParent_Done,
     /* 124131 */   // Label 2445: @124131
     /* 124131 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124192), // Rule ID 3309 //
     /* 124136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124151 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124190 */     GIR_RootConstrainSelectedInstOperands,
     /* 124191 */     // GIR_Coverage, 3309,
     /* 124191 */     GIR_EraseRootFromParent_Done,
     /* 124192 */   // Label 2446: @124192
     /* 124192 */   GIM_Reject,
     /* 124193 */ // Label 2442: @124193
     /* 124193 */ GIM_Reject,
     /* 124194 */ // Label 2436: @124194
     /* 124194 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124240), // Rule ID 1227 //
     /* 124199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124220 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124227 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124232 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124238 */   GIR_RootConstrainSelectedInstOperands,
     /* 124239 */   // GIR_Coverage, 1227,
     /* 124239 */   GIR_EraseRootFromParent_Done,
     /* 124240 */ // Label 2447: @124240
     /* 124240 */ GIM_Reject,
     /* 124241 */ // Label 2437: @124241
     /* 124241 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124480),
     /* 124246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124252 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124315), // Rule ID 6026 //
     /* 124257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124287 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124313 */     GIR_RootConstrainSelectedInstOperands,
     /* 124314 */     // GIR_Coverage, 6026,
     /* 124314 */     GIR_EraseRootFromParent_Done,
     /* 124315 */   // Label 2449: @124315
     /* 124315 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124378), // Rule ID 3695 //
     /* 124320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124350 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124376 */     GIR_RootConstrainSelectedInstOperands,
     /* 124377 */     // GIR_Coverage, 3695,
     /* 124377 */     GIR_EraseRootFromParent_Done,
     /* 124378 */   // Label 2450: @124378
     /* 124378 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124418), // Rule ID 1225 //
     /* 124383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124398 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124416 */     GIR_RootConstrainSelectedInstOperands,
     /* 124417 */     // GIR_Coverage, 1225,
     /* 124417 */     GIR_EraseRootFromParent_Done,
     /* 124418 */   // Label 2451: @124418
     /* 124418 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124479), // Rule ID 3306 //
     /* 124423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124438 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124477 */     GIR_RootConstrainSelectedInstOperands,
     /* 124478 */     // GIR_Coverage, 3306,
     /* 124478 */     GIR_EraseRootFromParent_Done,
     /* 124479 */   // Label 2452: @124479
     /* 124479 */   GIM_Reject,
     /* 124480 */ // Label 2448: @124480
     /* 124480 */ GIM_Reject,
     /* 124481 */ // Label 2438: @124481
     /* 124481 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124720),
     /* 124486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124492 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124555), // Rule ID 6025 //
     /* 124497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124527 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124553 */     GIR_RootConstrainSelectedInstOperands,
     /* 124554 */     // GIR_Coverage, 6025,
     /* 124554 */     GIR_EraseRootFromParent_Done,
     /* 124555 */   // Label 2454: @124555
     /* 124555 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124618), // Rule ID 3693 //
     /* 124560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124590 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124616 */     GIR_RootConstrainSelectedInstOperands,
     /* 124617 */     // GIR_Coverage, 3693,
     /* 124617 */     GIR_EraseRootFromParent_Done,
     /* 124618 */   // Label 2455: @124618
     /* 124618 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124658), // Rule ID 1228 //
     /* 124623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124638 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124656 */     GIR_RootConstrainSelectedInstOperands,
     /* 124657 */     // GIR_Coverage, 1228,
     /* 124657 */     GIR_EraseRootFromParent_Done,
     /* 124658 */   // Label 2456: @124658
     /* 124658 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124719), // Rule ID 3303 //
     /* 124663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124678 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124717 */     GIR_RootConstrainSelectedInstOperands,
     /* 124718 */     // GIR_Coverage, 3303,
     /* 124718 */     GIR_EraseRootFromParent_Done,
     /* 124719 */   // Label 2457: @124719
     /* 124719 */   GIM_Reject,
     /* 124720 */ // Label 2453: @124720
     /* 124720 */ GIM_Reject,
     /* 124721 */ // Label 2439: @124721
     /* 124721 */ GIM_Reject,
     /* 124722 */ // Label 58: @124722
     /* 124722 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2464*/ GIMT_Encode4(125642),
     /* 124733 */ /*GILLT_v2s32*//*Label 2458*/ GIMT_Encode4(124781), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124745 */ /*GILLT_v4s16*//*Label 2459*/ GIMT_Encode4(124828),
     /* 124749 */ /*GILLT_v4s32*//*Label 2460*/ GIMT_Encode4(124875), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124761 */ /*GILLT_v8s8*//*Label 2461*/ GIMT_Encode4(125115),
     /* 124765 */ /*GILLT_v8s16*//*Label 2462*/ GIMT_Encode4(125162), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124777 */ /*GILLT_v16s8*//*Label 2463*/ GIMT_Encode4(125402),
     /* 124781 */ // Label 2458: @124781
     /* 124781 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(124827), // Rule ID 1204 //
     /* 124786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124807 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124812 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124814 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124819 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124825 */   GIR_RootConstrainSelectedInstOperands,
     /* 124826 */   // GIR_Coverage, 1204,
     /* 124826 */   GIR_EraseRootFromParent_Done,
     /* 124827 */ // Label 2465: @124827
     /* 124827 */ GIM_Reject,
     /* 124828 */ // Label 2459: @124828
     /* 124828 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(124874), // Rule ID 1203 //
     /* 124833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124854 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 124857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124859 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124861 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124872 */   GIR_RootConstrainSelectedInstOperands,
     /* 124873 */   // GIR_Coverage, 1203,
     /* 124873 */   GIR_EraseRootFromParent_Done,
     /* 124874 */ // Label 2466: @124874
     /* 124874 */ GIM_Reject,
     /* 124875 */ // Label 2460: @124875
     /* 124875 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(125114),
     /* 124880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124886 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(124949), // Rule ID 6030 //
     /* 124891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124921 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124947 */     GIR_RootConstrainSelectedInstOperands,
     /* 124948 */     // GIR_Coverage, 6030,
     /* 124948 */     GIR_EraseRootFromParent_Done,
     /* 124949 */   // Label 2468: @124949
     /* 124949 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125012), // Rule ID 3703 //
     /* 124954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124984 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125010 */     GIR_RootConstrainSelectedInstOperands,
     /* 125011 */     // GIR_Coverage, 3703,
     /* 125011 */     GIR_EraseRootFromParent_Done,
     /* 125012 */   // Label 2469: @125012
     /* 125012 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125052), // Rule ID 1206 //
     /* 125017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125032 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125050 */     GIR_RootConstrainSelectedInstOperands,
     /* 125051 */     // GIR_Coverage, 1206,
     /* 125051 */     GIR_EraseRootFromParent_Done,
     /* 125052 */   // Label 2470: @125052
     /* 125052 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125113), // Rule ID 3327 //
     /* 125057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125072 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125111 */     GIR_RootConstrainSelectedInstOperands,
     /* 125112 */     // GIR_Coverage, 3327,
     /* 125112 */     GIR_EraseRootFromParent_Done,
     /* 125113 */   // Label 2471: @125113
     /* 125113 */   GIM_Reject,
     /* 125114 */ // Label 2467: @125114
     /* 125114 */ GIM_Reject,
     /* 125115 */ // Label 2461: @125115
     /* 125115 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125161), // Rule ID 1207 //
     /* 125120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125141 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125146 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125148 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125153 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125159 */   GIR_RootConstrainSelectedInstOperands,
     /* 125160 */   // GIR_Coverage, 1207,
     /* 125160 */   GIR_EraseRootFromParent_Done,
     /* 125161 */ // Label 2472: @125161
     /* 125161 */ GIM_Reject,
     /* 125162 */ // Label 2462: @125162
     /* 125162 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125401),
     /* 125167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125173 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125236), // Rule ID 6029 //
     /* 125178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125208 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125234 */     GIR_RootConstrainSelectedInstOperands,
     /* 125235 */     // GIR_Coverage, 6029,
     /* 125235 */     GIR_EraseRootFromParent_Done,
     /* 125236 */   // Label 2474: @125236
     /* 125236 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125299), // Rule ID 3701 //
     /* 125241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125271 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125297 */     GIR_RootConstrainSelectedInstOperands,
     /* 125298 */     // GIR_Coverage, 3701,
     /* 125298 */     GIR_EraseRootFromParent_Done,
     /* 125299 */   // Label 2475: @125299
     /* 125299 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125339), // Rule ID 1205 //
     /* 125304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125319 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125337 */     GIR_RootConstrainSelectedInstOperands,
     /* 125338 */     // GIR_Coverage, 1205,
     /* 125338 */     GIR_EraseRootFromParent_Done,
     /* 125339 */   // Label 2476: @125339
     /* 125339 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125400), // Rule ID 3324 //
     /* 125344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125359 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125398 */     GIR_RootConstrainSelectedInstOperands,
     /* 125399 */     // GIR_Coverage, 3324,
     /* 125399 */     GIR_EraseRootFromParent_Done,
     /* 125400 */   // Label 2477: @125400
     /* 125400 */   GIM_Reject,
     /* 125401 */ // Label 2473: @125401
     /* 125401 */ GIM_Reject,
     /* 125402 */ // Label 2463: @125402
     /* 125402 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125641),
     /* 125407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125413 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125476), // Rule ID 6028 //
     /* 125418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125448 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125474 */     GIR_RootConstrainSelectedInstOperands,
     /* 125475 */     // GIR_Coverage, 6028,
     /* 125475 */     GIR_EraseRootFromParent_Done,
     /* 125476 */   // Label 2479: @125476
     /* 125476 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125539), // Rule ID 3699 //
     /* 125481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125511 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125537 */     GIR_RootConstrainSelectedInstOperands,
     /* 125538 */     // GIR_Coverage, 3699,
     /* 125538 */     GIR_EraseRootFromParent_Done,
     /* 125539 */   // Label 2480: @125539
     /* 125539 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125579), // Rule ID 1208 //
     /* 125544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125559 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125577 */     GIR_RootConstrainSelectedInstOperands,
     /* 125578 */     // GIR_Coverage, 1208,
     /* 125578 */     GIR_EraseRootFromParent_Done,
     /* 125579 */   // Label 2481: @125579
     /* 125579 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125640), // Rule ID 3321 //
     /* 125584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125599 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125638 */     GIR_RootConstrainSelectedInstOperands,
     /* 125639 */     // GIR_Coverage, 3321,
     /* 125639 */     GIR_EraseRootFromParent_Done,
     /* 125640 */   // Label 2482: @125640
     /* 125640 */   GIM_Reject,
     /* 125641 */ // Label 2478: @125641
     /* 125641 */ GIM_Reject,
     /* 125642 */ // Label 2464: @125642
     /* 125642 */ GIM_Reject,
     /* 125643 */ // Label 59: @125643
     /* 125643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2489*/ GIMT_Encode4(126113),
     /* 125654 */ /*GILLT_v2s32*//*Label 2483*/ GIMT_Encode4(125702), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125666 */ /*GILLT_v4s16*//*Label 2484*/ GIMT_Encode4(125740),
     /* 125670 */ /*GILLT_v4s32*//*Label 2485*/ GIMT_Encode4(125778), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125682 */ /*GILLT_v8s8*//*Label 2486*/ GIMT_Encode4(125877),
     /* 125686 */ /*GILLT_v8s16*//*Label 2487*/ GIMT_Encode4(125915), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125698 */ /*GILLT_v16s8*//*Label 2488*/ GIMT_Encode4(126014),
     /* 125702 */ // Label 2483: @125702
     /* 125702 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(125739), // Rule ID 1510 //
     /* 125707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125721 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125726 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125731 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125737 */   GIR_RootConstrainSelectedInstOperands,
     /* 125738 */   // GIR_Coverage, 1510,
     /* 125738 */   GIR_EraseRootFromParent_Done,
     /* 125739 */ // Label 2490: @125739
     /* 125739 */ GIM_Reject,
     /* 125740 */ // Label 2484: @125740
     /* 125740 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(125777), // Rule ID 1509 //
     /* 125745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125759 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125764 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125769 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125775 */   GIR_RootConstrainSelectedInstOperands,
     /* 125776 */   // GIR_Coverage, 1509,
     /* 125776 */   GIR_EraseRootFromParent_Done,
     /* 125777 */ // Label 2491: @125777
     /* 125777 */ GIM_Reject,
     /* 125778 */ // Label 2485: @125778
     /* 125778 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(125876),
     /* 125783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125786 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(125820), // Rule ID 1513 //
     /* 125791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125802 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125818 */     GIR_RootConstrainSelectedInstOperands,
     /* 125819 */     // GIR_Coverage, 1513,
     /* 125819 */     GIR_EraseRootFromParent_Done,
     /* 125820 */   // Label 2493: @125820
     /* 125820 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(125875), // Rule ID 3672 //
     /* 125825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125836 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 125836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 125851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125853 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125873 */     GIR_RootConstrainSelectedInstOperands,
     /* 125874 */     // GIR_Coverage, 3672,
     /* 125874 */     GIR_EraseRootFromParent_Done,
     /* 125875 */   // Label 2494: @125875
     /* 125875 */   GIM_Reject,
     /* 125876 */ // Label 2492: @125876
     /* 125876 */ GIM_Reject,
     /* 125877 */ // Label 2486: @125877
     /* 125877 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(125914), // Rule ID 1508 //
     /* 125882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125896 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 125896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 125899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125901 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125906 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125912 */   GIR_RootConstrainSelectedInstOperands,
     /* 125913 */   // GIR_Coverage, 1508,
     /* 125913 */   GIR_EraseRootFromParent_Done,
     /* 125914 */ // Label 2495: @125914
     /* 125914 */ GIM_Reject,
     /* 125915 */ // Label 2487: @125915
     /* 125915 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126013),
     /* 125920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125923 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(125957), // Rule ID 1512 //
     /* 125928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125939 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 125939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 125942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125955 */     GIR_RootConstrainSelectedInstOperands,
     /* 125956 */     // GIR_Coverage, 1512,
     /* 125956 */     GIR_EraseRootFromParent_Done,
     /* 125957 */   // Label 2497: @125957
     /* 125957 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126012), // Rule ID 3666 //
     /* 125962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125973 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 125973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 125988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125990 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126010 */     GIR_RootConstrainSelectedInstOperands,
     /* 126011 */     // GIR_Coverage, 3666,
     /* 126011 */     GIR_EraseRootFromParent_Done,
     /* 126012 */   // Label 2498: @126012
     /* 126012 */   GIM_Reject,
     /* 126013 */ // Label 2496: @126013
     /* 126013 */ GIM_Reject,
     /* 126014 */ // Label 2488: @126014
     /* 126014 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126112),
     /* 126019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126022 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(126056), // Rule ID 1511 //
     /* 126027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126038 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126054 */     GIR_RootConstrainSelectedInstOperands,
     /* 126055 */     // GIR_Coverage, 1511,
     /* 126055 */     GIR_EraseRootFromParent_Done,
     /* 126056 */   // Label 2500: @126056
     /* 126056 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(126111), // Rule ID 3660 //
     /* 126061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126072 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126089 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126109 */     GIR_RootConstrainSelectedInstOperands,
     /* 126110 */     // GIR_Coverage, 3660,
     /* 126110 */     GIR_EraseRootFromParent_Done,
     /* 126111 */   // Label 2501: @126111
     /* 126111 */   GIM_Reject,
     /* 126112 */ // Label 2499: @126112
     /* 126112 */ GIM_Reject,
     /* 126113 */ // Label 2489: @126113
     /* 126113 */ GIM_Reject,
     /* 126114 */ // Label 60: @126114
     /* 126114 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(126186),
     /* 126119 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126122 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(126137), // Rule ID 32 //
     /* 126127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126130 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126135 */     GIR_RootConstrainSelectedInstOperands,
     /* 126136 */     // GIR_Coverage, 32,
     /* 126136 */     GIR_Done,
     /* 126137 */   // Label 2503: @126137
     /* 126137 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(126161), // Rule ID 283 //
     /* 126142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126145 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126148 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126159 */     GIR_RootConstrainSelectedInstOperands,
     /* 126160 */     // GIR_Coverage, 283,
     /* 126160 */     GIR_EraseRootFromParent_Done,
     /* 126161 */   // Label 2504: @126161
     /* 126161 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126185), // Rule ID 577 //
     /* 126166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126169 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126172 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126183 */     GIR_RootConstrainSelectedInstOperands,
     /* 126184 */     // GIR_Coverage, 577,
     /* 126184 */     GIR_EraseRootFromParent_Done,
     /* 126185 */   // Label 2505: @126185
     /* 126185 */   GIM_Reject,
     /* 126186 */ // Label 2502: @126186
     /* 126186 */ GIM_Reject,
     /* 126187 */ // Label 61: @126187
     /* 126187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2510*/ GIMT_Encode4(126486),
     /* 126198 */ /*GILLT_v4s16*//*Label 2506*/ GIMT_Encode4(126234), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126214 */ /*GILLT_v8s8*//*Label 2507*/ GIMT_Encode4(126297),
     /* 126218 */ /*GILLT_v8s16*//*Label 2508*/ GIMT_Encode4(126360), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126230 */ /*GILLT_v16s8*//*Label 2509*/ GIMT_Encode4(126423),
     /* 126234 */ // Label 2506: @126234
     /* 126234 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(126296), // Rule ID 1572 //
     /* 126239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126263 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126271 */   // MIs[1] Operand 1
     /* 126271 */   // No operand predicates
     /* 126271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126273 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126278 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126280 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126282 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126294 */   GIR_RootConstrainSelectedInstOperands,
     /* 126295 */   // GIR_Coverage, 1572,
     /* 126295 */   GIR_EraseRootFromParent_Done,
     /* 126296 */ // Label 2511: @126296
     /* 126296 */ GIM_Reject,
     /* 126297 */ // Label 2507: @126297
     /* 126297 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(126359), // Rule ID 1571 //
     /* 126302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126326 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126330 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126334 */   // MIs[1] Operand 1
     /* 126334 */   // No operand predicates
     /* 126334 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126336 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126341 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126343 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126345 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126351 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126357 */   GIR_RootConstrainSelectedInstOperands,
     /* 126358 */   // GIR_Coverage, 1571,
     /* 126358 */   GIR_EraseRootFromParent_Done,
     /* 126359 */ // Label 2512: @126359
     /* 126359 */ GIM_Reject,
     /* 126360 */ // Label 2508: @126360
     /* 126360 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(126422), // Rule ID 3436 //
     /* 126365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126397 */   // MIs[1] Operand 1
     /* 126397 */   // No operand predicates
     /* 126397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126399 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126404 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126406 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126408 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126420 */   GIR_RootConstrainSelectedInstOperands,
     /* 126421 */   // GIR_Coverage, 3436,
     /* 126421 */   GIR_EraseRootFromParent_Done,
     /* 126422 */ // Label 2513: @126422
     /* 126422 */ GIM_Reject,
     /* 126423 */ // Label 2509: @126423
     /* 126423 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(126485), // Rule ID 3435 //
     /* 126428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126452 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126460 */   // MIs[1] Operand 1
     /* 126460 */   // No operand predicates
     /* 126460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126462 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126469 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126471 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126477 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126483 */   GIR_RootConstrainSelectedInstOperands,
     /* 126484 */   // GIR_Coverage, 3435,
     /* 126484 */   GIR_EraseRootFromParent_Done,
     /* 126485 */ // Label 2514: @126485
     /* 126485 */ GIM_Reject,
     /* 126486 */ // Label 2510: @126486
     /* 126486 */ GIM_Reject,
     /* 126487 */ // Label 62: @126487
     /* 126487 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126543), // Rule ID 1570 //
     /* 126492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126495 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126520 */   // MIs[1] Operand 1
     /* 126520 */   // No operand predicates
     /* 126520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126522 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126527 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126529 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126535 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126541 */   GIR_RootConstrainSelectedInstOperands,
     /* 126542 */   // GIR_Coverage, 1570,
     /* 126542 */   GIR_EraseRootFromParent_Done,
     /* 126543 */ // Label 2515: @126543
     /* 126543 */ GIM_Reject,
     /* 126544 */ // Label 63: @126544
     /* 126544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2523*/ GIMT_Encode4(127104),
     /* 126555 */ /*GILLT_s32*//*Label 2516*/ GIMT_Encode4(126615), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126567 */ /*GILLT_v2s32*//*Label 2517*/ GIMT_Encode4(126693), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126579 */ /*GILLT_v4s16*//*Label 2518*/ GIMT_Encode4(126731),
     /* 126583 */ /*GILLT_v4s32*//*Label 2519*/ GIMT_Encode4(126769), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126595 */ /*GILLT_v8s8*//*Label 2520*/ GIMT_Encode4(126868),
     /* 126599 */ /*GILLT_v8s16*//*Label 2521*/ GIMT_Encode4(126906), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126611 */ /*GILLT_v16s8*//*Label 2522*/ GIMT_Encode4(127005),
     /* 126615 */ // Label 2516: @126615
     /* 126615 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(126692),
     /* 126620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126623 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(126657), // Rule ID 197 //
     /* 126628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126639 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126655 */     GIR_RootConstrainSelectedInstOperands,
     /* 126656 */     // GIR_Coverage, 197,
     /* 126656 */     GIR_EraseRootFromParent_Done,
     /* 126657 */   // Label 2525: @126657
     /* 126657 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(126691), // Rule ID 534 //
     /* 126662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126673 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126689 */     GIR_RootConstrainSelectedInstOperands,
     /* 126690 */     // GIR_Coverage, 534,
     /* 126690 */     GIR_EraseRootFromParent_Done,
     /* 126691 */   // Label 2526: @126691
     /* 126691 */   GIM_Reject,
     /* 126692 */ // Label 2524: @126692
     /* 126692 */ GIM_Reject,
     /* 126693 */ // Label 2517: @126693
     /* 126693 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(126730), // Rule ID 1548 //
     /* 126698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126712 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126717 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126722 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126728 */   GIR_RootConstrainSelectedInstOperands,
     /* 126729 */   // GIR_Coverage, 1548,
     /* 126729 */   GIR_EraseRootFromParent_Done,
     /* 126730 */ // Label 2527: @126730
     /* 126730 */ GIM_Reject,
     /* 126731 */ // Label 2518: @126731
     /* 126731 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126768), // Rule ID 1547 //
     /* 126736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126750 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126760 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126766 */   GIR_RootConstrainSelectedInstOperands,
     /* 126767 */   // GIR_Coverage, 1547,
     /* 126767 */   GIR_EraseRootFromParent_Done,
     /* 126768 */ // Label 2528: @126768
     /* 126768 */ GIM_Reject,
     /* 126769 */ // Label 2519: @126769
     /* 126769 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(126867),
     /* 126774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126777 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(126811), // Rule ID 1551 //
     /* 126782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126793 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126809 */     GIR_RootConstrainSelectedInstOperands,
     /* 126810 */     // GIR_Coverage, 1551,
     /* 126810 */     GIR_EraseRootFromParent_Done,
     /* 126811 */   // Label 2530: @126811
     /* 126811 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(126866), // Rule ID 3658 //
     /* 126816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126827 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 126827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 126842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126844 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126864 */     GIR_RootConstrainSelectedInstOperands,
     /* 126865 */     // GIR_Coverage, 3658,
     /* 126865 */     GIR_EraseRootFromParent_Done,
     /* 126866 */   // Label 2531: @126866
     /* 126866 */   GIM_Reject,
     /* 126867 */ // Label 2529: @126867
     /* 126867 */ GIM_Reject,
     /* 126868 */ // Label 2520: @126868
     /* 126868 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(126905), // Rule ID 1546 //
     /* 126873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126887 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 126890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126892 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126897 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126903 */   GIR_RootConstrainSelectedInstOperands,
     /* 126904 */   // GIR_Coverage, 1546,
     /* 126904 */   GIR_EraseRootFromParent_Done,
     /* 126905 */ // Label 2532: @126905
     /* 126905 */ GIM_Reject,
     /* 126906 */ // Label 2521: @126906
     /* 126906 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(127004),
     /* 126911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126914 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(126948), // Rule ID 1550 //
     /* 126919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126930 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 126933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126946 */     GIR_RootConstrainSelectedInstOperands,
     /* 126947 */     // GIR_Coverage, 1550,
     /* 126947 */     GIR_EraseRootFromParent_Done,
     /* 126948 */   // Label 2534: @126948
     /* 126948 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(127003), // Rule ID 3656 //
     /* 126953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126964 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 126964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 126979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126981 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127001 */     GIR_RootConstrainSelectedInstOperands,
     /* 127002 */     // GIR_Coverage, 3656,
     /* 127002 */     GIR_EraseRootFromParent_Done,
     /* 127003 */   // Label 2535: @127003
     /* 127003 */   GIM_Reject,
     /* 127004 */ // Label 2533: @127004
     /* 127004 */ GIM_Reject,
     /* 127005 */ // Label 2522: @127005
     /* 127005 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127103),
     /* 127010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127013 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127047), // Rule ID 1549 //
     /* 127018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127029 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127045 */     GIR_RootConstrainSelectedInstOperands,
     /* 127046 */     // GIR_Coverage, 1549,
     /* 127046 */     GIR_EraseRootFromParent_Done,
     /* 127047 */   // Label 2537: @127047
     /* 127047 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(127102), // Rule ID 3654 //
     /* 127052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127063 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127080 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127100 */     GIR_RootConstrainSelectedInstOperands,
     /* 127101 */     // GIR_Coverage, 3654,
     /* 127101 */     GIR_EraseRootFromParent_Done,
     /* 127102 */   // Label 2538: @127102
     /* 127102 */   GIM_Reject,
     /* 127103 */ // Label 2536: @127103
     /* 127103 */ GIM_Reject,
     /* 127104 */ // Label 2523: @127104
     /* 127104 */ GIM_Reject,
     /* 127105 */ // Label 64: @127105
     /* 127105 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2541*/ GIMT_Encode4(127212),
     /* 127116 */ /*GILLT_v8s8*//*Label 2539*/ GIMT_Encode4(127136), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127132 */ /*GILLT_v16s8*//*Label 2540*/ GIMT_Encode4(127174),
     /* 127136 */ // Label 2539: @127136
     /* 127136 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127173), // Rule ID 1552 //
     /* 127141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127155 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127160 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127165 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127171 */   GIR_RootConstrainSelectedInstOperands,
     /* 127172 */   // GIR_Coverage, 1552,
     /* 127172 */   GIR_EraseRootFromParent_Done,
     /* 127173 */ // Label 2542: @127173
     /* 127173 */ GIM_Reject,
     /* 127174 */ // Label 2540: @127174
     /* 127174 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(127211), // Rule ID 1553 //
     /* 127179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127193 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127198 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127203 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127209 */   GIR_RootConstrainSelectedInstOperands,
     /* 127210 */   // GIR_Coverage, 1553,
     /* 127210 */   GIR_EraseRootFromParent_Done,
     /* 127211 */ // Label 2543: @127211
     /* 127211 */ GIM_Reject,
     /* 127212 */ // Label 2541: @127212
     /* 127212 */ GIM_Reject,
     /* 127213 */ // Label 65: @127213
     /* 127213 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2547*/ GIMT_Encode4(127502),
     /* 127224 */ /*GILLT_s32*//*Label 2544*/ GIMT_Encode4(127272), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127252 */ /*GILLT_v4s32*//*Label 2545*/ GIMT_Encode4(127384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127268 */ /*GILLT_v8s16*//*Label 2546*/ GIMT_Encode4(127443),
     /* 127272 */ // Label 2544: @127272
     /* 127272 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(127383),
     /* 127277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127280 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(127314), // Rule ID 199 //
     /* 127285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127296 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127312 */     GIR_RootConstrainSelectedInstOperands,
     /* 127313 */     // GIR_Coverage, 199,
     /* 127313 */     GIR_EraseRootFromParent_Done,
     /* 127314 */   // Label 2549: @127314
     /* 127314 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(127348), // Rule ID 326 //
     /* 127319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127330 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127346 */     GIR_RootConstrainSelectedInstOperands,
     /* 127347 */     // GIR_Coverage, 326,
     /* 127347 */     GIR_EraseRootFromParent_Done,
     /* 127348 */   // Label 2550: @127348
     /* 127348 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(127382), // Rule ID 536 //
     /* 127353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127364 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127380 */     GIR_RootConstrainSelectedInstOperands,
     /* 127381 */     // GIR_Coverage, 536,
     /* 127381 */     GIR_EraseRootFromParent_Done,
     /* 127382 */   // Label 2551: @127382
     /* 127382 */   GIM_Reject,
     /* 127383 */ // Label 2548: @127383
     /* 127383 */ GIM_Reject,
     /* 127384 */ // Label 2545: @127384
     /* 127384 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127442), // Rule ID 3331 //
     /* 127389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127403 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127420 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127425 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127431 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127440 */   GIR_RootConstrainSelectedInstOperands,
     /* 127441 */   // GIR_Coverage, 3331,
     /* 127441 */   GIR_EraseRootFromParent_Done,
     /* 127442 */ // Label 2552: @127442
     /* 127442 */ GIM_Reject,
     /* 127443 */ // Label 2546: @127443
     /* 127443 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127501), // Rule ID 3330 //
     /* 127448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127462 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127484 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127499 */   GIR_RootConstrainSelectedInstOperands,
     /* 127500 */   // GIR_Coverage, 3330,
     /* 127500 */   GIR_EraseRootFromParent_Done,
     /* 127501 */ // Label 2553: @127501
     /* 127501 */ GIM_Reject,
     /* 127502 */ // Label 2547: @127502
     /* 127502 */ GIM_Reject,
     /* 127503 */ // Label 66: @127503
     /* 127503 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2558*/ GIMT_Encode4(127934),
     /* 127514 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(127574), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127542 */ /*GILLT_v4s32*//*Label 2555*/ GIMT_Encode4(127652), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127558 */ /*GILLT_v8s16*//*Label 2556*/ GIMT_Encode4(127746), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127570 */ /*GILLT_v16s8*//*Label 2557*/ GIMT_Encode4(127840),
     /* 127574 */ // Label 2554: @127574
     /* 127574 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(127651),
     /* 127579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127582 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(127616), // Rule ID 198 //
     /* 127587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127598 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127614 */     GIR_RootConstrainSelectedInstOperands,
     /* 127615 */     // GIR_Coverage, 198,
     /* 127615 */     GIR_EraseRootFromParent_Done,
     /* 127616 */   // Label 2560: @127616
     /* 127616 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(127650), // Rule ID 535 //
     /* 127621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127632 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127648 */     GIR_RootConstrainSelectedInstOperands,
     /* 127649 */     // GIR_Coverage, 535,
     /* 127649 */     GIR_EraseRootFromParent_Done,
     /* 127650 */   // Label 2561: @127650
     /* 127650 */   GIM_Reject,
     /* 127651 */ // Label 2559: @127651
     /* 127651 */ GIM_Reject,
     /* 127652 */ // Label 2555: @127652
     /* 127652 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(127745), // Rule ID 4758 //
     /* 127657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127671 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127695 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127698 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127701 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127707 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127720 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127728 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127734 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127743 */   GIR_RootConstrainSelectedInstOperands,
     /* 127744 */   // GIR_Coverage, 4758,
     /* 127744 */   GIR_EraseRootFromParent_Done,
     /* 127745 */ // Label 2562: @127745
     /* 127745 */ GIM_Reject,
     /* 127746 */ // Label 2556: @127746
     /* 127746 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127839), // Rule ID 4759 //
     /* 127751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127765 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127765 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127768 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127772 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127789 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127792 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127795 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127801 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127814 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127828 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127837 */   GIR_RootConstrainSelectedInstOperands,
     /* 127838 */   // GIR_Coverage, 4759,
     /* 127838 */   GIR_EraseRootFromParent_Done,
     /* 127839 */ // Label 2563: @127839
     /* 127839 */ GIM_Reject,
     /* 127840 */ // Label 2557: @127840
     /* 127840 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(127933), // Rule ID 4757 //
     /* 127845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127859 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 127859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127871 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127874 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127878 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127883 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 127886 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127889 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127895 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 127906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127908 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127916 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127922 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127931 */   GIR_RootConstrainSelectedInstOperands,
     /* 127932 */   // GIR_Coverage, 4757,
     /* 127932 */   GIR_EraseRootFromParent_Done,
     /* 127933 */ // Label 2564: @127933
     /* 127933 */ GIM_Reject,
     /* 127934 */ // Label 2558: @127934
     /* 127934 */ GIM_Reject,
     /* 127935 */ // Label 67: @127935
     /* 127935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2572*/ GIMT_Encode4(128309),
     /* 127946 */ /*GILLT_s16*//*Label 2565*/ GIMT_Encode4(127998),
     /* 127950 */ /*GILLT_s32*//*Label 2566*/ GIMT_Encode4(128025),
     /* 127954 */ /*GILLT_s64*//*Label 2567*/ GIMT_Encode4(128052), GIMT_Encode4(0),
     /* 127962 */ /*GILLT_v2s32*//*Label 2568*/ GIMT_Encode4(128079), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127974 */ /*GILLT_v4s16*//*Label 2569*/ GIMT_Encode4(128106),
     /* 127978 */ /*GILLT_v4s32*//*Label 2570*/ GIMT_Encode4(128133), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127994 */ /*GILLT_v8s16*//*Label 2571*/ GIMT_Encode4(128221),
     /* 127998 */ // Label 2565: @127998
     /* 127998 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(128024), // Rule ID 683 //
     /* 128003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128017 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128022 */   GIR_RootConstrainSelectedInstOperands,
     /* 128023 */   // GIR_Coverage, 683,
     /* 128023 */   GIR_Done,
     /* 128024 */ // Label 2573: @128024
     /* 128024 */ GIM_Reject,
     /* 128025 */ // Label 2566: @128025
     /* 128025 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(128051), // Rule ID 684 //
     /* 128030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128044 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128049 */   GIR_RootConstrainSelectedInstOperands,
     /* 128050 */   // GIR_Coverage, 684,
     /* 128050 */   GIR_Done,
     /* 128051 */ // Label 2574: @128051
     /* 128051 */ GIM_Reject,
     /* 128052 */ // Label 2567: @128052
     /* 128052 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128078), // Rule ID 685 //
     /* 128057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128071 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128076 */   GIR_RootConstrainSelectedInstOperands,
     /* 128077 */   // GIR_Coverage, 685,
     /* 128077 */   GIR_Done,
     /* 128078 */ // Label 2575: @128078
     /* 128078 */ GIM_Reject,
     /* 128079 */ // Label 2568: @128079
     /* 128079 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128105), // Rule ID 1711 //
     /* 128084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128098 */   // (fceil:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /* 128103 */   GIR_RootConstrainSelectedInstOperands,
     /* 128104 */   // GIR_Coverage, 1711,
     /* 128104 */   GIR_Done,
     /* 128105 */ // Label 2576: @128105
     /* 128105 */ GIM_Reject,
     /* 128106 */ // Label 2569: @128106
     /* 128106 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(128132), // Rule ID 1713 //
     /* 128111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128125 */   // (fceil:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /* 128130 */   GIR_RootConstrainSelectedInstOperands,
     /* 128131 */   // GIR_Coverage, 1713,
     /* 128131 */   GIR_Done,
     /* 128132 */ // Label 2577: @128132
     /* 128132 */ GIM_Reject,
     /* 128133 */ // Label 2570: @128133
     /* 128133 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(128220),
     /* 128138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128141 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(128164), // Rule ID 1712 //
     /* 128146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128157 */     // (fceil:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /* 128162 */     GIR_RootConstrainSelectedInstOperands,
     /* 128163 */     // GIR_Coverage, 1712,
     /* 128163 */     GIR_Done,
     /* 128164 */   // Label 2579: @128164
     /* 128164 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(128219), // Rule ID 3986 //
     /* 128169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128180 */     // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128197 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128217 */     GIR_RootConstrainSelectedInstOperands,
     /* 128218 */     // GIR_Coverage, 3986,
     /* 128218 */     GIR_EraseRootFromParent_Done,
     /* 128219 */   // Label 2580: @128219
     /* 128219 */   GIM_Reject,
     /* 128220 */ // Label 2578: @128220
     /* 128220 */ GIM_Reject,
     /* 128221 */ // Label 2571: @128221
     /* 128221 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(128308),
     /* 128226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128229 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(128252), // Rule ID 1714 //
     /* 128234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128245 */     // (fceil:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /* 128250 */     GIR_RootConstrainSelectedInstOperands,
     /* 128251 */     // GIR_Coverage, 1714,
     /* 128251 */     GIR_Done,
     /* 128252 */   // Label 2582: @128252
     /* 128252 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(128307), // Rule ID 3974 //
     /* 128257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128268 */     // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128285 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128305 */     GIR_RootConstrainSelectedInstOperands,
     /* 128306 */     // GIR_Coverage, 3974,
     /* 128306 */     GIR_EraseRootFromParent_Done,
     /* 128307 */   // Label 2583: @128307
     /* 128307 */   GIM_Reject,
     /* 128308 */ // Label 2581: @128308
     /* 128308 */ GIM_Reject,
     /* 128309 */ // Label 2572: @128309
     /* 128309 */ GIM_Reject,
     /* 128310 */ // Label 68: @128310
     /* 128310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2587*/ GIMT_Encode4(128447),
     /* 128321 */ /*GILLT_s16*//*Label 2584*/ GIMT_Encode4(128333),
     /* 128325 */ /*GILLT_s32*//*Label 2585*/ GIMT_Encode4(128371),
     /* 128329 */ /*GILLT_s64*//*Label 2586*/ GIMT_Encode4(128409),
     /* 128333 */ // Label 2584: @128333
     /* 128333 */ GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(128370), // Rule ID 691 //
     /* 128338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128352 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128357 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128368 */   GIR_RootConstrainSelectedInstOperands,
     /* 128369 */   // GIR_Coverage, 691,
     /* 128369 */   GIR_EraseRootFromParent_Done,
     /* 128370 */ // Label 2588: @128370
     /* 128370 */ GIM_Reject,
     /* 128371 */ // Label 2585: @128371
     /* 128371 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(128408), // Rule ID 690 //
     /* 128376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128390 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128395 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128400 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128406 */   GIR_RootConstrainSelectedInstOperands,
     /* 128407 */   // GIR_Coverage, 690,
     /* 128407 */   GIR_EraseRootFromParent_Done,
     /* 128408 */ // Label 2589: @128408
     /* 128408 */ GIM_Reject,
     /* 128409 */ // Label 2586: @128409
     /* 128409 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(128446), // Rule ID 689 //
     /* 128414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128428 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128433 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128444 */   GIR_RootConstrainSelectedInstOperands,
     /* 128445 */   // GIR_Coverage, 689,
     /* 128445 */   GIR_EraseRootFromParent_Done,
     /* 128446 */ // Label 2590: @128446
     /* 128446 */ GIM_Reject,
     /* 128447 */ // Label 2587: @128447
     /* 128447 */ GIM_Reject,
     /* 128448 */ // Label 69: @128448
     /* 128448 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2598*/ GIMT_Encode4(128822),
     /* 128459 */ /*GILLT_s16*//*Label 2591*/ GIMT_Encode4(128511),
     /* 128463 */ /*GILLT_s32*//*Label 2592*/ GIMT_Encode4(128538),
     /* 128467 */ /*GILLT_s64*//*Label 2593*/ GIMT_Encode4(128565), GIMT_Encode4(0),
     /* 128475 */ /*GILLT_v2s32*//*Label 2594*/ GIMT_Encode4(128592), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128487 */ /*GILLT_v4s16*//*Label 2595*/ GIMT_Encode4(128619),
     /* 128491 */ /*GILLT_v4s32*//*Label 2596*/ GIMT_Encode4(128646), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128507 */ /*GILLT_v8s16*//*Label 2597*/ GIMT_Encode4(128734),
     /* 128511 */ // Label 2591: @128511
     /* 128511 */ GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(128537), // Rule ID 686 //
     /* 128516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128530 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128535 */   GIR_RootConstrainSelectedInstOperands,
     /* 128536 */   // GIR_Coverage, 686,
     /* 128536 */   GIR_Done,
     /* 128537 */ // Label 2599: @128537
     /* 128537 */ GIM_Reject,
     /* 128538 */ // Label 2592: @128538
     /* 128538 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(128564), // Rule ID 687 //
     /* 128543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128557 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128562 */   GIR_RootConstrainSelectedInstOperands,
     /* 128563 */   // GIR_Coverage, 687,
     /* 128563 */   GIR_Done,
     /* 128564 */ // Label 2600: @128564
     /* 128564 */ GIM_Reject,
     /* 128565 */ // Label 2593: @128565
     /* 128565 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(128591), // Rule ID 688 //
     /* 128570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128584 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128589 */   GIR_RootConstrainSelectedInstOperands,
     /* 128590 */   // GIR_Coverage, 688,
     /* 128590 */   GIR_Done,
     /* 128591 */ // Label 2601: @128591
     /* 128591 */ GIM_Reject,
     /* 128592 */ // Label 2594: @128592
     /* 128592 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(128618), // Rule ID 1707 //
     /* 128597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128611 */   // (ffloor:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /* 128616 */   GIR_RootConstrainSelectedInstOperands,
     /* 128617 */   // GIR_Coverage, 1707,
     /* 128617 */   GIR_Done,
     /* 128618 */ // Label 2602: @128618
     /* 128618 */ GIM_Reject,
     /* 128619 */ // Label 2595: @128619
     /* 128619 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(128645), // Rule ID 1709 //
     /* 128624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128638 */   // (ffloor:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /* 128643 */   GIR_RootConstrainSelectedInstOperands,
     /* 128644 */   // GIR_Coverage, 1709,
     /* 128644 */   GIR_Done,
     /* 128645 */ // Label 2603: @128645
     /* 128645 */ GIM_Reject,
     /* 128646 */ // Label 2596: @128646
     /* 128646 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(128733),
     /* 128651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128654 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(128677), // Rule ID 1708 //
     /* 128659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128670 */     // (ffloor:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /* 128675 */     GIR_RootConstrainSelectedInstOperands,
     /* 128676 */     // GIR_Coverage, 1708,
     /* 128676 */     GIR_Done,
     /* 128677 */   // Label 2605: @128677
     /* 128677 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(128732), // Rule ID 3984 //
     /* 128682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128693 */     // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128710 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128730 */     GIR_RootConstrainSelectedInstOperands,
     /* 128731 */     // GIR_Coverage, 3984,
     /* 128731 */     GIR_EraseRootFromParent_Done,
     /* 128732 */   // Label 2606: @128732
     /* 128732 */   GIM_Reject,
     /* 128733 */ // Label 2604: @128733
     /* 128733 */ GIM_Reject,
     /* 128734 */ // Label 2597: @128734
     /* 128734 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(128821),
     /* 128739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128742 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(128765), // Rule ID 1710 //
     /* 128747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128758 */     // (ffloor:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /* 128763 */     GIR_RootConstrainSelectedInstOperands,
     /* 128764 */     // GIR_Coverage, 1710,
     /* 128764 */     GIR_Done,
     /* 128765 */   // Label 2608: @128765
     /* 128765 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(128820), // Rule ID 3972 //
     /* 128770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128781 */     // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128798 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128818 */     GIR_RootConstrainSelectedInstOperands,
     /* 128819 */     // GIR_Coverage, 3972,
     /* 128819 */     GIR_EraseRootFromParent_Done,
     /* 128820 */   // Label 2609: @128820
     /* 128820 */   GIM_Reject,
     /* 128821 */ // Label 2607: @128821
     /* 128821 */ GIM_Reject,
     /* 128822 */ // Label 2598: @128822
     /* 128822 */ GIM_Reject,
     /* 128823 */ // Label 70: @128823
     /* 128823 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2615*/ GIMT_Encode4(129118),
     /* 128834 */ /*GILLT_s16*//*Label 2610*/ GIMT_Encode4(128886),
     /* 128838 */ /*GILLT_s32*//*Label 2611*/ GIMT_Encode4(128924),
     /* 128842 */ /*GILLT_s64*//*Label 2612*/ GIMT_Encode4(128962), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128866 */ /*GILLT_v4s32*//*Label 2613*/ GIMT_Encode4(129000), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128882 */ /*GILLT_v8s16*//*Label 2614*/ GIMT_Encode4(129059),
     /* 128886 */ // Label 2610: @128886
     /* 128886 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(128923), // Rule ID 671 //
     /* 128891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128905 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128910 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128921 */   GIR_RootConstrainSelectedInstOperands,
     /* 128922 */   // GIR_Coverage, 671,
     /* 128922 */   GIR_EraseRootFromParent_Done,
     /* 128923 */ // Label 2616: @128923
     /* 128923 */ GIM_Reject,
     /* 128924 */ // Label 2611: @128924
     /* 128924 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(128961), // Rule ID 672 //
     /* 128929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128943 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128948 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128953 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128959 */   GIR_RootConstrainSelectedInstOperands,
     /* 128960 */   // GIR_Coverage, 672,
     /* 128960 */   GIR_EraseRootFromParent_Done,
     /* 128961 */ // Label 2617: @128961
     /* 128961 */ GIM_Reject,
     /* 128962 */ // Label 2612: @128962
     /* 128962 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(128999), // Rule ID 673 //
     /* 128967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128981 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128986 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128991 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128997 */   GIR_RootConstrainSelectedInstOperands,
     /* 128998 */   // GIR_Coverage, 673,
     /* 128998 */   GIR_EraseRootFromParent_Done,
     /* 128999 */ // Label 2618: @128999
     /* 128999 */ GIM_Reject,
     /* 129000 */ // Label 2613: @129000
     /* 129000 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129058), // Rule ID 3978 //
     /* 129005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129019 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 129019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 129034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129036 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129041 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129047 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129056 */   GIR_RootConstrainSelectedInstOperands,
     /* 129057 */   // GIR_Coverage, 3978,
     /* 129057 */   GIR_EraseRootFromParent_Done,
     /* 129058 */ // Label 2619: @129058
     /* 129058 */ GIM_Reject,
     /* 129059 */ // Label 2614: @129059
     /* 129059 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129117), // Rule ID 3966 //
     /* 129064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129078 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129095 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129100 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129106 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129115 */   GIR_RootConstrainSelectedInstOperands,
     /* 129116 */   // GIR_Coverage, 3966,
     /* 129116 */   GIR_EraseRootFromParent_Done,
     /* 129117 */ // Label 2620: @129117
     /* 129117 */ GIM_Reject,
     /* 129118 */ // Label 2615: @129118
     /* 129118 */ GIM_Reject,
     /* 129119 */ // Label 71: @129119
     /* 129119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2624*/ GIMT_Encode4(129256),
     /* 129130 */ /*GILLT_s16*//*Label 2621*/ GIMT_Encode4(129142),
     /* 129134 */ /*GILLT_s32*//*Label 2622*/ GIMT_Encode4(129180),
     /* 129138 */ /*GILLT_s64*//*Label 2623*/ GIMT_Encode4(129218),
     /* 129142 */ // Label 2621: @129142
     /* 129142 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(129179), // Rule ID 668 //
     /* 129147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129161 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129166 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129171 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129177 */   GIR_RootConstrainSelectedInstOperands,
     /* 129178 */   // GIR_Coverage, 668,
     /* 129178 */   GIR_EraseRootFromParent_Done,
     /* 129179 */ // Label 2625: @129179
     /* 129179 */ GIM_Reject,
     /* 129180 */ // Label 2622: @129180
     /* 129180 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129217), // Rule ID 669 //
     /* 129185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129199 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129204 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129209 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129215 */   GIR_RootConstrainSelectedInstOperands,
     /* 129216 */   // GIR_Coverage, 669,
     /* 129216 */   GIR_EraseRootFromParent_Done,
     /* 129217 */ // Label 2626: @129217
     /* 129217 */ GIM_Reject,
     /* 129218 */ // Label 2623: @129218
     /* 129218 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129255), // Rule ID 670 //
     /* 129223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129237 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129242 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129247 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129253 */   GIR_RootConstrainSelectedInstOperands,
     /* 129254 */   // GIR_Coverage, 670,
     /* 129254 */   GIR_EraseRootFromParent_Done,
     /* 129255 */ // Label 2627: @129255
     /* 129255 */ GIM_Reject,
     /* 129256 */ // Label 2624: @129256
     /* 129256 */ GIM_Reject,
     /* 129257 */ // Label 72: @129257
     /* 129257 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(129272), // Rule ID 12 //
     /* 129262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129265 */   // (trap)  =>  (TRAPNaCl)
     /* 129265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129270 */   GIR_RootConstrainSelectedInstOperands,
     /* 129271 */   // GIR_Coverage, 12,
     /* 129271 */   GIR_Done,
     /* 129272 */ // Label 2628: @129272
     /* 129272 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(129287), // Rule ID 13 //
     /* 129277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129280 */   // (trap)  =>  (TRAP)
     /* 129280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129285 */   GIR_RootConstrainSelectedInstOperands,
     /* 129286 */   // GIR_Coverage, 13,
     /* 129286 */   GIR_Done,
     /* 129287 */ // Label 2629: @129287
     /* 129287 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(129302), // Rule ID 285 //
     /* 129292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129295 */   // (trap)  =>  (tTRAP)
     /* 129295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129300 */   GIR_RootConstrainSelectedInstOperands,
     /* 129301 */   // GIR_Coverage, 285,
     /* 129301 */   GIR_Done,
     /* 129302 */ // Label 2630: @129302
     /* 129302 */ GIM_Reject,
     /* 129303 */ // Label 73: @129303
     /* 129303 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(129319), // Rule ID 1838 //
     /* 129308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129311 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129317 */   GIR_RootConstrainSelectedInstOperands,
     /* 129318 */   // GIR_Coverage, 1838,
     /* 129318 */   GIR_EraseRootFromParent_Done,
     /* 129319 */ // Label 2631: @129319
     /* 129319 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(129346), // Rule ID 1839 //
     /* 129324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129327 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129330 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129344 */   GIR_RootConstrainSelectedInstOperands,
     /* 129345 */   // GIR_Coverage, 1839,
     /* 129345 */   GIR_EraseRootFromParent_Done,
     /* 129346 */ // Label 2632: @129346
     /* 129346 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(129362), // Rule ID 2024 //
     /* 129351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129354 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129360 */   GIR_RootConstrainSelectedInstOperands,
     /* 129361 */   // GIR_Coverage, 2024,
     /* 129361 */   GIR_EraseRootFromParent_Done,
     /* 129362 */ // Label 2633: @129362
     /* 129362 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129389), // Rule ID 2025 //
     /* 129367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129370 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129373 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129387 */   GIR_RootConstrainSelectedInstOperands,
     /* 129388 */   // GIR_Coverage, 2025,
     /* 129388 */   GIR_EraseRootFromParent_Done,
     /* 129389 */ // Label 2634: @129389
     /* 129389 */ GIM_Reject,
     /* 129390 */ // Label 74: @129390
     /* 129390 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(129810),
     /* 129395 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129398 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2639*/ GIMT_Encode4(129696),
     /* 129409 */   /*GILLT_v4s32*//*Label 2636*/ GIMT_Encode4(129441), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129425 */   /*GILLT_v8s16*//*Label 2637*/ GIMT_Encode4(129512), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129437 */   /*GILLT_v16s8*//*Label 2638*/ GIMT_Encode4(129583),
     /* 129441 */   // Label 2636: @129441
     /* 129441 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(129511), // Rule ID 3241 //
     /* 129446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129481 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129509 */     GIR_RootConstrainSelectedInstOperands,
     /* 129510 */     // GIR_Coverage, 3241,
     /* 129510 */     GIR_EraseRootFromParent_Done,
     /* 129511 */   // Label 2640: @129511
     /* 129511 */   GIM_Reject,
     /* 129512 */   // Label 2637: @129512
     /* 129512 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(129582), // Rule ID 3242 //
     /* 129517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129552 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129580 */     GIR_RootConstrainSelectedInstOperands,
     /* 129581 */     // GIR_Coverage, 3242,
     /* 129581 */     GIR_EraseRootFromParent_Done,
     /* 129582 */   // Label 2641: @129582
     /* 129582 */   GIM_Reject,
     /* 129583 */   // Label 2638: @129583
     /* 129583 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(129695),
     /* 129588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129592 */     GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(129658), // Rule ID 3245 //
     /* 129597 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129600 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129604 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129608 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129612 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129616 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129621 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129626 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129628 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129628 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129631 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129633 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129637 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129641 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129644 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129650 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129656 */       GIR_RootConstrainSelectedInstOperands,
     /* 129657 */       // GIR_Coverage, 3245,
     /* 129657 */       GIR_EraseRootFromParent_Done,
     /* 129658 */     // Label 2643: @129658
     /* 129658 */     GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(129694), // Rule ID 3049 //
     /* 129663 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129666 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129670 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129670 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129673 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129675 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129677 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129680 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129686 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129692 */       GIR_RootConstrainSelectedInstOperands,
     /* 129693 */       // GIR_Coverage, 3049,
     /* 129693 */       GIR_EraseRootFromParent_Done,
     /* 129694 */     // Label 2644: @129694
     /* 129694 */     GIM_Reject,
     /* 129695 */   // Label 2642: @129695
     /* 129695 */   GIM_Reject,
     /* 129696 */   // Label 2639: @129696
     /* 129696 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2647*/ GIMT_Encode4(129809),
     /* 129707 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(129727), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129723 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(129768),
     /* 129727 */   // Label 2645: @129727
     /* 129727 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(129767), // Rule ID 3087 //
     /* 129732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129743 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129748 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129765 */     GIR_RootConstrainSelectedInstOperands,
     /* 129766 */     // GIR_Coverage, 3087,
     /* 129766 */     GIR_EraseRootFromParent_Done,
     /* 129767 */   // Label 2648: @129767
     /* 129767 */   GIM_Reject,
     /* 129768 */   // Label 2646: @129768
     /* 129768 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(129808), // Rule ID 3077 //
     /* 129773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129784 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129789 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129806 */     GIR_RootConstrainSelectedInstOperands,
     /* 129807 */     // GIR_Coverage, 3077,
     /* 129807 */     GIR_EraseRootFromParent_Done,
     /* 129808 */   // Label 2649: @129808
     /* 129808 */   GIM_Reject,
     /* 129809 */   // Label 2647: @129809
     /* 129809 */   GIM_Reject,
     /* 129810 */ // Label 2635: @129810
     /* 129810 */ GIM_Reject,
     /* 129811 */ // Label 75: @129811
     /* 129811 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(130090),
     /* 129816 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129819 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(130089),
     /* 129830 */   /*GILLT_v4s32*//*Label 2651*/ GIMT_Encode4(129862), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129846 */   /*GILLT_v8s16*//*Label 2652*/ GIMT_Encode4(129945), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129858 */   /*GILLT_v16s8*//*Label 2653*/ GIMT_Encode4(130013),
     /* 129862 */   // Label 2651: @129862
     /* 129862 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(129944), // Rule ID 3147 //
     /* 129867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129878 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129890 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129903 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129909 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129942 */     GIR_RootConstrainSelectedInstOperands,
     /* 129943 */     // GIR_Coverage, 3147,
     /* 129943 */     GIR_EraseRootFromParent_Done,
     /* 129944 */   // Label 2655: @129944
     /* 129944 */   GIM_Reject,
     /* 129945 */   // Label 2652: @129945
     /* 129945 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(130012), // Rule ID 3146 //
     /* 129950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129961 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129973 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130010 */     GIR_RootConstrainSelectedInstOperands,
     /* 130011 */     // GIR_Coverage, 3146,
     /* 130011 */     GIR_EraseRootFromParent_Done,
     /* 130012 */   // Label 2656: @130012
     /* 130012 */   GIM_Reject,
     /* 130013 */   // Label 2653: @130013
     /* 130013 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(130088), // Rule ID 3145 //
     /* 130018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130029 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130047 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130053 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130069 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130086 */     GIR_RootConstrainSelectedInstOperands,
     /* 130087 */     // GIR_Coverage, 3145,
     /* 130087 */     GIR_EraseRootFromParent_Done,
     /* 130088 */   // Label 2657: @130088
     /* 130088 */   GIM_Reject,
     /* 130089 */   // Label 2654: @130089
     /* 130089 */   GIM_Reject,
     /* 130090 */ // Label 2650: @130090
     /* 130090 */ GIM_Reject,
     /* 130091 */ // Label 76: @130091
     /* 130091 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(130379),
     /* 130096 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130099 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2662*/ GIMT_Encode4(130378),
     /* 130110 */   /*GILLT_v4s32*//*Label 2659*/ GIMT_Encode4(130142), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130126 */   /*GILLT_v8s16*//*Label 2660*/ GIMT_Encode4(130225), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130138 */   /*GILLT_v16s8*//*Label 2661*/ GIMT_Encode4(130302),
     /* 130142 */   // Label 2659: @130142
     /* 130142 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(130224), // Rule ID 3153 //
     /* 130147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130158 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130170 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130180 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130183 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130222 */     GIR_RootConstrainSelectedInstOperands,
     /* 130223 */     // GIR_Coverage, 3153,
     /* 130223 */     GIR_EraseRootFromParent_Done,
     /* 130224 */   // Label 2663: @130224
     /* 130224 */   GIM_Reject,
     /* 130225 */   // Label 2660: @130225
     /* 130225 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(130301), // Rule ID 3152 //
     /* 130230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130241 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130253 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130263 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130266 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130299 */     GIR_RootConstrainSelectedInstOperands,
     /* 130300 */     // GIR_Coverage, 3152,
     /* 130300 */     GIR_EraseRootFromParent_Done,
     /* 130301 */   // Label 2664: @130301
     /* 130301 */   GIM_Reject,
     /* 130302 */   // Label 2661: @130302
     /* 130302 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(130377), // Rule ID 3151 //
     /* 130307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130318 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130330 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130336 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130342 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130375 */     GIR_RootConstrainSelectedInstOperands,
     /* 130376 */     // GIR_Coverage, 3151,
     /* 130376 */     GIR_EraseRootFromParent_Done,
     /* 130377 */   // Label 2665: @130377
     /* 130377 */   GIM_Reject,
     /* 130378 */   // Label 2662: @130378
     /* 130378 */   GIM_Reject,
     /* 130379 */ // Label 2658: @130379
     /* 130379 */ GIM_Reject,
     /* 130380 */ // Label 77: @130380
     /* 130380 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(130660),
     /* 130385 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130388 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2670*/ GIMT_Encode4(130659),
     /* 130399 */   /*GILLT_v4s32*//*Label 2667*/ GIMT_Encode4(130431), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130415 */   /*GILLT_v8s16*//*Label 2668*/ GIMT_Encode4(130507), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130427 */   /*GILLT_v16s8*//*Label 2669*/ GIMT_Encode4(130583),
     /* 130431 */   // Label 2667: @130431
     /* 130431 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(130506), // Rule ID 3150 //
     /* 130436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130447 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130465 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130471 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130504 */     GIR_RootConstrainSelectedInstOperands,
     /* 130505 */     // GIR_Coverage, 3150,
     /* 130505 */     GIR_EraseRootFromParent_Done,
     /* 130506 */   // Label 2671: @130506
     /* 130506 */   GIM_Reject,
     /* 130507 */   // Label 2668: @130507
     /* 130507 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(130582), // Rule ID 3149 //
     /* 130512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130523 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130538 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130541 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130547 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130580 */     GIR_RootConstrainSelectedInstOperands,
     /* 130581 */     // GIR_Coverage, 3149,
     /* 130581 */     GIR_EraseRootFromParent_Done,
     /* 130582 */   // Label 2672: @130582
     /* 130582 */   GIM_Reject,
     /* 130583 */   // Label 2669: @130583
     /* 130583 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(130658), // Rule ID 3148 //
     /* 130588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130599 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130617 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130623 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130656 */     GIR_RootConstrainSelectedInstOperands,
     /* 130657 */     // GIR_Coverage, 3148,
     /* 130657 */     GIR_EraseRootFromParent_Done,
     /* 130658 */   // Label 2673: @130658
     /* 130658 */   GIM_Reject,
     /* 130659 */   // Label 2670: @130659
     /* 130659 */   GIM_Reject,
     /* 130660 */ // Label 2666: @130660
     /* 130660 */ GIM_Reject,
     /* 130661 */ // Label 78: @130661
     /* 130661 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(130956),
     /* 130666 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130669 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2678*/ GIMT_Encode4(130955),
     /* 130680 */   /*GILLT_v4s32*//*Label 2675*/ GIMT_Encode4(130712), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130696 */   /*GILLT_v8s16*//*Label 2676*/ GIMT_Encode4(130795), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130708 */   /*GILLT_v16s8*//*Label 2677*/ GIMT_Encode4(130872),
     /* 130712 */   // Label 2675: @130712
     /* 130712 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(130794), // Rule ID 3156 //
     /* 130717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130728 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130740 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130753 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130759 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130792 */     GIR_RootConstrainSelectedInstOperands,
     /* 130793 */     // GIR_Coverage, 3156,
     /* 130793 */     GIR_EraseRootFromParent_Done,
     /* 130794 */   // Label 2679: @130794
     /* 130794 */   GIM_Reject,
     /* 130795 */   // Label 2676: @130795
     /* 130795 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(130871), // Rule ID 3155 //
     /* 130800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130811 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130823 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130836 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130869 */     GIR_RootConstrainSelectedInstOperands,
     /* 130870 */     // GIR_Coverage, 3155,
     /* 130870 */     GIR_EraseRootFromParent_Done,
     /* 130871 */   // Label 2680: @130871
     /* 130871 */   GIM_Reject,
     /* 130872 */   // Label 2677: @130872
     /* 130872 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(130954), // Rule ID 3154 //
     /* 130877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130888 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130900 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130910 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130913 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130919 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130935 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130952 */     GIR_RootConstrainSelectedInstOperands,
     /* 130953 */     // GIR_Coverage, 3154,
     /* 130953 */     GIR_EraseRootFromParent_Done,
     /* 130954 */   // Label 2681: @130954
     /* 130954 */   GIM_Reject,
     /* 130955 */   // Label 2678: @130955
     /* 130955 */   GIM_Reject,
     /* 130956 */ // Label 2674: @130956
     /* 130956 */ GIM_Reject,
     /* 130957 */ // Label 79: @130957
     /* 130957 */ GIM_Reject,
     /* 130958 */ }; // Size: 130958 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
